/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/* $Id: rudolph.c,v 1.8 2002/03/27 17:04:21 dumon Exp $ */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/time.h>
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>
#include <linux/fb.h>
#include <sys/mman.h>

#include "ts-mem.h"
#include "realms.h"
#include "rudolph.h"
#include "canvas.h"
#include "Event.h"
#include "pixel.h"

r_screen screen;

r_screen screen_init(void) {

  static struct fb_var_screeninfo vinfo;
  static struct fb_fix_screeninfo finfo;
  static int fbfd = 0;
  static char *fbp = 0;
  long int screensize = 0;

  woempa(9, "called screen_init()\n");
  
  if (!fbfd) {

    /* 
    ** Open the file for reading and writing:
    */
    
    fbfd = open("/dev/fb0", O_RDWR);
    
    if (!fbfd) {
      wabort(ABORT_WONKA, "cannot open framebuffer device.\n");
    }
    
    woempa(9, "successfully opened framebuffer device ...\n");

    /*
    ** Get fixed screen information:
    */

    if (ioctl(fbfd, FBIOGET_FSCREENINFO, &finfo)) {
      wabort(ABORT_WONKA, "error reading fixed information.\n");
    }
            
    /*
    ** Get variable screen information: 
    */
    
    if (ioctl(fbfd, FBIOGET_VSCREENINFO, &vinfo)) {
      wabort(ABORT_WONKA, "error reading variable information.\n");
    }                          

    /* 
    ** Figure out the size of the screen in bytes:
    */
    
    screensize = vinfo.xres * vinfo.yres * vinfo.bits_per_pixel / 8;
    
    /* 
    ** Map framebuffer device to memory:
    */
    
    fbp = (char *)mmap(0, (unsigned)screensize, PROT_READ | PROT_WRITE, MAP_SHARED, fbfd, 0);

    if ((int)fbp == -1) { 
      wabort(ABORT_WONKA, "failed to map framebuffer device to memory.\n");
    }

    woempa(9, "succesfully mapped framebuffer device to memory ...\n");

    woempa(9, "--------------------------------------------------------\n");
    woempa(9, "framebuffer screen specifications:\n");
    woempa(9, "   x resolution: %3d, y resolution: %3d, bits per pixel: %3d\n", vinfo.xres, vinfo.yres, vinfo.bits_per_pixel);
    woempa(9, "   x offset    : %3d, y offset    : %3d, line length   : %3d\n", vinfo.xoffset, vinfo.yoffset, finfo.line_length);
    woempa(9, "   memory      : %p\n", fbp);
    woempa(9, "--------------------------------------------------------\n");

    /*
    ** Initialze screen structure:
    */

    screen = allocMem_system(sizeof(r_Screen));

    if(swap_display) {
      screen->height = vinfo.xres;
      screen->width = vinfo.yres;
    } else {
      screen->height = vinfo.yres;
      screen->width = vinfo.xres;
    }
    screen->video = (w_ubyte*) fbp;

    woempa(9, "finished screen_init()\n");
  }
  
  return screen;
}

void screen_update(int x1, int y1, int x2, int y2) {
}

