/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/* $Id: touchscreen.c,v 1.7 2002/03/28 10:57:26 dumon Exp $ */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/time.h>
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <stdio.h>
#include <fcntl.h>

#include "ts-mem.h"
#include "realms.h"
#include "rudolph.h"
#include "canvas.h"
#include "Event.h"

typedef struct {
  short pressure; //  0 = up, 1 = down*/
  short xpos;
  short ypos;
  short pad;
} ts_event;

static ts_event ts;
static char *mouse_path;
static int mfd;
static int cached_event = 0;

/*
** Somewhat ad-hoc function to set the path of the mouse (touchscreen)  device
*/

void mouse_set_path(char *s) {
  char *buf = allocMem_system(strlen(s) + 1);
  strcpy(buf, s);
  mouse_path = buf;
}

void mouse_init(void) {

  woempa(9, "called mouse_init()\n");
    
  mfd = open(mouse_path, O_NONBLOCK);
  if (mfd == -1) {
    wabort(ABORT_WONKA, "error: failed to initialize mouse or touchscreen\n");
  }
  else {
    woempa(9, "succesfully initialized mouse or touchscreen\n");
  }
                                       
}

int mouse_poll(int *state, int *x, int *y) {

  static int ox = 0;
  static int oy = 0;
  static int state1 = 0;
  static int state2 = 0;
  struct timeval tv;
  fd_set rfds;
 
  tv.tv_sec = 0;
  tv.tv_usec = 0;
 
  if(!cached_event) {
    ts.pressure = 0;
    ts.xpos = 0;
    ts.ypos = 0;
  }

  FD_ZERO(&rfds);
  FD_SET(mfd, &rfds);
                        
  if (select(mfd + 1, &rfds, NULL, NULL, &tv) || cached_event) {

    if(!cached_event) {
      read(mfd, &ts, sizeof(ts));
    }

    cached_event = 0;
  
    /*
    ** Update the states:
    */
    
    state2 = state1;
    state1 = (ts.pressure > 0);
   
    /*
    ** Handle the coordinates:
    */
        
    if (state1) {
      if(swap_display) {
        ox = ts.ypos;
        oy = screen->height - ts.xpos;
      } 
      else {
        ox = ts.xpos;
        oy = ts.ypos;
      }
    }

    *x = ox;
    *y = oy;
    
    
    /*
    ** Map the states on Java states:
    */
    
    if (state1 == 0) {
      *state = R_EVENT_MOUSE_RELEASED;
    
      return 1;
    }
    else if (state2 == 0) {
      *state = R_EVENT_MOUSE_PRESSED;

      return 1;
    }
    else { 
      *state = R_EVENT_MOUSE_DRAGGED;

      return 1;
    }
  }
  else {
    return 0;
  }        
}

void mouse_flush(void) {
  int result = 0;
  do {
    result = read(mfd, &ts, sizeof(ts));
    if(result > 0)  {
      cached_event = 1;
    }
  } while(result > 0); 
}

