/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.rudolph;

import java.awt.*;
import java.util.*;

import com.acunia.wonka.rudolph.taskbar.*;

public class WindowManager {

  private static WindowManager wm = null;
  private Vector windowList;

  public static WindowManager getInstance() {
    if(wm == null) wm = new WindowManager();
    return wm;
  }
  
  private WindowManager() {
    windowList = new Vector();
  }

  public Rectangle checkBounds(Window win, int x, int y, int w, int h) {
    
    if(!(win instanceof TaskBar)) {
      Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
 
      int tl = TaskBar.getBarLocation();
      int ts = TaskBar.getBarSize();
      
      int ttop = (tl == TaskBar.TOP ? ts : 0);
      int tbot = (tl == TaskBar.BOTTOM ? ts : 0);
      int tlef = (tl == TaskBar.LEFT ? ts : 0);
      int trig = (tl == TaskBar.RIGHT ? ts : 0);
      
      if(x < tlef) { x = tlef; }
      if(y < ttop) { y = ttop; }
      if(x + w > screen.width - trig) { w = screen.width - x - trig; }
      if(y + h > screen.height - tbot) { h = screen.height - y - tbot; }
      
    }
    
    return new Rectangle(x, y, w, h);
  }

  public void addWindow(Window win) {
    if(!(win instanceof TaskBar)) { 
      TaskBar.getTaskBar();
      windowList.add(win);
    }
  }

  public Vector getWindows() {
    return windowList;
  }

  public void maximize(Window win) {
    Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
    win.setSize(screen.width, screen.height);
  }

}

