/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.rudolph.taskbar.applets;

import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import java.util.Vector;
import java.util.StringTokenizer;
import com.acunia.wonka.rudolph.taskbar.*;
import com.acunia.wonka.rudolph.keyboard.*;

public class KeyboardApplet extends TaskBarApplet implements MouseListener {

  private static final byte[] kbdIconData_e = {
    -119,   80,   78,   71,   13,   10,   26,   10,    0,    0,    0,   13,   73,   72,   68,   82,    0,    0,    0,   20,    0,    0,    0,   15,    8,
       6,    0,    0,    0,  -28, -104,  -17,   85,    0,    0,    0,    6,   98,   75,   71,   68,    0,   -1,    0,   -1,    0,   -1,  -96,  -67,  -89,
    -109,    0,    0,    0,    9,  112,   72,   89,  115,    0,    0,   23,   13,    0,    0,   23,   13,    1,   88,   69,  108, -126,    0,    0,    0,
       7,  116,   73,   77,   69,    7,  -46,    1,   24,   10,   23,   20,   41,   33, -108,  121,    0,    0,    0,  120,   73,   68,   65,   84,  120,
    -100,  -75, -110,   81,   10,  -64,   32,   12,   67,  -45,   77,  -16,   -2,  -73,  -19, -121, -112,  125,  117,  116,   85,   68,  -89,   62,   16,
      74,  -43,  -48,   24, -123,   36,  -79, -111,    4,    0,   34,  -78,   69, -116,   36,  -82,  -40,  -80, -127,  103,  107,  -29,   35,  -72,    3,
      33,  -55,   99, -106,    1,   64, -117,   78,  -37,  -10,   84, -126,   -7,  -50,   75,   83,  -90,  -40,  -16,  -10,   71,  -22,  -56,   82,  -54,
      90,  -76,   47,   56,   75,  -21,  121,  -50,  -89,  -36,  -78,  -25, -105,  -39,  -12,  117,  119,   66,   19,   19, -111,  -22,   75,  -68, -105,
     -36,   94,  -68,   59, -100,  114,  -17, -100,   39,    1,  -19,  -76,   -2,  -14,    0,  -63,   46, -103, -128,  -19,  -46,   51,  -28,    0,    0,
       0,    0,   73,   69,   78,   68,  -82,   66,   96, -126
  };

  private static final byte[] kbdIconData_d = {
    -119,   80,   78,   71,   13,   10,   26,   10,    0,    0,    0,   13,   73,   72,   68,   82,    0,    0,    0,   20,    0,    0,    0,   15,    8,
       6,    0,    0,    0,  -28, -104,  -17,   85,    0,    0,    0,    6,   98,   75,   71,   68,    0,    0,    0,    0,    0,    0,   -7,   67,  -69,
     127,    0,    0,    0,    9,  112,   72,   89,  115,    0,    0,   23,   13,    0,    0,   23,   13,    1,   88,   69,  108, -126,    0,    0,    0,
       7,  116,   73,   77,   69,    7,  -46,    1,   24,   10,   24,   36, -120,   96,  -72,   26,    0,    0,    0,   97,   73,   68,   65,   84,  120,
    -100,  -43,  -45,   65,   10,  -64,   32,   12,   68,  -47,  -33,  -30,  -59,  114,  -14,   57,   90,  -70,   40,    5,   27,  117, -109,  102,   97,
       7,    4,   81, -116,  121, -117,   28, -110, -100,  -62,   52,    0,   51,   43,   41,   38, -119,   51,   30,   72,   74,  -19,  -97,  -68,   10,
      86,  -75,  -23,   64,  -55, -110,  -28,   67, -121,   25,  118,  -97,   -3,  -56,   -3,   -5, -127,   -4, -107,   11,   59, -110,    9,   -4,   54,
      -7,    0,  -72,  -89,  103,   70, -118,  119,  113,  -54,  126,   66,   94,  -47,   50,  -71,    0,  -85,   85,  -76,   22,  118,   47, -128,  -31,
       0,    0,    0,    0,   73,   69,   78,   68,  -82,   66,   96, -126
  };

  private static final byte[] kbdSelectData_d = {
    -119,   80,   78,   71,   13,   10,   26,   10,    0,    0,    0,   13,   73,   72,   68,   82,    0,    0,    0,   10,    0,    0,    0,   15,    8,
       6,    0,    0,    0,  -35,   -1,   94,   14,    0,    0,    0,    6,   98,   75,   71,   68,    0,    0,    0,    0,    0,    0,   -7,   67,  -69,
     127,    0,    0,    0,    9,  112,   72,   89,  115,    0,    0,   23,   11,    0,    0,   23,   11,    1,  -40,   70,   40,   25,    0,    0,    0,
       7,  116,   73,   77,   69,    7,  -46,    3,   25,   11,   35,   49,   26,  -79,  -19,   -5,    0,    0,    0,  -76,   73,   68,   65,   84,  120,
    -100, -107, -111,  -79,   13, -125,   64,   12,   69,   31,   81, -114,   13,  -82,   57,  -90,   97,   28,   22, -126,   37, -114,   25,   60,   11,
    -123,   93,  112,   27,  -32, -126,   84, -112, -100,   18,   37,  -60, -107,  101,   61,  -67,  111,  -39, -115, -120,  -20,   92,  -88,   59,   64,
     -33,   -9,   95,   33,   17,  -31,  118,  -59,    6,   92,    7,  -17,    0,   33,    4,   98, -116, -124,   16,  104, -102,    6, -128,  125,  -33,
     113,  119,   74,   41,   79,   48,  -58,  -56,   48,   12,  116,   93,   87, -127,  -86,  -54,   52,   77,   79,  -16,  -80,  -90, -108,  104,  -37,
      22, -128,  109,  -37,   88,  -41,  -75,  -34,  -79, -108,  -62,   60,  -49,  103,  -52,  -89,  -39,   13,  -64,  -35,   81,   85,  -52,   12,  119,
     -57,  -35,   49,   51,   84,   21,  119,  -81,  -93,   75,   41,  -28, -100,   73,   41,    1, -112,  115,  -82,   18,   78,  -16,  -80,   46,  -53,
       2,   80,  -39,   42,  -16,  -80, -114,  -29,  120,  -10,  111,  119,  124,  -75, -102,   25,  -97,  -22,  -65,  -49, -120,  -56,   79,  -16,    1,
     121,  -45,  107,   76,  100,   78,    9,   15,    0,    0,    0,    0,   73,   69,   78,   68,  -82,   66,   96, -126
  };

  private static final byte[] kbdSelectData_e = {
    -119,   80,   78,   71,   13,   10,   26,   10,    0,    0,    0,   13,   73,   72,   68,   82,    0,    0,    0,   10,    0,    0,    0,   15,    8,
       6,    0,    0,    0,  -35,   -1,   94,   14,    0,    0,    0,    6,   98,   75,   71,   68,    0,    0,    0,    0,    0,    0,   -7,   67,  -69,
     127,    0,    0,    0,    9,  112,   72,   89,  115,    0,    0,   23,   12,    0,    0,   23,   12,    1, -118,    2, -114,  102,    0,    0,    0,
       7,  116,   73,   77,   69,    7,  -46,    3,   25,   11,   34,   38, -128,  121,   89,  125,    0,    0,    0,  -72,   73,   68,   65,   84,  120,
    -100, -107, -111,   49, -110, -124,   48,   12,    4, -101,   45,  -86,  -60,   35, -100,  -63,   95,   -4,   33,  -98,  -63,   -5,    8,   92,  118,
    -124,   31, -127,   18,  -49,   37,   11,   44,  -63,  -35,  114,   19,  -73,  -70,   70,   82,   39,   73,   60,   72,   15,  -48,  117,  -35,  -97,
    -112,   36,   94,   79,  108,  -64,  115,  -80,    7,   48,   51,   66,    8, -104,  -39,   89,   67,   18,  -18,   78,  -83,  -11,    2,   67,    8,
      44,  -53,  -62,   52,   77,   55,   48,  -25,  -52,   60,  -49,   23,  120,   88,  -57,  113,  100,   24,    6,    0,  -10,  125,  103,  -37,  -74,
     -37,   70,   50,   51,  -59,   24, -107,   82,   82,  107,   77,  -83,   53,  -91, -108,   20,   99, -108, -103,   73, -110,   94,    0,  -18,   78,
     -50, -103,   82,   10,  -18, -114,  -69,   83,   74,   33,  -25, -116,  -69,   95,   70,  -32,  102,   -3,  -76,  -67,   17,  -99,   29,   15,  -21,
     -70,  -82,    0,  119,   27,  -48,   73,  -46,  -79,  -23,  113,   38, -128,   90,  -21,    9,   74,  -70, -125,  -65,  -27,   95,   47,  -20, -113,
    -119,  111,   -7,    1,   60,   27, -115,  -37,  -96,  -96,  -49, -119,    0,    0,    0,    0,   73,   69,   78,   68,  -82,   66,   96, -126
  };

  private class KeyboardItem {
    public String name;
    public Keyboard keyboard;

    public KeyboardItem(String name) {
      this.name = name;
    }
  }

  private class KeyboardSelect extends Window implements ItemListener {

    private List layoutList;

    public KeyboardSelect(Frame f, int x, int y) {
      super(f);

      layoutList = new List(2);

      for(int i=0; i < keyboardItems.size(); i++) {
        layoutList.add(((KeyboardItem)keyboardItems.elementAt(i)).name);
      }

      layoutList.addItemListener(this);

      add(layoutList);
      pack();
      this.setBounds(x, y, this.getSize().width, this.getSize().height);
    }

    public void itemStateChanged(ItemEvent e) {
      KeyboardItem keybItem;
      String item = (String)e.getItem();
      showSelection = false;
      selectMenu.setVisible(false);
      for(int i=0; i < keyboardItems.size(); i++) {
        keybItem = (KeyboardItem)keyboardItems.elementAt(i);
        if(item.equals(keybItem.name)) {
          keyboard = keybItem;
          layoutList.select(i);
          if(showKbd) {
            kbdWindow.setVisible(false);
            buildKeyboard();
            kbdWindow.setVisible(true);
          }
          else {
            buildKeyboard();
          }
        }
      }
      KeyboardApplet.this.repaint();
    }

  }
   
  private Image kbdIcon_e;
  private Image kbdIcon_d;
  private Image kbdSelect_e;
  private Image kbdSelect_d;
  private boolean showKbd = false;
  private boolean showSelection = false;
  private boolean selection = true;
  private Window kbdWindow;
  private KeyboardSelect selectMenu;
  private Vector keyboardItems;
  private KeyboardItem keyboard;
      
  public KeyboardApplet(TaskBar taskbar) {
    super(taskbar);
    
    kbdIcon_e = Toolkit.getDefaultToolkit().createImage(kbdIconData_e);
    kbdIcon_d = Toolkit.getDefaultToolkit().createImage(kbdIconData_d);
    kbdSelect_e = Toolkit.getDefaultToolkit().createImage(kbdSelectData_e);
    kbdSelect_d = Toolkit.getDefaultToolkit().createImage(kbdSelectData_d);

    keyboardItems = new Vector();
    StringTokenizer st = new StringTokenizer(taskbar.getProperties().getProperty("applet.keyboard.layouts", "Default"));
    while(st.hasMoreTokens()) {
      keyboardItems.add(new KeyboardItem(st.nextToken()));
    }

    keyboard = new KeyboardItem(taskbar.getProperties().getProperty("applet.keyboard.defaultlayout", "Default"));
    selection = Boolean.valueOf(taskbar.getProperties().getProperty("applet.keyboard.selectable", "false")).booleanValue();

    addMouseListener(this);
  }

  public void paint(Graphics g) {
    if(selection) {
      if(showSelection) {
        g.drawImage(kbdSelect_e, 20, 0, null);
      }
      else {
        g.drawImage(kbdSelect_d, 20, 0, null);
      }
    }
    if(showKbd) {
      g.drawImage(kbdIcon_e, 0, 0, null);
    }
    else {
      g.drawImage(kbdIcon_d, 0, 0, null);
    }
  }

  public Dimension getPreferredSize() {
    return new Dimension((selection ? 30 : 20), 15);
  }

  public Dimension getMinimumSize() {
    return new Dimension((selection ? 30 : 20), 15);
  }
  
  public Dimension getMaximumSize() {
    return new Dimension((selection ? 30 : 20), 15);
  }

  private void buildKeyboard() {
    try {
      Class cl = Class.forName("com.acunia.wonka.rudolph.keyboard.Keyboard" + keyboard.name);
      Constructor con = cl.getConstructor(new Class[]{});
      keyboard.keyboard = (Keyboard)con.newInstance(new Object[]{});

      kbdWindow = new Window(taskbar);
      kbdWindow.add(keyboard.keyboard);
      kbdWindow.addMouseListener(this);
      keyboard.keyboard.addMouseListener(this);

      /*
       ** Get the location of the keyboard window.
       */

      int top = 0;
      int bottom = Toolkit.getDefaultToolkit().getScreenSize().height;

      String loc = taskbar.getProperties().getProperty("applet.keyboard.location", "bottom");

      if(loc.equals("top")) {
        kbdWindow.setBounds(0, top, keyboard.keyboard.getPreferredSize().width, keyboard.keyboard.getPreferredSize().height);
      }
      else if(loc.equals("bottom")) {
        kbdWindow.setBounds(0, bottom - keyboard.keyboard.getPreferredSize().height, 
                            keyboard.keyboard.getPreferredSize().width, keyboard.keyboard.getPreferredSize().height);
      }
      else if(loc.equals("taskbar")) {
        kbdWindow.setBounds(0, 0, keyboard.keyboard.getPreferredSize().width, keyboard.keyboard.getPreferredSize().height);
      }

    } catch(Exception e) {
      System.err.println("Could not load keyboard layout: " + keyboard.name);
    }
  }

  public void mouseClicked(MouseEvent event) {
    if(event.getSource() == this) {
      if(event.getX() <= 20) {

        /*
        ** The keyboard icon is pressed.
        */
        
        if(showKbd) {
          showKbd = false;
          kbdWindow.setVisible(false);
        }
        else {
          if(kbdWindow == null) {

            /*
            ** No keyboard window yet, build it.
            */

            buildKeyboard();
          }

          showKbd = true;
          kbdWindow.setVisible(true);
        }
      }
      else {

        /*
        ** The selection icon is pressed.
        */

        if(showSelection) {
          showSelection = false;
          selectMenu.setVisible(false);
        }
        else {
          if(selectMenu == null) {
            selectMenu = new KeyboardSelect(taskbar, getLocationOnScreen().x + 20, getLocationOnScreen().y);
          }

          showSelection = true;
          selectMenu.setVisible(true);
          selectMenu.toFront();
        }
      }
      repaint();
    }

    if(kbdWindow != null && showKbd) kbdWindow.setVisible(true);
    if(selectMenu != null && showSelection) selectMenu.setVisible(true);
  }
  
  public void mouseEntered(MouseEvent event) {
  }
  
  public void mouseExited(MouseEvent event) {
  }
  
  public void mousePressed(MouseEvent event) {
    if(kbdWindow != null && showKbd) kbdWindow.setVisible(true);
    if(selectMenu != null && showSelection) selectMenu.setVisible(true);
  }
 
  public void mouseReleased(MouseEvent event) {
    if(kbdWindow != null && showKbd) kbdWindow.setVisible(true);
    if(selectMenu != null && showSelection) selectMenu.setVisible(true);
  }
  
}

