/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/



package java.awt;

final public class SystemColor extends Color {

  /************************************************************/
  /** variables*/
  int index;
  static int[] colors;

  /************************************************************/
  /** static definitions colornames*/
  final public static byte DESKTOP = 0;
  final public static byte ACTIVE_CAPTION = 1;
  final public static byte ACTIVE_CAPTION_TEXT = 2;
  final public static byte ACTIVE_CAPTION_BORDER = 3;
  final public static byte INACTIVE_CAPTION = 4;
  final public static byte INACTIVE_CAPTION_TEXT = 5;
  final public static byte INACTIVE_CAPTION_BORDER = 6;
  final public static byte WINDOW = 7;
  final public static byte WINDOW_BORDER = 8;
  final public static byte WINDOW_TEXT = 9;
  final public static byte MENU = 10;
  final public static byte MENU_TEXT = 11;
  final public static byte TEXT = 12;
  final public static byte TEXT_TEXT = 13;
  final public static byte TEXT_HIGHLIGHT = 14;
  final public static byte TEXT_HIGHLIGHT_TEXT = 15;
  final public static byte TEXT_INACTIVE_TEXT = 16;
  final public static byte CONTROL = 17;
  final public static byte CONTROL_TEXT = 18;
  final public static byte CONTROL_HIGHLIGHT = 19;
  final public static byte CONTROL_LT_HIGHLIGHT = 20;
  final public static byte CONTROL_SHADOW = 21;
  final public static byte CONTROL_DK_SHADOW = 22;
  final public static byte SCROLLBAR = 23;
  final public static byte INFO = 24;
  final public static byte INFO_TEXT = 25;
  
  /************************************************************/
  /** static definitions SystenColor colors*/

  final public static SystemColor desktop;
  final public static SystemColor activeCaption;
  final public static SystemColor activeCaptionText;
  final public static SystemColor activeCaptionBorder;
  final public static SystemColor inactiveCaption;
  final public static SystemColor inactiveCaptionText;
  final public static SystemColor inactiveCaptionBorder;
  final public static SystemColor window;
  final public static SystemColor windowBorder;
  final public static SystemColor windowText;
  final public static SystemColor menu;
  final public static SystemColor menuText;
  final public static SystemColor text;
  final public static SystemColor textText;
  final public static SystemColor textHighlight;
  final public static SystemColor textHighlightText;
  final public static SystemColor textInactiveText;
  final public static SystemColor control;
  final public static SystemColor controlText;
  final public static SystemColor controlHighlight;
  final public static SystemColor controlLtHighlight;
  final public static SystemColor controlShadow;
  final public static SystemColor controlDkShadow;
  final public static SystemColor scrollbar;
  final public static SystemColor info;
  final public static SystemColor infoText;

	
  /************************************************************/
  /** static definitions color values*/
  static {
    colors = new int[26];
	
    colors[0]  = 0x8b0000;    // desktop
    colors[1]  = 0x00009b;    // active_caption
    colors[2]  = 0xffffff;    // active_caption_text
    colors[3]  = 0xcdcdcd;    // active_caption_border
    colors[4]  = 0x575757;    // inactive_caption
    colors[5]  = 0xcdcdcd;    // inactive_caption_text
    colors[6]  = 0xcdcdcd;    // inactive_caption_border
    colors[7]  = 0xd3d3d3;    // window
    colors[8]  = 0xffffffff;  // window_border
    colors[9]  = 0x000000;    // window_text
    colors[10] = 0xffffffff;  // menu
    colors[11] = 0xffffffff;  // menu_text
    colors[12] = 0xffffffff;  // text
    colors[13] = 0xffffffff;  // text_text
    colors[14] = 0xffffffff;  // text_highlight
    colors[15] = 0xffffffff;  // text_highlight_text
    colors[16] = 0xffffffff;  // text_inactive_text
    colors[17] = 0xd3d3d3;    // control
    colors[18] = 0x000000;    // controlText
    colors[19] = 0xffffff;    // control_highlight
    colors[20] = 0xffffffff;  // control_lt_highlight
    colors[21] = 0x575757;    // control_shadow
    colors[22] = 0x575757;    // control_dk_shadow
    colors[23] = 0xd3d3d3;    // scrollbar
    colors[24] = 0xd3d3d3;    // info
    colors[25] = 0x000000;    // info_text

    desktop = new SystemColor(DESKTOP);
    activeCaption = new SystemColor(ACTIVE_CAPTION);
    activeCaptionText = new SystemColor(ACTIVE_CAPTION_TEXT);
    activeCaptionBorder = new SystemColor(ACTIVE_CAPTION_BORDER);
    inactiveCaption = new SystemColor(INACTIVE_CAPTION);
    inactiveCaptionText = new SystemColor(INACTIVE_CAPTION_TEXT);
    inactiveCaptionBorder = new SystemColor(INACTIVE_CAPTION_BORDER);
    window = new SystemColor(WINDOW);
    windowBorder = new SystemColor(WINDOW_BORDER);
    windowText = new SystemColor(WINDOW_TEXT);
    menu = new SystemColor(MENU);
    menuText = new SystemColor(MENU_TEXT);
    text = new SystemColor(TEXT);
    textText = new SystemColor(TEXT_TEXT);
    textHighlight = new SystemColor(TEXT_HIGHLIGHT);
    textHighlightText = new SystemColor(TEXT_HIGHLIGHT_TEXT);
    textInactiveText = new SystemColor(TEXT_INACTIVE_TEXT);
    control = new SystemColor(CONTROL);
    controlText = new SystemColor(CONTROL_TEXT);
    controlHighlight = new SystemColor(CONTROL_HIGHLIGHT);
    controlLtHighlight = new SystemColor(CONTROL_LT_HIGHLIGHT);
    controlShadow = new SystemColor(CONTROL_SHADOW);
    controlDkShadow = new SystemColor(CONTROL_DK_SHADOW);
    scrollbar = new SystemColor(SCROLLBAR);
    info = new SystemColor(INFO);
    infoText = new SystemColor(INFO_TEXT);
  }

  /************************************************************/
  /** Constructor */
  SystemColor(byte index) {
    super(colors[index]);
    this.index = index;
  }

  /************************************************************/
  /** RGB function */
  public int getRGB() {
    return colors[index];
  }

  /************************************************************/
  /** diagnostics */
  public String toString () {
    return "SystemColor [r = "+ getRed() +", g = "+ getGreen() +", b = " + getBlue() + "]";
  }
}
