/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


package java.awt;

import java.awt.image.*;
import java.net.URL;

public abstract class Toolkit extends Object {

  static {
    Component.initRudolph();
  }

  public abstract void beep();

  public abstract int checkImage(Image image, int w, int h, ImageObserver observer);

  public abstract Image createImage(ImageProducer producer);

  public abstract Image createImage(String filename);

  public abstract Image createImage(byte[] imageData);

  public abstract Image createImage(byte[] imageData, int offset, int count);

  public abstract Image createImage(java.net.URL url);

  public abstract ColorModel getColorModel();
  
  public static synchronized Toolkit getDefaultToolkit() {
    return (java.awt.Toolkit)com.acunia.wonka.rudolph.Toolkit.getInstance();
  }

  public abstract String[] getFontList();
  
  public abstract FontMetrics getFontMetrics(Font font);

  public abstract Image getImage(String filename);

  public abstract Image getImage(URL url);
  
  public abstract int getMenuShortcutKeyMask();

  protected static Container getNativeContainer(Component component) {
    return null;
  }
  
  //public abstract PrintJob getPrintJob(Frame frame, String title, Properties properties);

  public static String getProperty(String key, String defaultValue) {
    return defaultValue;
  }
  
  public abstract int getScreenResolution();
  
  public abstract Dimension getScreenSize();
  
  //public abstract ClipBoard getSystemClipboard();

  public EventQueue getSystemEventQueue() {
    return null;
  }

  protected abstract EventQueue getSystemEventQueueImpl();

  protected void loadSystemColors(int[] systemColors) {
  }

  public abstract boolean prepareImage(Image image, int w, int h, ImageObserver observer);

  public abstract void sync();

}

