/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/* $Id: BufferImageSource.c,v 1.4 2002/03/20 10:54:07 dbuytaert Exp $ */

#include <string.h>
#include <stdio.h>

#include "awt-classes.h"  // F_Component_*, F_Graphics_*
#include "realms.h"
#include "threads.h"       // currentWonkaThread
#include "ts-mem.h"       // allocMem(), releaseMem()
#include "stack.h"
#include "heap.h"

#include "arrays.h"        // Array stuff
#include "canvas.h"       // r_Buffer
#include "Image.h"

w_void BufferImageSource_getImageData(JNIEnv *env, jobject thisObject, jobject imageInstance) { 
  w_thread thread = currentWonkaThread;
  r_image  image = (r_image)imageInstance[F_Image_wotsit];
  w_int    w = image->w;
  w_int    h = image->h;
  w_int    length = w * h;
  w_int    *result;
  w_int    x;
  w_int    y;
 
  thisObject[F_BufferImageSource_pixels] = (w_int)allocArrayInstance(thread, atype2clazz[P_int], 1, &length); 
  result = instance2Array_int((w_instance)thisObject[F_BufferImageSource_pixels]);

  for (y = 0; y < h; y++) {
    for (x = 0; x < w; x++) {
      *result = pixelget(image->buffer->buffer, image->buffer->fw, x, y);
      result++;
    }
  }
  
  return;
}

