/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/* $Id: PNGImageSource.c,v 1.4 2002/02/20 09:03:19 dfrederickx Exp $ */

#include <string.h>
#include <stdio.h>

#include "awt-classes.h"  // F_Component_*, F_Graphics_*
#include "realms.h"
#include "threads.h"       // currentWonkaThread
#include "ts-mem.h"       // allocMem(), releaseMem()
#include "stack.h"
#include "heap.h"

#include "png.h"          // PNG reader
#include "arrays.h"        // Array stuff

w_void PNGImageSource_readImage(JNIEnv *env, jobject thisObject, jbyteArray imagedata) {
  
  w_thread     thread = currentWonkaThread;
  w_png_image  p;
  w_ubyte      *start = instance2Array_byte(imagedata);
  w_int        *result;
  w_int        length = instance2Array_length(imagedata);

  // return rgba image
  p = w_png_read(start, (signed)length);    

  if(p == NULL || p->data == NULL) {
    woempa(10, "WARNING: could not load PNG image.\n");
    return;
  }

  // Initialize PNGImageSource where possible:
  thisObject[F_PNGImageSource_width] = p->width;
  thisObject[F_PNGImageSource_height] = p->height;

  length = p->width * p->height;
  thisObject[F_PNGImageSource_pixels] = (w_int)allocArrayInstance(thread, atype2clazz[P_int], 1, &length); 

  if(thisObject[F_PNGImageSource_pixels]) {
    
    result = instance2Array_int((w_instance)thisObject[F_PNGImageSource_pixels]);
    memcpy(result, p->data, (w_word)(p->width * p->height * 4));

  }
  else {
    woempa(10, "WARNING: could not allocate array to hold image data.\n");
  }
  
  // Release memory:
  releaseMem(p->data);
  releaseMem(p);  
  
  return;
}

