/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/* $Id: Label.c,v 1.4 2002/02/20 09:03:04 dfrederickx Exp $ */

#include "awt-classes.h"  // F_Label_*
#include "strings.h"      // cstring2String() 
#include "ts-mem.h"       // allocMem(), releaseMem()
#include "realms.h"
#include "threads.h"	  // currentWonkaThread

#include "canvas.h"
#include "platform.h"

#include "Component.h"
#include "Font.h"
#include "Label.h"

void Label_createPeer(JNIEnv *env, jobject thisLabel) {
             
  r_component component = (r_component)thisLabel[F_Component_wotsit];
  component->tag = Z_LABEL;

}

void Label_drawLabel(r_buffer buffer, r_component component) {

  w_instance labelInstance = component->instance;
 
  // Retrieve coordinates:
  w_int x = (w_int)labelInstance[F_Component_x];
  w_int y = (w_int)labelInstance[F_Component_y];
  w_int h = (w_int)labelInstance[F_Component_height];
  w_int w = (w_int)labelInstance[F_Component_width];
                           
  // Retrieve label/text:
  w_instance stringInstance = (w_instance)labelInstance[F_Label_text];
  w_string string = (w_string)stringInstance[F_String_wotsit];
    
  w_instance fcol;
  r_font font;
  
  // Retrieve label alignment:
  unsigned int alignment = (unsigned int)labelInstance[F_Label_alignment];

  // Retrieve font:
  Component_getFont(component, &font);

  // Retrieve foreground color:
  Component_getForeground(component, &fcol, Component_getColor(F_SystemColor_controlText));
                          
  // Debug output:
  // woempa(9, "called Label_draw('%w'): x = %i, y = %i, w = %i, h = %i\n", string, x, y, w, h);

  // Draw truetype string:
  Font_drawStringAligned(buffer, font, x, y, w, h, string, color2pixel(fcol), alignment);

}

