/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: ScrollPane.c,v 1.11 2002/03/20 13:04:20 gray Exp $ 
*/

#include "ts-mem.h"       // allocMem(), releaseMem()
#include "realms.h"
#include "strings.h"      // cstring2String()
#include "threads.h"       // currentWonkaThread
#include "loading.h"      // instance2clazz()
#include "awt-classes.h"  // F_ScrollPane_*
#include "canvas.h"
#include "Component.h"

void ScrollPane_setViewport(JNIEnv * env, w_instance this, w_instance instance, int x, int y, int w, int h) {
  r_component component = (r_component)instance[F_Component_wotsit];
  r_canvas canvas = (r_canvas)component->object;
  
  woempa(9, "component '%k' %p: buffer[w = %d, h = %d], viewport[x = %d, y = %d, w = %d, h = %d], canvas %p\n", (instance2clazz(instance)), instance, canvas->buffer->fw, canvas->buffer->fh, x, y, w, h, canvas);
  
  canvas->buffer->ox = x;
  canvas->buffer->oy = y;
  canvas->buffer->vw = w;
  canvas->buffer->vh = h;
}

