###########################################################################
# Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 #
#                                                                         #
# This software is copyrighted by and is the sole property of Acunia N.V. #
# and its licensors, if any. All rights, title, ownership, or other       #
# interests in the software remain the property of Acunia N.V. and its    #
# licensors, if any.                                                      #
#                                                                         #
# This software may only be used in accordance with the corresponding     #
# license agreement. Any unauthorized use, duplication, transmission,     #
#  distribution or disclosure of this software is expressly forbidden.    #
#                                                                         #
# This Copyright notice may not be removed or modified without prior      #
# written consent of Acunia N.V.                                          #
#                                                                         #
# Acunia N.V. reserves the right to modify this software without notice.  #
#                                                                         #
#   Acunia N.V.                                                           #
#   Vanden Tymplestraat 35      info@acunia.com                           #
#   3000 Leuven                 http://www.acunia.com                     #
#   Belgium - EUROPE                                                      #
###########################################################################

.file "call-stack.s"

.text
.align 4
.global cs_skip_caller

#
# cs_skip_caller(unsigned int address)
#
#   Overwrite the caller's return address by the specified address.  Make
#   sure that the given address points to a "leave" instruction such that
#   it will take care of restoring the correct stack pointer.
# 

cs_skip_caller:
  push   %ebp                    # save the old base pointer
  mov    %esp, %ebp              # intialize the new base pointer
  mov    0x8(%ebp), %edx         # load the specified address in %edx
  mov    (%ebp), %eax            # load the caller's base pointer
  mov    %edx, 0x4(%eax)         # overwrite the caller's return address
  leave                          # prepare the stack for returning  
  ret                            # return
