#ifndef _J_ASSEMBLER_H
#define _J_ASSEMBLER_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: assembler.h,v 1.5 2002/03/13 11:26:29 dbuytaert Exp $ 
*/

typedef struct j_Asm {
  j_ref refs;
  char *base;
  char *step;
  int size;
} j_Asm;

typedef struct j_Ref {
  char * address;
  j_node dst;
  j_ref next;
} j_Ref;

j_asm asm_create_block(void);
  /* Create a new block for assembly code. */

void asm_free_block(j_asm block);
  /* Free a block of assembly code. */

int asm_emit(j_asm block, int endian, int count, ...);
  /* Emit (append) one or more instructions to the block. */

void asm_dump(j_asm block);
  /* Print the specified block of assembly code to the screen. */

char *asm_insn(j_word inst);
  /* Print a bit-wise representation of the specified instruction. */

char *asm_export(j_asm block);
  /* Export a block of assembly code. */

void asm_add_reference(j_asm block, char * address, j_node dst);
  /* Register a node's address to the assembler. */

void asm_patch_references(j_asm block);
  /* Patch the backward and forward references within a block. */
  
#endif
