#ifndef _J_IR_H
#define _J_IR_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: ir.h,v 1.39 2002/03/15 10:43:43 dbuytaert Exp $ 
*/

#include "j-spot.h"
#include "method.h"
#include "node.h"

#define j_link_next        -1
#define j_link_none        -2
#define j_insert_before     0
#define j_insert_after      1

typedef struct j_Edge {
  int target;
  int label;
  j_edge next;
} j_Edge;

void ir_add_node(j_method method, j_node node, int tedge, int fedge, int offset);
  /* Add a node to the control flow graph with the specified 'true' and 'false' edges. */

j_node ir_get_node(j_method method, int pc);
  /* Get the node at the specified program counter. */

j_node ir_get_branch(j_method method, j_node node);
  /* Get the outgoing node that branches. */

int ir_is_jump(j_node node);
  /* Check whether the given node is a conditional or unconditional jump. */
 
int ir_is_join(j_node node);
  /* Check whether the given node is a join point. */

void ir(j_method method);
  /* Construct the control flow graph. */

/*
** Register:
** ---------
*/

typedef struct j_Map {
  j_opcode opcode;
  int res;
  int op1;
  int op2;
  int flags;
} j_Map;

#endif /* _J_IR_H */
