#ifndef _J_SPOT_H
#define _J_SPOT_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: j-spot.h,v 1.9 2002/02/27 13:26:43 dbuytaert Exp $ 
*/

#include <stdio.h>
#include "wonka.h"
#include "settings.h"

/* 
**`flarp' is yet another metasyntactic variable like foo, mummble, woempa.
** Among those who use it, it is associated with a legend that any program
** not containing the word `flarp' somewhere will not work.  The legend is
** discreetly silent on the reliability of programs which _do_ contain the
** magic word:
*/

#define j_flarp(color, format, a...)   \
  fprintf(stderr, "\e[1;3%dm", color); \
  woempa(9, format, ##a);              \
  fprintf(stderr, "\e[m")

/*
** The color codes that can be used by flarp:
*/

#define red      0x01
#define green    0x02
#define yellow   0x03
#define blue     0x04
#define purple   0x05
#define magenta  0x06
#define white    0x07

/*
** Type definitions
*/

typedef unsigned int j_word;
typedef struct j_Method * j_method;
typedef struct j_Node * j_node;
typedef struct j_Edge * j_edge;
typedef struct j_Asm * j_asm;
typedef struct j_Ref * j_ref;

static inline char *j_spaces(const int depth) { 
  const char *spaces = "                                          ";  // 40 spaces
  return (char *)(spaces + strlen(spaces) - (2 * depth));
}
      
#endif 
