#ifndef _J_MIMIC_STACK_H
#define _J_MIMIC_STACK_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: mimic-stack.h,v 1.5 2002/03/25 16:18:28 dbuytaert Exp $ 
*/

#include "j-spot.h"

void ms_init(j_method method);
  /* Initializes the mimic stack. */
  
int ms_push(void * item);
  /* Pushes new item on the mimic stack. */

void * ms_pop(void);
  /* Pops an item off the mimic stack. */
  
void * ms_top(void);
  /* Retrieves the top stack item. */

void * ms_get(int depth);
  /* Get the item on the specified stack location. */

void ms_set(int depth, void * item);
  /* Set the ekement on the specified stack location. */

void ms_dup1(void);
  /* Duplicate the top stack item. */

void ms_dup1_x1(void);
  /* Duplicate the top stack item and insert a new item beneath the second item. */

void ms_dup1_x2(void);
  /* Duplicate the top stack item and insert a new item beneath the third item. */

void ms_dup2(void);
  /* Duplicate the top two stack items. */

void ms_dup2_x1(void);
  /* Duplicate the top two stack items and insert a new item beneath the third item. */

void ms_dup2_x2(void);
  /* Duplicate the top two stack items and insert a new item beneath the forth item. */

void ms_swap(void);
  /* Swaps the top two items on the mimic stack. */

void ms_flap(void);
  /* Unfolds, suspends or saves the current stack state. */

void ms_flop(void);
  /* Restores or resumes the last suspended stack stack. */

int ms_next(void);
  /* Checks if there are one or more saved stack states. */
 
void ms_set_local(j_method method, j_node node, int index);
  /* Register a local variable. */

j_node ms_get_local(j_method method, int index);
  /* Retrieve a local variable. */

void ms_dump(void);
  /* Dumps the current stack to the screen or terminal. */

#endif
