#ifndef _J_RT_HOOKS_H
#define _J_RT_HOOKS_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: rt-hooks.h,v 1.7 2002/03/13 15:48:14 dbuytaert Exp $ 
*/

#include "j-spot.h"

/*
** Run-time intefaces:
*/

int rt_cmp(j_method method, j_node s1, j_node s2);
  /* Returns 1 if s1 > s2, 0 if s1 = s2 and -1 if s1 < s2. */
   
int rt_monitorenter(j_method method, j_node symbol);
  /* Enter monitor for the object reference in symbol. */
  
int rt_monitorexit(j_method method, j_node symbol);
  /* Exit monitor for the object reference in symbol. */

int rt_athrow(j_method method, j_node symbol);
  /* Throw an exception. */

int rt_putfield(w_instance instance, w_field field, j_word value);
  /* Set a field in the object reference in symbol. */

int rt_getfield(w_instance instance, w_field field);
  /* Get a field in the object reference in symbol. */

int rt_putstatic(w_field field, j_word value);
  /* Set a static field in the object reference in symbol. */

int rt_getstatic(j_word * data);
  /* Get a static field in the object reference in symbol. */

int rt_new(w_clazz clazz);
  /* Create a new instance of the specified class. */

int rt_instanceof(w_instance instance, w_clazz clazz);
  /* Determine whether an instance is of a given type. */

int rt_checkcast(w_instance instance, w_clazz clazz);
  /* Ensure that an instance is of the given type. */

int rt_invokevirtual(w_method method, w_instance instance, ...);
  /* Invoke an instance method. */

int rt_invokespecial(w_method method1, w_method method2, ...);
  /* Invoke an instance method. */

int rt_invokestatic(w_method method, ...);
  /* Invoke a class method. */

int rt_array_create(w_clazz clazz, int dimensions, ...);
  /* Create a new array of primitive type components. */

int rt_array_load(w_instance array, int index, int type);
  /* Load a value from the specified array at the given location. */

int rt_array_store(w_instance array, int index, int value, int type);
  /* Store a value into the specified array at the given location. */

int rt_array_length(w_instance array);
  /* Get the length of an array. */

#endif
