/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class ArithmeticOperationsTest  {

  /*
  ** The "int_" functions will never be compiled.
  */

  int int_iadd(int a, int b) {
    return a + b;
  }

  int int_isub(int a, int b) {
    return a - b;
  }

  int int_imul(int a, int b) {
    return a * b;
  }

  int int_idiv(int a, int b) {
    return a / b;
  }

  int int_ineg(int a) {
    return - a;
  }

  /*
  ** The "com_" functions will awlays be compiled.
  */

  int com_iadd(int a, int b) {
    return a + b;
  }

  int com_isub(int a, int b) {
    return a - b;
  }

  int com_imul(int a, int b) {
    return a * b;
  }

  int com_idiv(int a, int b) {
    return a / b;
  }

  int com_ineg(int a) {
    return - a;
  }

  public void run(JTest jt) {

    /*
    ** To test the arithmetic operations both using positive and negative
    ** numbers, we let 'i' and 'j' itererate from a negative to a positive
    ** value.
    */

    for (int i = -5; i < 5; i++) {
      for (int j = -5; j < 5; j++) {
        jt.assert(int_iadd(i, j), com_iadd(i, j), "ArithemeticOperationsTest.com_iadd("+ i +", "+ j +")");
        jt.assert(int_isub(i, j), com_isub(i, j), "ArithemeticOperationsTest.com_isub("+ i +", "+ j +")");
        jt.assert(int_imul(i, j), com_imul(i, j), "ArithemeticOperationsTest.com_imul("+ i +", "+ j +")");
        // jt.assert(test_idiv(i, j), com_idiv(i, j), "ArithemeticOperationsTest.com_idiv("+ i +", "+ j +")");
        jt.assert(int_ineg(i), com_ineg(i), "ArithemeticOperationsTest.com_ineg("+ i +")");
      }
    }
  }
}

