/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class ComparisonTest  {

  /*
  ** The "int_" functions will never be compiled.
  */

  public boolean int_if_icmplt(int x, int y) {
    return (x < y);
  }

  public boolean int_if_icmpgt(int x, int y) {
    return (x > y);
  }

  public boolean int_if_icmple(int x, int y) {
    return (x <= y);
  }

  public boolean int_if_icmpge(int x, int y) {
    return (x >= y);
  }

  public boolean int_if_icmpeq(int x, int y) {
    return (x == y);
  }

  public boolean int_if_icmpne(int x, int y) {
    return (x != y);
  }

  public boolean int_iflt(int x) {
    return (x < 0);
  }

  public boolean int_ifgt(int x) {
    return (x > 0);
  }

  public boolean int_ifle(int x) {
    return (x <= 0);
  }

  public boolean int_ifge(int x) {
    return (x >= 0);
  }

  public boolean int_ifeq(int x) {
    return (x == 0);
  }

  public boolean int_ifne(int x) {
    return (x != 0);
  }

  public boolean int_ifnull(Object o) {
    return (o == null);
  }

  public boolean int_ifnonnull(Object o) {
    return (o != null);
  }

  public boolean int_if_acmpeq(Object x, Object y) {
    return (x == y);
  } 
 
  public boolean int_if_acmpne(Object x, Object y) {
    return (x != y);
  }

  public int int_comparison_1(int x) {

    /*
    ** An if-else block.
    */

    int state = 0;

    if (x < 0) {
      state = state + x;
    }
    else {
      state = state - x;
    }
    
    return state;
  } 

  public int int_comparison_2(int x) {
    
    /*
    ** An if-elseif-else block.
    */

    int state = 0;

    if (x < -2) {
      state = 1;
    }
    else if (x < 0) {
      state = 2;
    }
    else if (x == 0) {
      state = 3;
    }
    else if (x < 3) {
      state = 4;
    }
    else {
      state = 5;
    }

    return state;
  }

  public int int_comparison_3(int x) {

    /*
    ** Multiple adjecent if blocks.
    */

    int state = 0;

    if (state < -2) {
      state = state + 1;
    }

    if (state < 0) {
      state = state + 1;
    }

    if (state == 0) {
      state = state + 1;
    }

    if (state < 3) {
      state = state + 1;
    }

    if (state < 5) {
      state = state + 1;
    }

    return state;
  }

  public int int_comparison_4(int x) {

    /*
    ** Multiple adjecent if-else blocks.
    */

    int state = 0;

    if (state < -2) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (state < 0) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (state == 0) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (state < 3) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (state < 5) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    return state;
  }

  public int int_comparison_5(int x) {

    /*
    ** Expressions in the if clause.
    */

    int state = 0;

    if (x > 0 && x < 5) {
      state = state + 1;
    }

    if (x > 2 && x < 3) {
      state = state + 1;
    }

    if (x < 0 || x > 5) {
      state = state + 1;
    }

    if (x < 2 || x > 3) {
      state = state + 1;
    }

    if ((x & 1) == 1 && (x & 2) == 1) {
      state = state + 1;
    }
  
    if ((x | 1) == 1 || (x | 2) == 2) {
      state = state + 1;
    }
   
    return state;
  }

  public int int_tableswitch_1(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 5;
        break;
      case 2:
        state = 4;
        break;
      case 3:
        state = 3;
        break;
      case 4:
        state = 2;
        break;
      default:
        state = 1;
    }

    return state;
  }

  public int int_tableswitch_2(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 4;
        break;
      case 2:
        state = 3;
        break;
      case 3:
        state = 2;
        break;
      default:
        state = 1;
    }

    switch (state) {
      case 4:
        state = 8;
        break;
      case 5:
        state = 7;
        break;
      case 6:
        state = 6;
        break;
      default:
        state = 5;
    }

    return state;
  }

  public int int_tableswitch_3(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 7;
        break;
      case 2:
        state = 6;
        break;
      case 3:
        state = 5;
        break;
      default:

        switch (x) {
          case 4:
            state = 4;
            break;
          case 5:
            state = 3;
            break;
          case 6:
            state = 2;
            break;
          default:
            state = 1;
        }
    }

    return state;
  }

  public int int_lookupswitch_1(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        state = 6;
        break;
      case 1:
        state = 5;
        break;
      case 2:
        state = 4;
        break;
      case 3:
        state = 3;
        break;
      case 4:
        state = 2;
        break;
      default:
        state = 1;
    }

    return state;
  }

  public int int_lookupswitch_2(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        break;
      case 1:
        state = 4;
        break;
      case 2:
        state = 3;
        break;
      case 3:
        state = 2;
        break;
      default:
        state = 1;
    }

    switch (state) {
      case 100000:
        break;
      case 4:
        state = 8;
        break;
      case 5:
        state = 7;
        break;
      case 6:
        state = 6;
        break;
      default:
        state = 5;
    }

    return state;
  }

  public int int_lookupswitch_3(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        break;
      case 1:
        state = 7;
        break;
      case 2:
        state = 6;
        break;
      case 3:
        state = 5;
        break;
      default:

        switch (x) {
          case 100000:
            break;
          case 4:
            state = 4;
            break;
          case 5:
            state = 3;
            break;
          case 6:
            state = 2;
            break;
          default:
            state = 1;
        }
    }

    return state;
  }

  /*
  ** The "com_" functions will always be compiled.
  */

  public boolean com_if_icmplt(int x, int y) {
    return (x < y);
  }

  public boolean com_if_icmpgt(int x, int y) {
    return (x > y);
  }

  public boolean com_if_icmple(int x, int y) {
    return (x <= y);
  }

  public boolean com_if_icmpge(int x, int y) {
    return (x >= y);
  }

  public boolean com_if_icmpeq(int x, int y) {
    return (x == y);
  }

  public boolean com_if_icmpne(int x, int y) {
    return (x != y);
  }

  public boolean com_iflt(int x) {
    return (x < 0);
  }

  public boolean com_ifgt(int x) {
    return (x > 0);
  }

  public boolean com_ifle(int x) {
    return (x <= 0);
  }

  public boolean com_ifge(int x) {
    return (x >= 0);
  }

  public boolean com_ifeq(int x) {
    return (x == 0);
  }

  public boolean com_ifne(int x) {
    return (x != 0);
  }

  public boolean com_ifnull(Object o) {
    return (o == null);
  }

  public boolean com_ifnonnull(Object o) {
    return (o != null);
  }

  public boolean com_if_acmpeq(Object x, Object y) {
    return (x == y);
  }

  public boolean com_if_acmpne(Object x, Object y) {
    return (x != y);
  }

  public int com_comparison_1(int x) {

    /*
    ** An if-else block.
    */

    int state = 0;

    if (x < 0) {
      state = state + x;
    }
    else {
      state = state - x;
    }

    return state;
  } 

  public int com_comparison_2(int x) {

    /*
    ** An if-elseif-else block.
    */

    int state = 0;

    if (x < -2) {
      state = 1;
    }
    else if (x < 0) {
      state = 2;
    }
    else if (x == 0) {
      state = 3;
    }
    else if (x < 3) {
      state = 4;
    }
    else {
      state = 5;
    }

    return state;
  }

  public int com_comparison_3(int x) {

    /*
    ** Multiple adjecent if blocks.
    */

    int state = 0;

    if (state < -2) {
      state = state + 1;
    }

    if (state < 0) {
      state = state + 1;
    }

    if (state == 0) {
      state = state + 1;
    }

    if (state < 3) {
      state = state + 1;
    }

    if (state < 5) {
      state = state + 1;
    }

    return state;
  }

  public int com_comparison_4(int x) {

    /*
    ** Multiple adjecent if-else blocks.
    */

    int state = 0;

    if (state < -2) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (state < 0) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (state == 0) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (state < 3) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (state < 5) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    return state;
  }

  public int com_comparison_5(int x) {

    /*
    ** Expressions in the if clause.
    */

    int state = 0;

    if (x > 0 && x < 5) {
      state = state + 1;
    }

    if (x > 2 && x < 3) {
      state = state + 1;
    }

    if (x < 0 || x > 5) {
      state = state + 1;
    }

    if (x < 2 || x > 3) {
      state = state + 1;
    }

    if ((x & 1) == 1 && (x & 2) == 1) {
      state = state + 1;
    }
  
    if ((x | 1) == 1 || (x | 2) == 2) {
      state = state + 1;
    }
   
    return state;
  }

  public int com_tableswitch_1(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 5;
        break;
      case 2:
        state = 4;
        break;
      case 3:
        state = 3;
        break;
      case 4:
        state = 2;
        break;
      default:
        state = 1;
    }

    return state;
  }

  public int com_tableswitch_2(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 4;
        break;
      case 2:
        state = 3;
        break;
      case 3:
        state = 2;
        break;
      default:
        state = 1;
    }

    switch (state) {
      case 4:
        state = 8;
        break;
      case 5:
        state = 7;
        break;
      case 6:
        state = 6;
        break;
      default:
        state = 5;
    }

    return state;
  }

  public int com_tableswitch_3(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 7;
        break;
      case 2:
        state = 6;
        break;
      case 3:
        state = 5;
        break;
      default:

        switch (x) {
          case 4:
            state = 4;
            break;
          case 5:
            state = 3;
            break;
          case 6:
            state = 2;
            break;
          default:
            state = 1;
        }
    }

    return state;
  }

  public int com_lookupswitch_1(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        break;
      case 1:
        state = 5;
        break;
      case 2:
        state = 4;
        break;
      case 3:
        state = 3;
        break;
      case 4:
        state = 2;
        break;
      default:
        state = 1;
    }

    return state;
  }

  public int com_lookupswitch_2(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        break;
      case 1:
        state = 4;
        break;
      case 2:
        state = 3;
        break;
      case 3:
        state = 2;
        break;
      default:
        state = 1;
    }

    switch (state) {
      case 100000:
        break;
      case 4:
        state = 8;
        break;
      case 5:
        state = 7;
        break;
      case 6:
        state = 6;
        break;
      default:
        state = 5;
    }

    return state;
  }

  public int com_lookupswitch_3(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        break;
      case 1:
        state = 7;
        break;
      case 2:
        state = 6;
        break;
      case 3:
        state = 5;
        break;
      default:

        switch (x) {
          case 100000:
            break;
          case 4:
            state = 4;
            break;
          case 5:
            state = 3;
            break;
          case 6:
            state = 2;
            break;
          default:
            state = 1;
        }
    }

    return state;
  }

  public void run(JTest jt) {

    /*
    ** To test the comparison operations both using positive and negative
    ** numbers, we let 'i' and 'j' itererate from a negative to a positive 
    ** value.
    */

    for (int i = -5; i < 5; i++) {

      /*
      ** Compare two integer arguments.
      */

      for (int j = -5; j < 5; j++) {
        jt.assert(int_if_icmplt(i, j), com_if_icmplt(i, j), "ComparisonTest.com_if_icmplt("+ i +", "+ j +")");
        jt.assert(int_if_icmpgt(i, j), com_if_icmpgt(i, j), "ComparisonTest.com_if_icmpgt("+ i +", "+ j +")");
        jt.assert(int_if_icmple(i, j), com_if_icmple(i, j), "ComparisonTest.com_if_icmple("+ i +", "+ j +")");
        jt.assert(int_if_icmpge(i, j), com_if_icmpge(i, j), "ComparisonTest.com_if_icmpge("+ i +", "+ j +")");
        jt.assert(int_if_icmpeq(i, j), com_if_icmpeq(i, j), "ComparisonTest.com_if_icmpeq("+ i +", "+ j +")");
        jt.assert(int_if_icmpne(i, j), com_if_icmpne(i, j), "ComparisonTest.com_if_icmpne("+ i +", "+ j +")");
      }

      /*
      ** Compare one integer argument with zero.
      */

      jt.assert(int_iflt(i), com_iflt(i), "ComparisonTest.com_iflt("+ i +")");
      jt.assert(int_ifgt(i), com_ifgt(i), "ComparisonTest.com_ifgt("+ i +")");
      jt.assert(int_ifle(i), com_ifle(i), "ComparisonTest.com_ifle("+ i +")");
      jt.assert(int_ifge(i), com_ifge(i), "ComparisonTest.com_ifge("+ i +")");
      jt.assert(int_ifeq(i), com_ifeq(i), "ComparisonTest.com_ifeq("+ i +")");
      jt.assert(int_ifne(i), com_ifne(i), "ComparisonTest.com_ifne("+ i +")");

      /*
      ** Test "if - else if - else" statements:
      */

      jt.assert(int_comparison_1(i), com_comparison_1(i), "ComparisonTest.com_comparison_1("+ i +")");
      jt.assert(int_comparison_2(i), com_comparison_2(i), "ComparisonTest.com_comparison_2("+ i +")");
      jt.assert(int_comparison_3(i), com_comparison_3(i), "ComparisonTest.com_comparison_3("+ i +")");
      jt.assert(int_comparison_4(i), com_comparison_4(i), "ComparisonTest.com_comparison_4("+ i +")");
      jt.assert(int_comparison_5(i), com_comparison_5(i), "ComparisonTest.com_comparison_5("+ i +")");
    }

    /*
    ** Compare object references.
    */

    jt.assert(int_ifnull(null), com_ifnull(null), "ComparisonTest.com_ifnull(null)");
    jt.assert(int_ifnull(this), com_ifnull(this), "ComparisonTest.com_ifnull(this)");
    jt.assert(int_ifnonnull(null), com_ifnonnull(null), "ComparisonTest.com_ifnonnull(null)");
    jt.assert(int_ifnonnull(this), com_ifnonnull(this), "ComparisonTest.com_ifnonnull(this)");
    jt.assert(int_if_acmpeq(this, null), com_if_acmpeq(this, null), "ComparisonTest.com_if_acmpeq(this, null)");
    jt.assert(int_if_acmpeq(null, this), com_if_acmpeq(null, this), "ComparisonTest.com_if_acmpeq(null, this)");
    jt.assert(int_if_acmpeq(this, this), com_if_acmpeq(this, this), "ComparisonTest.com_if_acmpeq(this, this)");
    jt.assert(int_if_acmpeq(null, null), com_if_acmpeq(null, null), "ComparisonTest.com_if_acmpeq(null, null)");
    jt.assert(int_if_acmpne(this, null), com_if_acmpne(this, null), "ComparisonTest.com_if_acmpne(this, null)");
    jt.assert(int_if_acmpne(null, this), com_if_acmpne(null, this), "ComparisonTest.com_if_acmpne(null, this)");
    jt.assert(int_if_acmpne(this, this), com_if_acmpne(this, this), "ComparisonTest.com_if_acmpne(this, this)");
    jt.assert(int_if_acmpne(null, null), com_if_acmpne(null, null), "ComparisonTest.com_if_acmpne(null, null)");

    /*
    ** Test some special/extreme cases:
    */

    int i = Integer.MIN_VALUE;
    int j = Integer.MAX_VALUE;

    jt.assert(int_if_icmplt(i, j), com_if_icmplt(i, j), "ComparisonTest.com_if_icmplt("+ i +", "+ j +")");
    jt.assert(int_if_icmpgt(i, j), com_if_icmpgt(i, j), "ComparisonTest.com_if_icmpgt("+ i +", "+ j +")");
    jt.assert(int_if_icmple(i, j), com_if_icmple(i, j), "ComparisonTest.com_if_icmple("+ i +", "+ j +")");
    jt.assert(int_if_icmpge(i, j), com_if_icmpge(i, j), "ComparisonTest.com_if_icmpge("+ i +", "+ j +")");
    jt.assert(int_if_icmpeq(i, j), com_if_icmpeq(i, j), "ComparisonTest.com_if_icmpeq("+ i +", "+ j +")");
    jt.assert(int_if_icmpne(i, j), com_if_icmpne(i, j), "ComparisonTest.com_if_icmpne("+ i +", "+ j +")");

    /*
    ** Test jump tables, the "tableswitch" bytecode in specific.
    */

    for (int k = -5; k < 5; k++) {
      jt.assert(int_tableswitch_1(k), com_tableswitch_1(k), "ComparisonTest.com_tableswitch_1("+ k +")");
      jt.assert(int_tableswitch_2(k), com_tableswitch_2(k), "ComparisonTest.com_tableswitch_2("+ k +")");
      jt.assert(int_tableswitch_3(k), com_tableswitch_3(k), "ComparisonTest.com_tableswitch_3("+ k +")");
      jt.assert(com_lookupswitch_1(k), com_lookupswitch_1(k), "ComparisonTest.com_loopkupswitch_3("+ k +")");
    }

    /*
    ** Test jump tables, the "lookupswitch" bytecode in specific.
    */

    for (int l = -5; l < 5; l++) {
      jt.assert(int_lookupswitch_1(l), com_lookupswitch_1(l), "ComparisonTest.com_loopkupswitch_1("+ l +")");
      jt.assert(int_lookupswitch_2(l), com_lookupswitch_2(l), "ComparisonTest.com_loopkupswitch_2("+ l +")");
      jt.assert(int_lookupswitch_3(l), com_lookupswitch_3(l), "ComparisonTest.com_loopkupswitch_3("+ l +")");
    }
  }
}
