/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class JTest  {

  public int tests = 0;

  public void assert(int a, int b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (a != b) {
      System.exit(0);
    }

    tests++;
  }

  public void assert(long a, long b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (a != b) {
      System.exit(0);
    }

    tests++;
  }

  public void assert(double a, double b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (a != b) {
      System.exit(0);
    }

    tests++;
  }

  public void assert(boolean a, boolean b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (a != b) {
      System.exit(0);
    }

    tests++;
  }

  public void assert(Object a, Object b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (a != null) {
      if (a.equals(b) == false) {
        System.exit(0);
      }
    }
    else {
      if (b != null) {
        System.exit(0);
      }
    }

    tests++;
  }

  public static void main(String[] args) {
    JTest jt = new JTest();

    ReturnTest rt = new ReturnTest();
    rt.run(jt);

    ArithmeticOperationsTest aot = new ArithmeticOperationsTest();
    aot.run(jt);

    ComparisonTest ct = new ComparisonTest();
    ct.run(jt);

    LoopTest lt = new LoopTest();
    lt.run(jt);

    ObjectTest ot = new ObjectTest();
    ot.run(jt);

    StackTest st = new StackTest();
    st.run(jt);

    LogicOperationsTest lot = new LogicOperationsTest();
    lot.run(jt);

    ExpressionTest expt = new ExpressionTest();
    expt.run(jt);

    RecursiveMethodsTest rmt = new RecursiveMethodsTest();
    rmt.run(jt);

    MethodTest mt = new MethodTest();
    mt.run(jt);

    ArrayTest at = new ArrayTest();
    at.run(jt);

    ProblemTest pt = new ProblemTest();
    pt.run(jt);
    
    ExceptionTest exct = new ExceptionTest();
    exct.run(jt);

    System.out.println("----> passed "+ jt.tests +" tests");
  }
}
