/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class LogicOperationsTest  {

  /*
  ** The "int_" functions will never be compiled.
  */
  
  public int int_iand(int x, int y) {
    return x & y;
  }

  public int int_ior(int x, int y) {
    return x | y;
  }

  public int int_ixor(int x, int y) {
    return x ^ y;
  }

  /*
  ** The "com_" functions will awlays be compiled.
  */

  public int com_iand(int x, int y) {
    return x & y;
  }

  public int com_ior(int x, int y) {
    return x | y;
  }

  public int com_ixor(int x, int y) {
    return x ^ y;
  }

  public void run(JTest jt) {
    
    for (int i = -5; i < 5; i++) {
      for (int j = -5; j < 5; j++) {

        /*
        ** Test the bitwise boolean operations.
        */

        jt.assert(int_iand(i, j), com_iand(i, j), "com_iand("+ i +", "+ j +")");
        jt.assert(int_ior(i, j), com_ior(i, j), "com_ior("+ i +", "+ j +")");
        jt.assert(int_ixor(i, j), com_ixor(i, j), "com_ixor("+ i +", "+ j +")");

        /*
        ** Test the shift operations.
        */
      }
    }
  }
}

