/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class LoopTest  {
 
  /*
  ** A single for-loop.
  */
 
  public int com_loop_1(int x) {
    int i;
  
    for (i = 0; i < x; i++) {
    }

    return i;
  }

  /*
  ** Nested for-loops.
  */

  public int com_loop_2(int x, int y, int z) {
    int i = 0;
    int j = 0;
    int k = 0;

    for (; i < x; i++) {
      for (; j < y; j++) {
        for (; k < z; k++) {
          // empty loop
        }
      }
    }

    return i + j + k;
  }

  public int com_loop_3(int x, int y, int z) {
    int iterations = 0;

    for (int i = 0; i < x; i++) {
      for (int j = 0; j < y; j++) {
        for (int k = 0; k < z; k++) {
          iterations++;
        }
      }
    }

    return iterations;
  }

  public int com_loop_4(int x) {
    int i = 0;
 
    while (i < x) {
      i = i + 1;
    }

    return i;
  }

  public void run(JTest jt) {
    jt.assert(com_loop_1(10), com_loop_1(10), "LoopTest.com_loop_1()");
    jt.assert(com_loop_2(3, 4, 5), com_loop_2(3, 4, 5), "LoopTest.com_loop_2()");
    jt.assert(com_loop_3(3, 4, 5), com_loop_3(3, 4, 5), "LoopTest.com_loop_3()");
    jt.assert(com_loop_4(10), com_loop_4(10), "LoopTest.com_loop_4()");
  }
}
