/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

/*
** HISTORY:
**
** "int_test_1": 
**    Used to misplace (invalid order) an assignement instruction in the 
**    IR's DAG which caused a segfault the first time the generated code 
**    got called.  
*/

public class ProblemTest  {

  private String string = "olleke-bolleke";
  private boolean b;

  /*
  ** The "int_" functions will never be compiled.
  */

  public String int_test_1(int x) {
    return (x > 4 ? "" : string.substring(0, x));
  }
  
  public boolean int_test_2(boolean x) {
    b = !x;
    return b;
  }

  /*
  ** The "com_" functions will always be compiled.
  */

  public String com_test_1(int x) {
    return (x > 4 ? "" : string.substring(0, x));
  }

  public boolean com_test_2(boolean x) {
    b = !x;
    return b;
  }

  public void run(JTest jt) {
    int i[] = { 5, 3, 7, 0, 9 };
    boolean b[] = { true, false, true, false, true };

    for (int j = 0; j < 5; j++) {
      jt.assert(int_test_1(i[j]), com_test_1(i[j]), "ProblemTest.int_test_1("+ i[j] +")");
      jt.assert(int_test_2(b[j]), com_test_2(b[j]), "ProblemTest.int_test_2("+ b[j] +")");
    }
  }
}
