/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class RecursiveMethodsTest  {
  
  /*
  ** The "int_" functions will never be compiled.
  */
 
  public int int_recursive_1(int x) {
    if (x < 0) {
      x = 0;
    }
    else {   
      x = x + int_recursive_1(x - 1);
    }

    return x;
  }

  public int int_recursive_2(int x) {
    if (x < 0) {
      x = 0;
    }
    else if (x < 5){   
      x = x + int_recursive_2(x - 1);
    }
    else {
      x = x + int_recursive_2(x - 2);
    }

    return x;   
  }

  public int int_recursive_3(int x) {

    /*
    ** Fibonacci - simple to write, horrible to compute.
    */

    if (x < 2) {
      x = 1;
    }
    else {
      x = int_recursive_3(x - 1) + int_recursive_3(x - 2);
    }

    return x;   
  }

  /*
  ** The "com_" functions will awlays be compiled.
  */
  
  public int com_recursive_1(int x) {
    if (x < 0) {
      x = 0;
    }
    else {   
      x = x + com_recursive_1(x - 1);
    }

    return x; 
  } 

  public int com_recursive_2(int x) {
    if (x < 0) {
      x = 0;
    }
    else if (x < 5){   
      x = x + com_recursive_2(x - 1);
    }
    else {
      x = x + com_recursive_2(x - 2);
    }

    return x;   
  }

  public int com_recursive_3(int x) {

    /*
    ** Fibonacci - simple to write, horrible to compute.
    */

    if (x < 2) {
      x = 1;
    }
    else {
      x = com_recursive_3(x - 1) + com_recursive_3(x - 2);
    }

    return x;   
  }

  public void run(JTest jt) {
    
    for (int i = 0; i < 10; i++) {
      jt.assert(int_recursive_1(i), com_recursive_1(i), "com_recursive_1("+ i +")");
      jt.assert(int_recursive_2(i), com_recursive_2(i), "com_recursive_2("+ i +")");
      jt.assert(int_recursive_3(i), com_recursive_3(i), "com_recursive_3("+ i +")");
    }
  }
}

