/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class ReturnTest  {
 
  /*
  ** The "int_" functions will never be compiled.
  */

  public int int_multiple_1(int x) {

    /*
    ** A test to check whether multiple exit points work.
    */

    if (x < 2) {
      return 1;
    }

    if (x < 4) {
      return 2;
    }

    if (x < 6) {
      return 3;
    }

    if (x < 8) {
      return 4;
    }

    return 5;
  }

  /*
  ** The "com_" functions will awlays be compiled.
  */
 
  public boolean com_ireturn_1() {
    return true;
  }

  public byte com_ireturn_2() {
    return 5;
  }

  public char com_ireturn_3() {
    return 'd';
  }

  public int com_ireturn_4() {
    return 5;
  }

  public int com_ireturn_5() {
    return 5;
  }

  public Object com_areturn_1() {
    return new Integer(5);
  }

  public long com_lreturn_1() {
    return 5;
  }

  public float com_freturn_1() {
    return 5;
  }

  public double com_dreturn_1() {
    return 5;
  }
 
  public int com_multiple_1(int x) {

    /*
    ** A test to check whether multiple exit points work.
    */

    if (x < 2) {
      return 1;
    }
 
    if (x < 4) {
      return 2;
    }

    if (x < 6) {
      return 3;
    }

    if (x < 8) {
      return 4;
    }

    return 5;
  }
 
  public void run(JTest jt) {

    /*
    ** Test the different return types:
    */

    jt.assert(com_ireturn_1(), com_ireturn_1(), "ReturnTest.com_ireturn_1");
    jt.assert(com_ireturn_2(), com_ireturn_2(), "ReturnTest.com_ireturn_2");
    jt.assert(com_ireturn_3(), com_ireturn_3(), "ReturnTest.com_ireturn_3");
    jt.assert(com_ireturn_4(), com_ireturn_4(), "ReturnTest.com_ireturn_4");
    jt.assert(com_ireturn_5(), com_ireturn_5(), "ReturnTest.com_ireturn_5");
    // jt.assert(com_areturn_1(), com_areturn_1(), "ReturnTest.com_areturn_1");
    // jt.assert(com_lreturn_1(), com_lreturn_1(), "ReturnTest.com_lreturn_1");
    // jt.assert(com_freturn_1(), com_freturn_1(), "ReturnTest.com_freturn_1");
    // jt.assert(com_dreturn_1(), com_dreturn_1(), "ReturnTest.com_dreturn_1");

    /*
    ** Test multiple returns (multiple exit points):
    */

    for (int i = 0; i < 10; i++) {
      jt.assert(int_multiple_1(i), com_multiple_1(i), "ReturnTest.com_multiple_1("+ i +")");
    }
  }
}
