/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class StackTest  {
 
  public int com_iconst_m1() {
    return -1;
  }

  public int com_iconst_0() {
    return 0;
  }

  public int com_iconst_1() {
    return 1;
  }

  public int com_iconst_2() {
    return 2;
  }

  public int com_iconst_3() {
    return 3;
  }

  public int com_iconst_4() {
    return 4;
  }

  public int com_iconst_5() {
    return 5;
  }

  public int com_bipush_1() {
    return 100;
  }

  public int com_bipush_2() {
    return -100;             // check sign
  }

  public int com_sipush_1() {
    return 400;
  }

  public int com_sipush_2() {
    return -400;             // check sign
  }

  public int com_ldc_1() {
    return 100000;
  }

  public int com_ldc_2() {
    return -100000;          // check sign
  }

  public int com_ldc_3() {
    return 2147483647;       // maximum value
  }

  public int com_ldc_4() {
    return -2147483648;      // check sign, minimum value
  }
  
  public Object com_aconst_null() {
    return null;
  }

  public int com_iloadstore_1() {
    int l1 = 1;              // istore_1
    return l1;               // iload_1
  }

  public int com_iloadstore_2() {
    int l1 = 1;              // istore_1
    int l2 = 2;              // istore_2
    return l2;               // iload_2
  }

  public int com_iloadstore_3() {
    int l1 = 1;              // istore_1
    int l2 = 2;              // istore_2
    int l3 = 3;              // istore_3
    return l3;               // iload_3
  }

  public int com_iloadstore_4() {
    int l1 = 1;              // istore_1
    int l2 = 2;              // istore_2
    int l3 = 3;              // istore_3
    int l4 = 4;              // istore <4>
    return l4;               // iload <4>
  }

  public int com_iloadstore_5() {
    int l1 = 1;              // istore_1
    int l2 = 2;              // istore_2
    int l3 = 3;              // istore_3
    int l4 = 4;              // istore <4>
    int l5 = 5;              // istore <5>
    return l5;               // iload <5>
  }

  public void run(JTest jt) {

    /*
    ** Test the instructions that push constants onto the operand 
    ** stack.
    */

    // Integers:
    jt.assert(com_iconst_0(), com_iconst_0(), "com_iconst_0()");
    jt.assert(com_iconst_1(), com_iconst_1(), "com_iconst_1()");
    jt.assert(com_iconst_2(), com_iconst_2(), "com_iconst_2()");
    jt.assert(com_iconst_3(), com_iconst_3(), "com_iconst_3()");
    jt.assert(com_iconst_4(), com_iconst_4(), "com_iconst_4()");
    jt.assert(com_iconst_5(), com_iconst_5(), "com_iconst_5()");
    jt.assert(com_bipush_1(), com_bipush_1(), "com_bipush_1()");
    jt.assert(com_bipush_2(), com_bipush_2(), "com_bipush_2()");
    jt.assert(com_sipush_1(), com_sipush_1(), "com_sipush_2()");
    jt.assert(com_sipush_2(), com_sipush_2(), "com_sipush_2()");
    jt.assert(com_ldc_1(), com_ldc_1(), "com_ldc_1()");
    jt.assert(com_ldc_2(), com_ldc_2(), "com_ldc_2()");
    jt.assert(com_ldc_3(), com_ldc_3(), "com_ldc_3()");
    jt.assert(com_ldc_4(), com_ldc_4(), "com_ldc_4()");

    // Longs:
      // TODO

    // Float:
      // TODO

    // Doubles:
      // TODO

    // Object references:
    jt.assert(com_aconst_null(), com_aconst_null(), "com_aconst_null()");

    /*
    ** Test the instructions that load and store local variables.
    */

    jt.assert(com_iloadstore_1(), com_iloadstore_1(), "com_iloadstore_1()");
    jt.assert(com_iloadstore_2(), com_iloadstore_2(), "com_iloadstore_2()");
    jt.assert(com_iloadstore_3(), com_iloadstore_3(), "com_iloadstore_3()");
    jt.assert(com_iloadstore_4(), com_iloadstore_4(), "com_iloadstore_4()");
    // jt.assert(com_iloadstore_5(), com_iloadstore_5(), "com_iloadstore_5()");
  }
}

