/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: compiler_test.c,v 1.2 2002/02/27 13:26:43 dbuytaert Exp $
*/

#include "tests.h"
#include "ir.h"
#include "methods.h"
#include "translate.h"
#include "compiler.h"
#include "statistics.h"

void compiler_test(void) {

#ifdef BROKEN_CODE
  
  j_method method;
  
  /*
  ** Compile method test1():
  */
 
  method = method_test("JTest.test1()", JTest_test1__, 7); 
  translate(method);
  compile(method);

  if (method->failed) {
    woempa(9, "failed to compile method JTest.test1()\n");
  }
  else {
    woempa(9, "successfully compiled method JTest.test1()\n");
    method_execute(method);
  }
  
  woempa(9, "-----------------------------------------------------------------\n");
  
  /*
  ** Compile method test1():
  */
 
  method = method_test("JTest.test2()", JTest_test2__, 9);
  translate(method);
  compile(method);

  if (method->failed) {
    woempa(9, "failed to compile method JTest.test2()\n");
  }
  else {
    woempa(9, "successfully compiled method JTest.test2()\n");
    method_execute(method);
  }

  woempa(9, "-----------------------------------------------------------------\n");
  
  /*
  ** Dump compiler statistics:
  */
  
  stats_dump();
  
#endif

}
