/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: mimic-stack_test.c,v 1.3 2002/02/27 15:36:00 dbuytaert Exp $
*/

#include "tests.h"
#include "ir.h"
#include "mimic-stack.h"

void mimic_stack_test(void) {

  void * pointer = (void *)0xcafebabe;
  int i;
  int j;

  /*
  ** Initialize stack:
  */

  ms_init(NULL);

  for (i = 0; i < 20; i++) {
  
    /*
    ** Test a simple push and pop:
    */
    
    ms_push(pointer);
    
    if (ms_top() != pointer) {
      wabort(ABORT_WONKA, "invalid top of stack\n");
    }
    else if (ms_pop() != pointer) {
      wabort(ABORT_WONKA, "invalid stack content\n");
    }
    else {
      woempa(9, "push and pop work ...               OK\n");
    }

    ms_push(pointer);

    /*
    ** Fold the stack:
    */
  
    for (j = 0; j < 20; j++) {
      ms_flap();
  
      if (ms_top() != pointer) {
        wabort(ABORT_WONKA, "stack got corrupted");
      }
    }

    woempa(9, "folded the stack 20 times ...       OK\n");

    /*
    ** Unfold the stack:
    */
  
    for (j = 0; j < 20; j++) {
      ms_flop();
    
      if (ms_top() != pointer) {
        wabort(ABORT_WONKA, "stack got corrupted\n");
      }
    }

    woempa(9, "unfolded the stack 20 times ...     OK\n");

    ms_pop();
  
  }

  woempa(9, "+----------------------------------+\n");
  woempa(9, "| Passed all mimic stack tests     |\n");
  woempa(9, "+----------------------------------+\n");

}
