/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: o4w.c,v 1.1 2002/03/21 08:27:08 dfrederickx Exp $
*/

#include <windows.h>
#include <stdlib.h>
#include "oswald.h"

DWORD lastError = 0;

int command_line_argument_count;
char ** command_line_arguments;

O4wEnv * o4wenv;			// a structure that keeps some info of the windows (thread0 environment
extern x_size usecs_per_tick;

x_status x_oswald_init(x_size max_heap, x_size millis) {
	msec_per_tick = millis;
	usecs_per_tick = millis * 1000;
	x_kernel_setup();
	return xs_success;
}

/*
 * The functions that initialise our o4e stuff.
 * The function x_oswald_init(requested heap size, msec / tick) is called from the main function in main.c
 * x_setup_kernel will call x_os_main from the application that runs (wonka) to initialise threads
*/

void x_kernel_setup() {
	int test;
	
	O4wEnvInit();		// initialise our o4w
	test = mem_init();	// initialise our memory stuff

	// test to see if we succeeded in creating the memory
	// if not => stop and display error message
	if (test == FALSE) {
		while(1) {
			loempa(9, "FAILED TO INTIALISE MEMORY!!!\n");
			Sleep(200);
		}
	}

	loempa(9,"Before x_os_main\n");
	x_os_main(command_line_argument_count, command_line_arguments, malloc(1024*1024));
	loempa(9,"After x_os_main\n");

	// Enter the infinite loop that takes care of our timer ticks
	while(1) {
		Sleep(1);	
		o4wenv->timer_ticks++;
	}

	loempa(9, "We should never get here!!!\n");
}

void O4wEnvInit() {
	static O4wEnv theEnv;
	loempa(9,"We are in O4wEnvInit\n");

	o4wenv = &theEnv;
	o4wenv->timer_ticks = 0;
	o4wenv->num_threads = 0;
	o4wenv->num_started = 0;    
	o4wenv->num_deleted = 0;
	InitializeCriticalSection(&o4wenv->w_critical_section);
	x_thread_init();
}



static const char * _status2char[] = {
	"success",				/*  0 */
	"no instance",			/*  1 */
	"not owner",				/*  2 */
	"deadlock",				/*  3 */
	"bad context",			/*  4 */
	"bad option",				/*  5 */
	"deleted",				/*  6 */
	"bad element",			/*  7 */
	"threads waiting",			/*  8 */
	"incomplete",				/*  9 */
	"interrupted",			/* 10 */
	"tick error",				/* 11 */
	"timer error",			/* 12 */
	"activation error",			/* 13 */
	"bad state",				/* 14 */
	"insufficient memory",		/* 15 */
	"bad argument",			/* 16 */
	"still owns events",			/* 17 */
	"is not ELF file",			/* 18 */
	"module is in error",		/* 19 */
	"module sequence error",		/* 20 */
	"no more memory",			/* 21 */
	"relocation failed",			/* 22 */
	"symbol multiply defined",		/* 23 */
	"unresolved symbols remain",	/* 24 */
	"(unknown)",				/* 15 */
};
                                                    
const char * status2char(x_status status) {
  return _status2char[(status >= xs_unknown) ? xs_unknown : status];
}      

x_sleep x_time_get(void){
	return o4wenv->timer_ticks;
}
