#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "oswald.h"
#include "o4w.h"
#include "main_test.h"
#include "monitor_test.h"


/*
 * A Test Program for monitors
 * Principle: Prog1 works together with Prog2
 * They are testing the wait and notify function as well as the integrity of a shared variable
 * Prog2 is testing the enter-exit behavior with timeouts
 * Prog3 is testing the function x_thread_stop_waiting(x_thread thread)
 */
void monitor_testprogram(void* args){
    int t;	    
    m_thread = malloc(11 * sizeof(x_Thread));
    m_stack =  malloc(11 * stacksize);	    
    monitor = (x_monitor) malloc(sizeof(x_Monitor));
    monitor2 = (x_monitor) malloc(sizeof(x_Monitor));
    monitor3 = (x_monitor) malloc(sizeof(x_Monitor));
    teller=0;

    ERRORs = FALSE;
    create_mem();

    x_monitor_create(monitor);
    x_monitor_create(monitor2);
    x_monitor_create(monitor3);
    for(t=0;t<3;t++){
		x_thread_create(mstruct[t],&prog1,(void*)t,mstack[t],stacksize,5,TF_START);
    }
	for(t=3;t<6;t++){
		x_thread_create(mstruct[t],&prog2,(void*)t,mstack[t],stacksize,5,TF_START);
    }
	for(t=6;t<9;t++){
		x_thread_create(mstruct[t],&prog3,(void*)t,mstack[t],stacksize,5,TF_START);
    }
	for(t=9;t<10;t++){
		x_thread_create(mstruct[t],&prog4,(void*)t,mstack[t],stacksize,4,TF_START);
	}
	while(1){Sleep(1000);}

	x_thread_suspend(x_thread_current());
	
}

void prog1(void* arg){
	int temp;
	int data = (int) arg;
	int max = (data+1)*10;
	loempa(9,"MONITOR - Thread %d is entering prog1 \n",data);
	x_monitor_enter(monitor, x_eternal);
	while(1){
		while(teller>=max){
			loempa(9,"MONITOR - Thread %d is waiting on monitor because teller should be < %d but teller is: %d\n",x_thread_current()->id,max,teller);
			x_monitor_wait(monitor,x_eternal);
		}
			
		temp = teller;
		teller++;
		x_thread_sleep(50);
		temp++;
		if (teller!= temp || teller > 30 || teller < 0){	//ERROR
			loempa(9,"MONITOR - ERROR,teller:\n",teller);
			ERRORs = TRUE;
			exit(0);
		}
		loempa(9,"MONITOR - Thread %p is increasing teller to value: %d, teller now: %d\n",x_thread_current(),max,teller);			
		
	}
	
}
void prog2(void* arg){
	x_status state;
	int data = (int) arg;
	loempa(9,"MONITOR - Thread %d is entering countprog2\n",data);
	while(1){
		state = x_monitor_enter(monitor2, 100);
		while(state == xs_no_instance){
			state = x_monitor_enter(monitor2, 100);
			if (state == xs_no_instance)
				loempa(9,"MONITOR - Timeout occured, trying again \n");
		}
		x_thread_sleep(200 + (rand() % 50));
		x_monitor_exit(monitor2);
		x_thread_sleep(200 + (rand() % 50));
	}
	
}
void prog3(void* arg){
	int data = (int) arg;
	loempa(9,"MONITOR - Thread %d is entering prog3 \n",data);
	if(data == 6 || data == 7){
		while(1){
			x_monitor_enter(monitor3,1000);
			x_monitor_wait(monitor3,x_eternal);
			x_thread_sleep(50 + (rand() % 50));
			x_monitor_exit(monitor3);
		}
	}
	else{
		while(1){
			x_thread_stop_waiting(mstruct[6]);
			x_thread_sleep(50 + (rand() % 50));
			x_thread_stop_waiting(mstruct[7]);
			x_thread_sleep(50 + (rand() % 50));
		}
	}
	

}

void prog4(void* arg){
	int data = (int) arg;
	loempa(9,"MONITOR - Thread %d is entering checkprog \n",data);
	while(1){
		if(ERROR == TRUE){
			while(1){
				loempa(9,"MONITOR - ERROR\n");
				exit(0);
			}
		}
		else{
			loempa(9,"MONITOR - Check_thread has detected no error\n");
			if(teller == 30){
				loempa(9,"MONITOR - Teller had value 30 => it's my job to set it back to 0\n");
				x_monitor_enter(monitor, x_eternal);
				teller=0;
				x_monitor_notify_all(monitor); // notifty all to continue
				x_monitor_exit(monitor);
			}
			x_thread_sleep(200);
		}
	}
	

}


void create_mem(){
    int u;
    loempa(9,"MONITOR - Entering function to create mem for the monitortest\n");
	monitorpool1 = HeapCreate(HEAP_NO_SERIALIZE, 21 * sizeof(x_Thread), 0);
    loempa(9,"MONITOR - Memory for monitor test created\n");

    loempa(9,"MONITOR - Allocating memory for threads that test monitors\n");
    for(u=0;u<10;u++){
		mstruct[u] = HeapAlloc(monitorpool1, HEAP_ZERO_MEMORY, sizeof(x_Thread));
    }
    loempa(9,"MONITOR - Na alloc\n");
	
	
}
