/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: sem_test.c,v 1.5 2002/03/26 15:59:53 dfrederickx Exp $
*/

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include "../include/oswald.h"
#include "../include/o4w.h"
#include "main_test.h"
#include "sem_test.h"

static x_size initial;

// the test program
void sem_test(void* args){
	initial = (rand() % 10) + 1;
	s_thread = malloc(2 * sizeof(x_Thread));
	s_stack  = malloc(2 * stacksize);
	sem = malloc(sizeof(o4w_Semaphore));
	x_sem_create(sem, initial);
	x_thread_create(malloc(2 * sizeof(x_Thread)),&sem_put_prog,(void*)0,malloc(2 * stacksize),stacksize,5,TF_START);
	x_thread_create(malloc(2 * sizeof(x_Thread)),&sem_get_prog,(void*)1,malloc(2 * stacksize),stacksize,5,TF_START);
}

void sem_put_prog(void* arg) {
	int i;
    int delay;
    x_status stat;
	for( i=1; i!=0;i++) {
		delay = i + (rand() % 50);
        stat = x_sem_put(sem);
        if( stat == 0 ) loempa(1,"SEMAPHORE_TEST :Semaphore put succes, nr of sems: %d \n", sem->count);
        else loempa(1, "SEMAPHORE_TEST :problem with semaphore, returned %d\n ",stat);
        x_thread_sleep(delay);
			loempa(1,"SEMAPHORE_TEST :putthread sleeping for %d ticks\n", delay);
			loempa(1,"SEMAPHORE_TEST :putthread sleeping for %d ticks\n", i);
	}
}


void sem_get_prog(void* arg) {
	int i;
    int delay;
    for(i=1;i!=0;i++) {
		delay = 10;
			loempa(7,"SEMAPHORE_TEST : sem_get_prog\n");
        if( sem->count == 0) {
				loempa (1,"SEMAPHORE_TEST :Semaphore count 0, nothing can be get!, yielding\n");
        }
		x_sem_get(sem,100);
			loempa(1,"SEMAPHORE_TEST : sempahore decreased to %d\n", sem->count);
            loempa(1,"SEMAPHORE_TEST : getthread sleeping for %d ticks\n", delay);
        x_thread_sleep(delay);
			loempa(1,"SEMAPHORE_TEST :putthread sleeping for %d ticks\n", i);
	}
}
