#ifndef _HOST_H
#define _HOST_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: host.h,v 1.1.1.1 2001/11/21 10:41:33 pollock Exp $
**
** Linux host specific parts.
*/

#include <types.h>

/*
** For linux, we only have dummy irqs
*/

#define IRQ_MAX            1      /* The number of IRQ's we have for this host         */
#define IRQ_TICK           0      /* The index for the TIMER TICK IRQ                  */

x_ubyte * x_host_setup(x_ubyte * memory);
x_ubyte * x_irqs_setup(x_ubyte * memory);

extern x_ubyte * host_memory_end;

extern volatile x_word critical_status;
extern volatile x_word miss_tick;

#define x_enter_critical _x_enter_critical()
inline static void _x_enter_critical(void) {
  critical_status = 1;
}

#define x_exit_critical _x_exit_critical()
inline static void _x_exit_critical(void) {
  critical_status = 0;
}

x_size x_millis2ticks(x_size millis);
x_size x_seconds2ticks(x_size seconds);
x_size x_ticks2usecs(x_size ticks);
x_size x_usecs2ticks(x_size usecs);

void x_host_post(void);

#endif /* _HOST_H */
