/**************************************************************************
* Copyright  (c) 2002 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.awt.Color;

import java.awt.*;
import com.acunia.wonka.test.awt.*;

public class Decode extends VisualTestImpl {

  private static String[] colorStrings = {
    "#7f7f7f",
    "0x7f7f7f",
    "0X7f7f7f",
    "0177177177",
    "0x7f,0x7f,0x7f",
    "127,127,127",
    "0177,0177,0177"
  };

  public String getHelpText() {
    return
      "This test checks to see whether the Color.decode() method can\n"+
      "recognise and return the various stringified colour formats that it's"+
      "meant to recognise.  I'm not entirely sure what these are, but\n"+
      "anything with two commas in is taken to be three numbers to pass\n"+
      "to Integer.decode() 'as-is'.  Anything that starts with # or 0x is\n"+
      "treated as a three hex bytes together, and anything that starts with\n"+
      "a zero is taken as three packed octal bytes together.\n"
      ;
  }
  
  public Decode() {
    super();
    
    for (int c = 0; c < colorStrings.length; c++) {
      Color conv;
      conv = Color.decode(colorStrings[c]);
      
      if (conv.getRed() != 127 || conv.getGreen() != 127 || conv.getBlue() != 127)
        System.err.println("Colour "+colorStrings[c]+" decoded as "+conv.getRed()+","+conv.getGreen()+","+conv.getBlue());
    }
  }  
}
