/*
 * ServiceDetails.java
 *
 * Created on August 23, 2001, 4:43 PM
 */

package com.acunia.wonka.test.awt.IAA;

import java.awt.*;
import java.awt.event.*;

/**
 * @author  jan
 * @version
 */
public class ActionConfirmDialog extends Panel implements ImageDefs {
    private TextArea message;
    private Label title;
    private ImageLabel label;
    private ImageButton confirmButton;
    private ImageButton backButton;
    private Panel buttonPanel;
    private static final Font TITLEFONT = new Font("Verdana", Font.BOLD, 15);

    /** Creates new ServiceDetails */
    public ActionConfirmDialog() {
        this.setLayout(
            new BorderLayout());
        Panel mainPanel = new Panel(
            new BorderLayout());
        Panel titlePanel = new Panel(
            new FlowLayout(FlowLayout.LEFT));
        titlePanel.setBackground(Color.white);
        message = new TextArea("", 5, 20, TextArea.SCROLLBARS_VERTICAL_ONLY);//SCROLLBARS_NONE);
        message.setEditable(false);
        message.setBackground(Color.white);
        BorderedContainer panel = new ScrollableContainer(message);
        label = new ImageLabel();
        title = new Label();
        title.setBackground(Color.white);
        title.setFont(TITLEFONT);
        titlePanel.add(label);
        titlePanel.add(title);
        mainPanel.add(titlePanel, BorderLayout.NORTH);
        mainPanel.add(panel, BorderLayout.CENTER);
        ImageButtonConfig backConfig = null;
        try {
            backConfig = new ImageButtonConfig(this, NOIMAGE, NOIMAGE, NOACTIVE);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        backButton = new ImageButton(backConfig);
        ImageButtonConfig confirmConfig = null;
        try {
            confirmConfig = new ImageButtonConfig(this, YESIMAGE, YESIMAGE, YESACTIVE);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        confirmButton = new ImageButton();
        buttonPanel = new Panel(
            new FlowLayout());
        buttonPanel.setBackground(Color.white);
        buttonPanel.add(backButton);
        buttonPanel.add(confirmButton);
        this.add(mainPanel, BorderLayout.CENTER);
        this.add(buttonPanel, BorderLayout.SOUTH);
    }

    public ImageButton setConfirmButton(ImageButtonConfig config) {
        buttonPanel.remove(confirmButton);
        confirmButton = new ImageButton(config);
        buttonPanel.add(confirmButton);
        return confirmButton;
    }

    public void setIcon(Image icon) {
        label.setImage(icon);
        this.label.invalidate();
        if (this.label.getParent() != null) this.label.getParent().validate();
    }

    public void setMessage(String message) {
        this.message.setText(message);
        this.message.invalidate();
        if (this.message.getParent() != null) this.message.getParent().validate();
    }

    public String getMessageForService(String service, String language) {
        if (service.equals("E-mail")) {
            return language.equals("en") ? "The e-mail service allows to safely read, send and reply to e-mails when you are on the road or just out and about." :
                "Der e-mail Dienst erlaubt sicheres und einfaches lesen, beantworten und versenden von e-mails, w\u00e4hrend Sie auf der Reise sind.";
        } else if (service.equals("Where am I?")) {
            return language.equals("en") ? "By the touch of one button you are able to view your position on a map of your surrounding area ? so that you will never be lost again." :
                "Durch das Dr\u00fccken einer Taste sehen Sie eine Umgebungskarte um Ihre momentane Position  - so da\u00df Sie zuk\u00fcnftig immer wissen, wo Sie sind.";
        } else if (service.equals("My Phone")) {
            return language.equals("en") ? "You want to safely & easily control your mobile phone?\nDownload the latest mobile phone service from OnStar with new features like voice control, address book synchronisation, etc." :
                "Sie m\u00f6chten Ihr Mobiltelefon sicher & einfach bedienen?\nLaden Sie den neusten OnStar Telefondienst ? mit neuesten Funktionen wie Spracheingabe, Abgleich mit Telefonbuch, ...";
        } else if (service.equals("Navigation")) {
            return language.equals("en") ? "Based on your current position and latest European map data, OnStar provides you a full dynamic navigation service.\nThat incorporates traffic and road condition updates and forecasts - to ensure that you reach your destination quickly and safely.\nDriving instructions are given using clear pictograms and voice commands." :
                "Basierend auf Ihrer Position sowie neuesten europ\u00e4ischen Karten, bietet Ihnen OnStar ein kompletten dynamischen Navigationsdienst.\nDie aktuelle und zuk\u00fcnftige Verkehrs- und Stra\u00dfensituation wird ber\u00fccksichtigt, um sicherzustellen, da\u00df Sie Ihr Ziel schnell und sicher erreichen.\nSie erhalten Fahrtinstruktionen \u00fcber klare Piktogramme und Sprache.";
        } else if (service.equals("My Car")) {
            return language.equals("en") ? "Powered by GenRad Diagnostic Solutions, you can:\n- Diagnose and fix vehicle faults,\n- Personalise your car ?  e.g. set door locking,  passenger airbag,  alarm settings, etc.\n- Intermittent Fault Finding supports your dealer to identify and fix faults quicker & cheaper\n- Trip computer & interactive vehicle user manual" :
                "Erm\u00f6glicht durch GenRad Diagnose-L\u00f6sungen, k\u00f6nnen Sie:\n- Fahrzeugfehler diagnostizieren und beheben\n- Personalisieren Sie Ihr Auto ? z.B. Fernentriegelung einstellen, Beifahrerairbag ein-/ausschalten, etc.\n- Aufsp\u00fcren tempor\u00e4rer Fahrzeugst\u00f6rungen, um die Reperatur g\u00fcnstiger & schneller zu machen\n- Bordcumputer\n- Interaktives Fahrzeug-Bedienhandbuch";
        } else if (service.equalsIgnoreCase("GenRad VI Service")) {
            return language.equals("en") ? "Powered by GenRad Diagnostic Solutions, you can:\n- Diagnose and fix vehicle faults,\n- Personalise your car ?  e.g. set door locking,  passenger airbag,  alarm settings, etc.\n- Intermittent Fault Finding supports your dealer to identify and fix faults quicker & cheaper\n- Trip computer & interactive vehicle user manual" :
                "Erm\u00f6glicht durch GenRad Diagnose-L\u00f6sungen, k\u00f6nnen Sie:\n- Fahrzeugfehler diagnostizieren und beheben\n- Personalisieren Sie Ihr Auto ? z.B. Fernentriegelung einstellen, Beifahrerairbag ein-/ausschalten, etc.\n- Aufsp\u00fcren tempor\u00e4rer Fahrzeugst\u00f6rungen, um die Reperatur g\u00fcnstiger & schneller zu machen\n- Bordcumputer\n- Interaktives Fahrzeug-Bedienhandbuch";
        } else if (service.equals("Weather")) {
            return language.equals("en") ? "What is the weather today, tomorrow or in the next three days?\nThis service allows you to view the weather in your current or a selected destination." :
                "Wie ist das Wetter heute, morgen oder f\u00fcr die n\u00e4chsten 3 Tage?\nDieser Dienst erlaubt Ihnen jederzeit das Wetter zu erfragen ? ob f\u00fcr Ihre momentane Position oder f\u00fcr Ihr Reiseziel.";
        } else if (service.equals("Request Map")) {
            return language.equals("en") ? "You are driving to a unknown destination and want to receive a map of that area?\nRequest Map sends you a map for a chosen destination." :
                "Sie fahren zu einem Ihnen unbekannten Ort und wollen eine Landkarte f\u00fcr diesen Ort sehen?\nDieser Dienst zeigt Ihnen einen Kartenausschnitt f\u00fcr jedes eingegebene Ziel.";
        } else
            return "";
    }

    public void setTitle(String title) {
        this.title.setText(title);
        this.title.invalidate();
        if (this.title.getParent() != null) this.title.getParent().validate();
    }
}
