/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.awt.IAA;

import com.acunia.wonka.test.awt.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class ActionConfirmDialogTest extends VisualTestImpl implements ImageDefs {
	
  public ActionConfirmDialogTest() {
    super();

    setLayout(new BorderLayout());

    ActionConfirmDialog cd = new ActionConfirmDialog();
    
    ImageButtonConfig confirmConfig = null;
    try {
      confirmConfig = new ImageButtonConfig(this, YESIMAGE, YESIMAGE, YESACTIVE);
    } catch (Exception ex) {
      ex.printStackTrace();
    }
    cd.setConfirmButton(confirmConfig);

    cd.setIcon(Toolkit.getDefaultToolkit().getImage(OKIMAGE));

    cd.setMessage(
      "What is Wonka?\n\n" +
      "Wonka is ACUNIA's cleanroom Virtual Machine for the JavaTM language.  It is extremely portable and self-contained, " +
      "and can optionally be used with its own real-time executive (OSwaldTM) to provide a complete solution for embedded " +
      "devices. It is a full implementation of the Java language, not just a subset. And it's Open Source.\n\n" +
      "An Embedded VM\n\n" +
      "We didn't build a Virtual Machine first, and then look for a market; we had a project, we had some hardware, and " +
      "the project required that hardware to run Java. The result is a Java implementation designed from the start for " +
      "embedded systems.\n\n" +
      "A VM for Real-Time\n\n" +
      "That system has real-time requirements; maybe not Hard Real-Time, but hard enough for most of us. We don't claim to " +
      "have made a totally predictable Java (it may not even be possible), but we have worked hard to bring Java's inherent " +
      "unpredictability under control.\n\n" +
      "A Java2-compatible VM\n\n" +
      "Some embedded VMs sacrifice full Java compatibility for other aims.  Wonka doesn't.  Automatic garbage collection, " +
      "dynamic class loading, user-defined class loaders, fine-grained access control, they're all there.  The standard " +
      "distribution doesn't include JavaBeansTM or Swing, but you could add them if you wanted to: all the infrastructure " +
      "needed is present.\n\n" +
      "Full AWT 1.1.8 Support\n\n" +
      "Wonka comes with a high-performance lightweight AWT (RudolphTM) suitable for any memory-mapped or framebuffer display. " +
      "Or you can plug in your own implementation, or run with no AWT at all (e.g. in a ``headless'' system).  The choice " +
      "is yours.\n");

    cd.setTitle("WHAT IS WONKA ?");
    add(cd, BorderLayout.CENTER);
  }

  public String getHelpText(){
    return "Simulates an <ActionConfirmdialog> panel as used in the IAA demo. Note that there is NO coupling between the ScrollBar"+
    " on the right and the message TextArea left of it. (Yet you can scroll the text in the TextArea by dragging a selection"+
    " over the top or bottom of the Text window)";
  }

}
