/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

// V.1.01.00 2001/08/29 : first release
// V.1.01.01 2001/08/29 : excluded CVS directories from files list
// V.1.01.02 2001/08/29 : Option to only load checked files
// V.1.02.01 2001/08/31 : Double list and quick scan possibilities
// V.1.02.02 2001/08/31 : bugfixes and selective file-load for subdirs
// V.1.02.03 2001/08/31 : added buttons for showing scripts and c/h/java files
// V.1.02.03 2001/09/03 : logging file
// V.1.02.04 2001/09/03 : edit screen allows to place header on current text position / button for header files only
// V.1.02.05 2001/09/03 : added buttons for same directory and last directory


// Author: N.Oberfeld
// Version 1.01.01
// Created: 2001/08/29

package com.acunia.wonka.test.awt.IAA;

//import
import com.acunia.wonka.test.awt.*;
import java.io.*;        // File & Streams
import java.awt.*;       // layout & buttons
import java.awt.event.*; // button events

public class BorderedComponentsTest extends VisualTestImpl {
	
  /****************************************************************/
  /** variables
  */

  /****************************************************************/
  /** constructor
  */
  public BorderedComponentsTest() {
    super();
    setLayout(new GridLayout(8,2));
    // bordered labels
    add(new BorderedLabel("Etched & raised, thin",Label.CENTER,BorderedLabel.ETCHED, BorderedLabel.RAISED,1));
    add(new BorderedLabel("Etched & raised, thick",Label.CENTER,BorderedLabel.ETCHED, BorderedLabel.RAISED,4));
    add(new BorderedLabel("Etched & lowered, thin",Label.CENTER,BorderedLabel.ETCHED, BorderedLabel.LOWERED,1));
    add(new BorderedLabel("Etched & lowered, thick",Label.CENTER,BorderedLabel.ETCHED, BorderedLabel.LOWERED,4));
    add(new BorderedLabel("Shadow & raised, thin",Label.CENTER,BorderedLabel.SHADOW, BorderedLabel.RAISED,1));
    add(new BorderedLabel("Shadow & raised, thick",Label.CENTER,BorderedLabel.SHADOW, BorderedLabel.RAISED,4));
    add(new BorderedLabel("Shadow & lowered, thin",Label.CENTER,BorderedLabel.SHADOW, BorderedLabel.LOWERED,1));
    add(new BorderedLabel("Shadow & lowered, thick",Label.CENTER,BorderedLabel.SHADOW, BorderedLabel.LOWERED,4));
    // bordered container
    add(new Label("Bordered Containers :"));
    add(new Label());
    BorderedContainer bc1 = new BorderedContainer();
    bc1.setInsets(new Insets(1, 1, 1, 1));
    add(new Label(showInsets(bc1.getInsets())));
    add(bc1);
    BorderedContainer bc2 = new BorderedContainer();
    bc2.setInsets(new Insets(5, 5, 5, 25));
    add(new Label(showInsets(bc2.getInsets())));
    add(bc2);
    BorderedContainer bc3 = new BorderedContainer();
    bc3.setInsets(new Insets(15, 15, 15, 5));
    add(new Label(showInsets(bc3.getInsets())));
    add(bc3);

  }


  /***********************/
  /** Insets auxilliary */
  private String showInsets(Insets i){
   return "Insets topleft("+i.top+", "+i.left+")bottomright("+i.bottom+", "+i.right+")";
  }

  /*********************/
  /** VirtualTest help */
  public String getHelpText(){
    return "Test on the construction and behavior of the giza.component.util classes used for the IAA demo:\n"+
           "Tested here are BorderedComponent and BorderedLabel:\n"+
           "If this test is performed correctly, you should see on the screen:\n"+
           "-> Eight bordered labels with each of the combinations of style = etched/shadowed, level=raised/lowered and border thickness"+
           " 1 or 4 pixels\n"+
           "-> three BorderedComponents with insets respectingly (1,1,1,1), (5,5,5,25) and (15,15,15,5)"+
           "\n\nPS: due to some <undocumented features> in the Insignia-code for the bordered components:\n"+
           "=> etched labels with a border width bigger then 1 display some interlooped rectangles instead of etched borders\n"+
           "=> No mather what insets you define for the bordered component, the border is always drawn exactly on the components outline";
  }

  /********************/
  /** test main */
  static public void main (String[] args) {
	  new BorderedComponentsTest();
  }

  // (end of class CopyWriter
}
