/*
 * BorderedContainer.java
 *
 * Created on August 23, 2001, 11:42 AM
 */

package com.acunia.wonka.test.awt.IAA;

import java.awt.*;

/**
 *
 * @author  ivan
 * @version 
 */
public class BorderedContainer extends Container {
    
    private Insets _insets = new Insets(0, 0, 0, 0);
    private boolean _borderEnabled = true;
    private int borderOffset = 0;
    /** Creates new BorderedContainer */
    public BorderedContainer() {
    }
    
    public void setInsets(Insets insets) {
        _insets = insets;
    }
    
    public Insets getInsets() {
        return _insets;
    }
    
    public void paint(Graphics g) {
        super.paint(g);
        if (_borderEnabled) {
            Dimension d = getSize();
            g.drawRect(borderOffset , borderOffset, d.width - borderOffset - 1, d.height - borderOffset - 1);
        }
    }
    
    public void setBorderEnabled(boolean enabled) {
        setBorderEnabled(enabled, 0);
    }
    
     public void setBorderEnabled(boolean enabled, int borderOffset) {
        _borderEnabled = enabled;
        repaint();
    }
   
    public Dimension getPreferredSize() {
        Dimension d = super.getPreferredSize();
        return new Dimension(d.width + _insets.left + _insets.right, 
                    d.height + _insets.top + _insets.bottom);
    }

}
