/*
 * BrowserDesktop.java
 *
 * Created on August 22, 2001, 1:14 PM
 */

package com.acunia.wonka.test.awt.IAA;

import java.awt.Panel;
import java.awt.GridLayout;
import java.util.Vector;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.util.Enumeration;
//import com.acunia.util.awt.ImageButtonConfig;
//import com.acunia.util.awt.ImageIcon;
//import com.acunia.util.awt.Sound;
//import com.acunia.otf.publication.agent.ServiceInfo;

/** @author  jan */
public class BrowserDesktop extends Panel {
  private Vector serviceList;
  private ServiceTouchAction touchAction = null;
  //private Sound touchSound;
  private static final Font DUMMYFONT = new Font("Verdana", Font.ITALIC, 11);

  private class SoundAction implements ActionListener {
    public void actionPerformed(ActionEvent e) {
      //touchSound.play();
    }
  }


  /** Creates new form BrowserDesktop */
  public BrowserDesktop() {
    this(null);
  }

  public BrowserDesktop(ServiceTouchAction touchAction) {
    this.touchAction = touchAction;
    this.setBackground(Color.white);
    serviceList = new Vector();
    /*
    try {
      Component comp = this.getClass().equals(BrowserDesktop.class) ? (Component)this :
      (Component)BrowserGUI.getInstance();
      touchSound = new Sound(comp, "/beep.au");
    } catch (Exception e) {
      e.printStackTrace();
    }
    */
  }

  public void setTouchAction(ServiceTouchAction touchAction) {
    this.touchAction = touchAction;
  }

  public void setServices(ServiceVisualisation[] services) {
    serviceList.removeAllElements();
    for (int i = 0; i < services.length; i++) {
      serviceList.addElement(services[i]);
    }
    updateDesktop();
  }

  public void setServices(Vector services) {
    serviceList.removeAllElements();
    Enumeration e = services.elements();
    while (e.hasMoreElements()) {
      serviceList.addElement((ServiceVisualisation)e.nextElement());
    }
    updateDesktop();
  }

  public void addServices(ServiceVisualisation[] services) {
    for (int i = 0; i < services.length; i++) {
      serviceList.addElement(services[i]);
    }
    updateDesktop();
  }

  public void addService(ServiceVisualisation service) {
    serviceList.addElement(service);
    updateDesktop();
  }

  public void removeDummyServices() {
    int nrOfElements = serviceList.size();
    for (int i = nrOfElements - 1; i >= 0; i--) {
      ServiceVisualisation current = (ServiceVisualisation)serviceList.elementAt(i);
      if (current.isDummy()) {
        serviceList.removeElementAt(i);
      }
    }
    updateDesktop();
  }

  public void removeService(String serviceId) {
    int servicePosition = findServicePosition(serviceId);
    if (servicePosition != -1) {
      serviceList.removeElementAt(servicePosition);
    }
    updateDesktop();
  }

  private int findServicePosition(String serviceId) {
    Enumeration e = serviceList.elements();
    int i = 0;
    while (e.hasMoreElements()) {
      ServiceVisualisation current = (ServiceVisualisation)e.nextElement();
      if (current.getId().equals(serviceId)) {
        return i;
      }
      i++;
    }
    return -1;
  }

  public void updateDesktop() {
    this.removeAll();
    int nrOfElements = serviceList.size();
    int nrOfDummyElements = 0;
    if (nrOfElements < 6) {
      nrOfDummyElements = 6 - nrOfElements;
      setLayout( new GridLayout(3, 2));
    }
    else {
      setLayout(new GridLayout((nrOfElements + 1)/2, 2));
    }

    for (int i = nrOfElements - 1; i >= 0; i--) {
      ServiceVisualisation current = (ServiceVisualisation)serviceList.elementAt(i);
      ImageIcon icon = new ImageIcon(current.getName(), current.getImage());
      if (touchAction != null) {
        if (current.isDummy()) {
          icon.setLabelFont(DUMMYFONT);
        }
        icon.addActionListener( new ServiceTouchListener(touchAction, current.getName(), current.getId()));
        icon.addActionListener( new SoundAction());
      }
      this.add(icon);
    }

    for (int i = 0; i < nrOfDummyElements; i++) {
      Label dummyLabel = new Label("");
      dummyLabel.setBackground(Color.white);
      this.add(dummyLabel);
    }

    //validation
    this.invalidate();
    if (this.getParent() != null) {
      this.getParent().validate();
    }
  }

    public static void main(String[] args) throws Exception {
/*    final java.awt.Frame f = new java.awt.Frame("List Test");
    f.setSize(240, 288);
    f.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(java.awt.event.WindowEvent we) {
        f.dispose();
        System.exit(0);
      }
    });
    f.setLayout(new java.awt.BorderLayout());

    class MyServiceTouchAction implements ServiceTouchAction {
      public void doAction(String name, String id) {
        System.out.println("I'm afraid I can't do that Dave! Not for service  " + name + " with Id : " + id);
      }
    }
    ImageButtonConfig dummy = null;
    try {
      dummy = new ImageButtonConfig(f, "/javalogo52x88.gif",
      "/javalogo52x88.gif",
      "/javalogo_down.gif");
    } catch (Exception ex) {
      ex.printStackTrace();
    }

    BrowserDesktop dtop = new BrowserDesktop(new MyServiceTouchAction());

    dtop.addService(new ServiceVisualisation("service1", "one", dummy));
    dtop.addService(new ServiceVisualisation("service2", "two", dummy));
    dtop.addService(new ServiceVisualisation("service3", "three", dummy));
    dtop.addService(new ServiceVisualisation("service4", "four", dummy));
    dtop.addService(new ServiceVisualisation("service5", "five", dummy));

    dtop.removeService("service4");

      com.acunia.util.awt.ScrollableContainer sc =   new com.acunia.util.awt.ScrollableContainer(dtop);
      //dtop.setSize(240, 288);
      f.add(sc, java.awt.BorderLayout.CENTER);
      f.setVisible(true);
 */
    }
}
