/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

// V.1.01.00 2001/08/29 : first release
// V.1.01.01 2001/08/29 : excluded CVS directories from files list
// V.1.01.02 2001/08/29 : Option to only load checked files
// V.1.02.01 2001/08/31 : Double list and quick scan possibilities
// V.1.02.02 2001/08/31 : bugfixes and selective file-load for subdirs
// V.1.02.03 2001/08/31 : added buttons for showing scripts and c/h/java files
// V.1.02.03 2001/09/03 : logging file
// V.1.02.04 2001/09/03 : edit screen allows to place header on current text position / button for header files only
// V.1.02.05 2001/09/03 : added buttons for same directory and last directory


// Author: N.Oberfeld
// Version 1.01.01
// Created: 2001/08/29

package com.acunia.wonka.test.awt.IAA;

//import
import com.acunia.wonka.test.awt.*;
import java.io.*;        // File & Streams
import java.awt.*;       // layout & buttons
import java.awt.event.*; // button events

public class BrowserDesktopSim extends VisualTestImpl implements ImageDefs, ActionListener {
	

  /****************************************************************/
  /** variables
  */
  private Button addNew;
  private Button remove;

  private BrowserDesktop desktop;
  private ImageButtonConfig okayConfig;
  private String current;
  private int lastno;

  private List display;
  /****************************************************************/
  /** constructor
  */
  public BrowserDesktopSim() {
    super();

    setLayout(new BorderLayout());
    // images
    ImageButtonConfig okay = null;
    try {
      okayConfig = new ImageButtonConfig(this, OKIMAGE, OKIMAGE, OKACTIVE);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }


    //Browser desktop
    desktop = new BrowserDesktop(new DisplayTouchAction());
    for(lastno=1; lastno<4; lastno++) {
      desktop.addService(new ServiceVisualisation( "service_"+lastno, "Service No."+lastno, okayConfig));
    }
    current = "??";
    add(desktop , BorderLayout.CENTER);

    //buttons
    Panel buttons = new Panel(new GridLayout(1,2) );
      addNew = new Button("Add new");
      addNew.addActionListener(this);
      buttons.add(addNew);
      remove = new Button("remove current (none)");
      remove.addActionListener(this);
      buttons.add(remove);
    add(buttons, BorderLayout.NORTH );

    //list
    display = new List(2,false);
    add(display , BorderLayout.SOUTH);
  }

  /****************************************************************/
  /**button pressed : Display event */
  private void displayText(String text) {
    if(display.getItemCount()>40) {
      display.removeAll();
    }
    System.out.println(text);
    display.add(text,0);
  }

  /****************************************************************/
  /**button pressed : Display event */
  public void actionPerformed(ActionEvent evt) {
    if(evt.getSource() == addNew) {
      current = "service_"+lastno;
      desktop.addService(new ServiceVisualisation(current, "Service No."+lastno, okayConfig) );
      remove.setLabel("remove "+current);
      displayText("added new service <"+current+">");
      lastno++;
    }
    else {
      desktop.removeService(current);
      displayText("removed service <"+current+">");
    }
  }

  /****************************************************************/
  /**inner ServiceTouchAction implementation */
  private class DisplayTouchAction implements ServiceTouchAction {
    /** our one and only action command : display the action in the display list*/
    public void  doAction(String name, String id) {
      displayText("Touched service <"+name+">, ID=<"+id+">");
      current = id;
      remove.setLabel("remove "+id);
    }

  }


  public String getHelpText(){
    return "Test on the construction and behavior of the IAA demo browser.* and manage.* components:\n\n"+
           "The screen displays a BrowserLayout consisting out of 3 ServiceVisualisation definitions."+
           "Use the buttons in the top row to add or delete another visualisation. The ServiceTouchAction event fired when clicking"+
           " a 'Service' is displayed in the event list below";
  }

  /********************/
  /** test main */
  static public void main (String[] args) {
	  new BrowserDesktopSim();
  }

  // (end of class CopyWriter
}
