/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

// V.1.01.00 2001/08/29 : first release
// V.1.01.01 2001/08/29 : excluded CVS directories from files list
// V.1.01.02 2001/08/29 : Option to only load checked files
// V.1.02.01 2001/08/31 : Double list and quick scan possibilities
// V.1.02.02 2001/08/31 : bugfixes and selective file-load for subdirs
// V.1.02.03 2001/08/31 : added buttons for showing scripts and c/h/java files
// V.1.02.03 2001/09/03 : logging file
// V.1.02.04 2001/09/03 : edit screen allows to place header on current text position / button for header files only
// V.1.02.05 2001/09/03 : added buttons for same directory and last directory


// Author: N.Oberfeld
// Version 1.01.01
// Created: 2001/08/29

package com.acunia.wonka.test.awt.IAA;

//import
import com.acunia.wonka.test.awt.*;
import java.io.*;        // File & Streams
import java.awt.*;       // layout & buttons
import java.awt.event.*; // button events
import java.util.*; // vector class

public class ChangeUserSim extends VisualTestImpl{
	
  /****************************************************************/
  /** variables
  */
  private ItemList userList;
  private boolean previousUserSelected = false;
  private Vector users = new Vector();
  private User currentUser;
  private int currenUserIndex;

  private java.awt.List display;
  //private ManageGUI parent;

  /****************************************************************/
  /** constructor
  */
  public ChangeUserSim() {
    super();

    //layout
    this.setLayout(new BorderLayout());
    display = new java.awt.List(3,false);
    add(display, BorderLayout.SOUTH);
    display.add("Select a user to log in...");

    //this.parent = parent;
    buildGUI();
    currentUser = getSelectedUser();

    // show the simulator frame
    show();
  }



  /****************************************************************/
  /** INNER CLASS WITH USER DEFINITIONS (Like that, we can gat one complete user in one list entry) */
  private class User {
    private String name;
    private String credential;
    private String language;

    public User(String name, String credential, String language) {
      this.name = name;
      this.credential = credential;
      this.language = language;
    }

    public String getName() {
      return name;
    }

    public String getLanguage() {
      return language;
    }

    public byte[] getCredential() {
      return credential.getBytes();
    }

    public String toString() {
      return name;
    }
  }

  /****************************************************************/
  /** get current selected user */
  private User getSelectedUser() {
      User selectedUser = null;
      Object[] selected = userList.getSelectedObjects();
      if (selected != null && selected.length != 0) {
          selectedUser = (User)selected[0];
      }
      return selectedUser;
  }

  /****************************************************************/
  /** set current user to new one */
  private void setCurrentUser(User user, int userIndex) {
System.out.println("setCurrentUser on "+user);
    currentUser = user;
    currenUserIndex = userIndex;
    displayText("Switched to new current user <"+user.getName()+">" );
/*
    BrowserGUI gui = BrowserGUI.getInstance();
    gui.setMessage(currentUser.getName());
    gui.setClientId(currentUser.getName());
    gui.setLanguage(currentUser.getLanguage());
    parent.updateLanguage();
*/
  }


  /****************************************************************/
  /** user name */
  public String getCurrentUserName() {
    return currentUser != null ? currentUser.getName() : "???";
  }

  /****************************************************************/
  /** <if> user logged in then... */
  public void userLoggedIn() {
    displayText("userLoggedIn called for user <"+getCurrentUserName()+">" );
  }


  /****************************************************************/
  /** Layout... */
  private void buildGUI() {
    //testing
    users.addElement( new User("acunia", "", "en"));
    users.addElement( new User("Helen Brown", "", "en"));
    users.addElement( new User("Peter Schultze", "", "de"));
    users.addElement( new User("John Smith", "", "en"));
    users.addElement( new User("Lieschen M\u00fcller", "", "de"));
    users.addElement( new User("Bruce Wayne", "", "en"));

    userList = new ItemList(users);
    userList.setInsets( new Insets(1, 1, 1, 1));
    userList.setBorderEnabled(true, 10);
    userList.addItemListener(  new ItemListener() {
                              public void itemStateChanged(ItemEvent e) {
                                User selectedUser = getSelectedUser();
/*
                                if (selectedUser != null && !previousUserSelected) {
                                  MessageDialog messageDialog = new MessageDialog(BrowserGUI.getInstance());
                                  messageDialog.setMessage(BrowserGUI.getInstance().getLanguage().equals("en") ? "Change User?" :
                                  "Benutzer wechseln?");
                                  messageDialog.setSize(200, 100);
                                  Rectangle pRect = messageDialog.getParent().getBounds();
                                  Rectangle dRect = messageDialog.getBounds();
                                  messageDialog.setBounds(pRect.x + ((pRect.width - dRect.width) / 2), pRect.y + ((pRect.height - dRect.height) / 2), 200, 100);
                                  messageDialog.show();
                                  messageDialog.addConfirmActionListener( new ActionListener() {
                                                                           public void actionPerformed(ActionEvent actionevt) {
                                                                             login();
                                                                             ChangeUserPanel.this.parent.showMainPanel();
                                                                           }
                                                                         });
                                }
*/
                                if (selectedUser != null) { // && !previousUserSelected) {
                                  login();
                                }
                              }
                            });
    add(userList, BorderLayout.CENTER);
  }

  /****************************************************************/
  /** Log-in new user (& log out old) */
  private void login() {
    User selectedUser = getSelectedUser();
    userList.setEnabled(false);
    //BrowserGUI gui = BrowserGUI.getInstance();
    if (currentUser != null) {
      String userName = currentUser.getName();
      //gui.setMessage("Logging out " + userName);
      showMessage(" user\n" + userName+"\n logged out");
      displayText(" user <" + userName+"> logged out");
/*      try {
        //parent.getIdentificationAgent().logout(userName, currentUser.getCredential());
        //gui.setMessage("User " + userName + " logged out");
        debug("User " + userName + " logged out");
      }
      catch (OTFException oe) {
        oe.printStackTrace();
        showMessage("Unable to logout user\n" + userName);
      }
*/
    }

    if (selectedUser != null) {
      String userName = selectedUser.getName();
      //gui.setMessage("Logging in " + userName);
      setCurrentUser(selectedUser, userList.getSelectedIndex());
      showMessage(" user\n" + userName+"\n logged in");
      displayText(" user <" + userName+"> logged in");
/*
      try {
        //parent.getIdentificationAgent().login(userName, selectedUser.getCredential());
        setCurrentUser(selectedUser, userList.getSelectedIndex());
      }
      catch (OTFException oe) {
        oe.printStackTrace();
        showMessage("Unable to login user\n" + userName + ".\nUsing previous instead");
        if (currentUser != null) {
          previousUserSelected = true;
          try {
            parent.getIdentificationAgent().login(currentUser.getName(), currentUser.getCredential());
            userList.setSelected(currenUserIndex, true);
            setCurrentUser(currentUser, currenUserIndex);
          }
          catch (OTFException oe2) {
            oe2.printStackTrace();
            showMessage("Unable to login user\n" + currentUser.getName());
          }
          previousUserSelected = false;
        }
      }
*/
    }
    userList.setEnabled(true);
  }

  /****************************************************************/
  /** show message in window */
  private void showMessage(String message) {
    Frame vtframe = vt.getFrame();
    //  MessageDialog messageDialog = new MessageDialog(this, MessageDialog.OK_OPTION, message);
    MessageDialog messageDialog = new MessageDialog(vtframe, MessageDialog.OK_OPTION, message);
    messageDialog.pack(); //setSize(200, 100);
    messageDialog.setBackground(Color.yellow);
    Rectangle pRect = messageDialog.getParent().getBounds();
    Rectangle dRect = messageDialog.getBounds();
    messageDialog.setBounds(pRect.x + ((pRect.width - dRect.width) / 2), pRect.y + ((pRect.height - dRect.height) / 2), 200, 100);
    messageDialog.show();
  }

  /********************/
  /** display */
  private void displayText(String text) {
    if(display.getItemCount()>40) {
      display.removeAll();
    }
    System.out.println(text);
    display.add(text,0);
  }

  public String getHelpText(){
    return "Test on the construction and behavior of the change-user menu for the IAA demo:\n"+
           "The screen should show a simulated change-user menu panel and an event display list\n"+
           "Clicking on one of the users causes this user to <log in> and the previuos one (if present) to <log out>\n"+
           "When logging in and logging out a MessagePanel will appear to let you confirm the actions taken "+
           "\n\n Ps, the event windows don't disappear by themselves when leaving this test: if they persist through the next test, "+
           " delete them manually by clicking their 'ok'-button";
  }

  /********************/
  /** test main */
  static public void main (String[] args) {
	  new ChangeUserSim();
  }

  // (end of class CopyWriter
}
