/*
 * ImageButton.java
 *
 * Created on 7 augustus 2001, 14:54
 */

package com.acunia.wonka.test.awt.IAA;

import java.awt.*;
import java.awt.event.*;

/**
 *
 * @author  Standard
 * @version
 */
public class ImageButton extends Component {
  
  private ImageButtonConfig _config;
  private boolean _pressed = false;
  private ActionListener _actionListener = null;
  private String param;
  
  public ImageButton() {
    addMouseListener(new ClickAdapter());
  }
  
  public ImageButton(ImageButtonConfig config) {
    _config = new ImageButtonConfig(config);
    addMouseListener(new ClickAdapter());
    Image img = config.getEnabledImage();
System.out.println("Imagebutton enabled image="+img);
    int width = img.getWidth(this);
    int height = img.getHeight(this);
System.out.println("Imagebutton width="+width+" , height="+height);
    setSize(width, height);
  }
  
  public void addActionListener(ActionListener l) {
    _actionListener = AWTEventMulticaster.add(_actionListener, l);
  }
  
  public void removeActionListener(ActionListener l) {
    _actionListener = AWTEventMulticaster.remove(_actionListener, l);
  }
  
  
  public void paint(Graphics g) {
    super.paint(g);
    Image img = isEnabled() ? (_pressed ? _config.getPushedImage() : _config.getEnabledImage())
    : _config.getDisabledImage();
    g.setColor(Color.white);
    int imageX = (this.getSize().width - img.getWidth(this)) / 2;
    //g.fillRect(0, 0, imageX, this.getSize().height);
    g.fillRect(0, 0, this.getSize().width, this.getSize().height);
    g.drawImage(img, imageX, 0, this);
  }
  
  private final class ClickAdapter extends MouseAdapter {
    public void mousePressed(MouseEvent e) {
      if (isEnabled()) {
        _pressed = true;
        repaint();
      }
    }
    
    public void mouseReleased(MouseEvent e) {
      if (isEnabled()) {
        _pressed = false;
        repaint();
        if (_actionListener != null) {
          _actionListener.actionPerformed(
          new ActionEvent(ImageButton.this,
          ActionEvent.ACTION_PERFORMED, ""));
        }
      }
    }
  }
  
  public void setConfig(ImageButtonConfig config) {
    _config = new ImageButtonConfig(config);
    Image img = config.getEnabledImage();
    setSize(img.getWidth(this), img.getHeight(this));
  }
  
  public ImageButtonConfig getConfig() {
    return _config;
  }
  
  public Dimension getPreferredSize() {
    if (_config != null) {
      Image img = _config.getEnabledImage();
      return new Dimension(img.getWidth(this), img.getHeight(this));
    }
    return new Dimension(-1,-1);
  }
  
  public Dimension getMinimumSize() {
    return getPreferredSize();
  }
  
  public Dimension getMaximumSize() {
    return getPreferredSize();
  }
  
  public void setEnabled(boolean enabled) {
    super.setEnabled(enabled);
    repaint();
  }
  
  public void setParam(String param) {
    this.param = param;
  }
  
  public String getParam() {
    return this.param;
  }
  
}
