/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

// Author: N.Oberfeld
// Version 1.01.01
// Created: 2001/08/29

package com.acunia.wonka.test.awt.IAA;

//import
import java.awt.*;       // layout & buttons
import java.awt.event.*; // button events

public interface ImageDefs {
	
  /****************************************************************/
  /** default image names
  */
  
  final static String path = System.getProperty("property.path", "/test");
  
  final static String NEWSIMAGE = path + "/news.png";

  /** map */
  final static String MAPIMAGE = path + "/map.png";
  final static String MAPACTIVE = path + "/map_a.png";
  final static String MAPPASSIVE = path + "/map_d.png";

  /** list-down button for combo box*/
  final static String LISTIMAGE = path + "/list.png";
  final static String LISTACTIVE = path + "/list_a.png";
  final static String LISTDISABLED = path + "/list_d.png";

  /** 'okay' button (no passive) */
  final static String OKIMAGE = path + "/ok.png";
  final static String OKACTIVE = path + "/ok_a.png";

  /** 'yes'/'no' button (no passive) */
  final static String YESIMAGE = path + "/yes.png";
  final static String YESACTIVE = path + "/yes_a.png";
  final static String NOIMAGE = path + "/no.png";
  final static String NOACTIVE = path + "/no_a.png";

  /** Scrollbar up-down-middle */
  final static String SCROLLUP_DEFAULT =  path + "/scrollup.png";
  final static String SCROLLUP_ACTIVE =  path + "/scrollup_a.png";
  final static String SCROLLUP_PASSIVE =  path + "/scrollup_d.png";
  final static String SCROLLDOWN_DEFAULT =  path + "/scrolldown.png";
  final static String SCROLLDOWN_ACTIVE =  path + "/scrolldown_a.png";
  final static String SCROLLDOWN_PASSIVE =  path + "/scrolldown_d.png";
  final static String SCROLLMIDDLE =  path + "/scrollmid.png";

  /** Tabs for TabbedPane */
  final static String TAB1_ACTIVE = path + "/tab-1-a.png";
  final static String TAB1_PASSIVE = path + "/tab-1-d.png";
  final static String TAB2_ACTIVE = path + "/tab-2-a.png";
  final static String TAB2_PASSIVE = path + "/tab-2-d.png";
  final static String TAB3_ACTIVE = path + "/tab-3-a.png";
  final static String TAB3_PASSIVE = path + "/tab-3-d.png";

}
