/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

// V.1.01.00 2001/08/29 : first release
// V.1.01.01 2001/08/29 : excluded CVS directories from files list
// V.1.01.02 2001/08/29 : Option to only load checked files
// V.1.02.01 2001/08/31 : Double list and quick scan possibilities
// V.1.02.02 2001/08/31 : bugfixes and selective file-load for subdirs
// V.1.02.03 2001/08/31 : added buttons for showing scripts and c/h/java files
// V.1.02.03 2001/09/03 : logging file
// V.1.02.04 2001/09/03 : edit screen allows to place header on current text position / button for header files only
// V.1.02.05 2001/09/03 : added buttons for same directory and last directory


// Author: N.Oberfeld
// Version 1.01.01
// Created: 2001/08/29

package com.acunia.wonka.test.awt.IAA;

//import
import com.acunia.wonka.test.awt.*;
import java.io.*;        // File & Streams
import java.awt.*;       // layout & buttons
import java.awt.event.*; // button events

public class ImageIconTest extends VisualTestImpl implements ImageDefs, ActionListener {
	

  /****************************************************************/
  /** variables
  */
  private ImageIcon labelTop;
  private ImageIcon labelBottom;
  private ImageIcon labelLeft;
  private ImageIcon labelRight;

  private ImageIcon textfieldTop;
  private ImageIcon textfieldBottom;
  private ImageIcon textfieldLeft;
  private ImageIcon textfieldRight;

  private List display;
  /****************************************************************/
  /** constructor
  */
  public ImageIconTest() {
    super();

    setLayout(new BorderLayout());
    // images
    ImageButtonConfig okay = null;
    try {
      okay = new ImageButtonConfig(this, OKIMAGE, OKIMAGE, OKACTIVE);
    }
    catch(Exception ex) {
      ex.printStackTrace();
    }
    // left top & bottom icons
    Panel left = new Panel(new BorderLayout());
      labelTop = new ImageIcon("top", okay, ImageIcon.TOP, false);
      labelTop.setBackground(Color.red);
      labelTop.addActionListener(this);
      left.add(labelTop, BorderLayout.NORTH);

      labelBottom = new ImageIcon("Bottom", okay, ImageIcon.BOTTOM, false);
      labelBottom.setBackground(Color.green);
      labelBottom.addActionListener(this);
      left.add(labelBottom, BorderLayout.SOUTH);
    add(left, BorderLayout.WEST);

    // right top & botom icons
    Panel right = new Panel(new BorderLayout());
      textfieldTop = new ImageIcon("top", okay, ImageIcon.TOP, true);
      textfieldTop.setBackground(Color.red);
      textfieldTop.addActionListener(this);
      right.add(textfieldTop, BorderLayout.NORTH);

      textfieldBottom = new ImageIcon("bottom", okay, ImageIcon.BOTTOM, true);
      textfieldBottom.setBackground(Color.green);
      textfieldBottom.addActionListener(this);
      right.add(textfieldBottom, BorderLayout.SOUTH);
    add(right, BorderLayout.EAST);

    // center left & right icons
    Panel center = new Panel(new GridLayout(4,1));
      labelLeft = new ImageIcon("left", okay, ImageIcon.LEFT, false);
      labelLeft.setBackground(Color.green);
      labelLeft.addActionListener(this);
      center.add(labelLeft);

      labelRight = new ImageIcon("right", okay, ImageIcon.RIGHT, false);
      labelRight.setBackground(Color.yellow);
      labelRight.addActionListener(this);
      center.add(labelRight);

      textfieldLeft = new ImageIcon("left textfield", okay, ImageIcon.LEFT, true);
      textfieldLeft.setBackground(Color.blue);
      textfieldLeft.addActionListener(this);
      center.add(textfieldLeft);

      textfieldRight = new ImageIcon("right textfield", okay, ImageIcon.RIGHT, true);
      textfieldRight.setBackground(Color.red);
      textfieldRight.addActionListener(this);
      center.add(textfieldRight);
    add(center, BorderLayout.CENTER);

    display = new List(2,false);
    add(display , BorderLayout.SOUTH);
  }

  /****************************************************************/
  /**button pressed : Display event */
  private void displayText(String text) {
    if(display.getItemCount()>40) {
      display.removeAll();
    }
    System.out.println(text);
    display.add(text,0);
  }

  /****************************************************************/
  /**button pressed : Display event */
  public void actionPerformed(ActionEvent evt) {
    Component source = (Component)evt.getSource();
    displayText(source.getClass().getName()+" clicked");
  }


  public String getHelpText(){
    return "Test on the construction and behavior of the giza.component.util classes used for the IAA demo:\n"+
           "On the screen you should see eight ImageIcon components: a group of labels with Icons, the label being placed above, under,"+
           " left or right of the icon and a group of editable textfield with icons, the fields being placed above, under"+
           "left and right of the icon as well,\n"+
           "The icon is an Imagebutton and clicking it should trigger an actionevent in the event list on the bottom of the test\n"+
           "\nspecial AWT classes needed:\n==========================\n"+
           "-> ImageIcon\n"+
           "-> Imagebutton, ImageButtonConfig and ImageUtils\n"+
           "-> GridbagLayout for left- and right aligned ImageIcons";
  }

  /********************/
  /** test main */
  static public void main (String[] args) {
	  new ImageIconTest();
  }

  // (end of class CopyWriter
}
