/*
 * ImageLabel.java
 *
 * Created on August 23, 2001, 4:52 PM
 */

package com.acunia.wonka.test.awt.IAA;

import java.awt.*;


/**
 *
 * @author  jan
 * @version
 */
public class ImageLabel extends Component {
  protected Image image;
  private int sx = -1;
  private int sy = -1;
  
  public ImageLabel() {
  }
  
  public ImageLabel(Image image) {
    this.image = image;
  }
  
  public void paint(Graphics g) {
    super.paint(g);
    if  (image!= null) {
      if(sx == -1 && sy == -1) {
        g.drawImage(image, 0, 0, this);
      } else {
        double width = image.getWidth(this);
        double height = image.getHeight(this);
        double xDiv = width / sx;
        double yDiv = height / sy;
        double maxScale = Math.max(xDiv, yDiv);
        
        g.clearRect(0,0,(int)width, (int)height);

        g.drawImage(image,((int)sx - (int)(width/maxScale)) / 2 ,0,(int)(width/maxScale),(int)(height/maxScale),0,0,(int)width, (int)height, this);
      }
    } else {
      g.drawString("NO IMAGE", 50, 50);
    }
  }
  
  public void setImage(Image image) {
   setImage(image, -1, -1);
  }
  
  public void setImage(Image image, int sx, int sy) {
    this.sx = sx;
    this.sy = sy;
    this.image = image;
    this.repaint();
  }
  
  public Dimension getPreferredSize() {
    return image == null ? super.getPreferredSize() : new Dimension(image.getWidth(this), image.getHeight(this));
  }
  
  public Dimension getMinimumSize() {
    return getPreferredSize();
  }
  
  public Dimension getMaximumSize() {
    return getPreferredSize();
  }
}
