/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

// V.1.01.00 2001/08/29 : first release
// V.1.01.01 2001/08/29 : excluded CVS directories from files list
// V.1.01.02 2001/08/29 : Option to only load checked files
// V.1.02.01 2001/08/31 : Double list and quick scan possibilities
// V.1.02.02 2001/08/31 : bugfixes and selective file-load for subdirs
// V.1.02.03 2001/08/31 : added buttons for showing scripts and c/h/java files
// V.1.02.03 2001/09/03 : logging file
// V.1.02.04 2001/09/03 : edit screen allows to place header on current text position / button for header files only
// V.1.02.05 2001/09/03 : added buttons for same directory and last directory


// Author: N.Oberfeld
// Version 1.01.01
// Created: 2001/08/29

package com.acunia.wonka.test.awt.IAA;

//import
import com.acunia.wonka.test.awt.*;
import java.io.*;        // File & Streams
import java.awt.*;       // layout & buttons
import java.awt.event.*; // button events

public class ImageScrollPaneTest extends VisualTestImpl implements ImageDefs, ActionListener {
	
  /****************************************************************/
  /** variables
  */
  private ImageButton panelButton1;
  private Label panelText1;
  private ImageButton panelButton2;
  private Label panelText2;
  private ImageButton panelButton3;
  private Label panelText3;
  private ImageButton panelButton4;
  private Label panelText4;
  private ImageButton panelButton5;
  private Label panelText5;
  private ImageButton panelButton6;
  private Label panelText6;

  private List display;

  /****************************************************************/
  /** constructor
  */
  public ImageScrollPaneTest() {
    super();

    setLayout(new BorderLayout());

    display = new List();
    display.add("Observer ImageUpdate() dispayed here");
    add(display, BorderLayout.SOUTH);

    ImageButtonConfig mapimages = null;
    try {
      mapimages = new ImageButtonConfig(this, MAPIMAGE, MAPACTIVE, MAPPASSIVE);
    }
    catch (Exception ex) {
      ex.printStackTrace();
      displayText(ex.toString());
    }

    if(mapimages!= null){
       Panel buttons = new Panel(new GridLayout(7,2));

       panelButton1 = new ImageButton(mapimages);
       panelButton1.setName("Map button 1");
       panelButton1.addActionListener(this);
       buttons.add(panelButton1);
       buttons.add(new Label("Map Button 1"));

       panelButton2 = new ImageButton(mapimages);
       panelButton2.setName("Map button 2");
       panelButton2.addActionListener(this);
       buttons.add(panelButton2);
       buttons.add(new Label("Map Button 2"));

       panelButton3 = new ImageButton(mapimages);
       panelButton3.setName("Map button 3");
       panelButton3.addActionListener(this);
       buttons.add(panelButton3);
       buttons.add(new Label("Map Button 3"));

       panelButton4 = new ImageButton(mapimages);
       panelButton4.setName("Map button 4");
       panelButton4.addActionListener(this);
       buttons.add(panelButton4);
       buttons.add(new Label("Map Button 4"));

       panelButton5 = new ImageButton(mapimages);
       panelButton5.setName("Map button 5");
       panelButton5.addActionListener(this);
       buttons.add(panelButton5);
       buttons.add(new Label("Map Button 5"));

       panelButton6 = new ImageButton(mapimages);
       panelButton6.setName("Map button 6");
       panelButton6.addActionListener(this);
       buttons.add(panelButton6);
       buttons.add(new Label("Map Button 6"));

       ScrollableContainer sc = new ScrollableContainer(buttons);
       add(sc, BorderLayout.CENTER);
    }
    else {
      System.out.println("Unable to load Images "+ MAPIMAGE);
    }

  }



  /****************************************************************/
  /**button pressed : Display event */
  public void actionPerformed(ActionEvent evt) {
    Component source = (Component)evt.getSource();
    displayText(source.getName()+" clicked:"+evt.getID());
  }


  /************/
  /** display */
  private void displayText(String text) {
    if(display.getItemCount()>40) {
      display.removeAll();
    }
    System.out.println(text);
    display.add(text,0);
  }


  public String getHelpText(){
    return "Test on the construction and behavior of the giza.component.util.ScrollableContainer class used for the IAA demo:\n"+
           "On the screen you should see a ScrollableContainer type scrollpane containing six ImageButtons.\n"+
           " => As the total height of the buttons is higher then the scrollpane, you will have to scroll up and down in order to see"+
           " the uppermost and lowermost buttons\n"+
           " => Clicking on a button fires an actionEvent displayed in the list below \n"+
           "\n   ============\nUses the java.awt.ScrollPane\n   ============\n";
  }

  /********************/
  /** test main */
  static public void main (String[] args) {
	  new ImageScrollbarTest();
  }

  // (end of class CopyWriter
}
