/**
 * SplashScreen.java
 *
 * @author Jan Castermans
 */

package com.acunia.wonka.test.awt.IAA;

import java.awt.*;
import java.awt.event.*;

public class SplashScreen extends Window {
  private Image _splashImage;
  private int _imgWidth;
  private int _imgHeight;
  private String _imgName;
  private static final int BORDERSIZE = 5;
  private static final Color BORDERCOLOR = Color.blue;
  
  public SplashScreen(Frame f, String imgName) {
    super(f);
    _imgName = imgName;
    _splashImage = loadSplashImage(f);
    showSplashScreen();
    f.addWindowListener(new WindowListener());
  }
  public Image loadSplashImage(Component c) {
    Image result = null;
    
    try {
      result = ImageUtils.loadImage(c, _imgName);
    _imgWidth = result.getWidth(this);
    _imgHeight = result.getHeight(this);
    } catch (Exception e) {
      e.printStackTrace();
    }
    
    return (result);
  }
  public boolean imageUpdate(Image img, int flags, int x,  int y, int width, int height) {
    if ((flags & (FRAMEBITS|ALLBITS))!= 0) {
      repaint();
    }
    
    return (flags & (ALLBITS|ABORT)) == 0;
  }
  
  public void update(Graphics g) {
    paint(g);
  }
  
  public void showSplashScreen() {
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    //setBackground(BORDERCOLOR);
    int w = _imgWidth + (BORDERSIZE * 2);
    int h = _imgHeight + (BORDERSIZE * 2);
    int x = (screenSize.width - w) /2;
    int y = (screenSize.height - h) /2;
    setBounds(x, y, w, h);
    setVisible(true);
  }
  
  public void paint(Graphics g) {
    g.drawImage(_splashImage, BORDERSIZE, BORDERSIZE,
    _imgWidth, _imgHeight, this);
  }
  
  class WindowListener extends WindowAdapter {
    public void windowActivated(WindowEvent we) {
      setVisible(false);
      dispose();
    }
  }
}

