/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

// V.1.01.00 2001/08/29 : first release
// V.1.01.01 2001/08/29 : excluded CVS directories from files list
// V.1.01.02 2001/08/29 : Option to only load checked files
// V.1.02.01 2001/08/31 : Double list and quick scan possibilities
// V.1.02.02 2001/08/31 : bugfixes and selective file-load for subdirs
// V.1.02.03 2001/08/31 : added buttons for showing scripts and c/h/java files
// V.1.02.03 2001/09/03 : logging file
// V.1.02.04 2001/09/03 : edit screen allows to place header on current text position / button for header files only
// V.1.02.05 2001/09/03 : added buttons for same directory and last directory


// Author: N.Oberfeld
// Version 1.01.01
// Created: 2001/08/29

package com.acunia.wonka.test.awt.IAA;

//import
import com.acunia.wonka.test.awt.*;
import java.io.*;        // File & Streams
import java.awt.*;       // layout & buttons
import java.awt.event.*; // button events

public class SplashTest extends VisualTestImpl implements ImageDefs, ActionListener{
	
  /****************************************************************/
  /** variables
  */
  Button leftSplash;
  Button rightSplash;

  Button showLeft;
  Button hideLeft;
  Button frontLeft;
  Button backLeft;

  Button showRight;
  Button hideRight;
  Button frontRight;
  Button backRight;

  Frame leftAnchor;
  Frame rightAnchor;

  List display;

  /****************************************************************/
  /** constructor
  */
  public SplashTest() {
    super();

    leftAnchor = null;
    rightAnchor = null;

    // build screen
    setLayout(new BorderLayout());
    // list
    display = new List();
    display.add("Dialog outcome dispayed here");
    add(display, BorderLayout.SOUTH);
    // buttons
    Panel buttons = new Panel(new GridLayout(6,2) );
      leftSplash = new Button("new left SplashScreen");
      leftSplash.addActionListener(this);
      buttons.add(leftSplash);
      rightSplash = new Button("new right SplashSreen");
      rightSplash.addActionListener(this);
      buttons.add(rightSplash);

      buttons.add(new Label("Left anchor frame:"));
      buttons.add(new Label("Right anchor frame:"));

      showLeft = new Button("show frame");//("simple ok-dialog");
      showLeft.addActionListener(this);
      buttons.add(showLeft);
      showRight = new Button("show frame");//("simple ok-dialog");
      showRight.addActionListener(this);
      buttons.add(showRight);

      hideLeft = new Button("hide frame");//("simple ok-dialog");
      hideLeft.addActionListener(this);
      buttons.add(hideLeft);
      hideRight = new Button("hide frame");//("simple ok-dialog");
      hideRight.addActionListener(this);
      buttons.add(hideRight);

      frontLeft = new Button("frame to front");//("simple ok-dialog");
      frontLeft.addActionListener(this);
      buttons.add(frontLeft);
      frontRight = new Button("frame to front");//("simple ok-dialog");
      frontRight.addActionListener(this);
      buttons.add(frontRight);

      backLeft = new Button("frame to back");//("simple ok-dialog");
      backLeft.addActionListener(this);
      buttons.add(backLeft);
      backRight = new Button("frame to back");//("simple ok-dialog");
      backRight.addActionListener(this);
      buttons.add(backRight);

    add(buttons , BorderLayout.CENTER);
  }

  public void stop(java.awt.Panel p){
    if(leftAnchor != null) {
      leftAnchor.dispose();
      leftAnchor = null;
    }
    if(rightAnchor != null) {
      rightAnchor.dispose();
      rightAnchor = null;
    }
  }

  /****************************************************************/
  /**button pressed : Display desired dialog window */
  public void actionPerformed(ActionEvent evt) {
    Component source = (Component)evt.getSource();
    if(source == leftSplash) {
      if(checkLeft()) {
        SplashScreen left = new SplashScreen(leftAnchor, NOIMAGE);
        left.show();
        displayText("new left SplashScreen (red)");
      }
    }
    else if(source == rightSplash) {
      if(checkRight()) {
        SplashScreen right = new SplashScreen(rightAnchor, OKIMAGE);
        right.show();
        displayText("new right SplashScreen (blue)");
      }
    }
    else if(source == showLeft) {
      if(checkLeft()) {
        leftAnchor.show(); //setVisible(true);
        displayText("Left anchor frame shown");
      }
    }
    else if(source == showRight) {
      if(checkRight()) {
        rightAnchor.show(); //.setVisible(true);
        displayText("Right anchor frame shown");
      }
    }
    else if(source == hideLeft) {
      if(checkLeft()) {
        leftAnchor.setVisible(false);
        displayText("Left anchor frame hidden");
      }
    }
    else if(source == hideRight) {
      if(checkRight()) {
        rightAnchor.setVisible(false);
        displayText("Right anchor frame hidden");
      }
    }
    else if(source == frontLeft) {
      if(checkLeft()) {
        leftAnchor.toFront();
        displayText("Left anchor frame to front");
      }
    }
    else if(source == frontRight) {
      if(checkRight()) {
        rightAnchor.toFront();
        displayText("Right anchor frame to front");
      }
    }
    else if(source == backLeft) {
      if(checkLeft()) {
        leftAnchor.toBack();
        displayText("Left anchor frame to back");
      }
    }
    else if(source == backRight) {
      if(checkRight()) {
        rightAnchor.toBack();
        displayText("Right anchor frame to back");
      }
    }
  }

  /**************************/
  /** Display event on list */
  private void displayText(String text){
    // clean list if needed
    if(display.getItemCount()>40) {
      display.removeAll();
    }
    //message to list
    display.add(text,0);
    //message to screen
    System.out.println(text);
  }


  /***************************/
  /** build left frane if needed */
  private boolean checkLeft() {
    displayText("Checking frames: left anchor = "+leftAnchor);

    Frame vtframe = vt.getFrame();
    if(vtframe == null) {
      // unable to access the main wonka frame yet
      displayText("Skipped command for vt.getFrame() not available yet");
      return false;
    }
    else if(leftAnchor == null) {
      leftAnchor = new Frame("Left anchor Frame"); //(vtframe, "Anchor frame");
      leftAnchor.setLayout(new GridLayout(7,3));
      leftAnchor.setBackground(Color.red);
      leftAnchor.setForeground(Color.white);
      leftAnchor.add(new Label("The Beatles",Label.RIGHT));
      leftAnchor.add(new Label());
      leftAnchor.add(new Label());

      leftAnchor.add(new Label());
      leftAnchor.add(new Label());
      leftAnchor.add(new Label());

      leftAnchor.add(new Label());
      leftAnchor.add(new Label("the",Label.CENTER));
      leftAnchor.add(new Label());

      leftAnchor.add(new Label());
      leftAnchor.add(new Label("R E D",Label.CENTER));
      leftAnchor.add(new Label());

      leftAnchor.add(new Label());
      leftAnchor.add(new Label("album",Label.CENTER));
      leftAnchor.add(new Label());

      leftAnchor.pack();
      displayText("Build Left anchor frame "+leftAnchor);
      return true;
    }
    else {
      // the anchor frame is up and running => just return 'the clock striketh ten and all is well'
      return true;
    }
  }

  /***************************/
  /** build right frane if needed */
  private boolean checkRight() {
    displayText("Checking frames: right anchor = "+rightAnchor);

    Frame vtframe = vt.getFrame();
    if(vtframe == null) {
      // unable to access the main wonka frame yet
      displayText("Skipped command for vt.getFrame() not available yet");
      return false;
    }
    else if(rightAnchor == null) {
      // the anchor frame isn't built yet => build it now
      rightAnchor = new Frame("Right anchor frame"); //(vtframe, "Anchor frame");
      rightAnchor.setLayout(new GridLayout(7,3));
      rightAnchor.setBackground(Color.blue);
      rightAnchor.setForeground(Color.white);
      rightAnchor.add(new Label("The Beatles",Label.RIGHT));
      rightAnchor.add(new Label());
      rightAnchor.add(new Label());

      rightAnchor.add(new Label());
      rightAnchor.add(new Label());
      rightAnchor.add(new Label());

      rightAnchor.add(new Label());
      rightAnchor.add(new Label("the",Label.CENTER));
      rightAnchor.add(new Label());

      rightAnchor.add(new Label());
      rightAnchor.add(new Label("B L U E",Label.CENTER));
      rightAnchor.add(new Label());

      rightAnchor.add(new Label());
      rightAnchor.add(new Label("album",Label.CENTER));
      rightAnchor.add(new Label());

      rightAnchor.pack();      displayText("Build right anchor frame "+rightAnchor);
      return true;
    }
    else {
      // the anchor frame is up and running => just return 'the clock striketh ten and all is well'
      return true;
    }
  }


  /***************************/
  /** VirtualTestEngine help */
  public String getHelpText(){
    return "Test on the construction and behavior of the giza.component.util classes used for the IAA demo:\n"+
           "This test simulates the behavior of the SplashScreen class. A splash screen is a little 'anouncement' window with a logo"+
           " image that appears on the screen for a brief moment while the main application (Frame) is being constructed"+
           "And disappears as soon as this main screen is shown\n"+
           "-> the four buttons show, hide, to front and to-back each show, hide, bring to back or bring to front the left (red)"+
           " or right(blue) anchor frame\n"+
           "-> the two <new splash-screen> buttons each build a SplashScreen instance attached to their according frame\n"+
           "On correct behavior, build a frame, hide it, build the splash-screen and show the frame again."+
           " The splash screen should now disappear";
  }

  /********************/
  /** test main */
  static public void main (String[] args) {
	  new SplashTest();
  }

  // (end of class CopyWriter
}
