/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.awt.IAA;

import com.acunia.wonka.test.awt.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class TabbedPaneTest extends VisualTestImpl implements ImageDefs {
	
  public TabbedPaneTest() {
    super();
    
    Panel panel1 = new Panel();
    Panel panel2 = new Panel();
    Panel panel3 = new Panel();

    panel1.add(new Label("This is panel 1"));
    panel2.add(new Label("This is panel 2"));
    panel3.add(new Label("This is panel 3"));

    panel1.setBackground(new Color(214, 214 ,214));
    panel2.setBackground(new Color(214, 214 ,214));
    panel3.setBackground(new Color(214, 214 ,214));

    setBackground(Color.white);

    setLayout(new BorderLayout(10, 10));
    TabbedPane mainPanel = new TabbedPane(TabbedPane.SOUTH);
    
    Image tab1 = Toolkit.getDefaultToolkit().getImage(TAB1_PASSIVE); 
    Image tab1_sel = Toolkit.getDefaultToolkit().getImage(TAB1_ACTIVE); 
    Image tab2 = Toolkit.getDefaultToolkit().getImage(TAB2_PASSIVE); 
    Image tab2_sel = Toolkit.getDefaultToolkit().getImage(TAB2_ACTIVE); 
    Image tab3 = Toolkit.getDefaultToolkit().getImage(TAB3_PASSIVE); 
    Image tab3_sel = Toolkit.getDefaultToolkit().getImage(TAB3_ACTIVE); 

    mainPanel.addTab(panel1, new ToggleButton(tab1, tab1_sel));
    mainPanel.addTab(panel2, new ToggleButton(tab2, tab2_sel));
    mainPanel.addTab(panel3, new ToggleButton(tab3, tab3_sel));
    mainPanel.setSelectedTab(0);

    add(mainPanel, BorderLayout.CENTER);
  }

  public Insets getInsets() {
    return new Insets(10, 10, 10, 10);
  }

  public String getHelpText(){
    return "olleke bolleke\n";
  }

}
