/*
 * ToggleButton.java
 *
 * Created on August 29, 2001, 4:13 PM
 */

package com.acunia.wonka.test.awt.IAA;

import java.awt.Component;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Graphics;
import java.awt.AWTEventMulticaster;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

/**
 *
 * @author  Standard
 * @version
 */
public class ToggleButton extends Component {
  private boolean selected = false;
  private ActionListener actionListener = null;
  protected Image image;
  protected Image imageSelected;
  
  public ToggleButton(Image image,  Image imageSelected) {
   this.image = image;
   this.imageSelected = imageSelected;
    setSize(image.getWidth(this), image.getHeight(this));
  }
  
  public void paint(Graphics g) {
    super.paint(g);
    Image img = selected?imageSelected:image;
    g.setColor(Color.lightGray);
    int imageX = (this.getSize().width - img.getWidth(this)) / 2;
    g.fillRect(0, 0, imageX, this.getSize().height);
    g.fillRect(imageX + img.getWidth(this), 0, this.getSize().width, this.getSize().height);
    g.drawImage(img, imageX, 0, this);
  }
  
  public void setSelected(boolean selected) {
    this.selected = selected;
  }
  
  public Dimension getPreferredSize() {
    if (image != null) {
      return new Dimension(image.getWidth(this), image.getHeight(this));
    }
    return new Dimension(-1,-1);
  }
  
  public Dimension getMinimumSize() {
    return getPreferredSize();
  }
  
  public Dimension getMaximumSize() {
    return getPreferredSize();
  }
  
  public void setEnabled(boolean enabled) {
    super.setEnabled(enabled);
    repaint();
  }
}
