/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


package com.acunia.wonka.test.awt;

import java.awt.event.*;
import java.awt.Label;

public class TimerThread implements Runnable, MouseListener {

  private VisualTestEngine vte;
  private Label info;
  private boolean stop = false;
  private long total = Runtime.getRuntime().totalMemory();
  private boolean status = true;
  private long lastLog;
 	
  public TimerThread(VisualTestEngine t, Label i) {
    vte = t;
    info = i;
    info.addMouseListener(this);
  }
 	
  public void mouseClicked(MouseEvent event) {
    status = status ? false : true;
    info.invalidate();
  }
  
  public void mouseEntered(MouseEvent event) {
  }
  
  public void mouseExited(MouseEvent event) {
  }
  
  public void mousePressed(MouseEvent event) {
  }
  
  public void mouseReleased(MouseEvent event) {
  }

  public void stop() {
    stop = true;
  }
 	
  public void run() {
    while (!stop) {
      try {
      	Thread.sleep(500);
      	String stats = "";
        if (status == true) {	
          stats = "memory: "+ (total - Runtime.getRuntime().freeMemory()) + " / " + total +" bytes";
        }
        else {
          stats = "round trip time: "+ vte.getRoundTrip() +" ms";
        }
        info.setText(stats);
        info.invalidate();

        if(vte.autorun) {
          long time = System.currentTimeMillis();
          if(time > lastLog + 10 * 60 * 1000){
            String msg = "TimerThread autorun status: \n";
            msg = msg + "\t completed "+vte.runCount+" runs\n";
            msg = msg + "\t currently testing "+vte.getCurrentTest();
            msg = msg + "\n\t "+stats;
            vte.log(msg, vte.getCurrentTest());
            lastLog = time;
          }
        }
      }
      catch(Exception e){
        e.printStackTrace();
        VTELogger.reportException("TimerThread: exception occured",e,true);
      } 	
    }
  }
}
