/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


package com.acunia.wonka.test.awt;

import java.awt.Panel;
import java.util.Date;
import java.io.*;

class VTELogger implements Runnable {

// static Logging section ...

/**
** if doWrite is true this method will not start a thread new thread but call errorlog itself
** this method should be be called with doWrite set to false if called from within the rudolph thread
*/
  static void reportException(String msg, Throwable t, boolean doWrite){
     StringBuffer b = new StringBuffer("Logging Exception: ");
     b.append(new Date());
     b.append('\n');
     b.append(msg);
     b.append('\n');
     b.append(logStackTrace(t));
     b.append("\nEnd of Exception log\n\n");
     if(doWrite){
       errorLog(b.toString());
     }
     else {
       new VTELogger(b.toString());
     }
  }

  static void log(String log, VisualTest v) {
    StringBuffer b = new StringBuffer("Logging Event ");
    b.append(new Date().toString());
    b.append('\n');
    b.append(v.getClass().getName());
    b.append('\n');
	  b.append(log);
    b.append("\ndone logging ...\n\n");
    new VTELogger(b.toString());     	
  }	

  static void logException(String log, VisualTest v, Throwable ex) {
    StringBuffer b = new StringBuffer("Logging Exception ");
    b.append(new Date().toString());
    b.append('\n');
    b.append(v.getClass().getName());
    b.append("\nMessage: ");
	  b.append(log);
    b.append("\n\n");
    b.append(logStackTrace(ex));
    b.append("\nEnd of Exception log\n\n");
    new VTELogger(b.toString());     	
  }	

  static char[] logStackTrace(Throwable t){
    try {
      CharArrayWriter cw = new CharArrayWriter();
      PrintWriter pw = new PrintWriter(cw);
      t.printStackTrace(pw);
      pw.close();
      return cw.toCharArray();
    }
    catch(Exception e){
      return ("FAILED TO PRINT A STACKTRACE OF "+t+"\n\tDUE TO :"+e+"\n").toCharArray();
    }
  }

  synchronized static void errorLog(String error) {
     FileWriter fw = null;
     try {
    	 fw = new FileWriter("vte.log", true);
    	 fw.write(error);
     }
     catch (IOException ioe) { }
     finally { 	
    	 if (fw != null) {
    	   try { fw.flush(); }
    	   catch (IOException e) { }
    	   try { fw.close(); }
    	   catch (IOException e) { }    	      		
    	 }
    }  	     	
  }

  synchronized static void writeLog(boolean r, VisualTest vt, Panel p, String name) {
    FileWriter fw = null;
    try {
    	fw = new FileWriter("vte.log", true);
    	fw.write("\nLogging: " + name + "\n");
    	fw.write("Time: " + new Date() + "\n");
    	fw.write("Result: " + (r ? "PASS" : "FAIL") + "\n");
    	fw.write("Log Message:\n");
    	vt.log(p, fw, r);
    	fw.write("\nEnd log Message\n");
    }
    catch (IOException ioe) { }
    finally { 	
    	if (fw != null) {
    	  try { fw.flush(); }
    	  catch (IOException e) { }
    	  try { fw.close(); }
    	  catch (IOException e) { }    	      		
    	}
    }  	     	
  }

  private boolean res;
  private VisualTest vt;
  private Panel p;
  private String log;
    	
  public VTELogger(String l) {
    log = l;
  	new Thread(VisualTestEngine.tg, this, "Logger thread " + this).start();
  }    	    	
    	
  public VTELogger(boolean r, String name, VisualTest vtest, Panel testPanel){
  	res = r;
  	vt = vtest;
  	p = testPanel;
  	log = name;
  }
    	
  public void run() {
  	if (vt != null) {
  	  writeLog(res, vt, p, log);
  	}
  	else {
  	  errorLog(log);
  	}
  }	

}
