/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


package com.acunia.wonka.test.awt.mauve;

import com.acunia.wonka.test.awt.*;
import java.lang.reflect.*;
import java.awt.Label;


public class MauveRunner extends VisualTestImpl{

  static Thread runner;
  private static int count=1;

  private synchronized static void performMauveTest(){
    if(runner == null){
      runner = new Thread(new Runner(), "Mauve Test Thread -- "+count);
      runner.start();
    }
  }

	public MauveRunner(){
	  this.add(new Label("running the mauve suite ...feel free to do the next test"));
	}
	
 	public String getHelpText(){
 	  return "This test will run the mauve test.  These tests will run in a seperate thread.  There are no things you should check here."
 	    +" The results will be logged to the VisualTester.";
 	}
 	
  public void start(java.awt.Panel p, boolean b){
    performMauveTest();
  }

  private static class Runner implements Runnable {

    public void run(){
      try {
        Class c = Class.forName("gnu.testlet.TestRunner");
        Class[] ca = new Class[2];
        ca[0] = c;
        ca[1] = String.class;
        Method m = c.getDeclaredMethod("runTests" , ca);
        Object[] obj = new Object[2];
        obj[0] = c.newInstance();
        obj[1] = "wonkatest.properties";
        m.invoke(null, obj);
      } catch (Exception e){
         System.out.println("MauveRunner thread encountered an exception "+e);
         e.printStackTrace();
      }
      runner = null;
    }
  }
}
