#ifndef _PROCESSOR_H
#define _PROCESSOR_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: processor.h,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
** 
** The Wonka kernel is software copyright by SmartMove NV (1999).
** Please see the file Copyright for information on it's legal use.
** 
*/

/*
** Machine dependent stuff for the StrongARM Architecture
*/

typedef void                        w_void;
typedef unsigned char               w_byte;
typedef unsigned char               w_ubyte;
typedef signed char                 w_sbyte;
typedef short                       w_short;
typedef unsigned short              w_ushort;
typedef int                         w_int;
typedef long long                   w_long;
typedef unsigned long long          w_ulong;
typedef unsigned int                w_float;   /* our emulation library works with int to represent floats ! */
typedef unsigned long long          w_double;  /* a double is made out of 64 bits, or 2 32 bit integers      */
typedef unsigned short              w_char;    /* a char is 16 bits (!) */
typedef int                         w_boolean;
typedef unsigned long long          w_hash;

/*
** A double word quantity is represented as an array of two 32 bit words. 
** LSW(l) and MSW(l) return the lower 32 bits and the upper 32 bits of a 64 bit quantity according
** to the settings of the MS_WORD and LS_WORD parameters. Our Wonka machine always uses these
** macros to get at double word values (be it floating point doubles or long integers).
**
*/

#ifdef BIG_ENDIAN
#undef BIG_ENDIAN
#endif

#ifndef LITTLE_ENDIAN
#define LITTLE_ENDIAN 1234
#endif

#define LITTLE_ENDIAN_PROCESSOR
#define LSW_PART(l)                  (w_word)(l)
#define MSW_PART(l)                  (w_word)((l)>>32)
#define DWORD_TO_WORDS(c, cm, cl)    (cm) = MSW_PART(c); (cl) = LSW_PART(c)
#define SIGN_EXTEND(b)               ((w_word)b)
#define WORDS2LONG(m, l)             (w_long)(((w_long)(m) << 32) | (l))

#endif /* _PROCESSOR_H */
