@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
@ Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 @
@                                                                         @
@ This software is copyrighted by and is the sole property of Acunia N.V. @
@ and its licensors, if any. All rights, title, ownership, or other       @
@ interests in the software remain the property of Acunia N.V. and its    @
@ licensors, if any.                                                      @
@                                                                         @
@ This software may only be used in accordance with the corresponding     @
@ license agreement. Any unauthorized use, duplication, transmission,     @
@  distribution or disclosure of this software is expressly forbidden.    @
@                                                                         @
@ This Copyright notice may not be removed or modified without prior      @
@ written consent of Acunia N.V.                                          @
@                                                                         @
@ Acunia N.V. reserves the right to modify this software without notice.  @
@                                                                         @
@   Acunia N.V.                                                           @
@   Vanden Tymplestraat 35      info@acunia.com                           @
@   3000 Leuven                 http://www.acunia.com                     @
@   Belgium - EUROPE                                                      @
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@

@
@ $Id: calls.s,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
@

.text
.align 0

@
@ unsigned long long call_static(JNIEnv * env, w_method method, word * stacktop, w_word * status, w_instance Class)@
@
@                                      r0            r1                r2               r3          [sp, #0] at entry
@
@ the returned result is in r1:r0 and is not touched by us upon return
@

.global call_static
call_static:
    stmfd sp!, {r4, lr}    @ Save a register we want to work with and link register
    ldr r4, [r1, #4]       @ Get argument count in r4
    cmp r4, #0             @ Are there any arguments
    beq cs_no_arg          @ No, handle this case specially, we don't use the stack..
    cmp r4, #1             @ Is there only one argument ?
    beq cs_single_arg      @ Yes, handle this specially also since we don't have to use the stack

    ldmfd sp!, {r4, lr}    @ We pop what we saved
    stmfd sp!, {r4-r6, lr} @ And push again to have some working registers
    mov r4, sp             @ Save the current stack pointer, we need to restore it after the call
    mov r6, r1             @ Get the method in r6, we can now overwrite r1
    ldr r1, [sp, #16]      @ Store the class instance in r1 as argument 2 for the call
    ldr r5, [r6, #4]       @ Get the argument count in r5
    str r3, [sp, #-4] !    @ Store status pointer on the stack
    subs r5, r5, #2        @ Reduce count with 2 since 2 arguments go in registers r2 and r3
    subeq r5, r2, #8       @ No pushable Java arguments left, prepare r5 as base
    beq cs_push_done       @ ... and do the call

    mov r3, sp             @ We'll use r3 as ARM stack base register
    sub sp, sp, r5, lsl #2 @ Make room on the stack for remaining pushable arguments
    add r5, r5, #2         @ Restore original argument count ...
    sub r5, r2, r5, lsl #2 @ ... and overwrite r5 with a pointer to the first Java argument, we need it later

  cs_push_arg:
    ldr lr, [r2, #-4] !    @ Decrement and get from Java stack
    str lr, [r3, #-4] !    @ Push it on ARM stack
    cmp r3, sp             @ Are we done yet ?
    bne cs_push_arg        @ no, push more ...

  cs_push_done: 
    ldmia r5, {r2, r3}     @ Load Java argument 1 and 2 in r2 and r3
    mov lr, pc             @ Prepare link register for return
    ldr pc, [r6, #8]       @ Do the call
    mov sp, r4             @ Restore the stack pointer
    ldmfd sp!, {r4-r6, pc} @ And go back after restoring clobbered registers

  cs_no_arg:               @ No args, r4 is available as scratch and should be restored when going back.
    ldr r4, [r1, #8]       @ Get function pointer in r4
    ldr r1, [sp, #8]       @ Get Class instance in r1 as second argument (env is allready in r0)
    mov r2, r3             @ Get status pointer in r2
    mov lr, pc             @ Prepare new link register
    mov pc, r4             @ Do the call
    ldmfd sp!, { r4, pc }  @ Go back to our own caller...

  cs_single_arg:           @ Single argument, r4 is available as scratch and should be restored when going back.
    ldr r4, [r1, #8]       @ Get function pointer in r4
    ldr r1, [sp, #8]       @ Get Class instance in r1 as second argument (env is allready in r0)
    ldr r2, [r2, #-4]      @ Get this single argument in r2, r3 contains the status word allready
    mov lr, pc             @ Prepare new link register
    mov pc, r4             @ Do the call
    ldmfd sp!, { r4, pc }  @ Go back to our own caller...

@
@ unsigned long long call_instance(JNIEnv * env, w_method method, word * stacktop, w_word * status)@
@
@                                      r0            r1                r2               r3
@
@ the returned result is in r1:r0 and is not touched by us upon return
@

.global call_instance
call_instance:
    stmfd sp!, {r4, lr}    @ Save a register we want to work with and link register
    ldr r4, [r1, #4]       @ Get argument count in r4
    cmp r4, #1             @ Is there more than 1 argument ?
    beq ci_single_arg      @ No, handle this case specially
    cmp r4, #2             @ Are there only 2 arguments ?
    beq ci_two_arg         @ Yes, handle this specially also since we don't have to use the stack

    ldmfd sp!, {r4, lr}    @ We pop what we saved
    stmfd sp!, {r4-r6, lr} @ And push again to have some working registers
    mov r4, sp             @ Save the current stack pointer, we need to restore it after the call
    ldr r6, [r1, #8]       @ Get function pointer in r6
    ldr r5, [r1, #4]       @ Get the argument count in r5
    str r3, [sp, #-4] !    @ Put the status pointer on the stack
    subs r5, r5, #3        @ Reduce count with 3 since 3 arguments go in registers r1, r2 and r3
    subeq r5, r2, #12      @ No pushable Java arguments left, prepare r5 as base
    beq ci_push_done       @ ... and do the call

    mov r3, sp             @ Prepare r3 to be used as ARM stack base
    sub sp, sp, r5, lsl #2 @ Make room for arguments on ARM stack
    add r5, r5, #3         @ Restore original argument count in r5 ...
    sub r5, r2, r5, lsl #2 @ ... so that we can make it point to the beginning of the Java stack arguments

  ci_push_arg:
    ldr lr, [r2, #-4] !    @ Decrement and get from Java stack
    str lr, [r3, #-4] !    @ Push it on ARM stack
    cmp r3, sp             @ Are we done yet ?
    bne ci_push_arg        @ no, push more ...

  ci_push_done:
    ldmia r5, {r1, r2, r3} @ Load r1, r2 and r3 with first 3 Java arguments. Use r5 we prepared earlier
    mov lr, pc             @ Prepare link register for return to here, pc is here --------------+
    mov pc, r6             @ Call the function                                                  |   
    mov sp, r4             @ Restore stack pointer <---------- PC contents ---------------------+
    ldmfd sp!, {r4-r6, pc} @ Restore single clobbered register and return

  ci_single_arg:           @ Single Java argument
    ldr r4, [r1, #8]       @ Get function pointer in r4
    ldr r1, [r2, #-4]      @ Get single Java argument in r1
    mov r2, r3             @ Get status pointer in r2
    mov lr, pc             @ Prepare new link register
    mov pc, r4             @ Do the call
    ldmfd sp!, { r4, pc }  @ Go back to our own caller...

  ci_two_arg:              @ Two Java arguments
    ldr r4, [r1, #8]       @ Get function pointer in r4
    sub r2, r2, #8         @ Adjust Java stack top
    ldr r1, [r2], #4       @ Load r1 with first argument
    ldr r2, [r2]           @ and r2 with second, r3 contains the status pointer allready
    mov lr, pc             @ Prepare new link register
    mov pc, r4             @ Do the call
    ldmfd sp!, { r4, pc }  @ Restore single clobbered register and return

