/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: pm.c,v 1.1 2002/03/11 09:24:50 ssymons Exp $
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include "wonka.h"
#include "ts-mem.h"
#include "heap.h"
#include "pm.h"

#define PM_FILE "./persistent.medium"

static int PMfd;

w_boolean openPM(void) {
  PMfd = open(PM_FILE, O_RDWR);
  woempa(9,"open: PMfd = %d\n",PMfd);

  if (PMfd < 0) {
    PMfd = open(PM_FILE, O_RDWR+O_CREAT, S_IRUSR | S_IWUSR);
  }
  return PMfd >= 0;
}

w_boolean readPMall(void) {
  ssize_t  l;
  l = read(PMfd, PS_start, (w_size)(PS_end - PS_start));
  woempa(9,"read %d bytes from fd %d\n",l,PMfd);

  return l == PS_end - PS_start;
}

w_boolean writePMall(void) {
  ssize_t  l;
  l = write(PMfd, PS_start, (w_size)(PS_end - PS_start));
  woempa(9,"wrote %d bytes to fd %d \n",l,PMfd);

  return l == PS_end - PS_start;
}

w_boolean writePMportion(void* start, w_size length) {
  ssize_t l = 0; 
  off_t   rc;
  off_t   o = ((char*)start) - PS_start;

  rc = lseek(PMfd, o, SEEK_SET);
  if (rc == o) {
    l = write(PMfd, start, length);
    woempa(9,"wrote %d bytes (%p..%p) to fd %d \n",l,start,((char*)start)+length-1,PMfd);
  }
  else {
    woempa(9,"lseek(%d,%d,SEEK_SET) returned %d!\n",PMfd,o,l);
  }

  return (rc == o) && (l == (ssize_t)length);
}

w_boolean closePM(void) {
  close(PMfd);
  woempa(9,"closed fd %d '%s'\n",PMfd,PM_FILE);

  return WONKA_TRUE;
}

w_boolean clearPM(void) {
  unlink(PM_FILE);
  woempa(9,"deleted '%s'\n",PM_FILE);
  PMfd = open(PM_FILE, O_RDWR+O_CREAT, S_IRUSR|S_IWUSR);
  woempa(9,"PMfd = %d\n",PMfd);

  if (PMfd >= 0) {
    writePMall();

    return WONKA_TRUE;

  }

  return WONKA_FALSE;

}

