#ifndef _BYTECODES_H
#define _BYTECODES_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: bytecodes.h,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
*/

OPCODE(nop,              0x00, aa)
OPCODE(aconst_null,      0x01, aa)
OPCODE(iconst_m1,        0x02, aa)
OPCODE(iconst_0,         0x03, aa)
OPCODE(iconst_1,         0x04, aa)
OPCODE(iconst_2,         0x05, aa)
OPCODE(iconst_3,         0x06, aa)
OPCODE(iconst_4,         0x07, aa)
OPCODE(iconst_5,         0x08, aa)
OPCODE(lconst_0,         0x09, aa)
OPCODE(lconst_1,         0x0a, aa)
OPCODE(fconst_0,         0x0b, aa)
OPCODE(fconst_1,         0x0c, aa)
OPCODE(fconst_2,         0x0d, aa)
OPCODE(dconst_0,         0x0e, aa)
OPCODE(dconst_1,         0x0f, aa)
OPCODE(bipush,           0x10, aa)
OPCODE(sipush,           0x11, aa)
OPCODE(ldc,              0x12, aa)
OPCODE(ldc_w,            0x13, aa)
OPCODE(ldc2_w,           0x14, aa)
OPCODE(iload,            0x15, aa)
OPCODE(lload,            0x16, aa)
OPCODE(fload,            0x17, aa)
OPCODE(dload,            0x18, aa)
OPCODE(aload,            0x19, aa)
OPCODE(iload_0,          0x1a, aa)
OPCODE(iload_1,          0x1b, aa)
OPCODE(iload_2,          0x1c, aa)
OPCODE(iload_3,          0x1d, aa)
OPCODE(lload_0,          0x1e, aa)
OPCODE(lload_1,          0x1f, aa)
OPCODE(lload_2,          0x20, aa)
OPCODE(lload_3,          0x21, aa)
OPCODE(fload_0,          0x22, aa)
OPCODE(fload_1,          0x23, aa)
OPCODE(fload_2,          0x24, aa)
OPCODE(fload_3,          0x25, aa)
OPCODE(dload_0,          0x26, aa)
OPCODE(dload_1,          0x27, aa)
OPCODE(dload_2,          0x28, aa)
OPCODE(dload_3,          0x29, aa)
OPCODE(aload_0,          0x2a, aa)
OPCODE(aload_1,          0x2b, aa)
OPCODE(aload_2,          0x2c, aa)
OPCODE(aload_3,          0x2d, aa)
OPCODE(iaload,           0x2e, aa)
OPCODE(laload,           0x2f, aa)
OPCODE(faload,           0x30, aa)
OPCODE(daload,           0x31, aa)
OPCODE(aaload,           0x32, aa)
OPCODE(baload,           0x33, aa)
OPCODE(caload,           0x34, aa)
OPCODE(saload,           0x35, aa)
OPCODE(istore,           0x36, aa)
OPCODE(lstore,           0x37, aa)
OPCODE(fstore,           0x38, aa)
OPCODE(dstore,           0x39, aa)
OPCODE(astore,           0x3a, aa)
OPCODE(istore_0,         0x3b, aa)
OPCODE(istore_1,         0x3c, aa)
OPCODE(istore_2,         0x3d, aa)
OPCODE(istore_3,         0x3e, aa)
OPCODE(lstore_0,         0x3f, aa)
OPCODE(lstore_1,         0x40, aa)
OPCODE(lstore_2,         0x41, aa)
OPCODE(lstore_3,         0x42, aa)
OPCODE(fstore_0,         0x43, aa)
OPCODE(fstore_1,         0x44, aa)
OPCODE(fstore_2,         0x45, aa)
OPCODE(fstore_3,         0x46, aa)
OPCODE(dstore_0,         0x47, aa)
OPCODE(dstore_1,         0x48, aa)
OPCODE(dstore_2,         0x49, aa)
OPCODE(dstore_3,         0x4a, aa)
OPCODE(astore_0,         0x4b, aa)
OPCODE(astore_1,         0x4c, aa)
OPCODE(astore_2,         0x4d, aa)
OPCODE(astore_3,         0x4e, aa)
OPCODE(iastore,          0x4f, aa)
OPCODE(lastore,          0x50, aa)
OPCODE(fastore,          0x51, aa)
OPCODE(dastore,          0x52, aa)
OPCODE(aastore,          0x53, aa)
OPCODE(bastore,          0x54, aa)
OPCODE(castore,          0x55, aa)
OPCODE(sastore,          0x56, aa)
OPCODE(pop,              0x57, aa)
OPCODE(pop2,             0x58, aa)
OPCODE(dup,              0x59, aa)
OPCODE(dup_x1,           0x5a, aa)
OPCODE(dup_x2,           0x5b, aa)
OPCODE(dup2,             0x5c, aa)
OPCODE(dup2_x1,          0x5d, aa)
OPCODE(dup2_x2,          0x5e, aa)
OPCODE(swap,             0x5f, aa)
OPCODE(iadd,             0x60, aa)
OPCODE(ladd,             0x61, aa)
OPCODE(fadd,             0x62, aa)
OPCODE(dadd,             0x63, aa)
OPCODE(isub,             0x64, aa)
OPCODE(lsub,             0x65, aa)
OPCODE(fsub,             0x66, aa)
OPCODE(dsub,             0x67, aa)
OPCODE(imul,             0x68, aa)
OPCODE(lmul,             0x69, aa)
OPCODE(fmul,             0x6a, aa)
OPCODE(dmul,             0x6b, aa)
OPCODE(idiv,             0x6c, aa)
OPCODE(ldiv,             0x6d, aa)
OPCODE(fdiv,             0x6e, aa)
OPCODE(ddiv,             0x6f, aa)
OPCODE(irem,             0x70, aa)
OPCODE(lrem,             0x71, aa)
OPCODE(frem,             0x72, aa)
OPCODE(drem,             0x73, aa)
OPCODE(ineg,             0x74, aa)
OPCODE(lneg,             0x75, aa)
OPCODE(fneg,             0x76, aa)
OPCODE(dneg,             0x77, aa)
OPCODE(ishl,             0x78, aa)
OPCODE(lshl,             0x79, aa)
OPCODE(ishr,             0x7a, aa)
OPCODE(lshr,             0x7b, aa)
OPCODE(iushr,            0x7c, aa)
OPCODE(lushr,            0x7d, aa)
OPCODE(iand,             0x7e, aa)
OPCODE(land,             0x7f, aa)
OPCODE(ior,              0x80, aa)
OPCODE(lor,              0x81, aa)
OPCODE(ixor,             0x82, aa)
OPCODE(lxor,             0x83, aa)
OPCODE(iinc,             0x84, aa)
OPCODE(i2l,              0x85, aa)
OPCODE(i2f,              0x86, aa)
OPCODE(i2d,              0x87, aa)
OPCODE(l2i,              0x88, aa)
OPCODE(l2f,              0x89, aa)
OPCODE(l2d,              0x8a, aa)
OPCODE(f2i,              0x8b, aa)
OPCODE(f2l,              0x8c, aa)
OPCODE(f2d,              0x8d, aa)
OPCODE(d2i,              0x8e, aa)
OPCODE(d2l,              0x8f, aa)
OPCODE(d2f,              0x90, aa)
OPCODE(i2b,              0x91, aa)
OPCODE(i2c,              0x92, aa)
OPCODE(i2s,              0x93, aa)
OPCODE(lcmp,             0x94, aa)
OPCODE(fcmpl,            0x95, aa)
OPCODE(fcmpg,            0x96, aa)
OPCODE(dcmpl,            0x97, aa)
OPCODE(dcmpg,            0x98, aa)
OPCODE(ifeq,             0x99, aa)
OPCODE(ifne,             0x9a, aa)
OPCODE(iflt,             0x9b, aa)
OPCODE(ifge,             0x9c, aa)
OPCODE(ifgt,             0x9d, aa)
OPCODE(ifle,             0x9e, aa)
OPCODE(if_icmpeq,        0x9f, aa)
OPCODE(if_icmpne,        0xa0, aa)
OPCODE(if_icmplt,        0xa1, aa)
OPCODE(if_icmpge,        0xa2, aa)
OPCODE(if_icmpgt,        0xa3, aa)
OPCODE(if_icmple,        0xa4, aa)
OPCODE(if_acmpeq,        0xa5, aa)
OPCODE(if_acmpne,        0xa6, aa)
OPCODE(j_goto,           0xa7, aa)
OPCODE(jsr,              0xa8, aa)
OPCODE(ret,              0xa9, aa)
OPCODE(tableswitch,      0xaa, aa)
OPCODE(lookupswitch,     0xab, aa)
OPCODE(ireturn,          0xac, aa)
OPCODE(lreturn,          0xad, aa)
OPCODE(freturn,          0xae, aa)
OPCODE(dreturn,          0xaf, aa)
OPCODE(areturn,          0xb0, aa)
OPCODE(vreturn,          0xb1, aa)
OPCODE(getstatic,        0xb2, aa)
OPCODE(putstatic,        0xb3, aa)
OPCODE(getfield,         0xb4, aa)
OPCODE(putfield,         0xb5, aa)
OPCODE(invokevirtual,    0xb6, aa)
OPCODE(invokespecial,    0xb7, aa)
OPCODE(invokestatic,     0xb8, aa)
OPCODE(invokeinterface,  0xb9, aa)
OPCODE(new,              0xbb, aa)
OPCODE(newarray,         0xbc, aa)
OPCODE(anewarray,        0xbd, aa)
OPCODE(arraylength,      0xbe, aa)
OPCODE(athrow,           0xbf, aa)
OPCODE(checkcast,        0xc0, aa)
OPCODE(instanceof,       0xc1, aa)
OPCODE(monitorenter,     0xc2, aa)
OPCODE(monitorexit,      0xc3, aa)
OPCODE(wide,             0xc4, aa)
OPCODE(multianewarray,   0xc5, aa)
OPCODE(ifnull,           0xc6, aa)
OPCODE(ifnonnull,        0xc7, aa)
OPCODE(goto_w,           0xc8, aa)
OPCODE(jsr_w,            0xc9, aa)
OPCODE(breakpoint,       0xca, aa)
OPCODE(impdep1,          0xfe, aa)
OPCODE(impdep2,          0xff, aa)

#endif /* _BYTECODES_H */
