#ifndef CONTROL_FLOW_ANALYSIS_H
#define CONTROL_FLOW_ANALYSIS_H
   
/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: control_flow_analysis.h,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
*/

w_instance control_flow_analysis(w_method, w_thread, w_basic_block_info);

void set_ith_bit(w_size, u1*);
w_boolean is_ith_bit_set(w_size, u1*);
u4 count_ones_in_array(u1*, w_size);

struct w_Basic_block_ll* lookup_basic_block_ll_item(w_size, struct w_Basic_block_ll*);
struct w_Basic_block* lookup_basic_block(w_size, struct w_Basic_block*, w_size);
void create_basic_block_ll_item(w_size, w_size, u1*, struct w_Basic_block_ll*);
void link_basic_block_ll_items(w_size, w_size, struct w_Basic_block_ll*);

w_instance check_args_type_0(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_1(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_2(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_3(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_4(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_5(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_6(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_7(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_8(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_9(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_10(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_11(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_12(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_13(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_14(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_15(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_16(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_17(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_18(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_19(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_20(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_21(w_method, w_size*, u1*, w_basic_block_ll, w_thread);
w_instance check_args_type_22(w_method, w_size*, u1*, w_basic_block_ll, w_thread);

static w_instance (*check_args[])(w_method, w_size*, u1*, w_basic_block_ll, w_thread) = {
   check_args_type_0,  //NOP 0
   check_args_type_0,  //ACONST_NULL 1
   check_args_type_0,  //ICONST_M1 2
   check_args_type_0,  //ICONST_0 3
   check_args_type_0,  //ICONST_1 4
   check_args_type_0,  //ICONST_2 5
   check_args_type_0,  //ICONST_3 6
   check_args_type_0,  //ICONST_4 7
   check_args_type_0,  //ICONST_5 8
   check_args_type_0,  //LCONST_0 9
   check_args_type_0,  //LCONST_1 10
   check_args_type_0,  //FCONST_0 11
   check_args_type_0,  //FCONST_1 12
   check_args_type_0,  //FCONST_2 13
   check_args_type_0,  //DCONST_0 14
   check_args_type_0,  //DCONST_1 15
   check_args_type_18, //BIPUSH 16
   check_args_type_19, //SIPUSH 17
   check_args_type_5,  //LDC 18
   check_args_type_6,  //LDC_W 19
   check_args_type_7,  //LDC2_W 20
   check_args_type_3,  //ILOAD 21
   check_args_type_3,  //LLOAD 22
   check_args_type_3,  //FLOAD 23
   check_args_type_3,  //DLOAD 24
   check_args_type_3,  //ALOAD 25
   check_args_type_0,  //ILOAD_0 26
   check_args_type_0,  //ILOAD_1 27
   check_args_type_0,  //ILOAD_2 28
   check_args_type_0,  //ILOAD_3 29
   check_args_type_0,  //LLOAD_0 30
   check_args_type_0,  //LLOAD_1 31
   check_args_type_0,  //LLOAD_2 32
   check_args_type_0,  //LLOAD_3 33
   check_args_type_0,  //FLOAD_0 34
   check_args_type_0,  //FLOAD_1 35
   check_args_type_0,  //FLOAD_2 36
   check_args_type_0,  //FLOAD_3 37
   check_args_type_0,  //DLOAD_0 38
   check_args_type_0,  //DLOAD_1 39
   check_args_type_0,  //DLOAD_2 40
   check_args_type_0,  //DLOAD_3 41
   check_args_type_0,  //ALOAD_0 42
   check_args_type_0,  //ALOAD_1 43
   check_args_type_0,  //ALOAD_2 44
   check_args_type_0,  //ALOAD_3 45
   check_args_type_0,  //IALOAD 46
   check_args_type_0,  //LALOAD 47
   check_args_type_0,  //FALOAD 48
   check_args_type_0,  //DALOAD 49
   check_args_type_0,  //AALOAD 50
   check_args_type_0,  //BALOAD 51
   check_args_type_0,  //CALOAD 52
   check_args_type_0,  //SALOAD 53
   check_args_type_3,  //ISTORE 54
   check_args_type_3,  //LSTORE 55
   check_args_type_3,  //FSTORE 56
   check_args_type_3,  //DSTORE 57
   check_args_type_3,  //ASTORE 58
   check_args_type_0,  //ISTORE_0 59
   check_args_type_0,  //ISTORE_1 60
   check_args_type_0,  //ISTORE_2 61
   check_args_type_0,  //ISTORE_3 62
   check_args_type_0,  //LSTORE_0 63
   check_args_type_0,  //LSTORE_1 64
   check_args_type_0,  //LSTORE_2 65
   check_args_type_0,  //LSTORE_3 66
   check_args_type_0,  //FSTORE_0 67
   check_args_type_0,  //FSTORE_1 68
   check_args_type_0,  //FSTORE_2 69
   check_args_type_0,  //FSTORE_3 70
   check_args_type_0,  //DSTORE_0 71
   check_args_type_0,  //DSTORE_1 72
   check_args_type_0,  //DSTORE_2 73
   check_args_type_0,  //DSTORE_3 74
   check_args_type_0,  //ASTORE_0 75
   check_args_type_0,  //ASTORE_1 76
   check_args_type_0,  //ASTORE_2 77
   check_args_type_0,  //ASTORE_3 78
   check_args_type_0,  //IASTORE 79
   check_args_type_0,  //LASTORE 80
   check_args_type_0,  //FASTORE 81
   check_args_type_0,  //DASTORE 82
   check_args_type_0,  //AASTORE 83
   check_args_type_0,  //BASTORE 84
   check_args_type_0,  //CASTORE 85
   check_args_type_0,  //SASTORE 86
   check_args_type_0,  //POP 87
   check_args_type_0,  //POP2 88
   check_args_type_0,  //DUP 89
   check_args_type_0,  //DUP_X1 90
   check_args_type_0,  //DUP_X2 91
   check_args_type_0,  //DUP2 92
   check_args_type_0,  //DUP2_X1 93
   check_args_type_0,  //DUP2_X2 94
   check_args_type_0,  //SWAP 95
   check_args_type_0,  //IADD 96
   check_args_type_0,  //LADD 97
   check_args_type_0,  //FADD 98
   check_args_type_0,  //DADD 99
   check_args_type_0,  //ISUB 100
   check_args_type_0,  //LSUB 101
   check_args_type_0,  //FSUB 102
   check_args_type_0,  //DSUB 103
   check_args_type_0,  //IMUL 104
   check_args_type_0,  //LMUL 105
   check_args_type_0,  //FMUL 106
   check_args_type_0,  //DMUL 107
   check_args_type_0,  //IDIV 108
   check_args_type_0,  //LDIV 109
   check_args_type_0,  //FDIV 110
   check_args_type_0,  //DDIV 111
   check_args_type_0,  //IREM 112
   check_args_type_0,  //LREM 113
   check_args_type_0,  //FREM 114
   check_args_type_0,  //DREM 115
   check_args_type_0,  //INEG 116
   check_args_type_0,  //LNEG 117
   check_args_type_0,  //FNEG 118
   check_args_type_0,  //DNEG 119
   check_args_type_0,  //ISHL 120
   check_args_type_0,  //LSHL 121
   check_args_type_0,  //ISHR 122
   check_args_type_0,  //LSHR 123
   check_args_type_0,  //IUSHR 124
   check_args_type_0,  //LUSHR 125
   check_args_type_0,  //IAND 126
   check_args_type_0,  //LAND 127
   check_args_type_0,  //IOR 128
   check_args_type_0,  //LOR 129
   check_args_type_0,  //IXOR 130
   check_args_type_0,  //LXOR 131
   check_args_type_4,  //IINC 132
   check_args_type_0,  //I2L 133
   check_args_type_0,  //I2F 134
   check_args_type_0,  //I2D 135
   check_args_type_0,  //L2I 136
   check_args_type_0,  //L2F 137
   check_args_type_0,  //L2D 138
   check_args_type_0,  //F2I 139
   check_args_type_0,  //F2L 140
   check_args_type_0,  //F2D 141
   check_args_type_0,  //D2I 142
   check_args_type_0,  //D2L 143
   check_args_type_0,  //D2F 144
   check_args_type_0,  //I2B 145
   check_args_type_0,  //I2C 146
   check_args_type_0,  //I2S 147
   check_args_type_0,  //LCMP 148
   check_args_type_0,  //FCMPL 149
   check_args_type_0,  //FCMPG 150
   check_args_type_0,  //DCMPL 151
   check_args_type_0,  //DCMPG 152
   check_args_type_1,  //IFEQ 153
   check_args_type_1,  //IFNE 154
   check_args_type_1,  //IFLT 155
   check_args_type_1,  //IFGE 156
   check_args_type_1,  //IFGT 157
   check_args_type_1,  //IFLE 158
   check_args_type_1,  //IF_ICMPEQ 159
   check_args_type_1,  //IF_ICMPNE 160
   check_args_type_1,  //IF_ICMPLT 161
   check_args_type_1,  //IF_ICMPGE 162
   check_args_type_1,  //IF_ICMPGT 163
   check_args_type_1,  //IF_ICMPLE 164
   check_args_type_1,  //IF_ACMPEQ 165
   check_args_type_1,  //IF_ACMPNE 166
   check_args_type_22, //GOTO 167
   check_args_type_22, //JSR 168
   check_args_type_21,  //RET 169
   check_args_type_14, //TABLESWITCH 170
   check_args_type_15, //LOOKUPSWITCH 171
   check_args_type_20,  //IRETURN 172
   check_args_type_20,  //LRETURN 173
   check_args_type_20,  //FRETURN 174
   check_args_type_20,  //DRETURN 175
   check_args_type_20,  //ARETURN 176
   check_args_type_20,  //RETURN 177
   check_args_type_9,  //GETSTATIC 178
   check_args_type_9,  //PUTSTATIC 179
   check_args_type_9,  //GETFIELD 180
   check_args_type_9,  //PUTFIELD 181
   check_args_type_10, //INVOKEVIRTUAL 182
   check_args_type_10, //INVOKESPECIAL 183
   check_args_type_10, //INVOKESTATIC 184
   check_args_type_11, //INVOKEINTERFACE 185
   check_args_type_17, //UNUSED 186
   check_args_type_8,  //NEW 187
   check_args_type_12, //NEWARRAY 188
   check_args_type_8,  //ANEWARRAY 189
   check_args_type_0,  //ARRAYLENGTH 190
   check_args_type_0,  //ATHROW 191
   check_args_type_8,  //CHECKCAST 192
   check_args_type_8,  //INSTANCEOF 193
   check_args_type_0,  //MONITORENTER 194
   check_args_type_0,  //MONITOREXIT 195
   check_args_type_16, //WIDE 196
   check_args_type_13, //MULTIANEWARRAY 197
   check_args_type_1,  //IFNULL 198
   check_args_type_1,  //IFNONNULL 199
   check_args_type_2,  //GOTO_W 200
   check_args_type_2,  //JSR_W 201
   check_args_type_17,  //reserved opcode BREAKPOINT 202
   check_args_type_17, //UNUSED 203
   check_args_type_17, //UNUSED 204
   check_args_type_17, //UNUSED 205
   check_args_type_17, //UNUSED 206
   check_args_type_17, //UNUSED 207
   check_args_type_17, //UNUSED 208
   check_args_type_17, //UNUSED 209
   check_args_type_17, //UNUSED 210
   check_args_type_17, //UNUSED 211
   check_args_type_17, //UNUSED 212
   check_args_type_17, //UNUSED 213
   check_args_type_17, //UNUSED 214
   check_args_type_17, //UNUSED 215
   check_args_type_17, //UNUSED 216
   check_args_type_17, //UNUSED 217
   check_args_type_17, //UNUSED 218
   check_args_type_17, //UNUSED 219
   check_args_type_17, //UNUSED 220
   check_args_type_17, //UNUSED 221
   check_args_type_17, //UNUSED 222
   check_args_type_17, //UNUSED 223
   check_args_type_17, //UNUSED 224
   check_args_type_17, //UNUSED 225
   check_args_type_17, //UNUSED 226
   check_args_type_17, //UNUSED 227
   check_args_type_17, //UNUSED 228
   check_args_type_17, //UNUSED 229
   check_args_type_17, //UNUSED 230
   check_args_type_17, //UNUSED 231
   check_args_type_17, //UNUSED 232
   check_args_type_17, //UNUSED 233
   check_args_type_17, //UNUSED 234
   check_args_type_17, //UNUSED 235
   check_args_type_17, //UNUSED 236
   check_args_type_17, //UNUSED 237
   check_args_type_17, //UNUSED 238
   check_args_type_17, //UNUSED 239
   check_args_type_17, //UNUSED 240
   check_args_type_17, //UNUSED 241
   check_args_type_17, //UNUSED 242
   check_args_type_17, //UNUSED 243
   check_args_type_17, //UNUSED 244
   check_args_type_17, //UNUSED 245
   check_args_type_17, //UNUSED 246
   check_args_type_17, //UNUSED 247
   check_args_type_17, //UNUSED 248
   check_args_type_17, //UNUSED 249
   check_args_type_17, //UNUSED 250
   check_args_type_17, //UNUSED 251
   check_args_type_17, //UNUSED 252
   check_args_type_17, //UNUSED 253
   check_args_type_17, //reserved opcode IMPDEP1 254
   check_args_type_17  //reserved opcode IMPDEP2 255

};
 
static const char* op_string[] = {
  "NOP",
  "ACONST_NULL",
  "ICONST_M1",
  "ICONST_0",
  "ICONST_1",
  "ICONST_2",
  "ICONST_3",
  "ICONST_4",
  "ICONST_5",
  "LCONST_0",
  "LCONST_1",
  "FCONST_0",
  "FCONST_1",
  "FCONST_2",
  "DCONST_0",
  "DCONST_1",
  "BIPUSH",
  "SIPUSH",
  "LDC",
  "LDC_W",
  "LDC2_W",
  "ILOAD",
  "LLOAD",
  "FLOAD",
  "DLOAD",
  "ALOAD",
  "ILOAD_0",
  "ILOAD_1",
  "ILOAD_2",
  "ILOAD_3",
  "LLOAD_0",
  "LLOAD_1",
  "LLOAD_2",
  "LLOAD_3",
  "FLOAD_0",
  "FLOAD_1",
  "FLOAD_2",
  "FLOAD_3",
  "DLOAD_0",
  "DLOAD_1",
  "DLOAD_2",
  "DLOAD_3",
  "ALOAD_0",
  "ALOAD_1",
  "ALOAD_2",
  "ALOAD_3",
  "IALOAD",
  "LALOAD",
  "FALOAD",
  "DALOAD",
  "AALOAD",
  "BALOAD",
  "CALOAD",
  "SALOAD",
  "ISTORE",
  "LSTORE",
  "FSTORE",
  "DSTORE",
  "ASTORE",
  "ISTORE_0",
  "ISTORE_1",
  "ISTORE_2",
  "ISTORE_3",
  "LSTORE_0",
  "LSTORE_1",
  "LSTORE_2",
  "LSTORE_3",
  "FSTORE_0",
  "FSTORE_1",
  "FSTORE_2",
  "FSTORE_3",
  "DSTORE_0",
  "DSTORE_1",
  "DSTORE_2",
  "DSTORE_3",
  "ASTORE_0",
  "ASTORE_1",
  "ASTORE_2",
  "ASTORE_3",
  "IASTORE",
  "LASTORE",
  "FASTORE",
  "DASTORE",
  "AASTORE",
  "BASTORE",
  "CASTORE",
  "SASTORE",
  "POP",
  "POP2",
  "DUP",
  "DUP_X1",
  "DUP_X2",
  "DUP2",
  "DUP2_X1",
  "DUP2_X2",
  "SWAP",
  "IADD",
  "LADD",
  "FADD",
  "DADD",
  "ISUB",
  "LSUB",
  "FSUB",
  "DSUB",
  "IMUL",
  "LMUL",
  "FMUL",
  "DMUL",
  "IDIV",
  "LDIV",
  "FDIV",
  "DDIV",
  "IREM",
  "LREM",
  "FREM",
  "DREM",
  "INEG",
  "LNEG",
  "FNEG",
  "DNEG",
  "ISHL",
  "LSHL",
  "ISHR",
  "LSHR",
  "IUSHR",
  "LUSHR",
  "IAND",
  "LAND",
  "IOR",
  "LOR",
  "IXOR",
  "LXOR",
  "IINC",
  "I2L",
  "I2F",
  "I2D",
  "L2I",
  "L2F",
  "L2D",
  "F2I",
  "F2L",
  "F2D",
  "D2I",
  "D2L",
  "D2F",
  "I2B",
  "I2C",
  "I2S",
  "LCMP",
  "FCMPL",
  "FCMPG",
  "DCMPL",
  "DCMPG",
  "IFEQ",
  "IFNE",
  "IFLT",
  "IFGE",
  "IFGT",
  "IFLE",
  "IF_ICMPEQ",
  "IF_ICMPNE",
  "IF_ICMPLT",
  "IF_ICMPGE",
  "IF_ICMPGT",
  "IF_ICMPLE",
  "IF_ACMPEQ",
  "IF_ACMPNE",
  "GOTO",
  "JSR",
  "RET",
  "TABLESWITCH",
  "LOOKUPSWITCH",
  "IRETURN",
  "LRETURN",
  "FRETURN",
  "DRETURN",
  "ARETURN",
  "RETURN",
  "GETSTATIC",
  "PUTSTATIC",
  "GETFIELD",
  "PUTFIELD",
  "INVOKEVIRTUAL",
  "INVOKESPECIAL",
  "INVOKESTATIC",
  "INVOKEINTERFACE",
  "UNUSED",
  "NEW",
  "NEWARRAY",
  "ANEWARRAY",
  "ARRAYLENGTH",
  "ATHROW",
  "CHECKCAST",
  "INSTANCEOF",
  "MONITORENTER",
  "MONITOREXIT",
  "WIDE",
  "MULTIANEWARRAY",
  "IFNULL",
  "IFNONNULL",
  "GOTO_W",
  "JSR_W",
  "BREAKPOINT",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "UNUSED",
  "IMPDEP1",
  "IMPDEP2"};

#endif
