#ifndef _DISPATCHER_H_
#define _DISPATCHER_H_

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: dispatcher.h,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
**
** The dispatcher files control how a method, be it a native method,
** byte code or J-Spot compiled method will be dispatched. Each dispatcher will
** handle the details of synchronization, if required, static or instance method
** calling and the collection of profiling information or not.
*/

#include <wonka.h>

typedef void (*w_call)(w_frame * frameref, w_code * coderef, w_method method);

typedef void (*w_return)(w_frame * frameref, w_code * coderef);

typedef struct w_Dispatcher {
  w_call do_call;       /* The function to execute a call to a method.                       */
  w_return do_return;   /* The function to execute a proper return. For Java byte code only. */
  w_ubyte row;          /* The row in the dispatcher matrix.                                 */
  w_ubyte col;          /* The column in the dispatcher matrix.                              */
} w_Dispatcher;

extern w_Dispatcher dispatchers[12][6];

/*
** A special dispatcher that handles calls to byte code method that only have a 
** void return as their first opcode. It just pops off the passed arguments.
*/

extern w_Dispatcher dispatch_vreturn;

#endif /* _DISPATCHER_H_ */
