#ifndef _EXCEPTION_H
#define _EXCEPTION_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: exception.h,v 1.2 2002/01/24 12:54:28 gray Exp $
*/

#include "wonka.h"

/**
  This file contains prototypes for functions which are used to throw
  exceptions from within a Java thread.
*/

/** Throw an exception: `message' is allowed to be NULL.
*/
void throwException(w_thread, w_clazz exception, w_string message);
/** As throwException, but takes a C-style string (or NULL)
*/
void throwException_C(w_thread, w_clazz exception, char *message);

/** Throw an OutOfMemoryError
*/
void throwOutOfMemoryError(w_thread);

void throwLocalException(w_thread sender, w_clazz exception, const char *file, const char *function, int line, const char *fmt, ...);
w_frame handleThrowable(w_instance throwable, w_frame, w_code code, w_code *new_code);
w_instance createExceptionInstance(w_thread thread, w_clazz clazz, w_string message);
void setLocalException(w_thread thread, w_instance Exception);
void fillInStackTrace(w_instance thisThrowable);

#ifndef __LINT__
#define ThrowLocalException(t, e, m, a...) throwLocalException((t), (e), __FILE__, __FUNCTION__, __LINE__, m, ##a)
#endif

#define WS_EXCEPTION     WS_InternalError

//@}

#endif /* _EXCEPTION_H */
