#ifndef _MEMSET_H
#define _MEMSET_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: memset.h,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
*/

inline static void *inline_memset(void *address, int cbyte, unsigned int size) {

  unsigned int mask = cbyte;
  unsigned int wordcopies = size / 4;
  unsigned int bytecopies = size - (wordcopies << 2);
  unsigned int i;
  void *cursor = address;

  /*
  ** Prepare the mask
  */

  mask <<= 8;
  mask |= cbyte;
  mask <<= 8;
  mask |= cbyte;
  mask <<= 8;
  mask |= cbyte;

  /*
  ** Do word copying
  */

  for (i = 0; i < wordcopies; i++) {
    *((unsigned int *)address) = mask;
    ((unsigned int *)address)++;
  }

  /*
  ** Do byte copying
  */

  for (i = 0; i < bytecopies; i++) {
    *((unsigned char *)address) = cbyte;
    ((unsigned char *)address)++;
  }

  return cursor;
  
}

#endif /* _MEMSET_H */
