/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: DeviceOutputStream.java,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
*/

package com.acunia.device;

import java.io.*;

public class DeviceOutputStream extends OutputStream {

  /** The internal device ID.
  */
  private int devid;

  /** Buffer used for write(I)V.
  */
  private byte[] microbuffer = new byte[1];

  private native int createFromString(String path)
    throws SecurityException;

  public DeviceOutputStream(String name) {
  // TODO: security check?
    devid = createFromString(name);
  }

  public void write(int b) 
    throws IOException
  {
    microbuffer[0] = (byte)b;
    writeFromBuffer(microbuffer, 0, 1);
  }

  private native void writeFromBuffer(byte[] b, int off, int len)
    throws IOException;

  public void write(byte[] b) throws IOException, NullPointerException {

    if(b==null) throw new NullPointerException();

    writeFromBuffer(b, 0, b.length);
  }

  public void write(byte[] b, int off, int len)
    throws IOException, NullPointerException, ArrayIndexOutOfBoundsException 
  {

    if(b==null) throw new NullPointerException();

    if(off<0 || len<0 || off+len>b.length)
      throw new ArrayIndexOutOfBoundsException();

    writeFromBuffer(b, off,len);
  }

}
