/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: UARTControlStream.java,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
*/

package com.acunia.device.uart;

import java.io.IOException;
import javax.comm.SerialPort;
import javax.comm.SerialPortEvent;

public class UARTControlStream {

  private native void createFromString(String path)
    throws SecurityException;

  public UARTControlStream(String name) {
  // TODO: security check?
    createFromString(name);
  }

  public native int getbaudrate();

  public native int setbaudrate(int newrate);

  public native int getstopbits();

  public native int setstopbits(int newbits);

  public native int getdatabits();

  public native int setdatabits(int newbits);

  public native int getflowcontrol();

  public native int setflowcontrol(int newflowcon);

  public native int getparity();

  public native int setparity(int newparity);

  public native boolean getdsr();

  public native boolean getcd();

  public native boolean getcts();

  public native boolean getri();

  public native boolean setdtr(boolean newval);

  public native boolean setrts(boolean newval);

  public native void sendbreak(int millis);

  private native void waitforevent(SerialPortEvent e);

  public SerialPortEvent getevent(SerialPort port) {
    SerialPortEvent e = new SerialPortEvent(port);

    this.waitforevent(e);

    return e;
  }

}
