/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: UARTDriver.java,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
*/

package com.acunia.device.uart;

import com.acunia.wonka.Etc;
import java.util.Vector;
import javax.comm.CommDriver;
import javax.comm.CommPort;
import javax.comm.CommPortIdentifier;

public class UARTDriver implements CommDriver {

  private static UARTDriver singleton = null;

  private UART[] commports;

  protected UARTDriver() {
  // This should be a Vector, and will be when Vector is fixed ...
    commports = new UART[20];
  }

  private native static String firstUARTname();

  private native static String nextUARTname();

  public void initialize() {
    String portname = firstUARTname();

    while (portname != null) {
      CommPortIdentifier.addPortName(portname,CommPortIdentifier.PORT_SERIAL,this);
      portname = nextUARTname();
    }
  }

  public static synchronized UARTDriver getInstance() {
    if (singleton == null) {
      singleton = new UARTDriver();
    }
    return singleton;
  }

  public CommPort getCommPort (String portName, int portType) 
    throws IllegalArgumentException
  {
    if (portType == CommPortIdentifier.PORT_SERIAL) {

      return new UART(portName);

    }
    else {

      throw new IllegalArgumentException();

    }
  }
}

