/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


package com.acunia.wonka;

/**
 * @author Geert.bossuyt@smartmove.com
 * With thanks to Elsvermeyen@hotmail.com
 * 
 */


public class DegreeNumber {

	private int degrees;
	private int minutes;
	private int seconds;
	private int milliSeconds;

	public DegreeNumber (){
		this(0,0,0,0);
	}

	public DegreeNumber (int degrees, int minutes, int seconds, int milliSeconds){
		
		this.degrees = degrees;
		this.minutes = minutes;
		this.seconds = seconds;
		this.milliSeconds = milliSeconds;
		checkValues();
	}
	
	public int getDegrees(){
		return degrees;
	}
	public int getMinutes(){
		return minutes;
	}
	public int getSeconds(){
		return seconds;
	}
	public int getMilliSeconds(){
		return milliSeconds;
	}
	public void setDegrees(int degrees){
	        this.degrees = degrees;
	}
	public void setMinutes(int minutes){
	        this.minutes = minutes;
	}
	public void setSeconds(int seconds){
                this.seconds = seconds;
        }
	public void setMilliSeconds(int milliSeconds){
	        this.milliSeconds = milliSeconds;
	}
	
	/**
	 * make shure degrees < 360
	 *	      minutes < 60
	 *	      seconds < 60
	 *	      milliSeconds < 1000 
	 */ 	
	public void checkValues() {
		while ( degrees > 359 ||
				minutes > 59 ||
				seconds > 59 ||
				milliSeconds > 999 ){
			// strip de laatste nullen 
			// omdat die geen waarde hebben na de comma.
			while ( milliSeconds % 10 == 0 && milliSeconds != 0)
				milliSeconds /= 10; 
			if (milliSeconds > 999) {
				seconds +=1;
				milliSeconds -= 1000;
			}
			if (seconds > 59) {
				minutes += 1; 
				seconds -= 60;
			}
			if (minutes > 59) {
				degrees +=1;
				minutes -= 60;
			}
			if (degrees > 359 ){
				degrees -=360;
			}
		}
	}

/**
 * dec is decimal number .
 * number of seconds and milliSeconds is counted and stored in this.seconds
 * and this.milliSeconds
 */
public void dec2Secs (int dec){

        int value = dec;
        int previousValue;
        int counter=0;
	int machtVan10 = 10;

	// to get to the size of dec.
	// calculat machtVan10 because Math.pow() was not available
	// at the time.
	while(value > 10 ) {
	        value/=10;  
		machtVan10 *=10; 
		
	} 
	this.seconds = (dec * 60 ) / machtVan10;
	this.milliSeconds = (dec * 60) % machtVan10;
}

/**
  * dec is decimal number.
  * number of minuts, seconds and milliSeconds is counted
  * and stored into this.seconds, this.milliSeconds and this.minutes
  */
	public void dec2Mins(int dec) {
		int value = dec;
	        int previousValue;
		int counter=0;
		int machtVan10 = 10;

		// to get to the size of dec.
		// calculat machtVan10 because Math.pow() was not available
		// at the time.
		while(value > 10 ) {
        	        value/=10;  
//	        	counter++;  
			machtVan10 *= 10;			
		}	 
		counter++;

//		this.minutes = (dec * 60)/((int)Math.pow(10,counter));
//		this.dec2Secs( (dec * 60)%((int)Math.pow(10,counter)));

		this.minutes = (dec * 60) / machtVan10;
	      	this.dec2Secs( (dec * 60) % machtVan10);



	}


static public void main (String [] args){
	System.out.println("DegreeNumber test");
	
	DegreeNumber d = new DegreeNumber();
	int [] i = {0,9335,1000,600,5,12356};
	for (int j=0;j<i.length;j++){
		d.dec2Secs(i[j]);
		System.out.println(""+i[j]+"   "+d);
	}

}



/**
 *  String format : degrees/minutes/seconds.milliSeconds
 */
	public String toString(){
		return (""+degrees+"/"+minutes+"/"+seconds+"."+milliSeconds);
	}
}