/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/



package com.acunia.wonka;

import java.io.*;
import javax.comm.*;

public class GPSmon implements Runnable {

  private static GPSmon singleton;

  private byte [] buf;
  private int bytecount;
  private SerialPort gps;
  private InputStream gpsData;
  
  private GPSmon() {
    buf = new byte[100];
    try {
      gps = (SerialPort)CommPortIdentifier.getPortIdentifier("uart04").open("GPSmon",1000);
      gpsData = gps.getInputStream();
//      gpsData = System.in;
      System.out.println("Reading GPS data from uart04 at "+gps.getBaudRate()+" bits/sec ...");
    } catch (Exception e) {
      System.out.println("Unable to initialise GPS: "+e.getMessage());
    }
  }

  public static GPSmon getInstance() {
    if (singleton==null) singleton = new GPSmon();

    return singleton;

  }

  public void run() {
    while (true) {
      try {
        bytecount = gpsData.available();
        while (bytecount==0) {
          Thread.sleep(100);
          bytecount = gpsData.available();
        }
        if (bytecount>100) bytecount = 100;
        bytecount = gpsData.read(buf,0,bytecount);
        System.out.print(new String(buf,0,0,bytecount));
      } catch (InterruptedException e) {
        System.out.println("\nInterrupted!");
      } catch (IOException e) {
        System.out.println("IOException: "+e.getMessage());
      }
    }
  }

}

