/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/




package com.acunia.wonka;

import java.io.*;
import javax.comm.*;

public class GSMtest implements Runnable {

  private static GSMtest singleton;

  private byte [] buf;
  private int bytecount;
  private SerialPort gsm;
  private InputStream gsmInput;
  private OutputStream gsmOutput;
  
  private GSMtest() {
    buf = new byte[256];
    try {
      gsm = (SerialPort)CommPortIdentifier.getPortIdentifier("uart02").open("GSMtest",1000);
      gsmInput = gsm.getInputStream();
      gsmOutput = gsm.getOutputStream();
      System.out.println("Reading GPS data from uart02 at "+gsm.getBaudRate()+" bits/sec ...");
    } catch (Exception e) {
      System.out.println("Unable to initialise GSM: "+e.getMessage());
    }
  }

  public static GSMtest getInstance() {
    if (singleton==null) singleton = new GSMtest();

    return singleton;

  }

  public void run() {
    String ATCommand = "AT\r\n";
    System.out.println("Sending 'AT'");
    try {
      gsmOutput.write(ATCommand.getBytes());
    } catch (Exception e) {
      System.out.println("Got exception: "+e.getMessage());
    }

    System.out.println("Listening for 'OK'");

    while (true) {
      try {
        bytecount = gsmInput.available();
        while (bytecount==0) {
          Thread.sleep(100);
          bytecount = gsmInput.available();
        }
    System.out.println("Read "+bytecount+" bytes");
        if (bytecount>256) bytecount = 256;
        bytecount = gsmInput.read(buf,0,bytecount);
        System.out.print(new String(buf,0,0,bytecount));
      } catch (InterruptedException e) {
        System.out.println("\nInterrupted!");
      } catch (IOException e) {
        System.out.println("IOException: "+e.getMessage());
      }
    }
  }

}

