/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


package com.acunia.wonka;


public class MeterNumber {

	private int meters;
	private int centiMeters;
	private int milliMeters;

	public MeterNumber (){
		this(0,0,0);
	}

	public MeterNumber (int meters, int centiMeters, int milliMeters){
		this.meters = meters;
		this.centiMeters = centiMeters;
		this.milliMeters = milliMeters;
		checkValues();
	}
	
	public int getMeters(){
		return meters;
	}
	public int getCentiMeters(){
		return centiMeters;
	}
	public int getMilliMeters(){
		return milliMeters;
	}
	public void setMeters(int meters){
	        this.meters  = meters;
	}
	public void setCentiMeters(int meters){
	        this.centiMeters = centiMeters;
	}
	public void setMilliMeters(int meters){
                this.milliMeters = milliMeters;
        }
	
	/**
	 * make shure mm no bigger then 9
	 * 	      cm no bigger then 99	
         */ 
	private void checkValues(){
		// strip final zeros
		while(milliMeters % 10 == 0 && milliMeters != 0 )
			milliMeters /= 10;
		while(centiMeters > 99 || milliMeters > 9){
			if (milliMeters > 9){
				centiMeters += 1;
				milliMeters -= 10;				
			}
			if ( centiMeters > 99){
				meters += 1;
				centiMeters -= 100;
			}
		}
		
	}

/**
 *  String format : meters"m" centiMeters"cm" millimeters"mm"
 */
	public String toString(){
		return (""+meters+"m "+centiMeters+"cm "+milliMeters+"mm");
	}
}