/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: PersistentStore.java,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
*/

package com.acunia.wonka;

public interface PersistentStore {
        // createPersistentObject makes obj a persistent object
        // which may later be restored using the string s, using
        // the specified persistent object store.
        // To ensure uniqueness, s should contain as a prefix
        // the reversed Internet domain name of the responsible
        // vendor, e.g. com.acme. ... .To ensure portability,
        // s should consist only of letters, periods and hyphens.
        // The caller must have a PersistentObjectPermission
        // which matches s.
        public void createPersistentObject (String s, Object obj)
                throws SecurityException;

        // restorePersistentObject restores a persistent object
        // which was created earlier using the string s. 
        // The caller must have a PersistentObjectPermission
        // which matches s.
        public Object restorePersistentObject (String s)
                throws SecurityException;

        // deletePersistentObject deletes a persistent object
        // which was created earlier using the string s. 
        // The caller must have a PersistentObjectPermission
        // which matches s.
        public Object deletePersistentObject (String s)
                throws SecurityException;
}

