/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


// Author: J. Vandeneede
// Created: 2001/03/13

package com.acunia.wonka;

//import rudolph.*;
import java.awt.*;
import java.awt.event.*;


public class TestList extends Frame  implements ActionListener
{

  java.awt.List redList;
  java.awt.List blueList;
  java.awt.List greenList;
	
	Button toRed;
	Button toBlue;
	Button toGreen;
	
  public TestList(int minitems, int desired, boolean multiple)
  {
    super("List Example");
    //lists by definitions
    redList = new java.awt.List(minitems, multiple);
    blueList = new java.awt.List(minitems, multiple);
    greenList = new java.awt.List(minitems, multiple);

    String item;
    for(int i=1; i<=desired;i++)
    {
System.out.println("Adding RED-LIST BLUE-LIST GREEN-LIST ITEM"+i);
    	redList.add("RED-LIST ITEM "+i);
    	blueList.add("BLUE-LIST ITEM"+i);
    	greenList.add("GREEN-LIST ITEM"+i+" (Extra long to test horizontal scrolling)");
    }
    redList.setBackground(new Color(255,128,128));
    blueList.setBackground(new Color(128,128,255));
    greenList.setBackground(new Color(128,225,128));

    toBlue = new Button("to BLUE");
    toBlue.addActionListener(this);
    toBlue.setBackground(new Color(255,128,128));
    toGreen = new Button("to GREEN");
    toGreen.addActionListener(this);
    toGreen.setBackground(new Color(128,128,225));
    toRed = new Button("to RED");
    toRed.addActionListener(this);
    toRed.setBackground(new Color(128,255,128));
		Panel buttonrow = new Panel(new GridLayout(1,2));
    buttonrow.add(toBlue);
    buttonrow.add(toGreen);
    buttonrow.add(toRed);
	
    add(redList, BorderLayout.NORTH);
    add(blueList, BorderLayout.WEST);
    add(greenList, BorderLayout.CENTER);
    add(buttonrow, BorderLayout.SOUTH);
		setSize(389, 219);
    show();
  }

  /** Button pressed: look at the button and either move all selected from red to blue or from blue to red*/
  public void actionPerformed(ActionEvent evt)
  {
  	if(evt.getSource() == toBlue) //red to blue
  		moveItems(redList, blueList);
  	else if(evt.getSource() == toGreen) //blue to big
  		moveItems(blueList, greenList);
  	else                           //big to red
  		moveItems(greenList, redList);
  }


  private void moveItems(java.awt.List from, java.awt.List to)
  {
		Object[] selected = from.getSelectedObjects();
		
		for(int i=0; i<selected.length; i++)
		{
			to.add((String)selected[i],0); //ad as first in row
			from.remove((String)selected[i]);
		}
  }

  static public void main (String[] args)
  {
    int min=3;
    int desired=5;
    boolean multiple=false;
    if(args.length>0)
    	min = Integer.parseInt(args[0]);
    if(args.length>1)
    	desired = Integer.parseInt(args[1]);
    if(args.length>2)
    	multiple = true;
  	new TestList(min, desired, multiple);
  }
}
