/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/**
 * $Id: VirtualFile.java,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
 */

package com.acunia.wonka;

import java.io.File;
import java.util.Vector;
import java.util.Hashtable;

public class VirtualFile {

  private static Hashtable ht = new Hashtable();

  public static boolean register (File f) {
    if (f == null) throw new NullPointerException("lap, null");
    String key = f.getPath()+File.separatorChar+f.getName();
//System.out.println("(EMO)register() "+key);
    boolean answer = false;
    //if (ht.contains(f)) {
    if (ht.containsKey(key)) {
//System.out.println("(EMO)VF: File "+key+" existed");
//System.out.println("(EMO)VF: File "+f+" existed");
    }
    else {
//      System.out.println("EMO: Saving file "+f.getPath()+"/"+f.getName());
      ht.put (f.getPath()+File.separatorChar+f.getName() ,f);
      answer = true;
// System.out.println("VF: (Name, File) ("+f.getPath()+"/"+f.getName()+", "+f+") registered");
    }
    return answer;
  }

  public static void unregister (File f) {
    if (ht.containsKey(f.getPath()+File.separatorChar+f.getName())) {
      ht.remove(f);
System.out.println("VF: File "+f+" unregistered");
    }
    else {
System.out.println("VF: File "+f+" already unregistered");
    }
  }

  public static File lookup(String filename) {
    // System.out.println("lookup asked for "+filename+", will return "+ht.get(filename));
//System.out.println("EMO: lookup() for "+filename);
//System.out.println("EMO: lookup() returning "+ht.get(filename));
    return (File)ht.get(filename);
  }

}

