/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: Chris.java,v 1.3 2002/01/08 16:57:37 gray Exp $
*/
package com.acunia.wonka.test;

import com.acunia.wonka.PersistentRoot;

import java.util.ArrayList;
import java.util.List;
import java.util.Dictionary;
import java.util.Enumeration;
import java.security.Permission;
import java.security.PermissionCollection;

class Chris implements Runnable {

  private static void test_implies(Permission a, Permission b, boolean expected) {
    boolean result = a.implies(b);
    System.out.println(a+" implies "+b+": "+result);
    System.out.println(result==expected?"==> OK":"==> ERROR");
  }

  private static void test_implies(PermissionCollection c, Permission b, boolean expected) {
    boolean result = c.implies(b);
    System.out.println(c+" implies "+b+": "+result);
    System.out.println(result==expected?"==> OK":"==> ERROR");
  }

  public void run() {
    System.out.println("Farewell world");
  }

  public static void main(String[] args) {
    Class ci = int.class;
    Class cs = java.io.Serializable.class;
    Class cc = Class.class;
    System.out.println(ci);
    System.out.println(cs);
    System.out.println(cc);
    String arch = System.getProperty("os.arch");
    Runtime rt = Runtime.getRuntime();
    Boolean impl;

/*
    int j = 0;
    long t0 = System.currentTimeMillis();
    for (int i = 0; i < 1000000; ++i) {
      synchronized(arch) {
        ++j;
      }
    }
    long t1 = System.currentTimeMillis();
    System.out.println("Performed "+j+" synchronized blocks in "+(t1-t0)+" milliseconds");
*/
    for (int i = 0; i < 10; ++i) {
    byte[][] blob = new byte[10][1000000];
    System.out.println("Memory available: "+rt.freeMemory());
    long t2 = System.currentTimeMillis();
    blob = null;
    rt.gc();
    long t3 = System.currentTimeMillis();
    System.out.println("gc() took "+(t3-t2)+" milliseconds");
    System.out.println("Memory available: "+rt.freeMemory());
    }

    if (args.length > 0) {
      StringBuffer sentence = new StringBuffer();
      for (int i = 0; i < args.length - 1; ++i) {
        sentence.append(args[i]);
        sentence.append(' ');
      }
      sentence.append(args[args.length - 1]);
      Carillon.getInstance(sentence.toString()).setDaemon(true);
    }
    else {
      Carillon.getInstance("Multithreaded programming is difficult and error prone. It is easy to make a mistake in synchronization that produces a data race, yet it can be extremely hard to locate this mistake during debugging.").setDaemon(true);
    }

    Runtime.getRuntime().addShutdownHook(new Thread(new Chris()));

  }

}

