/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: ObjectStreamConstants.java,v 1.1.1.1 2001/11/21 10:41:34 pollock Exp $
*/

package java.io;

public interface ObjectStreamConstants {

  final static short STREAM_MAGIC = (short)0xaced;
  final static short STREAM_VERSION = 5;

  final static int baseWireHandle = 0x7e0000;
  final static byte TC_ARRAY = (byte)0x75;
  final static byte TC_BASE = (byte)0x70;
  final static byte TC_BLOCKDATA = (byte)0x77;
  final static byte TC_BLOCKDATALONG = (byte)0x7a;
  final static byte TC_CLASS = (byte)0x76;
  final static byte TC_CLASSDESC = (byte)0x72;
  final static byte TC_ENDBLOCKDATA = (byte)0x78;
  final static byte TC_EXCEPTION = (byte)0x7b;

  final static byte TC_LONGSTRING = (byte)0x7C; //added in JLS 1.3

  final static byte TC_MAX = (byte)0x7b;
  final static byte TC_NULL = (byte)0x70;
  final static byte TC_OBJECT = (byte)0x73;
  final static byte TC_REFERENCE = (byte)0x71;
  final static byte TC_RESET = (byte)0x79;
  final static byte TC_STRING = (byte)0x74;

  final static byte SC_WRITE_METHOD = 0x01;
  final static byte SC_BLOCK_DATA = 0x08;
  final static byte SC_SERIALIZABLE = 0x02;
  final static byte SC_EXTERNALIZABLE = 0x04;

  public final static int PROTOCOL_VERSION_1 = 1;
  public final static int PROTOCOL_VERSION_2 = 2;

  public static final SerializablePermission SUBCLASS_IMPLEMENTATION_PERMISSION=
    new SerializablePermission("enableSubclassImplementation");
  public static final SerializablePermission SUBSTITUTION_PERMISSION=
    new SerializablePermission("enableSubstitution");
}
