/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: Character.java,v 1.8 2002/01/29 10:40:27 gray Exp $
*/

package java.lang;

public final class Character implements java.io.Serializable,Comparable {

  private static final long serialVersionUID = 3786198910865385080L;

  public static final char MIN_VALUE = '\u0000';
  public static final char MAX_VALUE = '\uffff';
  public static final int MIN_RADIX = 2;
  public static final int MAX_RADIX = 36;
  public static final Class TYPE = Character.getWrappedClass();
  public static final byte SPACE_SEPARATOR = 12;
  public static final byte LINE_SEPARATOR = 13;
  public static final byte PARAGRAPH_SEPARATOR = 14;
  public static final byte UPPERCASE_LETTER = 1;
  public static final byte LOWERCASE_LETTER = 2;
  public static final byte TITLECASE_LETTER = 3;
  public static final byte MODIFIER_LETTER = 4;
  public static final byte OTHER_LETTER = 5;
  public static final byte DECIMAL_DIGIT_NUMBER = 9;
  public static final byte LETTER_NUMBER = 10;
  public static final byte OTHER_NUMBER = 11;
  public static final byte NON_SPACING_MARK = 6;
  public static final byte ENCLOSING_MARK = 7;
  public static final byte COMBINING_SPACING_MARK = 8;
  public static final byte DASH_PUNCTUATION = 20;
  public static final byte START_PUNCTUATION = 21;
  public static final byte END_PUNCTUATION = 22;
  public static final byte CONNECTOR_PUNCTUATION = 23;
  public static final byte OTHER_PUNCTUATION = 24;
  public static final byte MATH_SYMBOL = 25;
  public static final byte CURRENCY_SYMBOL = 26;
  public static final byte MODIFIER_SYMBOL = 27;
  public static final byte OTHER_SYMBOL = 28;
  public static final byte CONTROL = 15;
  public static final byte FORMAT = 16;
  public static final byte UNASSIGNED = 0;
  public static final byte PRIVATE_USE = 18;
  public static final byte SURROGATE = 19;

/*
  void test_numericValues()
  {
    harness.checkPoint ("Character.getNumericValue");
    harness.check (Character.getNumericValue('0'), 0);
    harness.check (Character.getNumericValue('\u0be8'), 2);
    harness.check (Character.getNumericValue('\u246d'), 14);
    harness.check (Character.getNumericValue('\u2182'), 10000);
    harness.check (Character.getNumericValue('\u00bd'), -2);
    harness.check (Character.getNumericValue('A'), 10);
    harness.check (Character.getNumericValue('\u2155'), -2);
    harness.check (Character.getNumericValue('\u221e'), -1);

    harness.checkPoint ("Character.digit");
    harness.check (Character.digit ('9', 10), 9);
    harness.check (Character.digit ('9', 8), -1);
    harness.check (Character.digit ('a',10), -1);
    harness.check (Character.digit ('A', 16), 10);
    harness.check (Character.digit ('a', 11), 10);
    harness.check (Character.digit ('\u0041', 36), 10);
    harness.check (Character.digit ('\u0061', 36), 10);
    harness.check (Character.digit ('\uff41', 36), 10);
    harness.check (Character.digit ('-', 36), -1);
    harness.check (Character.digit ('Z', 36), 35);
    harness.check (Character.digit ((char)0x5a, 36), 35);
    harness.check (Character.digit ((char)0x5b, 36), -1);
    harness.check (Character.digit ((char) ('Z' + 1), 36), -1);
    harness.check (Character.digit ('\u0be7', 2), 1);
    harness.check (Character.digit ('\u0f27', 19), 7);
    harness.check (Character.digit ('0', 99), -1);
    harness.check (Character.digit ('0', -5), -1);

    harness.checkPoint ("Character.forDigit");
    harness.check (Character.forDigit(5, 10),'5');
    harness.check (Character.forDigit(5, 10), '\u0035');
    harness.check (Character.forDigit(10,10), 0);
    harness.check (Character.forDigit(10,10), '\u0000');
    harness.check (Character.forDigit(-1,10), 0);
    harness.check (Character.forDigit(0, 10),'0');
    harness.check (Character.forDigit(10,16),'a');
    harness.check (Character.forDigit(10, 16) != 'A');
    harness.check (Character.forDigit(1,  1), 0);
    harness.check (Character.forDigit(1,  2),'1');
    harness.check (Character.forDigit(1, 37), 0);
  }

  void test_toCases()
  {
    char highchar, lowchar, titlechar;
    harness.checkPoint ("Character 'b' ");
    highchar = (char)'B';
    lowchar =  (char)'b';
    harness.check (Character.isUpperCase (highchar));
    harness.check (!Character.isUpperCase (lowchar));
    harness.check (!Character.isLowerCase (highchar));
    harness.check (Character.isLowerCase (lowchar));
    harness.check (!Character.isTitleCase (highchar));
    harness.check (!Character.isTitleCase (lowchar));

    harness.check (Character.toUpperCase (highchar), highchar);
    harness.check (Character.toUpperCase (lowchar), highchar);
    harness.check (Character.toLowerCase (highchar), lowchar);
    harness.check (Character.toLowerCase (lowchar), lowchar);
    harness.check (Character.toTitleCase (highchar), highchar);
    harness.check (Character.toTitleCase (lowchar), highchar);

    harness.checkPoint ("Character 'psi' (\u03a8 \u03c8)  ");
    highchar = '\u03a8';
    lowchar =  '\u03c8';
    harness.check (Character.isUpperCase (highchar));
    harness.check (!Character.isUpperCase (lowchar));
    harness.check (!Character.isLowerCase (highchar));
    harness.check (Character.isLowerCase (lowchar));
    harness.check (!Character.isTitleCase (highchar));
    harness.check (!Character.isTitleCase (lowchar));

    harness.check (Character.toUpperCase (highchar), highchar);
    harness.check (Character.toUpperCase (lowchar), highchar);
    harness.check (Character.toLowerCase (highchar), lowchar);
    harness.check (Character.toLowerCase (lowchar), lowchar);
    harness.check (Character.toTitleCase (highchar), highchar);
    harness.check (Character.toTitleCase (lowchar), highchar);

    harness.checkPoint ("Character 'C circumflex' (\u0108 \u0109)  ");
    highchar = '\u0108';
    lowchar =  '\u0109';
    harness.check (Character.isUpperCase (highchar));
    harness.check (!Character.isUpperCase (lowchar));
    harness.check (!Character.isLowerCase (highchar));
    harness.check (Character.isLowerCase (lowchar));
    harness.check (!Character.isTitleCase (highchar));
    harness.check (!Character.isTitleCase (lowchar));

    harness.check (Character.toUpperCase (highchar), highchar);
    harness.check (Character.toUpperCase (lowchar), highchar);
    harness.check (Character.toLowerCase (highchar), lowchar);
    harness.check (Character.toLowerCase (lowchar), lowchar);
    harness.check (Character.toTitleCase (highchar), highchar);
    harness.check (Character.toTitleCase (lowchar), highchar);

    harness.checkPoint ("Character 'Lj' (/u01c7 /u01c8 /u01c9)  ");
    highchar = '\u01c7';
    lowchar =  '\u01c9';
    titlechar ='\u01c8';
    harness.check (Character.isUpperCase (highchar));
    harness.check (!Character.isUpperCase (lowchar));
    harness.check (!Character.isUpperCase (titlechar));
    harness.check (!Character.isLowerCase (highchar));
    harness.check (Character.isLowerCase (lowchar));
    harness.check (!Character.isLowerCase (titlechar));
    harness.check (!Character.isTitleCase (highchar));
    harness.check (!Character.isTitleCase (lowchar));
    harness.check (Character.isTitleCase (titlechar));

    harness.check (Character.toUpperCase (highchar), highchar);
    harness.check (Character.toUpperCase (lowchar), highchar);
    harness.check (Character.toUpperCase (titlechar), highchar);
    harness.check (Character.toLowerCase (highchar), lowchar);
    harness.check (Character.toLowerCase (lowchar), lowchar);
    harness.check (Character.toLowerCase (titlechar), lowchar);
    harness.check (Character.toTitleCase (highchar), titlechar);
    harness.check (Character.toTitleCase (lowchar), titlechar);
    harness.check (Character.toTitleCase (titlechar), titlechar);

    harness.checkPoint ("Character '-' (no letter)  ");
    highchar = '-';
    harness.check (!Character.isUpperCase (highchar));
    harness.check (!Character.isLowerCase (highchar));
    harness.check (!Character.isTitleCase (highchar));

    harness.check (Character.toUpperCase (highchar), highchar);
    harness.check (Character.toLowerCase (highchar), highchar);
    harness.check (Character.toTitleCase (highchar), highchar);
  }


  void test_hashCode ()
  {
    harness.checkPoint ("hashCode");
    Character a = new Character ('\uffda');
    Character b = new Character ('Z');

    harness.check (a.hashCode(), 0xffda); //65498);
    harness.check (b.hashCode(), 90);
  }

*/

  /**
   ** The char which is wrapped by this Character.
   */
  private final char value;

  /**
   ** Create our native tables.
   */
  private static native void createTables();
  static {
    createTables();
  }

  /**
   ** Construct a Character wrapping a particular char
   */
  public Character(char value) {
    this.value = value;
  }

  /**
   ** The string representattion is simply a one-character string.
   */
  public String toString() {
    char[] onechar = new char[1];

    onechar[0] = this.value;

    return new String(onechar);
  }

  /**
   ** This Character is `equal' to any other Character which wraps the same
   ** char, and to nothing else.
   */
  public boolean equals(Object obj) {
    if (obj == null) {

      return false;

    }

    try {
      Character c = (Character)obj;

      return this.value == c.value;

    }
    catch (ClassCastException cce) {

      return false;

    }
  }

  /**
   ** The hashcode is equal to the wrapped char.
   */
  public int hashCode() {

    return (int) value;

  }

  /**
   ** Get the wrapped char.
   */
  public char charValue() {

    return value;

  }

  /**
   ** Compare the values of the wrapped char's.
   */
  public int compareTo(Character anotherCharacter) {
    char other_value = anotherCharacter.value;

    if (value > other_value) return 1;

    if (value < other_value) return -1;

    return 0;
  }

  /**
   ** Will throw a ClassCastException if object of comparison is not a Character.
   */
  public int compareTo(Object something) throws ClassCastException {
    return compareTo((Character)something);
  }

  /**
   ** Consult native code tables to see if the char is assigned in UnicodeData.txt.
   */
  public native static boolean isDefined(char ch);

  /**
   ** Consult native code tables to see if the char is a lower-case letter
   ** (has no lower-case equivalent in  UnicodeData.txt and either has an
   ** upper-case equivalent or has `SMALL LETTER' or `SMALL LIGATURE' in its name).
   */
  public native static boolean isLowerCase(char ch);

  /**
   ** Consult native code tables to see if the char is an upper-case letter
   ** (has no upper-case equivalent in  UnicodeData.txt and either has an
   ** lower-case equivalent or has `CAPITAL LETTER' or `CAPITAL LIGATURE' 
   ** in its name).
   */
  public native static boolean isUpperCase(char ch);

  /**
   ** Consult native code tables to see if the char is a title-case letter
   ** (has both lower-case and upper-case equivalents in UnicodeData.txt).
   */
  public native static boolean isTitleCase(char ch);

  /**
   ** Consult native code tables to see if the char is a letter (is not
   ** in the range 2000-2FFF, and either is one of the three letter cases 
   ** above, or has a general category code in UnicodeData.txt beginning 
   ** with `L', or is in the range 0100-1FFF and is not a Digit, see below).
   */
  public native static boolean isLetter(char ch);

  /**
   ** Consult native code tables to see if the char is a digit (is not
   ** in the range 2000-2FFF, and either has `DIGIT' in its name or
   ** general category code `Nd' in UnicodeData.txt, depending on which
   ** version of the spec you are reading).
   */
  public native static boolean isDigit(char ch);

  /**
   ** Consult native code tables to see if the char is whitespace (is one
   ** of 0009, 000A, 000B, 000C, 000D, 001C, 001D, 001E, or 001F, or has
   ** a general category code in UnicodeData.txt beginning with `Z' and
   ** does not have a compatibility mapping marked <nobreak>).
   */
  public native static boolean isWhitespace(char ch);

  /**
   ** A char is a letter or a digit if it is a letter or a digit.
   */
  public static boolean isLetterOrDigit(char ch) {
    return isLetter(ch) || isDigit(ch);
  }

  /**
   ** A `Java letter' is a letter or $_.
   */
  public static boolean isJavaLetter(char ch) {

    return (ch=='$') || (ch=='_') || Character.isLetter(ch);

  }

  /**
   ** A `Java letter or digit' is a Java letter or a digit.
   */
  public static boolean isJavaLetterOrDigit(char ch) {

    return (ch=='$') || (ch=='_') || Character.isLetterOrDigit(ch);

  }

  // DEPRECATED - use isWhitespace(char)
  public static boolean isSpace(char ch) {
    return ch=='\n' || ch=='\t' ||ch=='\f' || ch=='\r' || ch==' ';
  }

  /**
   ** Consult native code tables to see if the char is a formatting char
   ** (has general category code `Cf' in UnicodeData.txt).
   */
  private native static boolean isFormat(char ch);

  public native static char toLowerCase(char ch);

  public native static char toUpperCase(char ch);

  public native static char toTitleCase(char ch);

  private static native int digitValue(char ch);

  private static native int numericValue(char ch);

  public static int digit(char ch, int radix) {
    if(radix<MIN_RADIX || radix>MAX_RADIX) {

      return -1;
 
    }

    if(isDigit(ch)) {
      int dv = digitValue(ch);

      return dv < radix ? dv : -1 ;

    }

    if(ch>='A' && ch<='Z' && ch < 'A' + radix - 10) {

      return ch-'A'+10;

    }

    if(ch>='a' && ch<='z' && ch < 'a' + radix - 10) {

      return ch-'a'+10;
    } 

    return -1;

  }


  public static int getNumericValue(char ch) {
    int result = digit(ch, 36);

    if (result == -1) {
      result = numericValue(ch);
    }

    return result;
  }

  public static boolean isIdentifierIgnorable(char ch) {
    return ( 
         (ch < ' ' && !Character.isWhitespace(ch))
      || (ch > '\u007e' && ch < '\u00a0') 
      || isFormat(ch)
    );
  }

  public static boolean isJavaIdentifierPart(char ch) {
    if (isLetterOrDigit(ch)) {

      return true;

    }
       
    int type = getType(ch);

    return
      type == CURRENCY_SYMBOL
      || type == CONNECTOR_PUNCTUATION
      || type == LETTER_NUMBER
      || type == COMBINING_SPACING_MARK
      || type == NON_SPACING_MARK
      || isIdentifierIgnorable(ch);

  }

  public static boolean isJavaIdentifierStart(char ch) {
    if (isLetter(ch)) {

      return true;

    }
       
    int type = getType(ch);

    return
      type == CURRENCY_SYMBOL
      || type == LETTER_NUMBER
      || type == CONNECTOR_PUNCTUATION;

  }

  public static boolean isUnicodeIdentifierPart(char ch) {
    if (isLetterOrDigit(ch)) {

      return true;

    }
       
    int type = getType(ch);

    return
      type == CONNECTOR_PUNCTUATION
      || type == LETTER_NUMBER
      || type == COMBINING_SPACING_MARK
      || type == NON_SPACING_MARK
      || isIdentifierIgnorable(ch);

  }

  public static boolean isUnicodeIdentifierStart(char ch) {
    return isLetter(ch) || getType(ch) == LETTER_NUMBER;
  }

  public static boolean isSpaceChar(char ch) {
    int type = getType(ch);

    return
      type == SPACE_SEPARATOR
      || type == LINE_SEPARATOR
      || type == PARAGRAPH_SEPARATOR;
  }

  public static boolean isISOControl(char ch) {
    return ((int)ch <= 0x001f) || ((int)ch >= 0x007f && (int)ch <= 0x009f);
  }

  public static int getType(char ch) {
    String cat = getCategory(ch);
    char cat0 = cat.charAt(0);
    char cat1 = cat.charAt(1);

    switch (cat0) {
      case 'C':
        switch (cat1) {
          case 'c':
            return CONTROL;

          case 'f':
            return FORMAT;

          case 'n':
            return UNASSIGNED;

          case 'o':
            return PRIVATE_USE;

          case 's':
            return SURROGATE;

        }
      case 'L':
        switch (cat1) {
          case 'l':
            return LOWERCASE_LETTER;

          case 'm':
            return MODIFIER_LETTER;

          case 'o':
            return OTHER_LETTER;

          case 't':
            return TITLECASE_LETTER;

          case 'u':
            return UPPERCASE_LETTER;

        }
      case 'M':
        switch (cat1) {
          case 'c':
            return COMBINING_SPACING_MARK;

          case 'e':
            return ENCLOSING_MARK;

          case 'n':
            return NON_SPACING_MARK;

        }
      case 'N':
        switch (cat1) {
          case 'd':
            return DECIMAL_DIGIT_NUMBER;

          case 'l':
            return LETTER_NUMBER;

/* New in 1.4?
          case 'm':
            return MODIFIER_NUMBER;
*/
          case 'o':
            return OTHER_NUMBER;

        }
      case 'P':
        switch (cat1) {
          case 'c':
            return CONNECTOR_PUNCTUATION;

          case 'd':
            return DASH_PUNCTUATION;

          case 'e':
          case 'f':
            return END_PUNCTUATION;

          case 'o':
            return OTHER_PUNCTUATION;

          case 'i':
          case 's':
            return START_PUNCTUATION;

/* New in 1.4?
          case 'f':
            return FINAL_QUOTE_PUNCTUATION;

          case 'i':
            return INITIAL_QUOTE_PUNCTUATION;
*/
        }
      case 'S':
        switch (cat1) {
          case 'c':
            return CURRENCY_SYMBOL;

          case 'k':
            return MODIFIER_SYMBOL;

          case 'm':
            return MATH_SYMBOL;

          case 'o':
            return OTHER_SYMBOL;

        }
      case 'Z':
        switch (cat1) {
          case 'l':
            return LINE_SEPARATOR;

          case 'p':
            return PARAGRAPH_SEPARATOR;

          case 's':
            return SPACE_SEPARATOR;
          
        }
    }

    return UNASSIGNED;
  }

  public static char forDigit(int digit, int radix) {
    if (radix < MIN_RADIX || radix > MAX_RADIX) {

      return 0;

    }

    if (digit < 0 || digit >= radix) {

      return 0;

    }

    if (digit < 10) {

      return (char)(digit + '0');

    }

    return (char)(digit + 'a' - 10);
  }



  private native static Class getWrappedClass();

  private native static String getCategory(char ch);

}
