/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: AccessibleObject.java,v 1.1.1.1 2001/11/21 10:41:35 pollock Exp $
*/

package java.lang.reflect;

public class AccessibleObject {

  private boolean accessible;

  protected AccessibleObject() {
    accessible = false;
  }
  
  private static void permissionCheck() {
    if (com.acunia.wonka.SecurityConfiguration.USE_ACCESS_CONTROLLER) {
      java.security.AccessController.checkPermission(new ReflectPermission("suppressAccessChecks"));
    }
    else if (com.acunia.wonka.SecurityConfiguration.USE_SECURITY_MANAGER) {
      SecurityManager sm = System.getSecurityManager();
      if (sm != null) {
        sm.checkPermission(new ReflectPermission("suppressAccessChecks"));
      }
    }
  }

  public static void setAccessible(AccessibleObject array[], boolean flag)
    throws SecurityException
  {
    permissionCheck();

    for (int i = 0; i < array.length; ++i) {
      array[i].accessible = flag;
    }
  }

  public void setAccessible(boolean flag)
    throws SecurityException 
  {
    permissionCheck();
    accessible = flag;
  }

  public boolean isAccessible() {
    return accessible;
  }
}
