/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package java.rmi.server;

import java.net.ServerSocket;
import java.net.Socket;
import java.io.IOException;

public abstract class RMISocketFactory implements RMIClientSocketFactory, RMIServerSocketFactory {

  public RMISocketFactory() {
    System.out.println("[RMISocketFactory] Not implemented...");
  }

  public abstract ServerSocket createServerSocket(int port) throws IOException;
  
  public abstract Socket createSocket(String host, int port) throws IOException;
  
  public static RMISocketFactory getDefaultSocketFactory() {
    System.out.println("[RMISocketFactory.getDefaultSocketFactory] Not implemented...");
    return null;
  }
  
  public static RMIFailureHandler getFailureHandler() {
    System.out.println("[RMISocketFactory.getFailureHandler] Not implemented...");
    return null;
  }
  
  public static RMISocketFactory getSocketFactory() {
    System.out.println("[RMISocketFactory.getSocketFactory] Not implemented...");
    return null;
  }
  
  public static void setFailureHandler(RMIFailureHandler fh) {
    System.out.println("[RMISocketFactory.setFailureHandler] Not implemented...");
  }
  
  public static void setSocketFactory(RMISocketFactory fac) throws IOException {
    System.out.println("[RMISocketFactory.setSocketFactory] Not implemented...");
  }
    
}

