/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: BasicPermission.java,v 1.1.1.1 2001/11/21 10:41:35 pollock Exp $
*/

package java.security;

import java.io.Serializable;

public abstract class BasicPermission extends Permission implements Serializable {

  public BasicPermission(String name) {
    super(name);
    int star = name.indexOf('*');
    if (name=="") throw new IllegalArgumentException();
    if (star>=0 && star<name.length()-1) throw new IllegalArgumentException();
  }

  public BasicPermission(String name, String actions) {
    this(name);
  }

  public boolean equals (Object o) {
    if (o == null)  {
    	return false;
    }
    if (this.getClass().equals(o.getClass())) {
      Permission p = (Permission)o;
      return this.getName().equals(p.getName());
    }
    else return false;
  }

  public int hashCode() {
    return getName().hashCode();
  }

  public String getActions() {
    return "";
  }

  public PermissionCollection newPermissionCollection() {
    return new com.acunia.wonka.security.BasicPermissionCollection();
  }

  public boolean implies (Permission p) {
    boolean answer = false;
    if (this.getClass().equals(p.getClass())) {
      String ourname = this.getName();
      int star = ourname.indexOf('*');
      if (star<0) {
        answer = ourname.equals(p.getName());
      }
      else {
        answer = ourname.substring(0,star-1).equals(p.getName().substring(0,star-1));
      }
    }
    return answer;
  }
}
