/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: SQLWarning.java,v 1.1 2002/02/06 11:28:09 dumon Exp $
*/

package java.sql;

public class SQLWarning extends SQLException {

  private SQLWarning nextWarning = null;
  
  public SQLWarning() {
    this(null, null, 0);
  }
  
  public SQLWarning(String reason) {
    this(reason, null, 0);
  }
  
  public SQLWarning(String reason, String SQLstate) {
    this(reason, SQLstate, 0);
  }
  
  public SQLWarning(String reason, String SQLstate, int vendorCode) {
    super(reason, SQLstate, vendorCode);
  }

  public SQLWarning getNextWarning() {
    return nextWarning;
  }
  
  public void setNextWarning(SQLWarning w) {
    nextWarning = w;
  }

}

