/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: ParsePosition.java,v 1.1.1.1 2001/11/21 10:41:35 pollock Exp $
*/

package java.text;

public class ParsePosition extends Object {

  private int index;
  private int errorIndex= -1;

  public ParsePosition(int index) {
    this.index = index;
  }

  public int getIndex() {
    return index;
  }

  public void setIndex(int index) {
    this.index = index;
  }

  public int getErrorIndex() {
    return errorIndex;
  }

  public void setErrorIndex(int index) {
    this.errorIndex = index;
  }

  public boolean equals(Object o){
    if(!(o instanceof ParsePosition)){
      return false;
    }
    ParsePosition pp = (ParsePosition)o;
    return (this.index == pp.index &&
            this.errorIndex == pp.errorIndex);
  }

  public int hashCode(){
    return 0xffffaaaa ^ index ^ errorIndex;
  }

  public String toString(){
    return this.getClass().getName()+"[index="+index+",errorIndex="+errorIndex+']';
  }
}