/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/**
 * $Id: Set.java,v 1.1.1.1 2001/11/21 10:41:35 pollock Exp $
 */

package java.util;

public interface Set extends Collection {

  public int size();
  public boolean isEmpty();
  public boolean contains(Object o) throws ClassCastException;

  public Iterator iterator();

  public Object[] toArray()throws ArrayStoreException;
  public Object[] toArray(Object[] a)throws ArrayStoreException;

  public boolean add(Object o) throws UnsupportedOperationException, 
    ClassCastException, IllegalArgumentException;
  public boolean remove(Object o) throws UnsupportedOperationException;

  public boolean containsAll(Collection c) throws ConcurrentModificationException;
  public boolean addAll(Collection c) throws UnsupportedOperationException, 
    ClassCastException, IllegalArgumentException, ConcurrentModificationException;
  public boolean retainAll(Collection c) throws UnsupportedOperationException, ConcurrentModificationException;
  public boolean removeAll(Collection c) throws UnsupportedOperationException, ConcurrentModificationException;

  public void clear() throws UnsupportedOperationException;
  public boolean equals(Object o);  
  public int hashCode();
}
