/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


package java.util;

public class StringTokenizer implements Enumeration {

  private String base;
  private String delimeted;
  private int delimeter;

  private boolean delimTokens;

  private int index=0;

  public StringTokenizer(String str){
    this(str, " \t\n\r" , false);
  }

  public StringTokenizer(String str, String delim){
    this(str, delim, false);
  }

  public StringTokenizer(String str, String delim, boolean returnTokens){
    this.base = str;
    this.delimTokens = returnTokens;
    setDelimeters(delim);
  }

  public int countTokens(){
    if (index >= delimeted.length()){
        return 0;
    }
    if (delimeter == -1){
        return 1;
    }
    int count = 0;
    if(delimTokens){
      int prev = index-1;
      int pos = delimeted.indexOf(delimeter, index);
      while (pos != -1){
         count++;
         if (pos - prev > 1){
           count++;
         }
         prev = pos;
         pos = delimeted.indexOf(delimeter, pos+1);
      }
      if (prev < delimeted.length()-1 & (prev != index-1 | count == 0)){
        count++;
      }
    }else{
      int pos = delimeted.indexOf(delimeter, index);
      int prev = index-1;
      while (pos != -1){
         if(pos - prev > 1){
           count++;
         }
         prev = pos;
         pos = delimeted.indexOf(delimeter, pos+1);
      }
      if (prev < delimeted.length()-1 & (prev != index-1 | count == 0)){
        count++;
      }
    }
    return count;
  }

  public boolean hasMoreElements(){
    return hasMoreTokens();
  }

  public boolean hasMoreTokens(){
    if (!delimTokens && delimeter != -1){
       while(index < delimeted.length() && delimeted.charAt(index) == delimeter){
          index++;
       }
    }
    return index < delimeted.length();
  }

  public Object nextElement(){
    return nextToken();
  }

  public String nextToken(){
    if (hasMoreTokens()){
        if(delimeter != -1){
          int pos = index;
          index = delimeted.indexOf(delimeter, index);
          if (pos == index){
            index++;
          }
          if (index == -1){
            index = delimeted.length();
          }
          return base.substring(pos,index);
        }else{
          index = base.length();
          return base;
        }
    }
    throw new NoSuchElementException();
  }

  public String nextToken(String delim){
    setDelimeters(delim);
    return nextToken();
  }

  private void setDelimeters(String delim){
    if(delim.length() == 0){
      delimeter = -1;
    } else{
      char dlm =delim.charAt(0);
      delimeter = dlm;
      base = base.substring(index);
      delimeted = base;
      index = 0;
      for (int i=1 ; i < delim.length() ; i++){
        delimeted = delimeted.replace(delim.charAt(i) , dlm);
      }
    }
  }

}
