
 banner type .ver 

.( loading Wonka extensions ) 13 emit cr 

only also oop definitions 

1 constant sort-by-hits 
2 constant sort-by-file 

variable class-hashtable-found 
variable class-hashtable 
variable string-hashtable-found 
variable string-hashtable 
variable thread-hashtable-found 
variable thread-hashtable 
variable group-hashtable-found 
variable group-hashtable 
variable globals-hashtable-found 
variable globals-hashtable 

: find-hashtables ( -- ) 
  s" hashtable:system-classes" find-hashtable 
  class-hashtable-found ! 
  class-hashtable ! 
  s" hashtable:strings" find-hashtable 
  string-hashtable-found ! 
  string-hashtable ! 
  s" hashtable:threads" find-hashtable 
  thread-hashtable-found ! 
  thread-hashtable ! 
  s" hashtable:groups" find-hashtable 
  group-hashtable-found ! 
  group-hashtable ! 
  s" hashtable:global-refs" find-hashtable 
  globals-hashtable-found ! 
  globals-hashtable ! 
; 

: welcome ( -- ) 
 ." Welcome to the wonderful world of Willy Wonka!" cr 
 ." For help cry 'help', to leave say 'bye'." cr 
; 

: abwelcome ( -- ) 
 ." Oh dear, something is amiss in the world of Willy Wonka!" cr 
 ." For help cry 'help', to leave say 'bye'." cr 
; 

: more ( "key" -- ) 
  ." Press return to continue, Q to quit: " 
  key dup 0x71 = swap 0x51 = or if abort then 
  cr 
; 

: basic-help ( -- ) 
 ." This is Claudia, your online debugging assistant.  Claudia understands" cr 
 ." a special version of the Forth language (FICL), with object-oriented" cr 
 ." extensions.  All requests to Claudia consist of a series of `words'" cr 
 ." separated by spaces.  Note that operators such as `,' or `-->' are also" cr 
 ." `words', so they need a space on each side!  You'll get used to it ..." cr 
 cr 
 ." Here are some useful one-word commands: " cr 
 ."   about              Tells you which version of the software you are running " cr 
 ."   errors             Explains Claudia's error messages " cr 
 ."   help               Prints the stuff you are reading now " cr 
 ."   classes globals  ) Print a list of all the classes, global refeences," cr 
 ."   groups  instances) thread groups, object instances, strings, or threads" cr 
 ."   strings threads  ) which currently exist in the system." cr 
 cr 
 cr more 
 ." Claudia has her own stack, which holds FICL objects.  Note that " cr 
 ." this stack is separate from any JAVA stack, and that FICL objects " cr 
 ." are not JAVA objects: they more like the jobject, jclass, etc. data" cr 
 ." types of JNI." cr 
 ." The following words can be used to directly push a FICL object reference" cr 
 ." onto Claudia's stack:                                           " cr 
 ."   Command                        Example                    Pushes a: " cr 
 ."   class <slashed-classname>      class java/lang/String     w-clazz" cr 
 ."   instance <offset>              instance 0x00678900        w-object" cr 
 ."   thread <thread-id>             thread 2                   w-thread" cr 
 ."   string <string-w/o-spaces>     string ([B)V               w-string" cr 
 ." If a string includes spaces, then you need to type e.g.      " cr 
 ."   string" 0x22 emit ."  Hello world" 0x22 emit cr 
 ." -- observe the position of the quotes carefully!" cr 
 cr 
 ." When you have such a FICL object, you can use the `-->' " cr 
 ." operator to manipulate the object.  Five useful operations are defined " cr 
 ." for all types of Claudia object: " cr 
 ."   --> help   lists the possible operations for this object type. " cr 
 ."              (The object remains on the stack)." cr 
 ."   --> show   displays the contents of this object. " cr 
 ."              (The object remains on the stack)." cr 
 ."   --> ref <name> Pops the object from the stack and saves it as `name'." cr 
 ."              Later, typing <name> will push the object back onto the stack. " cr 
 ."   --> dup    Duplicates the object on the stack. " cr 
 ."   --> drop   Drops the object from the stack. " cr 
 ." Many types of FICL object also have methods called `name' and `brief': " cr 
 ." these return a FICL string which holds the name of the underlying JAVA " cr 
 ." object or a brief description (the first line of the output from `show')," cr 
 ." respectively.  To display a FICL string use the (standard Forth) command" cr 
 ."   type cr " 
 cr 
; 

: help ( -- ) 
  depth 0= if basic-help else --> help then 
; 

: about ( -- ) banner type cr .ver ; 

: read-string ( delim-char "name" -- w-string-addr ) 
  word count wonkafy 
  dup 0= abort" No such string!" 
; 

.( loading Wonka object classes ) 13 emit cr 

object subclass w-hashtable 
 cell: realm 
 cell: label 
 w-hashtable ref: next 
 w-hashtable ref: previous 
 cell: currentsize
 cell: occupancy
end-class 

object subclass w-pointers 
  cell: bootmode 
  cell: first-hashtable 
  cell: ps-start ( POS start addr ) 
  cell: ps-end ( POS end addr ) 
end-class 

get-wonka-pointers w-pointers --> ref wonka-pointers 

object subclass w-reference 
  cell: referent 
end-class 

object subclass w-item 
  : dup 2dup ; 
  : drop 2drop ; 
end-class 

w-item subclass w-string 
  cell: padding 
  cell: hash 
  cell: instance 
  cell: length 
  cell: chars 
  : contents ( w-string-inst w-string-class -- c-addr u ) 
    drop dewonkafy 
  ; 
  : show ( w-string-inst w-string-class -- w-string-inst w-string-class ) 
    over ." String 0x" x. 
    2dup --> length  ." length: " @ . 
    2dup --> instance ." instance: 0x" @ x. 
    over string-hashtable slot-of-hashtable ." references: " . drop 
    2dup --> contents cr 4 spaces type 
    cr 
  ; 
  : help ( w-string-inst w-string-class -- ) 
    ." Methods of w-string: " cr 
    ."   --> contents type cr " cr 
    ."     Type the contents of the string " cr 
    ."   --> show " cr 
    ."     Show all information about the string " cr 
  ; 
end-class 

: string ( "name" -- w-string-addr ) 
  bl read-string 
  postpone w-string drop 
; 

: string" ( ccc <"> -- w-string-addr ) 
  0x22 read-string 
  postpone w-string drop 
; 

w-item subclass w-desc 
  w-string ref: name 
  cell: registered 
  cell: tag 
  cell: body 
end-class 

 0x0001 constant acc-public 
 0x0002 constant acc-private 
 0x0004 constant acc-protected 
 0x0008 constant acc-static 
 0x0010 constant acc-final 
 0x0200 constant acc-interface 
 0x0400 constant acc-abstract 

w-item subclass w-clazz 
  w-string ref: dotified 
  cell: label 
  cell: flags 
  cell: loader
  cell: version 
  w-clazz  ref: super 
  cell: num-interfaces 
  cell: interfaces 
  cell: num-fields 
  cell: fields 
  cell: num-methods 
  cell: methods 
  cell: member-hashtable 
  cell: interface-hashtable 
  cell: num-constants 
  cell: constants 
  cell: num-pool 
  cell: pool 
  cell: num-instance-fields 
  cell: num-inheritable-methods 
  cell: num-super-classes 
  cell: num-static-fields 
  cell: static-fields 
  cell: num-static-words 
  cell: instance-size 
  : show ( w-clazz-inst w-clazz-class -- w-clazz-inst w-clazz-class ) 
    2dup --> flags @ 
    dup acc-public and if ." public " then 
    dup acc-private and if ." private " then 
    dup acc-protected and if ." protected " then 
    dup acc-final and if ." final " then 
    acc-interface acc-abstract or and ?dup if 
      acc-abstract = if ." abstract class " else ." interface " then 
      else ." class " 
    then 
    2dup --> name --> contents type 
    over ."  w-clazz at 0x" x. 
    2dup --> flags ." flags: 0x" @ x. 
    2dup --> super over if 
      cr 2 spaces 
      ." superclass: " --> name --> contents type 
    else 2drop 
    then 
    cr 2 spaces 
    2dup --> num-interfaces @ 
    dup . ." interfaces" 
    ?dup if 
      ." :" 0 do 
        space 2dup --> interfaces @ i cells + @ 
        postpone w-clazz drop --> name --> contents type 
      loop 
    then 
    cr 2 spaces 
    2dup --> num-fields @ dup . ." fields " 
    ?dup if 
      ." :" 0 do 
        space 2dup --> fields @ i cells + @ 
        s" w-field drop --> name --> contents type " evaluate 
      loop 
    then 
    cr 2 spaces 
    2dup --> num-methods @ dup . ." methods " 
    ?dup if 
      ." :" 0 do 
        space 2dup --> methods @ i cells + @ 
        s" w-method drop --> fullname --> contents type " evaluate 
      loop 
    then 
    cr 
  ; 
  : field ( w-clazz-inst w-clazz-class "name" -- w-field-inst w-field-class ) 
    --> member-hashtable @ bl read-string swap read-hashtable 
    dup 0= abort" No such field!" 
    s" w-field drop " evaluate 
  ; 
  : method ( w-clazz-inst w-clazz-class "name" -- w-method-inst w-method-class ) 
    --> member-hashtable @ bl read-string swap read-hashtable 
    dup 0= abort" No such method!" 
    s" w-method drop " evaluate 
  ; 
  : new ( w-clazz-inst w-clazz-class -- w-object-inst w-object-clazz ) 
    drop (new) 
  ; 
  : start ( w-clazz-inst w-clazz-class -- ) 
    drop here 256 accept here swap (main) 
  ; 
  : help ( w-clazz-inst w-clazz-class -- ) 
    ." Methods of w-clazz: " cr 
    ."   --> show " cr 
    ."     Show all information about the class at top-of-stack" cr 
    ."   --> field <fieldname> " cr 
    ."     Replace the w-clazz by the named w-field " cr 
    ."     Example: field foo  " cr 
    ."   --> method <methodname-plus-signature> " cr 
    ."     Replace the w-clazz by the named w-method " cr 
    ."     Example: method main([Ljava/lang/String)  " cr 
    ."   --> new " cr 
    ."     Replace the w-clazz by a new instance of the class (a w-object)" cr 
    ."   --> start <up to 256 chars> " cr 
    ."     Pop the w-clazz and call its static void main() method," cr 
    ."     passing the rest of the command line as an array of String. " cr 
  ; 
end-class 

w-item subclass w-field 
  cell: slot 
  cell: label 
  cell: symbol 
  w-clazz ref: declared-in 
  w-string ref: name 
  w-desc ref: desc 
  cell: flags 
  cell: words 
  cell: const-value 
  : show ( w-field-inst w-field-class -- w-field-inst w-field-class ) 
    2dup --> label @ c@ 0x66 <> abort" Not a field!" 
    2dup --> flags @ acc-static and if 
      ." Static " else 
      ." Instance " then 
    2dup --> name --> contents ." field " type 
    2dup --> desc --> name --> contents ."  type " type 
    2dup --> slot @ ."  slot " . 
    2dup --> flags @ acc-static and if 
    2dup 2dup --> declared-in --> static-fields @ space dup x. rot rot --> slot @ space dup x. + @ x. 
( TODO: look up value of static )
    then 
    cr 
  ; 
  : help ( -- ) 
    ." Methods of w-field: " cr 
    ."   --> show " cr 
    ."     Show all information about the field " cr 
  ; 
end-class 

w-item subclass w-method 
  cell: slot 
  cell: arg-i 
  cell: function 
  cell: dispatcher 
  cell: label 
  cell: local-i 
  cell: return-i 
  cell: stack-i 
  cell: growth-i 
  cell: code 
  cell: code-length 
  w-string ref: name 
  w-string ref: fullname 
  w-desc ref: desc 
  cell: flags 
  w-clazz ref: declared-in 
  cell: do-virtual 
  cell: do-special 
  cell: do-static 
  cell: num-exceptions 
  cell: exceptions 
  cell: num-throws 
  cell: throws 
  cell: num-locals 
  cell: locals 
  cell: num-linenums 
  cell: linenums 
  : show ( w-method-inst w-method-class -- w-method-inst w-method-class ) 
    2dup --> label @ c@ 0x6d <> abort" Not a method!" 
    2dup --> flags @ 8 and if 
      ." Static " else 
      ." Instance " then 
    2dup --> name --> contents ." method " type 
    2dup --> desc --> name --> contents type 
    2dup --> declared-in --> name --> contents ."  declared in " type cr 
    2dup --> slot @ ."   slot " . ." : " 
    2dup --> arg-i @ . ." arg words, " 
    2dup --> return-i @ . ." return words, " 
    2dup --> local-i @ . ." local var words, " 
    2dup --> stack-i @ . ." stack words " 
    cr 
  ; 
  : help ( -- ) 
    ." Methods of w-method: " cr 
    ."   --> show " cr 
    ."     Show all information about the method " cr 
  ; 
end-class 

: cmove ( src-addr dest-addr num-chars -- ) 
 0 do over i + @ over i + ! loop 
; 

variable invoke-params 127 allot 
variable param-start 
variable param-count 
: params ( -- ) 
  here param-start ! 
; 
: endp ( -- ) 
  param-start @ 0= abort" Dangling endp!" 
  here param-start @ - param-count ! 
  param-start @ invoke-params param-count @ cmove 
  0 param-start ! 
; 


w-item subclass w-object 
  cell: madgic 
  cell: file 
  cell: line 
  cell: lock 
  cell: setref 
  cell: pobject 
  cell: hashcode 
  cell: flags 
  w-clazz ref: class 
  cell: fields 
  : init ( w-object-inst w-object-class -- ) 
    --> madgic @ 0xbeafbabe <> if 
      ." ERROR: " over x. ." is not an object!" abort 
    then 
  ; 
  : classname ( w-object-inst w-object-class -- c-addr u ) 
    2dup --> madgic @ 0xbeafbabe <> if 
      ." ERROR: " over x. ." is not an object!" abort 
    then 
    --> class --> name --> contents 
  ; 
  : field ( w-object-inst w-object-class -- address ) 
    2dup --> madgic @ 0xbeafbabe <> if 
      ." ERROR: " over x. ." is not an object!" abort 
    then 
    2dup --> class --> field --> slot @ swap drop + 
  ; 
  : method ( w-object-inst w-object-class -- w-object-inst w-object-class w-instance-method-inst w-instance-method-class ) 
    2dup --> madgic @ 0xbeafbabe <> if 
      ." ERROR: " over x. ." is not an object!" abort 
    then 
    2dup --> class --> method 
  ; 
  : show ( w-object-inst w-object-class -- w-object-inst w-object-class ) 
    2dup --> madgic @ 0xbeafbabe <> if 
      ." ERROR: " over x. ." is not an object!" abort 
    then 
    over ." Object 0x" x. 
    2dup --> classname ." is instance of class " type cr 
    2dup --> next drop ."   next: 0x" x. 
    2dup --> prev drop ." prev: 0x" x. 
    2dup --> madgic ." madgic: 0x" @ x. 
    2dup --> flags ." flags: 0x" @ x. 
    2dup --> lock @ ?dup if ." lock: 0x" x. then 
    2dup --> pobject @ ?dup if ." local copy of: 0x" x. then 
    2dup --> hashcode @ ?dup if  ." hashcode: 0x" x. then 
    cr 
  ; 
  : start ( w-clazz-inst w-clazz-class -- ) 
    drop (run) 
  ; 
  : help ( w-object-inst w-object-class -- ) 
    ." Methods of w-object: " cr 
    ."   --> show " cr 
    ."     Show all information about the object " cr 
    ."   --> field <fieldname> " cr 
    ."     Replace the w-object by the named w-field " cr 
    ."     Example: field foo  " cr 
    ."   --> start " cr 
    ."     Pop the w-object and call its void run() method." cr 
  ; 
end-class 

: load ( "name" -- ) 
  bl word count (load) 
; 

: utf16. ( itf16-addr -- ) 
  dup 2 + swap c@ 0 do dup i + i + c@ emit loop drop 
; 

: pclass2name ( class-pinstance-addr -- utf16-addr ) 
  2 cells + @ 
; 

: w-instance instance2object postpone w-object ; 

w-item subclass w-pobject 
  cell: lock 
  cell: setref 
  w-object ref: local-copy 
  cell: hashcode 
  cell: flags 
  cell: class 
  cell: fields 
  : is-class ( inst class -- true|false ) 
    --> class @ dup instance2pobject postpone w-pobject drop --> class @ = 
  ; 
  : is-string ( inst class -- true|false ) 
    --> class @ ( the class of this instance ) 
    dup pclass2name ( name of the class ) 
    instance2pobject postpone w-pobject drop --> class @ ( class of name = java/lang/String ) 
    = 
  ; 
  : show ( inst class -- inst class ) 
    over ." Persistent instance 0x" x. 
    2dup --> class @ 8 + @ ." of class " utf16. cr 
    2dup --> local-copy drop ."     local-copy: 0x" x. 
    2dup --> hashcode @ ." hashcode: 0x" x. 
    2dup --> flags @ ." flags: 0x" x. 
    2dup --> class @ ." class: 0x" x. cr 
    2dup --> is-string if 
      ."     contents: " 0x22 emit 
      2dup --> fields utf16. 
      0x22 emit 
    else 
      2dup --> is-class if 
        2dup --> fields pclass2name ."     is class  " utf16. cr 
      then 
      2dup --> fields ."     fields: " 
      8 0 do dup i cells + @ x. loop drop 
      ." ... " 
    then 
    cr 
  ; 
  : help ( w-pobject-inst w-pobject-class -- ) 
    ." Methods of w-pobject: " cr 
    ."   --> show " cr 
    ."     Show all information about the persistent object " cr 
  ; 
end-class 

: w-pinstance instance2pobject postpone w-pobject ; 

: class ( "name" -- inst class ) 
  class-hashtable-found @ 
    0= abort" Sorry, class information is not available at this time." 
  bl read-string class-hashtable @ read-hashtable 
  dup 0= abort" No such class!" 
  postpone w-clazz drop 
; 

( : ps ( -- ) 
(  first-pobject postpone w-pobject drop )
(  begin )
(    --> show )
(    swap next-pobject swap )
(    dup while )
(  repeat )
(  2drop )
( ; )

 0x00000001 constant flag-black 
 0x00000002 constant flag-soft-black 
 0x00000004 constant flag-weak-black 
 0x00000008 constant flag-phantom-black 
 0x00000010 constant flag-gray 
 0x00000020 constant flag-green 
 0x0000003f constant flag-non-white 

 0x00000600 constant p-flags-mask 
 0x00000200 constant flag-persistent 
 0x00000400 constant flag-local-copy 

: instance2flags 
  8 - @ 
; 

: pinstance ( "address" -- inst class ) 
  instance2pobject postpone w-pobject drop 
; 

: tinstance ( "address" -- inst class ) 
  instance2object postpone w-object drop 
; 

: xinstance ( "address" -- inst class ) 
  dup instance2flags p-flags-mask and 
  dup p-flags-mask = abort" Not a valid instance address!" 
  flag-persistent and 
  if pinstance else tinstance 
  then 
; 

: instance ( "address" -- inst class ) 
  bl word count evaluate xinstance 
; 

: hashtables ( -- ) 
  ." Found the following hashtables:" cr 
  first-hashtable begin 
    dup ."  " show-hashtable type cr 
    next-hashtable dup first-hashtable = 
  until drop ; 

: thread-report ( -- ) 
  ." Threads: " 
  thread-hashtable-found @ if 
    thread-hashtable @ 
  else 
    s" hashtable:threads" find-hashtable ( hashtable-addr 0|1 )
    2dup thread-hashtable-found ! thread-hashtable ! 
    0= abort"   Sorry, thread information is not available at this time." 
  then 
  dup postpone w-hashtable drop --> occupancy @ . ."  threads" cr 
  0 swap dup lock-hashtable begin 
    iterate-hashtable over 0< 0= if 
      2dup slot-of-hashtable show-thread type cr drop 
      swap 1+ swap ( increment slot number for next iteration ) 
    then 
  over 0< until 
  unlock-hashtable drop 
; 

: threads thread-report ; 

: group-report ( -- ) 
  ." Groups: " 
  group-hashtable-found @ if 
    group-hashtable @ 
  else 
    s" hashtable:groups" find-hashtable 
    2dup group-hashtable-found ! group-hashtable ! 
    0= abort"   Sorry, group information is not available at this time." 
  then 
  dup postpone w-hashtable drop --> occupancy @ . ."  groups" cr 
  0 swap dup lock-hashtable begin 
    iterate-hashtable over 0< 0= if 
      2dup slot-of-hashtable show-group type cr drop 
      swap 1+ swap ( increment slot number for next iteration ) 
    then 
  over 0< until 
  unlock-hashtable drop 
; 

: groups group-report ; 

: globals-report ( -- ) 
  ." Globals: " 
  globals-hashtable-found @ if 
    globals-hashtable @ 
  else 
    s" hashtable:global-refs" find-hashtable 
    2dup globals-hashtable-found ! globals-hashtable ! 
    0= abort" Sorry, globals information is not available at this time." 
  then 
  dup postpone w-hashtable drop --> occupancy @ . ."  globals" cr 
  0 swap dup lock-hashtable begin 
    iterate-hashtable over 0< 0= if 
      2dup slot-of-hashtable 2 spaces . ." references to instance " show-instance type cr 
      swap 1+ swap ( increment slot number for next iteration ) 
    then 
  over 0< until 
  unlock-hashtable drop 
; 

: globals globals-report ; 

: class-report ( -- ) 
  ." Classes: " 
  class-hashtable-found @ if 
    class-hashtable @ 
  else 
    s" hashtable:system-classes" find-hashtable 
    2dup class-hashtable-found ! class-hashtable ! 
    0= abort" Sorry, class information is not available at this time." 
  then 
  dup postpone w-hashtable drop --> occupancy @ . ."  classes" cr 
  0 swap dup lock-hashtable begin 
    iterate-hashtable over 0< 0= if 
      2dup slot-of-hashtable postpone w-clazz drop --> name --> contents type cr drop 
      swap 1+ swap ( increment slot number for next iteration ) 
    then 
  over 0< until 
  unlock-hashtable drop 
; 

: classes class-report ; 

: string-report ( -- ) 
  ." Strings: " 
  string-hashtable-found @ if 
    string-hashtable @ 
  else 
    s" hashtable:strings" find-hashtable 
    2dup string-hashtable-found ! string-hashtable ! 
    0= abort" Sorry, string information is not available at this time." 
  then 
  dup postpone w-hashtable drop --> occupancy @ . ."  strings" cr 
  0 swap dup lock-hashtable begin 
    iterate-hashtable over 0< 0= if 
      2dup slot-of-hashtable drop postpone w-string drop --> contents type cr 
      swap 1+ swap ( increment slot number for next iteration ) 
    then 
  over 0< until 
  unlock-hashtable drop 
; 

: strings string-report ; 

 0x00000010 constant wt-dequeued 
 0x00000020 constant wt-notified 
 0x00000040 constant wt-interrupted 
 0x00000080 constant wt-killed 
         52 constant thread-death 

object subclass w-thread 
  cell: funtab 
  cell: label 
  cell: flags 
  cell: top-frame 
  cell: id 
  w-string ref: name-w-string 
  cell: state 
  cell: messages 
  cell: group 
  cell: Thread-instance 
  cell: is-daemon 
  cell: bottom-frame 
  cell: jpriority 
  cell: kthread 
  cell: kstack 
  cell: ksize 
  cell: kpriority 
  cell: waiting-on 
  cell: waiting-with 
  cell: status 
  : show ( w-thread-instance w-thread-class -- w-thread-instance w-thread-class ) 
    over show-thread type cr 
  ; 
  : notify ( w-thread-instance w-thread-class -- ) 
    drop wt-notified wakeup-thread 
  ; 
  : interrupt ( w-thread-instance w-thread-class -- ) 
    drop wt-interrupted wakeup-thread 
  ; 
  : kill ( w-thread-instance w-thread-class -- ) 
    2dup --> status thread-death swap ! 
    drop wt-killed wakeup-thread 
  ; 
  : help ( w-thread-inst w-thread-class -- ) 
    ." Methods of w-thread: " cr 
    ."   --> interrupt cr " cr 
    ."     Interrupt the thread " cr 
    ."   --> show " cr 
    ."     Show all information about the thread " cr 
  ; 
end-class 

: find-thread 
  s" hashtable:threads" find-hashtable ( hashtable-addr 0|1 )
  2dup thread-hashtable-found ! thread-hashtable ! 
  0= abort" Sorry, thread information is not available at this time." 
  dup lock-hashtable 
  0 0 rot ( thread-id 0 0 thread-hashtable ) 
  begin   ( thread-id old-w-thread-addr slot-num thread-hashtable ) 
    iterate-hashtable over 0< abort" No thread found with this id." 
    ( thread-id old-w-thread-addr slot-num thread-hashtable ) 
    2dup slot-of-hashtable 
    ( thread-id old-w-thread-addr slot-num thread-hashtable kthread-addr new-w-thread-addr ) 
    >r drop rot drop r> rot 1+ rot 
    ( thread-id w-thread-addr slot-num+1 thread-hashtable ) 
    2 pick postpone w-thread drop --> id @ 
    4 pick =   ( thread-id w-thread-addr slot-num+1 thread-hashtable bool ) 
  until 
  ( thread-id w-thread-addr slot-num+1 thread-hashtable ) 
  unlock-hashtable drop 
  ( thread-id w-thread-addr ) 
  swap drop ( w-thread-addr ) 
  postpone w-thread drop 
; 

: thread ( "name" -- inst class ) 
  bl word count evaluate find-thread 
; 

: set-trigger-level ( i "name" -- ) 
  bl word count dup 1 = if drop 0 then 
  (set-trigger-level) 
; 

: hrule ( -- ) 
 ." ==============================================================" 
 ." ==============================================================" cr 
; 

: watchdog ( -- ) 
  hrule 
  ." Watchdog report after " current-timer-ticks . ."  ticks" cr 
  groups 
  threads 
  hrule 
; 

.( finished loading Wonka extensions ) 13 emit cr 

 quit 

