/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: Init.c,v 1.5 2002/03/08 14:50:00 gray Exp $
*/

#include <string.h>

#include "clazz.h"
#include "core-classes.h"
#include "heap.h"
#include "loading.h"
#include "checks.h"
#include "ts-mem.h"
#include "oswald.h"
#include "strings.h"
#include "threads.h"
#include "jni.h"

extern Wonka_InitArgs *system_vm_args;

w_instance Init_getCmdLineProperties(JNIEnv *env, w_instance this) {
  w_thread    thread = JNIEnv2w_thread(env);
  w_int       i;
  w_instance  Array = NULL;
  w_instance  String;
  w_string    string;
  w_int       length;

  for(length=0; length < 20; length++) {
    if(system_vm_args->properties[length] == NULL) break;
  }

  if(length > 0) {
  
    Array = allocArrayInstance(thread, clazzArrayOf_String, 1, &length);

    if (Array) {
      for (i = 0; i < length; i++) {
        String = allocInstance(thread, clazzString);
        if(String) {
          string = cstring2String(thread, system_vm_args->properties[i], strlen(system_vm_args->properties[i]));
          attachString(String, string);
        } else {
          String = nullInstance;
        }
        setArrayReferenceField(Array, String, i);
      }
    }
  }
  
  return Array;

}



