/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: NativeProcess.c,v 1.1 2002/02/01 17:27:29 dumon Exp $
*/

#include "core-classes.h"
#include "wonka.h"
#include "exec.h"

w_void NativeProcess_destroy(JNIEnv *env, w_instance thisInstance) {
  host_destroy((w_int)thisInstance[F_NativeProcess_process_id]);
  // printf(" = DESTROY =\n");
}

w_int NativeProcess_waitFor(JNIEnv *env, w_instance thisInstance) {
  // printf(" = WAIT =\n");
  return host_wait((w_int)thisInstance[F_NativeProcess_process_id]);
}

w_int ProcessInputStream_read(JNIEnv *env, w_instance thisInstance) {
  w_int result = host_read((w_int)thisInstance[F_ProcessInputStream_fd]);
  // printf(" = READ = %d, %c\n", result, result);
  return result;
}

w_void ProcessInputStream_close(JNIEnv *env, w_instance thisInstance) {
  // printf(" = CLOSE =\n");
  host_close((w_int)thisInstance[F_ProcessInputStream_fd]);
}

w_void ProcessOutputStream_write(JNIEnv *env, w_instance thisInstance, w_sbyte byte) {
  // printf(" = WRITE =\n");
  host_write((w_int)thisInstance[F_ProcessOutputStream_fd], (w_int)byte);
}

w_void ProcessOutputStream_close(JNIEnv *env, w_instance thisInstance) {
  // printf(" = CLOSE =\n");
  host_close((w_int)thisInstance[F_ProcessOutputStream_fd]);
}

