/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/* DO NOT EDIT THIS FILE - it is machine generated */
#include <jni.h>
#include <vfs.h>
#include <vfs_fcntl.h>

/* Header for class File */

#ifndef _Included_File
#define _Included_File
#ifdef __cplusplus
extern "C" {
#endif
/* Inaccessible static: separatorChar */
/* Inaccessible static: pathSeparatorChar */
/*
 * Class:     File
 * Method:    exists
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_File_exists
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  struct vfs_STAT statbuf;
  jboolean        result = JNI_FALSE;
  
  fid = (*env)->GetFieldID(env, thisclazz, "absname", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, thisObj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(vfs_stat((w_ubyte *)pathname, &statbuf) != -1) result = JNI_TRUE;

  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;

}

JNIEXPORT jstring JNICALL Java_File_get_CWD
  (JNIEnv *env, jobject thisObj) {
  return (*env)->NewStringUTF(env, current_working_dir);
}

JNIEXPORT jstring JNICALL Java_File_get_root
  (JNIEnv *env, jobject thisObj) {
  return (*env)->NewStringUTF(env, current_root_dir);
}

/*
 * Class:     File
 * Method:    list
 * Signature: ()[Ljava/lang/String;
 */
JNIEXPORT jobjectArray JNICALL Java_File_list
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jclass          clazz;
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  vfs_DIR         *dir;
  vfs_dirent      *dirent;
  jobjectArray    result = NULL;
  int             count = 0;
  jstring         entry;
  
  fid = (*env)->GetFieldID(env, thisclazz, "absname", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, thisObj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);

  dir = vfs_opendir(pathname);
  if(dir != NULL) {

    /* Count the entries */
    while((dirent = vfs_readdir(dir)) != NULL) count++;
    
    /* Substract 2 for . and .. */
    count -= 2;

    if(count < 0) {
      count = 0;
      woempa(9, "!!! %s is a corrupt directory, attempting to read it anyway...\n", pathname);
      woempa(9, "!!! It's recommended do to a fsck -f on this partition as soon as possible to prevent further corruption\n");
    }
    
    /* Create the objectArray */
    clazz = (*env)->FindClass(env, "java/lang/String");
    result = (*env)->NewObjectArray(env, count, clazz, NULL);    

    /* Rewind the directory */
    vfs_rewinddir(dir);
    count = 0;
    
    /* Fill up the objectArray */
    while((dirent = vfs_readdir(dir)) != NULL) {
      if((strcmp(dirent->d_name, ".") != 0) && 
         (strcmp(dirent->d_name, "..") != 0)) {
        
	      entry = (*env)->NewStringUTF(env, dirent->d_name);
        (*env)->SetObjectArrayElement(env, result, count, entry);
        (*env)->DeleteLocalRef(env, entry);
        
        count ++;
      }	
    }
  
    vfs_closedir(dir);
  }
  
  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;

}

/*
 * Class:     File
 * Method:    canRead
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_File_canRead
  (JNIEnv *env, jobject thisObj) {
  
  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  struct vfs_STAT statbuf;
  jboolean        result = JNI_FALSE;
  
  fid = (*env)->GetFieldID(env, thisclazz, "absname", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, thisObj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(vfs_stat((w_ubyte *)pathname, &statbuf) != -1) {
    if(((statbuf.st_mode & VFS_S_IRWXU) & VFS_S_IRUSR) == VFS_S_IRUSR) result = JNI_TRUE;
  }

  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;

}

/*
 * Class:     File
 * Method:    canWrite
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_File_canWrite
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  struct vfs_STAT statbuf;
  jboolean        result = JNI_FALSE;
  
  fid = (*env)->GetFieldID(env, thisclazz, "absname", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, thisObj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(vfs_stat((w_ubyte *)pathname, &statbuf) != -1) {
    if(((statbuf.st_mode & VFS_S_IRWXU) & VFS_S_IWUSR) == VFS_S_IWUSR) result = JNI_TRUE;
  }
  
  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;

}

/*
 * Class:     File
 * Method:    isFile
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_File_isFile
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  struct vfs_STAT statbuf;
  jboolean        result = JNI_FALSE;
  
  fid = (*env)->GetFieldID(env, thisclazz, "absname", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, thisObj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(vfs_stat((w_ubyte *)pathname, &statbuf) != -1) {
    if(VFS_S_ISREG(statbuf.st_mode)) result = JNI_TRUE;
  }
  
  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;

}

/*
 * Class:     File
 * Method:    isDirectory
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_File_isDirectory
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  struct vfs_STAT statbuf;
  jboolean        result = JNI_FALSE;
  
  fid = (*env)->GetFieldID(env, thisclazz, "absname", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, thisObj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(vfs_stat((w_ubyte *)pathname, &statbuf) != -1) {
    if(VFS_S_ISDIR(statbuf.st_mode)) result = JNI_TRUE;
  }
  
  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;

}

/*
 * Class:     File
 * Method:    lastModified
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_File_lastModified
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  struct vfs_STAT statbuf;
  jlong           result = 0;
  
  fid = (*env)->GetFieldID(env, thisclazz, "absname", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, thisObj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(vfs_stat((w_ubyte *)pathname, &statbuf) != -1) {
    result = 1;
  }
  
  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;
  
}

/*
 * Class:     File
 * Method:    length
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_File_length
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  struct vfs_STAT statbuf;
  jlong           result = 0;
  
  fid = (*env)->GetFieldID(env, thisclazz, "absname", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, thisObj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(vfs_stat((w_ubyte *)pathname, &statbuf) != -1) {
    result = statbuf.st_size;
  }
  
  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;
}

/*
 * Class:     File
 * Method:    mkdir
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_File_mkdir
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  jboolean        result = JNI_FALSE;
  
  fid = (*env)->GetFieldID(env, thisclazz, "absname", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, thisObj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if((int)vfs_mkdir((w_ubyte *)pathname, VFS_S_IRWXU | VFS_S_IRWXG | VFS_S_IRWXO) != -1) result = JNI_TRUE;

  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;
	  
}

/*
 * Class:     File
 * Method:    renameTo
 * Signature: (Ljava/io/File;)Z
 */
JNIEXPORT jboolean JNICALL Java_File_rename
  (JNIEnv *env, jobject thisObj, jstring file1, jstring file2) {
    
  jboolean        isCopy1;
  jboolean        isCopy2;
  const char      *pathname1;
  const char      *pathname2;
  jboolean        result = JNI_FALSE;
  
  pathname1 = (*env)->GetStringUTFChars(env, file1, &isCopy1);	  
  pathname2 = (*env)->GetStringUTFChars(env, file2, &isCopy2);	  

  if(vfs_rename(pathname1, pathname2) == 0) result = JNI_TRUE; 

  if(isCopy1 == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, file1, pathname1);
  if(isCopy2 == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, file2, pathname2);

  return result;
  return JNI_FALSE;
}

/*
 * Class:     File
 * Method:    delete
 * Signature: ()Z
 */
JNIEXPORT jboolean JNICALL Java_File_delete
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  struct vfs_STAT statbuf;
  jboolean        result = JNI_FALSE;
  
  fid = (*env)->GetFieldID(env, thisclazz, "absname", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, thisObj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(vfs_stat((w_ubyte *)pathname, &statbuf) != -1) {
    if(VFS_S_ISDIR(statbuf.st_mode)) {
      if(vfs_rmdir(pathname) == 0) result = JNI_TRUE;
      woempa(9, "%s is a directory, result = %d\n", pathname, result);
    } else {
      if(vfs_unlink(pathname) == 0) result = JNI_TRUE;
      woempa(9, "%s is a file, result = %d\n", pathname, result);
    }
  }
  
  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;

}

#ifdef __cplusplus
}
#endif
#endif
