/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/* DO NOT EDIT THIS FILE - it is machine generated */
#include <jni.h>
#include <vfs.h>
#include <vfs_fcntl.h>
/* Header for class FileInputStream */

#ifndef _Included_FileInputStream
#define _Included_FileInputStream
#ifdef __cplusplus
extern "C" {
#endif
#undef FileInputStream_SKIP_BUFFER_SIZE
#define FileInputStream_SKIP_BUFFER_SIZE 2048L
/* Inaccessible static: skipBuffer */
/*
 * Class:     FileInputStream
 * Method:    createFromString
 * Signature: (Ljava/lang/String;)V
 */

JNIEXPORT jint JNICALL Java_FileInputStream_createFromString
  (JNIEnv *env, jobject thisObj, jstring path) {

  const char  *pathname;
  jboolean    isCopy;
  vfs_FILE    *file;
  jclass      clazz;
  jmethodID   mid;
  jobject     obj;
  jfieldID    fid;
  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);

  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  
  
  file = vfs_fopen(pathname, "r");

  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  if(file == NULL) {
    
    return 1;

  } else {
    clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    obj = (*env)->NewObject(env, clazz, mid);

    fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
    (*env)->SetObjectField(env, thisObj, fid, obj);
    
    fid = (*env)->GetFieldID(env, clazz, "validFD", "Z");
    (*env)->SetIntField(env, obj, fid, 1);
    
    fid = (*env)->GetFieldID(env, clazz, "fd", "I");
    (*env)->SetIntField(env, obj, fid, (jint)file);

    fid = (*env)->GetFieldID(env, clazz, "fileName", "Ljava/lang/String;");
    (*env)->SetObjectField(env, obj, fid, path);
  }

  return 0;

}

/*
 * Class:     FileInputStream
 * Method:    createFromFileDescriptor
 * Signature: (Ljava/io/FileDescriptor;)V
 */
JNIEXPORT void JNICALL Java_FileInputStream_createFromFileDescriptor
  (JNIEnv *env, jobject thisObj, jobject fd) {

  jclass   thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID fid;
  
  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  (*env)->SetObjectField(env, thisObj, fid, fd);
	  
}

/*
 * Class:     FileInputStream
 * Method:    read
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_FileInputStream_read
  (JNIEnv *env, jobject thisObj) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;
  jint        result = -1;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
    result = 0;
  } else {
    if(!vfs_feof(file)) result = vfs_fgetc(file);
  }

  return result;
}

/*
 * Class:     FileInputStream
 * Method:    readIntoBuffer
 * Signature: ([BII)I
 */
JNIEXPORT jint JNICALL Java_FileInputStream_readIntoBuffer
  (JNIEnv *env, jobject thisObj, jbyteArray buffer, jint offset, jint length) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;
  jint        result;
  jboolean    isCopy;
  jbyte       *bytes = (*env)->GetByteArrayElements(env, buffer, &isCopy);
  jbyte       *data;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
    result = 0;
  } else {
    data = bytes + offset;
    result = vfs_fread(data, 1, (w_word)length, file);
    if(result == 0) result = -1;
  }

  if(isCopy == JNI_TRUE) (*env)->ReleaseByteArrayElements(env, buffer, bytes, 0);

  return result;
}

/*
 * Class:     FileInputStream
 * Method:    skip
 * Signature: (J)J
 */
JNIEXPORT jlong JNICALL Java_FileInputStream_skip
  (JNIEnv *env, jobject thisObj, jlong n) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;
  jlong       result = n;
  jlong       prev_pos;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
    result = 0;
  } else {
    prev_pos = vfs_ftell(file);
    result = vfs_fseek(file, (long)n, SEEK_SET);

    if(result == 0) {
      result = vfs_ftell(file) - prev_pos;
    } else {
      clazz = (*env)->FindClass(env, "java/io/IOException");
      mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
      throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
      (*env)->Throw(env, throwObj);
      result = 0; 
    }
  }

  return result;
}

/*
 * Class:     FileInputStream
 * Method:    available
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_FileInputStream_available
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject         obj;
  jthrowable      throwObj;
  jclass          clazz;
  jfieldID        fid;
  jmethodID       mid;
  vfs_FILE        *file;
  jint            result;
  jboolean        isCopy;
  jstring         path;
  const char      *filename;
  struct vfs_STAT statbuf;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));

  fid = (*env)->GetFieldID(env, clazz, "fileName", "Ljava/lang/String;");
  path = (jstring)((*env)->GetObjectField(env, obj, fid));
  filename = (*env)->GetStringUTFChars(env, path, &isCopy);	 
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
    result = 0;
  } else {
    if(vfs_stat((w_ubyte *)filename, &statbuf) != -1) {
      result = (statbuf.st_size - vfs_ftell(file));
    } else {
      clazz = (*env)->FindClass(env, "java/io/IOException");
      mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
      throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
      (*env)->Throw(env, throwObj);
      result = 0;
    }
  }

  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, filename);

  return result;  
}

/*
 * Class:     FileInputStream
 * Method:    close
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_FileInputStream_close
  (JNIEnv *env, jobject thisObj) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jclass      clazz;
  jfieldID    fid;
  vfs_FILE    *file;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  if (obj) {
    clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
    fid = (*env)->GetFieldID(env, clazz, "fd", "I");
    file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
    if(file) {
      vfs_fclose(file);
      (*env)->SetIntField(env, obj, fid, (jint)NULL);
    }
  }
}

#ifdef __cplusplus
}
#endif
#endif
