/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/* DO NOT EDIT THIS FILE - it is machine generated */
#include <jni.h>
#include <vfs.h>
/* Header for class FileOutputStream */

#ifndef _Included_FileOutputStream
#define _Included_FileOutputStream
#ifdef __cplusplus
extern "C" {
#endif
/*
 * Class:     FileOutputStream
 * Method:    createFromString
 * Signature: (Ljava/lang/String;)V
 */
JNIEXPORT jint JNICALL Java_FileOutputStream_createFromString
  (JNIEnv *env, jobject thisObj, jstring path, jboolean append){

  const char  *pathname;
  jboolean    isCopy;
  vfs_FILE    *file;
  jclass      clazz;
  jmethodID   mid;
  jobject     obj;
  jfieldID    fid;
  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);

  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(append == JNI_FALSE) {
    file = vfs_fopen(pathname, "w+");
  } else {
    file = vfs_fopen(pathname, "a+");
  }

  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);
 
  if(file == NULL) {

    return 1;
    
  } else {
    clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    obj = (*env)->NewObject(env, clazz, mid);

    fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
    (*env)->SetObjectField(env, thisObj, fid, obj);
    
    fid = (*env)->GetFieldID(env, clazz, "validFD", "Z");
    (*env)->SetIntField(env, obj, fid, 1);
    
    fid = (*env)->GetFieldID(env, clazz, "fd", "I");
    (*env)->SetIntField(env, obj, fid, (jint)file);

    fid = (*env)->GetFieldID(env, clazz, "fileName", "Ljava/lang/String;");
    (*env)->SetObjectField(env, obj, fid, path);
  }

  return 0;

}

/*
 * Class:     FileOutputStream
 * Method:    createFromFileDescriptor
 * Signature: (Ljava/io/FileDescriptor;)V
 */
JNIEXPORT void JNICALL Java_FileOutputStream_createFromFileDescriptor
  (JNIEnv *env, jobject thisObj, jobject fd) {

  jclass   thisclazz = (*env)->GetObjectClass(env, thisObj);
  jfieldID fid;
  
  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  (*env)->SetObjectField(env, thisObj, fid, fd);
	  
}

/*
 * Class:     FileOutputStream
 * Method:    write
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_FileOutputStream_write
  (JNIEnv *env, jobject thisObj, jint oneByte) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
  } else {
    vfs_fputc(oneByte, file);
  }
}

/*
 * Class:     FileOutputStream
 * Method:    writeFromBuffer
 * Signature: ([BII)V
 */
JNIEXPORT void JNICALL Java_FileOutputStream_writeFromBuffer
  (JNIEnv *env, jobject thisObj, jbyteArray buffer, jint offset, jint length) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;
  jboolean    isCopy;
  jbyte       *bytes = (*env)->GetByteArrayElements(env, buffer, &isCopy);
  jbyte       *data;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
  } else {
    data = bytes + offset;
    vfs_fwrite(data, 1, (w_word)length, file);
  }

  if(isCopy == JNI_TRUE) (*env)->ReleaseByteArrayElements(env, buffer, bytes, 0);

}

/*
 * Class:     FileOutputStream
 * Method:    close
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_FileOutputStream_close
  (JNIEnv *env, jobject thisObj) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jclass      clazz;
  jfieldID    fid;
  vfs_FILE    *file;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  woempa(9, "Closing file\n");

  if(obj != NULL) {

    woempa(9, "Still have a filedescriptor\n");
    
    clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
    fid = (*env)->GetFieldID(env, clazz, "fd", "I");
    file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid)); 

    if(file == NULL) {
      woempa(9, "Filedescriptor is empty\n");
      /*
      clazz = (*env)->FindClass(env, "java/io/IOException");
      mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
      throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
      (*env)->Throw(env, throwObj);
      */
    } else {
      woempa(9, "Calling vfs_fclose\n");
      vfs_fclose(file);
      fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
      (*env)->SetObjectField(env, thisObj, fid, (jobject)NULL);
    }
  }
}

/*
 * Class:     FileOutputStream
 * Method:    flush
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_FileOutputStream_flush
  (JNIEnv *env, jobject thisObj) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jclass      clazz;
  jfieldID    fid;
  vfs_FILE    *file;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  if (obj) {
    clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
    fid = (*env)->GetFieldID(env, clazz, "fd", "I");
    file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
    if(file) {
      vfs_fflush(file);
    }
  } 
}

#ifdef __cplusplus
}
#endif
#endif
