/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: ObjectInputStream.c,v 1.5 2002/03/20 13:04:20 gray Exp $
*/

#include <string.h>

#include "core-classes.h"
#include "clazz.h"
#include "fields.h"
#include "heap.h"
#include "loading.h"
#include "strings.h"
#include "stack.h"
#include "threads.h"
#include "ts-mem.h"     

w_instance ObjectInputStream_allocNewInstance(JNIEnv *env, w_instance this, w_instance Clazz) {
  w_thread thread = JNIEnv2w_thread(env);
  w_clazz clazz = Class2clazz(Clazz);
  w_instance newInstance;

  if (clazz==NULL) {
    woempa(1, "%k is a primitive class, returning null\n", clazz);
    return NULL;
  }

  classMustBeInitialized(clazz,thread);
  newInstance = allocInstance(JNIEnv2w_thread(env), clazz);

  return newInstance;
}

w_instance ObjectInputStream_getCallingClass(JNIEnv *env, w_instance this) {
  w_thread thread = JNIEnv2w_thread(env);

  return getCallingClazz(thread)->Class;
}

