/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/* DO NOT EDIT THIS FILE - it is machine generated */
#include <jni.h>
#include <vfs.h>
/* Header for class RandomAccessFile */

#ifndef _Included_RandomAccessFile
#define _Included_RandomAccessFile
#ifdef __cplusplus
extern "C" {
#endif
/*
 * Class:     RandomAccessFile
 * Method:    createFromString
 * Signature: (Ljava/lang/String;Ljava/lang/String;)V
 */
JNIEXPORT int JNICALL Java_RandomAccessFile_createFromString
  (JNIEnv *env, jobject thisObj, jstring path, jstring mode) {

  const char  *pathname;
  const char  *openmode;
  jboolean    isCopy1;
  jboolean    isCopy2;
  vfs_FILE    *file;
  jclass      clazz;
  jmethodID   mid;
  jobject     obj;
  jfieldID    fid;
  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);

  pathname = (*env)->GetStringUTFChars(env, path, &isCopy1);	  
  openmode = (*env)->GetStringUTFChars(env, mode, &isCopy2);	  
  
  file = vfs_fopen(pathname, openmode);

  if(isCopy1 == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);
  if(isCopy2 == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, mode, openmode);
 
  if(file == NULL) {

    return 1;
    
  } else {
    clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    obj = (*env)->NewObject(env, clazz, mid);

    fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
    (*env)->SetObjectField(env, thisObj, fid, obj);
    
    fid = (*env)->GetFieldID(env, clazz, "validFD", "Z");
    (*env)->SetIntField(env, obj, fid, 1);
    
    fid = (*env)->GetFieldID(env, clazz, "fd", "I");
    (*env)->SetIntField(env, obj, fid, (jint)file);

    fid = (*env)->GetFieldID(env, clazz, "fileName", "Ljava/lang/String;");
    (*env)->SetObjectField(env, obj, fid, path);
  }

  return 0;

}

/*
 * Class:     RandomAccessFile
 * Method:    read
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_RandomAccessFile_read
  (JNIEnv *env, jobject thisObj) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;
  jint        result = -1;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
    result = 0;
  } else {
    result = vfs_fgetc(file);
    //if(!vfs_feof(file)) result = vfs_fgetc(file);
  }

  return result;
}

/*
 * Class:     RandomAccessFile
 * Method:    readIntoBuffer
 * Signature: ([BII)I
 */
JNIEXPORT jint JNICALL Java_RandomAccessFile_readIntoBuffer
  (JNIEnv *env, jobject thisObj, jbyteArray buffer, jint offset, jint length) {
  
  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;
  jint        result;
  jboolean    isCopy;
  jbyte       *bytes = (*env)->GetByteArrayElements(env, buffer, &isCopy);
  jbyte       *data;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
    result = 0;
  } else {
    data = bytes + offset;
    result = vfs_fread(data, 1, (w_word)length, file);
    if(result == 0) result = -1;
  }

  if(isCopy == JNI_TRUE) (*env)->ReleaseByteArrayElements(env, buffer, bytes, 0);

  return result;
}

/*
 * Class:     RandomAccessFile
 * Method:    skipBytes
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_RandomAccessFile_skipBytes
  (JNIEnv *env, jobject thisObj, jint n) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;
  jlong       result = n;
  jlong       prev_pos;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
    result = 0;
  } else {
    prev_pos = vfs_ftell(file);
    result = vfs_fseek(file, (long)n, SEEK_SET);

    if(result == 0) {
      result = vfs_ftell(file) - prev_pos;
    } else {
      clazz = (*env)->FindClass(env, "java/io/IOException");
      mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
      throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
      (*env)->Throw(env, throwObj);
      result = 0; 
    }
  }

  return result;
}

/*
 * Class:     RandomAccessFile
 * Method:    write
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_RandomAccessFile_write
  (JNIEnv *env, jobject thisObj, jint oneByte) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
  } else {
    vfs_fputc(oneByte, file);
  }
}

/*
 * Class:     RandomAccessFile
 * Method:    writeFromBuffer
 * Signature: ([BII)V
 */
JNIEXPORT void JNICALL Java_RandomAccessFile_writeFromBuffer
  (JNIEnv *env, jobject thisObj, jbyteArray buffer, jint offset, jint length) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;
  jboolean    isCopy;
  jbyte       *bytes = (*env)->GetByteArrayElements(env, buffer, &isCopy);
  jbyte       *data;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
  } else {
    data = bytes + offset;
    vfs_fwrite(data, 1, (w_word)length, file);
  }

  if(isCopy == JNI_TRUE) (*env)->ReleaseByteArrayElements(env, buffer, bytes, 0);

}

/*
 * Class:     RandomAccessFile
 * Method:    getFilePointer
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_RandomAccessFile_getFilePointer
  (JNIEnv *env, jobject thisObj) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;
  jlong       result = -1;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
    result = 0;
  } else {
    result = vfs_ftell(file);
  }

  return result;
}

/*
 * Class:     RandomAccessFile
 * Method:    seek
 * Signature: (J)V
 */
JNIEXPORT void JNICALL Java_RandomAccessFile_seek
  (JNIEnv *env, jobject thisObj, jlong pos) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fd", "I");
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
  if(file == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
  } else {
    if(vfs_fseek(file, (long)pos, SEEK_SET) == -1) {
      clazz = (*env)->FindClass(env, "java/io/IOException");
      mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
      throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
      (*env)->Throw(env, throwObj);
    }
  }
}

/*
 * Class:     RandomAccessFile
 * Method:    length
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_RandomAccessFile_length
  (JNIEnv *env, jobject thisObj) {

  jclass          thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject         obj;
  jclass          clazz;
  jfieldID        fid;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  struct vfs_STAT statbuf;
  jlong           result = 0;
  
  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  fid = (*env)->GetFieldID(env, clazz, "fileName", "Ljava/lang/String;");
  path = (jstring)(*env)->GetObjectField(env, obj, fid);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(vfs_stat((w_ubyte *)pathname, &statbuf) != -1) {
    result = statbuf.st_size;
  }
  
  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;
}

/*
 * Class:     RandomAccessFile
 * Method:    setLength
 * Signature: (J)V
 */
JNIEXPORT void JNICALL Java_RandomAccessFile_setLength
  (JNIEnv *env, jobject thisObj, jlong len) {

}

/*
 * Class:     RandomAccessFile
 * Method:    close
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_RandomAccessFile_close
  (JNIEnv *env, jobject thisObj) {

  jclass      thisclazz = (*env)->GetObjectClass(env, thisObj);
  jobject     obj;
  jthrowable  throwObj;
  jclass      clazz;
  jfieldID    fid;
  jmethodID   mid;
  vfs_FILE    *file;

  fid = (*env)->GetFieldID(env, thisclazz, "fd", "Ljava/io/FileDescriptor;");
  obj = (*env)->GetObjectField(env, thisObj, fid);

  if(obj == NULL) {
    clazz = (*env)->FindClass(env, "java/io/IOException");
    mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
    throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
    (*env)->Throw(env, throwObj);
  } else {
    
    clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
    fid = (*env)->GetFieldID(env, clazz, "fd", "I");
    file = (vfs_FILE *)((*env)->GetIntField(env, obj, fid));
  
    if(file == NULL) {  
      clazz = (*env)->FindClass(env, "java/io/IOException");
      mid = (*env)->GetMethodID(env, clazz, "<init>", "()V");
      throwObj = (jthrowable)(*env)->NewObject(env, clazz, mid);
      (*env)->Throw(env, throwObj);
    } else {
      vfs_fclose(file);
      (*env)->SetIntField(env, obj, fid, (jint)NULL);
    }
    
  }
  
}

#ifdef __cplusplus
}
#endif
#endif
