/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: Reference.c,v 1.4 2002/03/20 13:04:20 gray Exp $
*/

#include "clazz.h"
#include "core-classes.h"
#include "heap.h"

void Reference_set(JNIEnv *env, w_instance this, w_instance referent) {
  woempa(7, "Setting reference from %k at %p to %k at %p\n", instance2clazz(this), this, instance2clazz(referent), (w_instance)referent);
  this[F_Reference_referent] = (w_word)referent;
}

w_instance Reference_get(JNIEnv *env, w_instance this) {
  w_instance referent = (w_instance)this[F_Reference_referent];
  woempa(7, "Getting reference from %k at %p to %k at %p\n", instance2clazz(this), this, instance2clazz(referent), (w_instance)referent);
  if (referent && isSet(instance2object(referent)->flags, O_CONDEMNED)) {

    return NULL;

  }

  return referent;
}

void Reference_clear(JNIEnv *env, w_instance this) {
  woempa(7, "User cleared reference from %k at %p to %k at %p\n", instance2clazz(this), this, instance2clazz((w_instance)this[F_Reference_referent]), (w_instance)this[F_Reference_referent]);
  this[F_Reference_referent] = 0;
}

