/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: Date.c,v 1.4 2002/02/20 08:59:55 dfrederickx Exp $
*/

#include <string.h>

#include "core-classes.h"
#include "clazz.h"
#include "dates.h"
#include "heap.h"
#include "ts-mem.h"
#include "realms.h"
#include "threads.h"
#include "strings.h"

#define isLeapYear(y) (!((y)%4)&&(((y)<1582)((y)%100)||!((y)%400)))

void Date_create_ymdhms(JNIEnv *env, w_instance thisDate, w_int year, w_int month, w_int date, w_int hours, w_int minutes, w_int seconds){
  w_date wonkadate;
  w_long ttime;

  wonkadate = allocMem(JNIEnv2w_thread(env), sizeof(w_Date));
  wonkadate->msec = 0;
  wonkadate->second = seconds;
  wonkadate->minute = minutes;
  wonkadate->hour = hours;
  wonkadate->day = date;
  wonkadate->month = month;
  wonkadate->year = year+1900;
  ttime = date2millis(wonkadate);
  releaseMem(wonkadate);

  thisDate[F_Date_millisSince1jan1970] = (w_word)LSW_PART(ttime);
  thisDate[F_Date_millisSince1jan1970+1] = (w_word)MSW_PART(ttime);

}

