/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: SimpleTimeZone.c,v 1.3 2002/02/20 08:59:55 dfrederickx Exp $
*/

#include <string.h>

#include "core-classes.h"
#include "clazz.h"
#include "dates.h"
#include "heap.h"
#include "realms.h"
#include "ts-mem.h"
#include "threads.h"
#include "strings.h"
#include "arrays.h"

#define MSEC1970         (0x000038831c799000LL)             /* nr of milliseconds in 1970          */

/**
* Class:     java_util_SimpleTimeZone
* Method:    setfields
* Signature: ([IJ)V
*/
void SimpleTimeZone_getfields (JNIEnv * env, w_instance this, w_instance Array, w_long ttime){
      	
 	w_date wdate;
        w_int * ip =  instance2Array_int(Array);

        wdate = allocMem(JNIEnv2w_thread(env), sizeof(w_Date));

 	ttime += MSEC1970;  	
 	
 	millis2date(ttime, wdate);
        ip[0] = wdate->year;
        ip[1] = wdate->month-1;
        ip[2] = wdate->day;
        ip[3] = wdate->msec%1000;
        ip[4] = dayOfWeek(wdate);

}
//typedef struct w_Date *                  w_date;

//typedef struct w_Date {
//  w_int msec;             /* milliseconds passed since midnight                     */
//  w_int second;           /* seconds passed since midnight                          */
//  w_int minute;           /* minutes passed since midnight                          */
//  w_int hour;             /* 24 hour clock, hour 0 is 00.00 AM                      */
//  w_int day;              /* the day as in dd/mm/yyyy                               */
//  w_int month;           /* the month as in dd/mm/yyyy                             */
//  w_int year;             /* the year as in dd/mm/yyyy. Note that it starts at 0001 */
//} w_Date;
