/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/



package java.awt;

public class CheckboxGroup implements java.io.Serializable {

  Checkbox selectedCheckbox = null;

  public CheckboxGroup() {
  }
    
  public synchronized void setSelectedCheckbox(Checkbox checkbox) {

    boolean success = true;

    if (selectedCheckbox != null) {
      if (selectedCheckbox.group == this) {
        selectedCheckbox.state = false;
      }
      else {
        success = false;
      }
    }

    if (success == true) {
      checkbox.state = true;
      selectedCheckbox = checkbox;
    }

  }

  public Checkbox getSelectedCheckbox() {
    return selectedCheckbox;
  }

  public synchronized void setCurrent(Checkbox checkbox) {
    setSelectedCheckbox(checkbox);
  }

  public Checkbox getCurrent() {
    return selectedCheckbox;
  }

  /**
   * Diagnostics
   */
  public String toString() {
    return getClass().getName();
  }
  public String paramString() {
    return getClass().getName() + "selected box:" + selectedCheckbox;
  }
}
