/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package java.awt;

public class Frame extends Window implements MenuContainer {
  
  String title;
  boolean resizable;

  public Frame() {
    super();

    this.title = "";
  }
  
  public Frame(String title) {
    super();

    this.title = title;
  }
  
  public Frame(Frame owner, String title) {
    super(owner);

    this.title = title;
  }
  
  /**
   * @status  not implemented
   * @remark  not implemented
   */ 
  native public Image getIconImage();
  
  /**
   * @status  not implemented
   * @remark  not implemented
   */ 
  native public MenuBar getMenuBar();
  
  public String getTitle() {
    return title;
  }
  
  /**
   * @remark  resizable frames are not supported yet
   */ 
  public boolean isResizable() {
    return false;
  }
  
  /**
   * @status  not implemented
   * @remark  not implemented
   */ 
  native protected String paramString();
  
  /**
   * @status  not implemented
   * @remark  not implemented
   */ 
  native public synchronized void removeComponent(MenuComponent component);
  
  /**
   * @status  not implemented
   * @remark  not implemented
   */ 
  native public synchronized void setIconImage(Image image);
  
  /**
   * @status  not implemented
   * @remark  not implemented
   */ 
  native public synchronized void setMenuBar(MenuBar menubar);

  /**
   * @status  not implemented
   * @remark  not implemented
   */ 
  public synchronized void setResizable(boolean resizable) {
    this.resizable = resizable;
  }
  
  public synchronized void setTitle(String title) {
    this.title = title;
  }
  
}
