/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


// Author: J. Vandeneede
// Created: 2001/05/18

package com.acunia.wonka.test.awt.Graphics;

import java.awt.*;
import com.acunia.wonka.test.awt.*;

public class DriveCar extends VisualTestImpl {

  public static final byte[] DATA = {
 -119,  80,  78,  71,  13,  10,  26,  10,   0,   0,   0,  13,  73,  72,  68,  82,
    0,   0,   0, -28,   0,   0,   0, 114,   8,   2,   0,   0,   0, -52,  10, -22,
 -124,   0,   0,   0,   6,  98,  75,  71,  68,   0, -67,   0, -67,   0, -67, 105,
   66, -43, -88,   0,   0,   0,   9, 112,  72,  89, 115,   0,   0,   0, 100,   0,
    0,   0, 100,   0,  15,-106, -59, -35,   0,   0,  32,   0,  73,  68,  65,  84,
  120, -38, -20, -68, 121, -76, 101,  87, 125, -33,  -7,  -5, -19, -23,-116, 119,
  124, 115, -67,  87,  85, -81,  84,-109,  84,-108,-124, -92,  18,  32, -55,  66,
 -128,   2,   6,  19, -64,  99,-106,-121, -43, -95,-109, -72, 123, 117, 108, -89,
  -37,  73,  55, 118,  59, -67,  58,-119,  99,  59, -50, -22, -58, -58,-114, -19,
  -76,-115,  27, 112,  47, -69,-115,-125,   7,  48,  24, 112,   8,-125,  16,  72,
   72, -94,  40,  52,-108, -92,  82,-107, -86,  84, 115, -43,  27, -18, -69, -17,
   78, 103, -38, -45, -81,  -1,  56, -81, -98,  10, 103, -91,  87, -64,  11,  49,
  -84,  -6,  -2, -15, -42,  61,  -9, -34, 117, -18, 121, 103, 127, -50, 111,  -1,
  -90, -67,-111,-120, -32,-122, 110, -24,  59,  65, -20,  91, 125,   1,  55, 116,
   67,  -1, -75, -70,   1, -21,  13, 125, -57, -24,   6, -84,  55, -12,  29, -93,
   27, -80, -34, -48, 119,-116, 110, -64, 122,  67, -33,  49, -70,   1, -21,  13,
  125, -57, -24,   6, -84,  55, -12,  29,  35, -15, -83, -66,-128, -17,  84,-107,
   64, -96, 117,   8, 114, -21,-104,  12,  40, -90,-111,-108,  87,   0,   0,   8,
 -124, -32,   0,-120,   0,  17,   0,  64, 120,  13,-120,   0,   8, -64,   0,  24,
  120, -88, -65, -26, -66, -42,  92, -48, -42, -37,  47, -67,  96,   4, -24, -81,
  125,  70,  96, -27, -42,  -5,  28,   0, -64,   3, 121, -16,  30,   0,-128,  20,
   16,   1,  16,  32, 121,   0, -30,   8, -56, 104, -21,  84,  68,  68,   2,  25,
    2,  56,  71,  72, -56,  56,  84,   8,  30,-128,  60,  72,   6,  12,-128, -64,
   49, -16,   8,-128, -37,  -1, -47, -73, -97, -16,  70,  81, -32,  27,-108,   5,
  -32,  96,  17,   6, 102,  34, -92,  84, -64,  57,-128, -75,  85, -62,  44,  48,
    6,  32,   0,  24, 120,   6,  30,   1,   5,  32,  84,  12, -96,-122, -49,  17,
   67,  98, -56,   0,  60,  16,   0,  49, -40,  30,   1, -68, -18,  -4,  30,   0,
    1,  16,   8, -64,  50, -80,  72,  30, -64,   3,  40,  64,   2,  64,  15, 108,
   27,  43,   2, 112,  84,  72,-117,-128,  12,-128, -41,  28,  19,   0,   1, 120,
    2, -26,   1,  25,  32,  18,-128,   3, 102,-127,   0, -72,   7,-120, 115,  13,
 -100,   1,  99, -64,   0,  16, -56,  89, -30,  12,  25, -61, 111, -29, -55, -10,
    6, -84, -33, -88,  10,  13, -95, -78,   8,  14,  60,   2,  72, 112, -88,  29,
  -96, -56, -92,   0,   0,  75,  32,-112,   4,  56,  14,   6, -64,  33, 120, 107,
 -101,   0,-128,   8,-116, 111, -99, -64,   1,  89, -81,  37,  18,  67,-122,-128,
   80,-101,  64,  32,   0,  96, -64,  56, -72, -21, 126, -20,  58,-118,  45,   7,
  100,   0, -84,  70, -39,   3,  88,   0,  34,   8, -12,  75, -33, -78,  12,  28,
    7,  98, -32,   1,  98, 111, -82, -99,   3, -21,  95,   5,   4,  96,-116, -80,
   34,  64, -25,  29,   3, -50,-103,   0,  96,  91,-113, -51, -73,  47, -85,  55,
   96,  -3,  70,  85,-128,  19,-124, -52, 122, 110,  45, 112,  14,  18,   9, -63,
 -128,  87, 101,   1,  66,   0,  87,   0, -36, 121,  52,  30,   1,-127, 115, -16,
  -27, 122,  57,-100, -28, -67,  77, -69,  49,-126,  97,-114,  89,-123, -71,   6,
  109,  61, -17,  35,  34,   0,  24,  99,-116,  49,-116, -79,  40,-118, -62,  48,
   44, -44,  34,-105,-126,  37, -95, 106,  36,  97, -89,  25,  78, -75, -80,-111,
 -128,  20, -42, -82,-117,  32,   0,-112,   0, -36,  57, -17,-119,  11,  17,   2,
 -128,   6,   6, -41,  72,  67,   2,  34,  96,   4,  68, -32,-124,  71,   0,  34,
   39,  60, -29,   4, -32, -74,  12, 121,  17, 122,   6,-116,   3, -42, 126,  73,
   -3,  38, -62, -41,  90,  -9, 111,  51, -35,-128, -11,  27,  20,   1,  16,  16,
    3,   4, -16,-107, -73, -60, -48,   1,-106, -96, -89,-100,-121, -63,  96, 120,
   -4, -60,  -6, -79, -81,  14, -97,  60,  62, 126, -26,  68, 118, -10, -68,  25,
  110,  36, 109,   4,  33, 101,  20,  71,-115,  86,-112, -74,  48,   8,  44,  48,
   71, -66,   8,  27,-116,  49,   0,  32,  34, -25,  28,  17,  33,  34,  34,  70,
   88, 120, -21, 124,  81, -39, -68, -44, -93, -52,  76, 114,-101,-105, -50,  88,
   92,  62, -48,-104,-101, -98, -34, 119,  83, -78, 111,  89, -19, -98,-105,  75,
   11, -31,-114,  -7, -80, -45,  84, -77, -69,   0, 106, -17,-109, 112,  11,  57,
    4,   0,  40,  16,-124,   2, -58,  94, -94, -80,  30, -16, -38, -32, -42, -26,
   -7,-102,  35,  77,   8,  -4, -21, -67,  17,  47, -93, 110, -64,  -6,-115, -54,
 -111,  37,  71,-126,  59, 111,  66, -49,  64,   3, -84,-115, -81, 126, -18,-117,
  -43,  -1,  -6,  -9, 115,  93, -27, -34,  65,  28,  36, -77, -45, -23, -12, -76,
  106,  53,-103,  20, -29, 116,-122,-112,  33,  19, -98, 113, -49, -72, 103, -62,
    2, 122,  32, -34,-111,   0, -64,  24,  83,  74,   5,  65,-128,-120,  90, 107,
   99,  76,  60, -69,  27,  56,  99,-116,  17,-128, 118, -74,  50, -70, -88,  74,
  107, -19, -20, -77, -49,  21,  69,  49,  30,-114,  39, -93, -84, -86,  12, 122,
   20,  76,  10,  33,  29,  57,  66,  68, -55,  49,  84, -86,-103,  68, -83,  70,
  -44,  72,  85,  20,-102, -41,  62, -48, -98, -97,-103,  89, -38, -63, -89,  58,
   16,  10,  13, -36,   0,  56,   0,  67,  42,  64, -84, -99, 107, -16, -64,  28,
 -120, 107, -56, 126, -37, -22,   6, -84, -33, -88,   8,  10,  93, -14,  32,  68,
  -89,  63, -13, 103,  31,  -3, -60,  -1, -11,-127, -53,-113,  61,  29,  26,  61,
  -43, -58, 110,  43,-103, 109, -73, -38, -95,-116, -47, -92,  28,  58,  73, -40,
   74, -30,  89, 104,  41,  37,  84,  20,  48,   5, -98,-109, 103,  14,  24,   1,
  -93,  21, -41, 118, -50,  89, 107,   1,   0,  17, 107,  43,  11,   0,-101, -56,
   25,  99,  10,  57, 103,  76,  16,  34,  17, 120,  34, -25, -13,-108,-120,  72,
    0,  74,   4,-123,-100, 121,  34, -29, -68, -75,  16,   9, 112, -34,  27, -21,
   74, 109,-118,  82, -25,-123, -55,  75, 103, -84,  49,  17,   8, -18,  56,  26,
  -63, 121,  35, 110,  47, -52,  77,  45, -52,  37, -83, -90, 122, -13,-111,  86,
  103,   6,  90,  93,  64,   5,  32, -63, 115,  96, -94,  14, -74, -66, 109, 117,
    3, -42, 111,  80,  68, -28,  17, -97, 125,  -2, -71, -33,  -8, -99, -33,  -4,
  -60, -89,  -2,  35,-105,  44, 105,  54,  70, -93, -47, -70, 107,  66,  85,  65,
   85,  66, -87, -63,  89, 105,  44, 104,  13, -34,  18, -72,  24,  96,  74,-120,
   25,   9,  59,   4,  46, -59, -47, -50, 118, 115,  42,-114, 110,  31,  21,-115,
   70, -93, -35, 110,  71,  81,  84,  59, -81,-116,  49,  33,-124,  23,  96, -67,
  -85, -68,  45, -67, -83, -64,  19,  67,  18,  12,  24, -53, -19,  44,  48, -12,
 -100, -68,  64,  39,-120,  56, 120, -55,-128,-125, -78,  41, 112,-122,-100,-127,
  -32, -64,  25,  10,  78,  12,-127,  97,-121,-122, -34, 123,  95,  57, 103, -83,
   32,-114, -42,-105,  69,-111, 101, -39, -62, -38, 104, -32, -20, -88, -47,  76,
  111, 123, -27, -98,  55, -66, -79, 113,  -9, -35, -74, -47,  28,   1, 116, -65,
  -43,  55, -10,  -1,  71,  55,  96, -35,-110, -75,  90,   8, -31,-100, -85, -51,
 -101, 115,-114, 115,  78,  68,-120,  47, 121, 113, -37,  73,  83, -25, -24,  11,
  -97, 127,  -4,-125,  31,  -4, -32, -93,-113,  62,  42,  21,  23,  66,-108, 101,
 -114,-120,  74, -87,-126,  56,   0, 120, -17,-119, -56, 123, -17, -67, 119, -50,
  121, -17,  29, 121, 107, -83, -42, -70,  40,  10, -25,-100,  49,   6, -86,  10,
 -126,   0, -36,   0,-120,  66,  79,-111,-125,  38,  64,  23,  96,  81,  53, -89,
   26, -83,  29,  98, -93,  29,-122,  51,  81, -72,  16,  68,  11,  82,  78, 113,
  -34, -31,  60, 102,  44,-121,  89, -57, 124,   1, 122,   2, -59,-120,-118,-126,
  105,  43,   1,  36, -74, -14,  41,  39,-103,  11,-108,  15,   3,  80,  82,  41,
   37,-124,  98, -64,  53,  64,  26,  68, -87,-108,   1,  57, -59,  64,  41, -31,
 -104, -85, -84,-103,  68,-115, -91, -86,  -7, -20, -23, 103,  -3,  -6,-123, -91,
  -29,  39,  55, -89, -62, -85,  63,  -8, -58, -17,  -7,  -5,  63,   5,-121, -66,
   39,  23, -32,   0, -72,   7, -59,  32, -53, -14,  86,  20,-125,  54,  16,  74,
   34,  50, -58,  72,  41, -21,-121, -22, -27, -41,  13,  88, -73, -27,   1, -96,
  -58, -85, -98,-117, -73,-112, 101,  82, 107, -49,  -7, -42,  -4,-100, -25, -43,
  -57,  63,  -2, -15, -33,  -6, -83, -33, -70, 122, -91, -25, -67,  87,  74,   9,
  -55,-116,  49,  68,  78, 107,  61,  26,-115,  80, 109,  25, -56, -19,  27,  75,
  -75,  24,   2,  64, -93, -47, -88,  31,   3,  41, -27, 104,  52,  98,-116,  37,
   73, -46, -21, 111, -28, -61,  13,   8,  89, -68,  52, -41,-102, 107, 123,  78,
  121,  89,-108,-105,  75, -81,  43,-105,  21,-112, 103, -54, -71,   6, -57, 102,
  -88,-110,  32, 124, -37, 100,  56,  21, -89, -69,  91, -99, -35,  81, 115,  30,
   69, -41,  64, 106,  29, 120, 120, -66,  51,-110,  42, -76,   4, -42, 115,  80,
 -119,  23, -46,  49,  41, -93, 104, -41,  76, -41, 121,-106, 105, 127, -71, -88,
   94, -44, -26,  36, -23,-109,  84, -82,  56, -35,  47, 122,-106,  68,-121,  37,
  -98,-101, -91, 110,  -4,-125,  58, 121,  71, -72, -13, -85,  47,-100,-104, 127,
  -45, -37, -10,  -3, -22, -49, -40,  40,  17,  99,-124,  64, 104,   5,  96,-100,
   98,  92,  59, -83,-108, -38, -66,  89, -11, 127,  71,  68, -37, 126, -53, -53,
  -96,  27, -80, 110, -53,-105, 101,  89,  99,  68,  68, -42,  90,  41, -91,  -9,
  -98, -95, -88, 115,  83, -34, -61,-105, -66, -12, -24,  -5, -34,  -9, -66, -93,
   71,-113,  38,  73, -30,  -3,  86, -66,  41, -53, -58, 121, -98,  19,  -7,  48,
   12, -61,  48, 116,  91, -10, -44,  59, -25, 106, 103, -76, -74, -78,  97,  24,
  106, -83, -85, -86,-118, -94, -56, 123, 111,-116,   9, -61,  48, -53,  50,  51,
 -126, 102, -40,-104,  91, -38,  49, -73, 115, -95, -69,  48,  37, -45,  96,  82,
   22,-125, -15,-128,  99,  90,  85,  85,  85,  85, 101,-107, 103,  89,  86, -27,
   89,  85,  85,  90, -21, -79,  90,   3, -29, -95, -48, -78,  52, -45,  14, -26,
   85, -78,  24,  55, -69, 113, 124, -41, -72,-102,  11,-109,  61,  97,  50, -89,
  100,  59,-111,  65,  83,-107, -95,-101,  80, -43, -89, -59,-121, 123,  23,  63,
  -70, 113, -18,  24,  84, -59, -44, -52,  76, 115, 113, -54, -91,  65,-122, 114,
   26,  39,-111,  88, 102, -35, -85,  69,  -2, 108, -69,  92, 122, -18, -28, -65,
 -111,  83, -33, 127, -17,  43,  63, 115, -22, -12,-128,-119,  31,  -7, -33,  -1,
   55,  56, 114,  71,-119,  92,  58,   1, -50,  83, -56, -22,  82, -89,  -9,  30,
    0, -74,   1, -83, 115,  23,  47, -37,   8, -35,-128, 117,  75, -29, -15, -72,
  -47, 104,   0,-128, -75,  86,   8, -79, 101,  13, -39,  86,  86, -14, -13, -97,
  127,  -8,   3,  31,  -8, -64,  51, -49,  60,  83, -49, -11,-100, -13,  60,  47,
 -108,  82, -61, -31, 112,  52,  26,  46,  44,  44, -36, 122, -21, -83,  75,  59,
  119,   4,  65,  64, -50, -42,  35,-118,-120, -75,  39,-128,-120,-100, -13, 102,
  -77,  -3, -95,  15, 125, -24, -55,  39, -97,   4,   0, -50, 121, -19, 114,  24,
   99,  84, 103, -25,  -2,-101, -10, -20, -35, -67,  44,-128, -58, -67, -51, 124,
   52, 114,  85,  73, -34, 123,  81,  86, -91, 113,  72, -64,-124,  33, -78, -32,
  -83,   7, -21, -99,-128,  22,  32,  90, -12,  37, -23,  92,  23,-103,  45,-116,
  -43,  64,  62,  24,  85,  85,  53,   6, -88,  18,  15, -69,  16, -34,  56,  55,
   -3,  -6,-103, -91,  89,  67, 111, -82,  -6, -51, 102, -77, -45, 106, -91, 105,
   58, -43, -98, -98,-101, -99,  77, -45,  84,  32,  11, -68, 116, 118,  18,  21,
  110, -87, -79,  35, -97, -18,  62, 114,  -2, -53,  43, 127, -12, 123, -17,  89,
  -38, -73, -21, -57, -66, -17, -54, -13,-105,  87,  87, -13, -47, 125,  71, -18,
   -8, -25,  63,  63,  15, 105, -77,-124,  92,  66, -60, -88, -98, 115, 106,  58,
  -21,  39, 112,  -5, -16, -27, -47,  13,  88,  95,-110,  49,-122,-120, -92,-108,
  -75,  89,   5,-128, -78,  44,  55, 122, -93, -33,  -7, -99, -33,  -7, -62,  23,
  -66,  32,-124,  64, -60,  58,  21,-102, 101,  89,  81, -28,-125, -63,  64,   8,
  113, -37, 109, -73, -35, 126, -57, 109,  82, -54, -31, 112,  19,   0, -56, -24,
  122,  20, -21, -17,  35, -94,  16,  34,   8,   2, -50, -27, -69, -33,  -3, 110,
  -58,  88, -93, -47,  48, -58,  32, -30, -38,  -6, -38, -52, -12, -52, 107, -33,
   -8,  22, -50, 121, 101, -12,  96,  48,  24, -25,-109,  -6,  74,-100, 115,  58,
   47,  38,-109,-119,  54, -42,   3,  51, -50,   3, 114, -82,  20,  16, 107,  76,
 -122, -64, -48,  51, -76, -36,  91, -26,  45,  -9,  14,-127,  24, -70,-112, -23,
   66,  51,-121, 100,  89,  57,  41, -96, -44,-112, -92,  97, -77, -75,  39, 104,
  -17,  59, 124, -13, -14, -63, 101,  30, 114,  87,  77,  34, -25,  66, 107, -79,
  -86,  54, -94, 110,  91,-102,  42,  40, -87,   0,  86,   6, 118, -33, -62, -23,
   71,  63, -73,  -9,  47,  31, 121, -49,  15, -68, -11, -87, -61,  93, 117,  89,
 -113, -49,  12,  63, 113, -25, -52, -98,  31,  -1,-111, -73, -50, -33,  57, -37,
  106, 110, -89, -76,-100, 115,   0, -64,  24, -85,  19, -61, -11,-115, 122, 121,
  116,   3, -42,  45,  89, -21,  57, 103, -75,-103, -48, -38,  42,  37,  94, 124,
  -15, -36,  -5, -33,  -1,  -2, -81,  28, 125,  98, 125, 125,  93,  41,  21, -57,
  -15, 104,  52, -54, -13, -36,  24,  51,  30,-113,-105,-106,  22, 111,  57, 116,
  112, -25, -50, -99,-120, 104,  76, 101,-116, -79,  86,  51, -58,  24, -16, -19,
  -31, -84, -99,-127,  26, -42,  44,  43,  62,  -8, -63,  15,  26,  99,  22,  22,
   22, -82,  92, -71,   2,   0, 119, -34, 121, -25, -31, -61,-121,  89,  86,  20,
   69, -47,  31,  13, -77,  34,  -9,   8, -98,  97,  81,-107,-109, -55, -92,  78,
  -72,-122,  42,  82,  74,  21,  69,  85,  22,  21, 120, 111, -76, 115,   1,  16,
   17, 122,   2, 114, -32,-119,  17,  32,   0,  34,  22, 118,  34,  85,  40,  84,
   16, -58, -87,  54,  -2, -20,  -7,-117,  65,  16,  29,  57, -14, -86, 123,-114,
  -20,-117,-126,  16, -84, -53, -78,  12,-112,  39, -83,  38,  40,-107, -23,  50,
  114,  81,  88,  77,  88,   2,  27, -52,  76,  42, -58,  68, -46,-100,-103,  -5,
  -40,  95, 126,  -8,  55,  31,  60,  -6, -22, 127, -14,  19, -61,-114, -30,  23,
   38,  23,  54, -77,  -9,  37,  89,  -6, -90,   7,  -2, -18,  -4,-111, -37, 111,
   63,  48,  61,  61,  93, -93,  89, -69, -35,   0, -80, -19, -33, -65,  60, -30,
  -65,  -8,-117, -65,  -8, -83, -26, -28, -37,  66, -11,-124,  86,  20,-107,-108,
    2,   0,  63, -16,-127,  63, 120,  -9, -69, -33, 125, -30, -60,   9, -93, -67,
 -108, -54, 123, -54, -13,  98,  50, -55, -58, -29,  73, -85, -43, -66,  -5, -18,
  123, -18, -71,  -9,  85, 105,-102,-106, 101, -82, 117, 101,  76,  85,  85, -91,
   -9,  94,  72, -26,  65, -40, 107, -98, -99,  39, 112,  68,  92,  72,  25,   4,
 -117,-117,  59,  47,  92, -72, -72, -78, -70,  38,-124,  44,  43,  61,  63, -65,
  112,  -9, -35,  -9,  32, -29, -49,  -9,  46, 111,-102, -78,   0, 111,-128,  89,
   68, 103, -56,  27,   2, -49,  52,  77,  60, -40,  40,-110,  97,  44,-115,  43,
 -116, -53,-119,  89, -30,-122, -86,  16,  29, 103,  36,  24,  40,   4,  73,  32,
  -99, -25, -50, -13,  74,  70,  12, -92, -46,  36,  11, -83,  39, 125, -61, -13,
  -71,-125, -77,  -5, -17, -39, -65,  99, -25, -94,-120,  67,  22,  40,  41,   2,
  -82,   2,  98,-127,  38, -76,-114, -15, 105, -26,  60,  87,  69, -40,   9, -89,
  -69,-115,  22, -99,  95, 107, -13,-122,  58, 124, -53,  99, -97,  -5,  -8, -98,
 -109, -93,-101,  95, 125, -21,-119, 104, 112,  68,  39,  98,  53, 127, 100, -72,
  -74, 105, -87, 119, -31,-100,  49, -90, -37, -19,  42, -91,  24,  99,  90, -21,
  -21, -77, -62,  47,-113, 110, -76,   8, -66,  36, -25,  40,-118,-126,  83, -89,
   78, -65,  -9, -67, -17, 125, -24, -95,-121,-126,  32,  16,  66,  32, -16, -94,
   40, -78,  44, -53, -13,  60,-114, -29, -69, -18, -70, -21, -64,-127,   3, 105,
 -102, 110,  14, -42,   0,  -4, -75,  26, -87,-109,  82,   2, 122, 107,  45, 112,
  -23,-128,   0,   0,  17,  60,  66, -35,  97,   5,-100, -83, -84, -10, -98,  59,
  113,  74,   5, -15,  96,  56,-119, -94, -12, -34, -17, -71, -65, -84, 108, -81,
  -41,  75,  40, -88, -86, -86, -88, -76, -77, 100,  61,  25, -29, 116, -27, -84,
   37, -26,  82, 107,-116,  97,  33, 120,  62,-103,  80,  94,  50,  33,  57,  32,
  -78, -92,  32, -94,  58,-116,  35,  34, -17,-128,  24,  17,  81, -57, -54, -62,
 -101,  42,  77, -58, -98,  38,-103, -37,  61, -77,  -9, -66, -59,  87, -17, -53,
  119, -98,  -4, -62,  25, -53, -64,  73, -58,-108,-112,-118, -89,  40, -37,  42,
 -104,-106,  97,  94, 108,  54, -90,-105,  93, -43,  66, -60,  40,  40, -25, -18,
   57, 120, -14, -30, -27,  -3, -83, -91,  79, -67, -29, -34,-113,  -3, -43, -45,
  123, -98,  59, -69, -13, -34,  29,  23,  -3, -24,  -5, -30,  67, -21, -85, -85,
  -97,  88, -65,  20,-114, -45, -11, -11, -11,-117,  23,  47,  30,  57, 114, 100,
  121, 121,  89,   8, -15,  50,-101,  85,  -8, -18, 118,   3, -22, -92, -32, -10,
  -31, -42, -51,  45,   1,  96,   0, -95, -45,-108,  58,  27,  72,   6,  30,  64,
  -13, -53,  17,  44,  86,  21,  -4, -37, 127,  -5, 127, 124,  -4, -93, 127, -55,
   57, -25,  12,-108,  82,-109, -55, -60,  24, -67, -71, -71,-103,  36, -55, -19,
  -73, -33, 126, -16, -32,  65, -58,  88,-106, 101, -50,  57, -25,  43, -70,  78,
  -75,-103,  65,  68,  34, -84, 103, -55, 122,  30,  23,  66, -76, -37, -19,  70,
  -93, -15, -95,  -1, -16, -25, -57,-113,  31,  15,-126, -64,  90,  -5, -29,  63,
   -2, -29,-116, -79,  94, -81,  87,-106, -91, -75, -58,  90,  91,  85, -75,  35,
   97, -67, 127,  41,-103,  80,-106, -91,  16,  98,  97,  97,  97,  56,  28, 102,
   89,   6, 117, -48, 118, -83,  27, 107,  59, -48, -87, -45,  14,-116,  65,  89,
 -106, -77, -77, -77, -25, -50, -99, -45,  90, -33, 119, -33, 125,  -9, -33, 127,
   -1,-123,  11,  23, -84, -75, 117,  60,  87,   7, 124, 117, -76,  87,  31, -42,
  -87,  15, -50, 121, -19,  97,  43, -91,-108,  82,  69, 119, -31,  -9, 127, -19,
   95, -66,  -5, -44, -54,  59, 126,  -2, -65, -17, -37,   8,  -3, -22,-108, -90,
   -9,  94,-123, -49, -51, -87,   3, -47, -20, 124, -48,  81,-117,  93,  25,-106,
 -101, -17,  -5, -93,   7,  54, -57,  59,  59, -14,  42,-101,  14, 102,  59, -23,
  -34, 101, 121, -45,  14,  92,-102, 107, -20, -33, -35, -66, 105,  23,-124,  49,
   64, -22,   9,-100,  39,  68, -50, -39, -42,  40,  88,-126,  49,  66,   8,  16,
   19,  64,   5,  64,  30,  20, -13, -36, -27, 100,  83,  23, -12,   5,  53,   0,
  112,  52,  17, -51,   8,-100,   3, -64,  62, -57, -18, 117,  -3, -75, -33, -75,
 -106, -43,  24, -77, -19,  -2, 111, 119,-121,   0, -64, 102,   8, -99, -84,  13,
   30,  56,  27,  41, 123,  85, -65, -17,  79, -81,  60, -69, -78,  -4,  43,  -1,
  -30, -55, -85, -89, 127,  -3, -41, 127,  -3, -60,-119, 103,-107,  82,  89,  62,
   78, -94, -72,  78,  28, 109, -12, -41, 111, -65,  -3, -10,  91, 111, -67,  53,
 -114, -29, -78,  44, -22, -34, -88, -78,  44, -61,  80, -63, -75, 116, -29, 118,
  -76,   1,   0,  74,-123, -37,-123,  -2,-102,   6, -58,  88,  81,  20, -89,  78,
  -99, 114, -50,  21,  69, 113, -53,  45, -73,  48, -58, -14,  60, -81, -45,  14,
  -29, -15, -56,  90,  91,-109,  90,  71, 111, -41,  23,  20, -32,-102, -17, -85,
  -75,  86,  74, 121, -17,   1, -73,  30,-113,-102, -41,  58,-128,-109,  82,  90,
  -85,-101, -51, -26, -38, -38,  26,  17,  45,  46,  46,  30,  62, 124, 120,  48,
   24,  56, -25,  24,  99, -11,  83,  84,-117,  49,  86,  63,  72, -37, -72, -41,
  103, -85, -95,  55, -58,  76,  73, 117, -33, -21,  95,  -9, -56, -39,  15,  -3,
  -99,   7,  79, -48,  15, -66,  74,  12, -94,  43,  83, -55,  -3,  36,  30, -55,
   47, -48,-108, 127, -82, -72, 116, 112, -77, -38,  55, -65, -72,  -4,  43, -17,
   50,  -7, 120, -25,  32,-119,  58, -27, 120,  56,  49, -71, 118,-107,  51, -57,
  -49,  12,  31,  62, 113, -91, 112, -96, -83, -38, -69,  40,-109,  40, -98, -99,
  110, -18, -36,  33,  22, -25,  97, -70,  13, -95,-108,-116, 117,  43,   6, -52,
   27, -55, -54,-112,  89,  64,   1,  16,   0,  79,-111,  91,   1, 109,-113,  37,
    3, -42,  76,  -4, 112, -62,  91, -87,   5, -24,-106,   8, -31,  75,  99,  -6,
   93,  11, -85,-108, -78,  38, 117,  59,-111,  84, -65, -33, -79,  96,  19, -72,
  -78, 121, -27, -60, -69,  -2, -23, -36,  95,  -4,  69,  35,-120,  62, -30, -30,
   99,-125, -34,  90, 127, 120, -10, -20,-103, 110, -73, -53,  57, 111,  52,  26,
   86,-101, -53,-105,  47,  53,  26,-115,  55, -67, -23,  13, -13, -13, -13,-115,
   70,  52,  30,-113,   6,-125,   1,  34,  70,  81, -44, 110, -89, -58, -72,-102,
 -104,-102, -56, 109, -45,  21, -57, 105, 109, -22,-118, -94,  24,-115,  70,-101,
 -101,-101,  87, -82,  92, -71, 116, -23,  82,  81,  20,  73,-110, 104, -83,  -9,
  -19, -37,-105, -25,  -7,  -6,  -6, 122, -98, -25,  53, -57, 117,  58, -74,  38,
  117,  91, -11, 101, 111,  -9,  97, -43, -77,  68,  -3,   9,  92,  87, 113, -88,
   -7,  99,-116, 105, -19,  57, -25, 117, 100, -74, 111, -33, -66, 118, -69, 125,
  -10, -20, -39,  26, -51,  26,  86, 118, -99, -74, -87, -35,  -2,  20, -82, -75,
  125,-119, -94, -72,  -9, -82, -69,  62,  -8, -24, -61,-113,  29, 125, -20, -18,
  -41, -19, -86, -10, -19, -55, -54, -32,  21, -35, -30,  39,  27,   7, -34, 119,
  -23,  73, -36, -75,  56,  42,  39,  79, -99,  61,  79, 118, -90, -77, 103, -25,
   83,  81,  -2,  35,  47, -82,  25, -83,-125,  78, 107, -10,-106, 125, -68,-103,
  102, -38, -28,-107,  54, -50,-106, -25,  78,  23, -43, 102, -17, -20,  21,  58,
  -15,  85, -18,  72, 121, -50,   1, -47,  35, -90,  34,  94,-100,-101, -70, -19,
   80, -29, -26, 125,  16,  37,  96,   8,-100,   0,  38,  65, -95,   1,  87,-127,
  111,  67,-120,  81, -77,   0,  40,-100,  14,-100, -70, 126,  76, -65, 107,  97,
  -83,  85,  91, -87,  58, 116, -83,-121, -92,-128,  60, 114, -39, -43, -97,  -2,
  -57, 119,  28,  63,  55, -40, 113, -24, -95,  61,  59, -50, -20, -35, 115,  -7,
  -59,-115, -63,  -6, -22, -50, -99,  59, -13,  60, -49,-117,   9,  17, -83, -81,
  -82, -74,  90, -83,  -5, -17, -65, 127, -41, -18,  -7, -31, 112, -72, -66, -66,
  -50,  57, -17, 116,  58, -37, -25, 108, -73, -69, -37,  67,  78,  68,  85,  85,
  101,  89,  86,  20, -59,  87,-113,  61,  61,  28,  14,  -5,  -3, 126, -81, -41,
   27,  14,-121,  53, 106, -50, -69,  56,  74, -68,  -9, -83,  86,  43,-118, -94,
  -47, 104, -92, -75, -82,  25, -83, 103,-128, -70,  36,  91,  95, -13,  54, -81,
   66,-120, -38,-118,  43, -91,  16, -79, -98, -48,   1,  96, -37,  82, -42,  95,
  -82, 109, 112,  24,-122,-125, -63, -96, -66, -56,  -3,  -5,  -9,  -9,  -5, 125,
  -17,  -3,  54,-117, -75, -22, -61,  -6, -99, -38,   1, -88, -75, 109, 116,  17,
   49,  31, -12, -26, 119, -52,  52, -34,  -4, -67,  31,  59,  -2, 123, -81,  -2,
   -4,  49, 122, -35,  61,  83,  23, -92,  81,  39, -34,-118, -45, -97,  43,  -3,
   90, -18,  54,  25,  86,  97, -84, -49, 110,-128, 102,  47, -40, -34,  15,-123,
   13,  48, -42, 107,  83, -84, 111, -70,-107,  -2, 100,  56, -78,-123,  65,   0,
   17,  59, -59, -79, -47,  72, 120,  10, -92, -83, -55, 117,-103, -27,  85,  85,
   -7,  11, -21,  27,  95, 124,  -4, -36, -65,  -1,-112, -45, -50, 116,-101, -47,
 -111,-125, -69, -33,  -2,  -6, -91,  -5,  95,  45,  70, -54,  52, 121,   3,  20,
  110,  76, -96,-103,  74,-128,-112, -85,  92, -70,  -8, -70, -90, -59, -17, 102,
   88, -73,  45,  31,  92, -85, -93,   2,  64,  37,  32, 122,  -4, -71, -10, -25,
  -97,  63,  -1,   3,  -9,  -2, -66,-128,  75,   3, -15, -62, -54, -26, -36, -58,
  102, -85, -43,  26,-113,-121,   0,  32, -91, -68, 116, -23,  98, -69, -43, 122,
  -29,-101,  30,-104, -97, -97, -17, -11,  86,  24,  99, 113,  28, -41,  25,  40,
   41, 101, -19,  77,  94, -72, 112,  97,  52,  26, -83, -81, -81, -41,  80, -26,
  121,  94,  -5, -99,  12,-123,  49, -90, 118,   1, -61,  48,  20,  66,  68,  81,
  -60,  57, -97,  76, -78,  44, -53,  14,  29,  58,  84,  85,  85, -98, -25, -37,
   78, 109, -19, -89, -42,  22, -12, 122,  88, -21,  -7, -67,  -2, 114,-115, 120,
  -35,-102,  13,   8, -37,  96, 109, 127,  25,   0,-126,  64, 109, 110, 110,  54,
 -101, -51,  59, -17, -68, 115, 106, 106, -22, -14, -27, -53,  73,-110, -44, 110,
  -64, -11, 118, 116,  27,  95, 126, -99, -82, 119,  21,  72,-105,  38, -41, -81,
  -71, -25,  13,  15, 125, -49,  35,  79,  60, -14, -12,  29,  79, -99,  79, 119,
  -66, 114, -77, 111,  82,-103, -67, 115,  -9,  43, 127, -19,-103, 103, -41, 119,
  -92, -53, -69, -45, -85,-109, -75,  -2,  19, -49,  -4,-113,-117, -73, -76, -25,
  -72, -16, -52,  21, -90, -16, 125, -29, -99, -11,  46,-116,-108,-108,  82, 102,
   96, -55, 107, 103,  13, 120, -53, -64, -57,  18,  27, -19,-112,  97, -77, -37,
  113,   8,-114, -84, -50,  11, -67, -42, -41,  79,  62, 123, -15,  99, -97,  61,
  -41,  31,  -5,  -5,  95, 125,  -1, -65,  -5,  87, -80, -76,   0,   1,  56,  70,
   28, -48, 105,  34, -11,  53, -19, -75, -33, -51, -80, 110,-101, -97,-102,  84,
   33,   4,   0, -76,  61, -62, -62, -51, -65, -41,  94, 120, -62, -70,  43, -42,
   29,  60, -37, -17, -14, -36,  52, -56,  15, -77,  58,  48,  90,  93,  93, -23,
  118, -69, 111, 121, -13,-101,-106,-105,-105,-121, -61,  97, -73,  59, -21, -67,
  -49, -13, 124, 109, 109,  99, 109, 109, 109, 117, 117, 117, 117, 117, 117,  48,
   24, -28,  89, -71,-115,  84, 109, -91, -62,  32,  14,   3,  80,  74, -43, 101,
  -37,  40,-118, 106,  95, 118,  59, 100, 110, -75,  90, -69, 118, -19, -46,  90,
  107, -83,   1, -96,  40,-118, -70,  78, -69,  -3,  32,  93,  95,  13,  18,  66,
  -44, 113,-113,  49,-122, 115,  30, -57, -15, 100,  50, -31,-100, 115,  33, 106,
  -45,  14,   0,  53, 100,  53, -78, 107, 107, 107, -34,  -5, -71, -71, -71,  35,
   71,-114, 108, 108, 108,  56, -25,-108,  82, 117,  41, -18, 122,  82, -81, -89,
  115,  27, -48, -21,  15, 121,  72,  99, -29, 111,  10, -70,  39, -33,  -2, -58,
   79,  60, 114,  -4, -64,  -5,  63, -23, 127, 110, -54, -88,  -8, -30,  96, 125,
  -17, -20, -34,  55,  45, -17,  -1,  88,  53, 126, -10, -30, -15, -71, -75, -85,
   -1, -16, -48, -66, 123,  14,  47, 109,  84, -82,  20, -38,-104, -54, -23,  82,
   23,  37, 104, -85,  29, 121, 109,  92,-110,  34,   1,  -9,  32,-120, -92,  -9,
 -127,   7, -26,  29, 120, -22,-123, -88,   4, 103, -32,  17,  33, -99, 110, -16,
   78, -84,  15, -52, 100, -29, -15,-117, -97, 120, -16,-105,  15,  -4, -43, -65,
  -40, 120, 113,-108, -58,  18,  28, -45, -64,-107,  72,  12,-127, -68, -18, -98,
  124, -85,-119,  -6, 102, -87, -82, 115, -42,   4, 108,-109,-102, 101,  25,  38,
  -55, 111,  -4, -55, -97,  63, -78, -76, -96,  54, 120,  99, -80,  86,   6,  20,
  -12,-121, -91,-108,-128,  12,   0,  70, -29,  33,   0,  28,  62, 124,  40,  73,
 -110,-121,  31, 126, -40,  90, 125, -15, -62, -54, -58, -58, -58, -26, -26, 102,
   77,  24,   0, 112, -50,-107,  10, -89, -90,-110, -19,  -7, -70, 126, -65, 126,
  -19,-100,  39,   2, -17, -55,  24,  91,  15, -65, -75, -82,  46, -21, -17, -39,
  -77, -57,  90,  59,-103,  76, -86, -86, -86, -83,  41,  92, 115,  42, -82, -97,
 -120, 107, -33,  87,   8,  97, -83,-115, -29, -72, 110,  84,   8,-126, -96,  54,
 -109,  66, -78, -38, 103, -88, -83,  99,  93,  84, -13, -34,  -9, 122, -67, 118,
  -69, 125,  -8, -16, -31,  32,   8,-122, -61,  97, 125,-110, 122,  30, -88, -61,
   -1,-102, -47, -21,  95,  95,  31, 114, 109, -13, -22,   2,  46,-116,  98, -21,
  -61, -37,  15, -36,  -2, -16,  -2,  93,  47, -68, -16, -60,  45,-113,  45,  -5,
   87, -33, -49, -86,  66,   6,  -8, -86, -87, -16, -95, -57,  30,   1, -18, -33,
  -58, -25,  94, -65, 112, -32,-119, -75, -77,  11,-105, -83, -51,  39, -38,  26,
   68,  20, -32,  37,  50,   5,   0, -50,  87, -71, -83, -57,-127, -64,  27, 114,
 -102,  28,   0,   0, 122,  61, -10,  94,  74, -57, -96, -76,   6,   0, -92,-108,
 -100,  43,-101,  52,  -9, -33, 127, 115, 124, -12, -52,   7, -33, -14,  -9, 126,
  -30, 115, 127,  89, 113, -95,  20,  71, -16, -32,  52, -56,-105,  34, -84, -17,
   90,  88,  -1, -13,  20,  96,-106, 101,  71,-113,  30,  -3, -27,  95,  -5, 119,
  116, -74,-121,  55,  47,  52, -81, -12,  98, -32,  39, -44, -28,-112,-119, 115,
  109,  74,  94, 100,  -7, -92,  14, -34,  31, 125, -12, -47,  47,  63,  -2,  -8,
   96, -48, -73, -42,  74,-111,  10,  33,-126,  32,  10, -61,  -8, 122,  52, -75,
   46,  -1, 115, -57,-111,-120, 106,  59, -59,  57, -81,-125, -21, -38, -93, -83,
   -3, -50,  93, -69, 118,  13,   6,-125, -94,  40, -22, -96,  10, -66,  54,  77,
   81, -37, -47, 107,  -7,  47,  66, -60, -86, -86, -30,  56, -82,  23,  14, 112,
  -50,-125,  32, -16, -66,  46, -77, -31, -74, -67, 116, -50, -43,  -3,  49,  82,
  -54, -87, -87, -87,  -3,  -5,  -9, -41, -11, -74,-102, -56, 109,  82, -21, -61,
  -19, -68,  85, -83, -19,  95, -65, -34,  19,  40,  98, 108,  14,-107, -55,  39,
    7,  22, -26,-113, -33, 113, -28, -20, -71,  11, -81, 121, -12,-119, -85,  15,
  -68, -93, -87,  76,  -1, -71, -45,  31,  -2,  -3,  -9,  46, -58,  -4, -97,  -1,
   55, -17,  92, -38, -67,  -1,-123,-107,  23, -59, -96,  92,  49, -61, -68,  44,
    8,  65,  41,   1, -28, -48,  56,-119,  32,   8, -95, -56,   1, -64,-125, -77,
  100,  29, 122,-113, -98, -48,   3,  -8,  70,  38,-120,   0,-112, -73, -94,  52,
 -102,-102,  10, -69,  83,  86, -87, -46, 121, -36, -85, -18,-103, -38, -15, -32,
   31, 127, -18, -54, 111,  -4, -65,  11, -17,  -6,  73,   4,-124, -52, -28,   9,
 -117, -81,  27, -63, 111, 122, -98,  53,  39,  45,-112,  73,  16, -24,   1,  12,
  108,  45,  -4,  53,-128, 114, 107,   1, -48,  75,  75, -20,   1,  60,   0,  93,
  -21,  85, -81,  -1, 110,  19, -57,  72,   3,  64, -67,  70,   8, -23,  90,  71,
   -5, -75, 107,  39,  14,  14,  64,-109,  85, -56,  16,  60,   3,  64,-126, -54,
   84,  66,  69,  30, -48,  59,  23,  48, -15, -39,  79, 124, -22,  -3, -17, 125,
   63,   9,-107, 101,  89,  89, -27, 117, 118, -77,  40,  10, -25, -84,  16, -94,
  114, 104,  43,  93,  55,  10,  26,  91,  57,  36,-112, -36,  56, -19,-116,  64,
   68,-122,  40,  17, -56, 104,  87, 106,  32, -49,-111, 109,  10, -17,-100, -75,
  -42, 114,  36, -58,  24,  71,  32, 112, -34, 123, -44,  91, -16, -43, -36,-105,
  101,  89,  85,-107,  16, -30, -75,  -9, -65, -95,  44, -53, -78,  44, -51,  53,
   93, -77,-114,  95,  99,  41, -21, -66,  68, -17,  61,  23,  88,  91, -51, 122,
    9,  97, -99, -64,  98,-116,-111,  71, -83, 117,  24,-122, -56,  72, 107,  93,
   71,  71, -57,-114,  29, -69, 105,  42,  61, -12,-106, -73, -66, -26, -26, -41,
  -12, -49,  93, -20,   5,   3, -34, 100,-119,  87, -42,  50,  76,  88,  64,  74,
   88,  22,  67, -88, -62, -60,  32,-107,  18, 120,  26, 118, -77,  28, -62, -40,
  105, 106, -80,  32,-118, -94,-119, -85,  60, 119,-111, -32, -52,-104, -84, -47,
 -100, 109, -52, -14,  -7, -87,  71,  30,  -1, 116, -11,  47, 127, -21,-121,  45,
  -65,  -5, 103, -33, -66, -14, -24, -87, -81,  60, -13,  84, 119, -49, -82,  55,
  -68,  -3,  -5,  32,  10,  46,-100,  59, 111, -58, -91, -45, -90,   4,  83, 123,
  -13,  14, -56,-111,   7,  68, -83, 117, 101, -51,  20, 112,  93,  85, 104, -67,
   96,-110,-120, -76, 115,  36,-104,  12,   2,   9, 101,  65,   0, -51,  78,  99,
  126,  49,-120,  91,  69,  81,-107, -93,   9, 104,  45,-102, -64,  27, -79, 127,
   -4, -20,  -8, -47, -45, -81,  94,  -3, -52,  72,  36,   1,  69,-127, -61, -21,
  -51, -23,  55, -35, -78, -58, -88, -22,-124,  11,  50, -96,   0,  44,  88,   2,
   70,   2, -92, -41,  64, -84, 110, 102,  70, -88, -51,  32, -29,   0, -52, -38,
   45,  84, -15,  58, 108,-119,  28,-122, -20,  58,-120, -73, -72,   6,  48, 124,
  -85,  33, -38,-125,  23,-114,   4,   7, -16,   0, 121,   1, 105, 114,  -6,-123,
  115, -49,-100,  57, -35,  31,-114, -78, -94,  -4, -54, -93, -57,  30, 126, -16,
  -95,  80,   4, -94,  45, -46, -92,  17,  40, 101,-127,-100, 101,  44,-118, -64,
   57, 109,  12,-109,-126,  33,-112, 117, -24, -99, -30,   1, -96,   7,  15, -54,
   43,  25,  74, 109,-115, -74, -42,  49, -14,-118,  81,  28,  10,  37,-103,-110,
  -69, 115, -44,  90, -25, 101,  81, -24, -46,  88, -21, -63,  89,  34,  34,-112,
   92,  72, -91, -78,  44, -85, 108,  25,-122, -31,  36,  47,-124,-108,-121, 110,
  -67, -83, -98, -51,-117, -94, -88, -13,   0, 112, -83,  -9,-118, -56, 111, -49,
  -56, -37,-127, -71,  -9,  62,-116, -44, -74, -53,  27,-122,  97, -99,  13,  64,
  -60,  34, -81,-102, -51,  38,  17, 121, -78,-100, -13, -87, -87, -50, -29,-113,
   63,  30, -57, -15, -92,  21, -18, 117, -79, -45,  85, 111,  78,  78, -71,  86,
   60,  46,  92,  16,  48, -39, -24, -84,  11,-118,-123, 109,  71, -70,  27,  22,
  -83,-112,  16,  82,-117,  29,  22,  93, 110,  20,  45,  84,-119, 101, -88, 109,
 -111,-115,  66,  65, -78, -93,  54, 120, 113,-112,  31, -88, -30,  80, 104, 122,
   -2, -14, -59,   7,  -5, -89, -85,  96,  48,  55,  49, -18, -49,  62,  37, 100,
  112, -24, -56, -19, -13,  -5, 110, -70, 120, -27, -14, -58, 112,  40,  25, -73,
 -123,  41,-122, -29,  40,  84, -88,  84,  54,-104,  88, 107, -21,  80,-110, 107,
  -99,  50, -74,  97,  39,   8,  32, -71,   8,  56,   0, -96,  65,  36,-114, -60,
  -88, -32, -95,-118,  19,  21, -73, -54,  76,  79, -58, 107,  72,  62,  84,  34,
   72, -30, -62,  -6, -58, -98,-101,  72, -74, -50, 109,-114, -49,  60,  -8, -91,
   -7, -41, -33,  31, -56, 120, 107,  43,-112,-105,  13,  86, 114,   0,-128, -34,
   89, -57, -84,  20,  66,   0,   1,  84,   4, 100,  89, -64,   0,  -8, -42, -18,
   11,  12,  29,   2,  33,  16,-128, -32, -75, -55, -12,  30,-128,   1, -15, -70,
  118, -71, -75, -34,  29, -64,   3,  57,  78, -98,  95,  91, -82,-119,-128,   4,
   14, -68,  87, -11, 126,  13, -42,  -6, -85, 107,  23, -49,-100, -87,  -2, -28,
  -77, -65,  -6,   7, -65,  -5,  69, -69, -71,  17, -77, -68,  14,  95, 100, -62,
   75, 111,  87, 108, 115, 106, -74, -35, 106, 121,-121, 100,  73, -54,-128, -93,
  112, -98, -84, 114,  76,  48,  32, 100,-114,  51, -17, -64,  58, 111,  29,   2,
  119,  96,  13,  89,   7,  14,   9,  57,  33, 120, -32, -58, 115, 111,  99,  76,
    2,  37,  99,  25,  17, 122, -57,-128,  56,  35,   4,  66, -76, -50, 100,  89,
  -42, -20, -76, -67,  -9,  87, -81,  94,-115,-101,-115,-125,   7,  15,  46,  44,
   46, -82,  92, -68,  82,-106, 101,  93,  82, -81,-101, -19, -21,-103, -41,  90,
  127, -67,  -5, 120, -99,  87,-128, -75, -97, -67, -35,  98,  91,   7,  97, 113,
   28,  55,-101, -51, -31, 112,-120,-128,-115,  70,  99,  50,-103,-116,  70, -93,
  -67, 123,  -9, -22, 124,  60, 123, 112, -49,-122, 114, -10, -14, 102,  55, 108,
   89,  25, 107,  12,  27,  58,  92,  61,  60,  19,  41,  12, 108,  30, -82,  93,
  108, -98,  24, -90,  82,   6, -99, -74,-115, -62,-101, 103, -90,-121,   9, -53,
  -37, -87, -62,  36, -20, -87,  25,  22,  54,  59, 105,  88,  13, -81, -12, -41,
   -1,  -6, -59, 103, -97,  -6, -20,-125, -20, -40,-119, -71, -63, -28,  71,  49,
   -6, -63,  67, -73, -75, -18, -35,  39, -67, -68, -38,  95,  63, 121, -10, -52,
  -60,  84,-115,  70,  51, 109, -74,  93, -90,-111, -96, -39, -22, 120, -17, -83,
  -15,  64, -34,  27, -49,  61,  83,  40, -47,  67,-112, -92,-100,  49,-127,-116,
    8, -84, -75, -64,-107,-120,   2,  25,   6, -68, -39,  80,  34, -32,-114, 115,
  -57, -62,  80,   6, 105, -24,-123, -49,  77,  25,   6, 115, 122, 122,  54,  89,
   92,-102,  73,-126, -22, -20, 106, -14,  64, -72, 109,-113,  94,  62,  88, -79,
   94, -32, -53,  37,-128, -84, -79,   5, -57,-111,-127, -88,   4, 114,  32,  14,
   94,-128, -29, -32,  57,  56,   0,  15, -64, -63,  51,  96,  47, -19,  44, -30,
   60, 104, -21, -83, -29,  27,  87, -55,  90,  93,  21, -70, -52, -53,  60,  51,
   69,  97, 116, 105, -83, 109, 108,-108,  73,-110,  32, -30, -54, -38,  -6, -27,
   23, -49,-105,-125,  65, -54,  85,  35,  78,  22,  15, -73, 126,  -9, -35,  63,
  119,  -7, -46, -54, -87, -77,  23,-122,   4, -89,  54, -42, -65, 120,  -4, -87,
   21,  40, -82, 102, -32, -77, -53,  27, 120, -39,  50,  97,-128, 123,  37,  64,
   42, -58, -27, -84,  82,  30,  72,  91,  87,-121, -34,  74,   8, -26,  61, 120,
 -116,  44,  15,-128, 121,-127, -98, -93,  37, -56, 117,  85,  58, -19,-127, -58,
  -43,   0,-127,  19,  67,  68,   4,  86,  -5,  36,  12,  17,-123, -16, -99,  86,
  107,  50,-103, 108, -10,  -5,  55,  45, -19, -70, -19, -74, -37, -46,  52,  29,
   14,-121,  42,  12,-112,  51,  21,   6,  53,-117, -41, -86,  86,-122,  95, -93,
  -10, 111,   4, -26,   4, -82, 118, -69, -73,  83,   4, -11,-117,  56,  78, 106,
   27,-100,  68,-111,  82, -22, -31,-121, -65,  58,  63,  63, -33, -23, 116, -86,
  -79,  89,  85,  54,   4, 126,  91,  99,  54, 119,  38,  19,  98, 122, 122, 113,
  -83,  40, -79,  59, 108,  62, 120,  -4, -32, -89, -97, -18, -98,  59,  95,  64,
    6, -87, 106,  65,-104,  76,  -4,  11, -86,-100,   9,  91, -10, -16, -51,-109,
   31, 120, -61, -26,  43, -10,  30,  91,  91,  57, -11,-107,  51,  79, -66, 120,
  -90,  60,  -6, -31, -50,   0,  -2, -63,  16, 126,  24, -26,  27, -73,  30, -54,
   14, 118, 116,  42,  79, -47, -26, 110, -22,  96, -88,  34,  41, -72,  11, 109,
  101,-118,  44, 107, -60,   9, -73, -34,  55, -62, -94,  40, 108, -94, -48,-117,
  113,  81,  10, -17, -29,  40, -46, 101, 101,  11,  11,  92,  16, -96, 115, -28,
 -127,  88, -88,   2,  25, -86,  32, -86, -56,-126, 101, -32,-128,-128,  25,  46,
   92,  16, -40,  86, 100,   3, -36, 119, -53, -67,-101,  97,  21,-126, -37,  -7,
  -54,  91,  54,  -2, -22,  24,  88, -17,-108, -25, -14, 107,   2,-113,-105,  35,
  -64,  50,-122,  42, -16,  82, 114,  15,  96,-119,  51,-128,-120,   3,  68, -80,
  -67, -67,   2,  -9,   5,-104,  18, 108, -31, -99, -39,  -4, -20, -89,-117, -31,
   56,  91, -23,  77,  46, -81,-103,-107,  77,  24, -26, -78, -76, -36,  81, 127,
   87,  71,   8,  17,  72,  37,  37, -25,  12, -67,  -9, -50,  25, 114, -82,  34,
  121, -66,  42,  75, 103,  84,  16,  52,  26,-115,  -7,  78,-110,-122,  81,  20,
 -124,  47, -12,  46, -92,  50,  62, -80, 111,  -9,  45,   7,  14, -38, -46,-118,
  -23,  25, 104, -73,  76,  85,  85,  25,-100, -67, 114, -27, -40, -55, -25,  30,
   63,  -3,  -4, -87, -75, -85,  43,  58,  31, 122,  83, 122, -97,  95, -72,  68,
    0,  62,  16,  35, 112,  27,  -3, 107,  79, -76,-108,  16, -76,  16,  48,  20,
   50,-110,  81, -64, 100,-128, -86, -87,  82,  37, -28,  90, -46,  71,   0, -12,
   64, -50, -93,   5, -12,-120,   4,   0, -64, -76,  63, 127, -14,-116, -10, 122,
  -25, -62, -50,  87,  30, 124, -59, 108, 107, 106,  56,  28,-106,-125,  73, -35,
   38,  91, -25,  -1, -73, -51, 100,  13, -23, -11, -51, -81,  47,  21,-106,  56,
  112, -50, 107,  95, -74,  46, -59, 109,-121, -16, 101,  89, -90, 105,-102,  54,
  -30, 115, -25, -50,  13,-121, -61,  61, 123, -10,  56, -25, -54, -87, 116,  79,
  -40, -79, -21,  -3,-110,  99, -39, 108, -64, -96, -12, -52, -58,  71,  22,  -9,
  124, -26,  83, -26,  75,-113,-103, 115,  47,-128,   0, -37,-127,  77, 103, -54,
   60,  91,   0, 104,   2,  56,  42, -90, -66,  52,  58,  -8, -12, -43, -49,  44,
    4, 127,-110, -99, 105, -82, -39, -97, -73, 123,  -1, -34, -50, -61, -25,  15,
 -121, -63,  66, 103,  94, -59,-103,  64, -57, -68,  43, -88, -87, -59,  -7, -30,
  -14, -36, -36,  92,  36,   3,  68, -20, -81, 111,-116,  -6,   3, -43, -30,   0,
   48,  24,-116,  56, -25,  68,-120,  76,  48,  46,  43, -83, -71, -13, -64, -72,
  -88,-100, -16, -64,  24, 114,   2, -49,   4,  67,-119,  22, -56,  -8,   0, -99,
  -42,-107, 101,-111, -20,  52, -43, -20,  28,  95,-104, 105,  46, -51,  68, -77,
  -35, -43,  73,  46,-122,  19, -20, -11, -59, -26, -26, -26, -79,  39,  97, -93,
  103, 118, -20, -84,  27,  32,  95,  50, 124, -33, -12,  70,  22, -19,  65,  49,
   13,  96,   0,  12,-104,  16, -92,   0, -16, -42, 112,  49, -82,  54,  -5,-101,
  -49, -98, -20, 127, -27, -23, -63, -47, -89, -14, -29,  39, -51,  -7, -53, 126,
   52,  22,  -5,  22,  84,  20, -86,  86,  26,  76, -75, 120, -73, -63, -38,   9,
   70, -54,  75,  62, -33,  51,  30,-127,  16, -84,   7,  15, -28,  60,  89, -14,
   68,  84, -91,  49,  73, -50, -62,  48, 104,  55,-126, -76, -31, -56, 107, 109,
   16, 113,  62,-117, 114,   9,  52, -35,  82,  83,  29, -32,  66, -28,  38, -50,
  124,  96, 104,  -3, -90,  70,  18,  68,  13, -82, -80, 116,  80,  58,  24, -26,
  -27,-123, -53,  87, -49,  95,  -4, -28, -71, 103, -82, -12,  55, -50, -12, -82,
  -98, -23, -83,  94, -22,-113,  74,  11,   8, -32,   1, -58, -72, -75, -89,  79,
  -35,-112,  65,-120,  12,   5, -25, -46, -88,-100, 115,  41, -71,   8,  68,  32,
   80,   9,  20,  68,   4,  30,  77,  57, -87, 107, -86, -81, 120, -59,  43,-120,
  -88, -33, -17, -41, 121, -85,-119, -43, -37,  25, -42, -19,-102, -66,  16,-126,
  121, -65,  13, -24, -41, 100, -17,   5, -42, -80, -42,  25,  40,   0, -88, -13,
   89, -50,-110, -75, -74, -35, 110,  15,  71,-101,  15,  61, -12,  80, -73, -37,
  -34, -71, 115, 103,  85,  85,  38,-106, -17,  -7, -23, 119, -83,-113,  54,  78,
  110, 108,   0, -15, 100, -74, -21,  89,  17, -10,  55, 110,  -5,-123, -33,  29,
   65, -82,  35,  27, -58, -60, -55,  26,   7,  85,-128,  58,  82,-119, -10, 123,
  122,  44, -76,  42, 120,  -3, -99, -47,-111,-125,-109,  75,  61,  92, -37,-100,
 -103,-103,  25, -72, -94,  31,-125,  -9,  62, -20,  87,   4, -54, -90,   9,  90,
  -34,  50, 106,-123,  46, 114, -50, -41,  87, 123,  51,  51,  51, -77,  83,  51,
  107,  43, -85,  70, -69,  56,  12,  39, 101, -43, 110, -73, -75, -42,  40,  56,
    0,-116,  39,-109, -83, -66,   8, -25, -84, -11, 100,  29,  49,  68, -87,  88,
  -88,  48,  10,-103,-110,  60,  64,  39,-108, 104,  79,  55,-106, 118,  39,  11,
   59, -88,-103,  64,  40,  81,  10,-102, -12, -57,  79,  61, -77,  -7, -91, -81,
 -108, -25,  47,  61,  -7, -24,  83,  -9,  -1, -15, 111,  45,  -1, -40,  79, -92,
   62, -72, 126,  31,-125, 111, -70, 101, 117,-118,-111, 119, -36, 107, -59,  60,
  104,   3,  89,  86, 126,  -2,-117, -97,  -5, -24, -57,  -4,  31, 125, -40,  33,
   -6,-128,  97,  35,  10, -90,  91, -23, -20,  84, 114, -32,-107,  65,  51,  41,
   92,  88, -81,-111,   7, -29,  -4, -90, -47, -85,  61, -46,-106, -84,  59,  25,
  102,-124,  72,  76,-127,  82,  60,-116,  69, -46,  80, 113,  42,  85,-104, -86,
   52, 108, -90,  16,   5,  20,   4,  42,-116, 101,  16,  50,  20,-100, -13, 113,
   55,-111, -50, -37,  97, -26, 122,  19,  94, -39, 108,  60,  30,  25,-101,-124,
 -111,  -5,  79,  39,  10,  41, 114,  70, -50,  25,  46,  32,-116,  20, -94, 107,
  -18,-128, -97, -39, -15,  64,  53, -20,-105,-127,  16, -35,  14,-113,  34, 100,
  106,  50,-104,  92,  58, 127, -31, -60, -87,  19,  47,  94, -70, -16, -28, -39,
  -45,  47,-116,   7,  43, -50,-115,   1, 114,   4,   3, -48,  26,-127,-121, -46,
    0,  76,   0,  28,  48, -73, -67, -28, -98, -77,  -5, -65,  -9, 123, -25, -25,
  -25,  47, -82, -83,  57, -25,-116,  55, -29,  50, -29,-100, -93,  -9, -37, 113,
   -3, 118,-115,-118, 115,  46, -82, -91,  63, -21, -39,  -1, -91,-108,  39,-121,
  -19,-114,-109, -19,  23,  66,   8,-122,-108,  36,-119,-108, -14,  -7, -25, -97,
   47, -53, 114, 121, 121, 121, -85, -16, -95, -85,  63,  -5, -12,  95,  45, -19,
  -35, -69,  -9,-106, -37, -82, -82, 110, 116,  23,  58,-115,-109,  39,-122, -17,
   -7,  67, -51, -13,-103,  36,  37, -12,  99, -83, 109,  34, -93,  52,   9, -84,
  -45,-109,  92, -23, 114,  35,  85, 122, -90,  25, -74,  -3,-114, -31,  70,   7,
   77, -34, -59,  39, -32,-126,  12, 102,  73,  59, 101, -48, -14,  40,  73,-110,
  -92,-123, -95,  37,   0,   0,  32,   0,  73,  68,  65,  84,  49, 115,  43,  27,
   87,  54, -58,  21,   6, -82, -45, 108,  53,  85,  52,  90, -19,   5,-114,  41,
   46,  10,  91,  89, -17,  67,  46,  77, -91,   1,  33,   8, -61, -62, 106, -98,
   70,-115, -23, -82,  -9, -66,  28,  78,  10,  83,  57, -94,  56,  74, -46, 110,
   87, -90,  49,  79,  66, -90, -44,-120, -57,  83, -69,-106, -38, -69, 118,-118,
  102,   3,-111, -80, -46, -90, -41,  43,  -5,-101,  -3, -81, 124, 101, -27, -23,
   39,  -5, 103,  94,-104, -19,-105,   8,  -7, -43,  39, -98, -72,  -7, -57, 126,
   20,  44, -64, 117, -35,   1, -33, 116,  88,  39,   0,   1,-125,  16, -64,  30,
   63,  -2, -23, -33,  -8,-115, -45, 127,  -2, -47,  93,  89, -75,  28, -58, -39,
  -35, -69, -71,-112,  66, -59,  66,-122, -64,  66,  79, -52,-114, 112,  50, -88,
   68, 126, 110, -85,   3, -56,  59, -25,-100,   7,   2,   0,  66,  80,  36,-103,
 -118,  84,  18,  40, -34,   8, 120,  71, -54,-106,  16,  13,  38,-126,  44,-115,
  -46, -71,  29,  65,  35, -47,   0, -60,  37,  32,  47,-118, -94,  28,  86,  -4,
  -52, 115,  85,  85, 122,  93, 113,-122,  30,-116,  70, 107,-124, -17,-115, -35,
   52,  70,  89,  54, -10,  85,  97, -13,  73, -79, -39,  43, -57,   3, -59, -96,
   25,  71, -89, -37, -45, -19,-123,  -7,  -3,-121, 111, 103, 115, 115, 121, 127,
  -45,  84, 126, -86,  59, -35, -39, -39, 126, -27,  91,  15, -21, -63,  40,  31,
   22, -92, -99,  47, 125,  -1, -54,  -6,  -7,  51, -25, -42, -82, -82, 125, -38,
  -26,  27, -61, -47, -59, -34,  -6, -54,  96,  48,   0, -25,   1,-120,  11, -32,
  124,  -1,  61, -81, -70,  56, -38,  56, -67, 126, -91,  46, -51,  91, 107, -83,
  -75,-116, -79,  52,  51, -37, -27, -82, -19,  25,  95,   8,  33, -82,  53, -93,
   -4, -51, 114, -88, -64,  58,  21,  90,  51, -70,  53,  90,  66,  24,  93, -42,
  117, -44,-117,  23,  47,  46,  47,  47,  55,-101,  77,  99,  76,  85,  85,  79,
  -99, 126, -26, -23,  99,  79,  78,-123, -15,  63,  -7, -51,  -9,  52, -17, -67,
  -83,  -4, -62,  81,  -2, -37, 127, 122,  96, 109, 125, -77,  93,  14,-123,  25,
    2,  22,-120, -36,  59, -66,  50,  73, -76, -17,   4, -15, -43, -88, -44, -66,
  -20, -82, -28, -30,  76, -17,  89,  41, -61, -69,  14, -18, -68, 121, 111, 119,
  101,  32,-123, -13, -34,-105,   2,  51, -44, 110,  56,  42, -78,-127, -46, -93,
  -27,  -7,  25, -43, -40,  51,  24,  12,  98, -95, -78,  98,  56,  28,  12,  90,
  -19, 118,  89,-106,-114,  -4, -62,  77, 123,  54,  -6,  -3, -92, -35, 108,  45,
   46, -28,  27, -21, 105,  26,  47, -33, 114, 112, 117, 109, -83, -99, -23,  42,
  -81,  24,  99, -99,-103, -23, -18, -36,  60, -92,  17,   8,  78,  28, 113, -49,
   17, -24, -74,  28, -38,-107, -34,  85,  63,  28,  68,  -3,-115, -51, -89,-114,
  -97,  63,  -6,  68, -29,  -7,  11, 122, -46,  11,   3, -45, -10,  86, -91,  44,
  -65, 120,  89,  16,-127, -11, -96,  94,  50, -83,  95, -65,  27,  48, 112, -48,
  -28,  37, -13,  22,  92,   8,  40,-128,  25,   2,-113,  44,-128, -62,-126, -16,
   32, -13, -84, 106,  71,   1,-108,   0,   1,  12, 120, -43,  94,  63,  -3, -52,
  -65,  -2,  63, -49,  -4, -39,  39, -27, 122,  95,  40,-103,  44,  47, -62, -12,
   84,  70,  20,  57,  15, -34,  50,  64,   4,  79, -42,-103, -86,  34, -25,  24,
   80,-114,-114, 123,  64, -29,  56,  49, -63, -72,   5,   2,  37, -62,  70,  82,
  -87,  32, -99, -99,   9, 103, 103, 108,-100, -22,  32,  12,  27, -99, -18, -44,
   92, -77, -47,  46, -69,  29,  87,  84,-108,  77,  40, -53, -11, 120,  84,  78,
 -122, -50,  84,-120, -64, 124,-122,   4,-116,  49, -55,-111,-100, -49, -13, -55,
  104, 115,  48,-103,  76,-102, -89,  86, -83,  16,-108,  36, 124, 118,  42,  92,
   90,  74,-105, 118,   4,  51,  51,  60,  77,-110, -68,  50, -58,  20, 101, -90,
 -117, -46, 123, -53,  24,   3, -14, -50,  57,-119,  94,   9,  89,  79, 109, -22,
   90, 118, -99,  49, -58, -14,  30,  21, -91,  30,  78, -86, 113,  86, 100,-109,
   73, -98,-115, -86,  73,  86,-107,-105, 114, -42,-101, -28,  23,   6,-101,  23,
   38,-109,  75, 101, -79, 106,  76, -33, -39, -62,  -5,  34,  14,-128,  11,  96,
   10, 120, -60, 120,  36, 100,  18,  69,  13,  37, -61,  57,  55, -34, 110, -38,
  -30,  76,  72,  41,-123,  80,   0,  16,  83, -59,  24,   3,-122, -64,-112,  16,
    9, -63, 120, 103,-116,-103,  89,  90, -94, -84,  -4, -24,-121,  -2, 116, 106,
  110, -26,  85, -81, -69, 111, -30, -86, -75, -75, -75,-117, 103, -50,-106, -85,
    5,  55,  62,  11, 108,  56,  27, -65,  85,  54, -33, 114, 122, -29,   0,  -8,
   85,-107,  61,  69, -62,-125,  43,  77, 105,   0,  56,  99, -64,-104, -75, -42,
   95, -37,  40,  40,   6,-104,  11, -62,-101, -10, -20,  92,  88, -34, -63,  19,
 -107,  -7, -86,  57,  98,  76,  73,  75, -66, -78,  70,   1,  15,  42, -97,  95,
  -19, -11,  47,  93,  61,  26,-103,  75,-101, -29, -41, -34, 113, -21,-127, -67,
    7, -99, 115,  55,  31,  56,  32,-124, 120, -26, -23, -29,-115,  31,  -4, -98,
  -80,-105, -97, 127, -15,  -4, -50,  34,  12, 119, -18,-110, 111, 121,  77,  57,
  -56,  24, -79,  69,  87, -23,  36,-120, -90, -38, -20,  -8, -59,  15,  -1, -10,
    7,  62,  -9,  -4,  19,  23, -14,-111, -99,  78, 127, 118, -25,-114,  55, -65,
  -19, 109, -80, -68, -29, -36, -72,  55, -70, -78, 102,-113,  62,  63,  62, 121,
 -118, -92, 117, 101, -24,  67, -33,  37,  88,-127,  -4, -62, -71,  -2, -95, -73,
   -1, -48, -21,  62,  -6,-121, 100,  34, -68,  14, -42, -81, -33, -78,  54, 121,
  110,  43,  43,  48, 100,  76,  24,   4,  11,  82,  48,  16,   0,  20,-119,  18,
   42,  91, -59, -51,  96,   4, -42, -59, 101, -89,  63,  24,  -4, -44, -65, 121,
  -33, 127,  -6,  35,  94,-108,  55, -51, -49,  53, -17,  60,  80, 122,  59, 113,
   20,-115,  38, 115,  44,-103,  72, 109, -83, -75, -58, 122, 107, -99,  49, -50,
  104,  81,  -9, -38,  89, -89,  68, -64, -91,  36,  15, -98, 113,  80,  50, 104,
  -91, -83, -23,  25,  55, -37,  65,  21,  96,  26, -57, -83, -42, -52, -44,  76,
  -38, 104,  11,  30,  90, 107, -14, -25, -98,  44,  38,  89,-111, 103, -24,  44,
  -25,   8,-116,  16, -63,  35,  70,  32, -85,  60,  31,  -9,  54, -54, -11,-127,
   27,-116, 120,  97,   2,  11, 115,   8, -93,  -5, 110, -18, -50,  76, -49,  47,
   44, -74, -38,  83,-114, 112,-100,-107,-125, -75, -43, -47,  -7,  98, 108,  77,
  -67,  66, -38,  91,  35,  24,  11, -92, -30,  72, -24,  28,  43,-116,  35, -56,
  -99, -97,  88, 107, -14, -78,  42, -53, -86,  40, -67, -79, -47, 100, -56,   9,
  -92, -57,-112, -77,  64, -56,  84, -78,  24, -63,   1, -69,  67, -28,  62, -16,
  110, -90,  99, -89, -89,-116,-123,  92, -37,  73,  86,  84,-107, -23, 109, -10,
    6,-123,  94, -75,-109, -85, -52, -82,  72, -40,  80, -40,  31,  65,-114, 110,
   61,  92,-106,  97, -60,   3,-123,-127, 100,  97, -56,  85,   0,  66,  16,  66,
  -96,  26, -58,  59,  33, 120,  16,-122,  40, -72, -11, -50,-111, 103,-116,  41,
   85, -99, 124,  -6, -87,-118,  10,  38, -23, -40, -47,  47, -11, 122, 107, -62,
  120,  40, -12, -37, -25,-109,  -3, -13, -69,  22,-100, -86, -98, 123, 113,  94,
   79,  90,  49,  59,-109, -28,  39, -99, 105, 108, -38,  93, -53, -69,  23,  22,
   22, 100,  16,  16,  81, -87, -85, -70,-107,  54,-105,  16,   1, 111, -85,  96,
   54, 109, -92, 113,  68,  72, -61,  60, -13,  85,  57,   2,  15,-106,  17, 108,
  -59,  54, -58, -21, -66, -50,  86, -85,  49,  85, 102, 119,  35, -40, -67, 127,
  -49, -20, -95, 125,  25,  64,  54, -73, -32,  25, -13, -36,  31,  90, 124,  13,
  -65, 123,  97, 127,  59, -52, -56, -59,-103, -59, -71,-103,  76,-113,  19,  22,
   64,  55,-108,-103,  -3, -24, -69, 126, -11,  31,  -2, -34, -81, 111,  42,-104,
   18, -72,   1,  52, -77, -42,  -1, -79,  94,  -1, -65,  61, -10, -36,  59, 119,
  -66,  82, -58, 116, 113, -68,  50,  80,  38,  22, -76, -73,  12,  46,  74,   4,
  -16,   6,  64,   0,-105,-120,  60,  77,   0,  25,-118, -65,  93,  54,  96,  68,
 -123,  82,  65,   8,  12,  74, -77, -75,  59,  18,   0,  25, -48,  10,  84,   4,
 -127,  14,-128, -86, -86, -68, -70,  -2, 127, 127, -16, -95,  95,  -2, -19,  81,
  111, -27,-127,  91, 110,   7,   5,  58, -92,-127,  47,  43,  70,   1,  48, -56,
   42,  70,  96,  96,  82,  85,  85, -35, -10,  38,  25, 114,-122,  64, -34, -23,
   10,  29,  35, 114,-122,  11,  30, -57,  97, -89,  35,-102,  45, -34, 110, -54,
  118,  27, -90,  27,  50,  80,  50,-118, 101,  20, 114, -50,   7,-101, -67, -63,
   -6, -26,  96,  48, -72,-119,  52,  71,  47,   2,   6, -79,-112,-106, -60,  70,
  -58,  86,-122, 124,-112, -97,  93, -39,  36,-114,  62,  16,-112,   4, 106, -57,
   84, -70,  48,  59, -77, 107, -95,  53, -35, -19,  51,  48, 101, -75,  54,  30,
   95,  90,  89, -91, -68,   2, 109,-103,  39, -18, -63, -70,-118,  35,   6,   4,
  -32,  29,   3,  16,-124, -42,  24, -83, 117,  53,  41, -75, -42,  85,  81, -38,
  -78, -14, -58,  50,   2,  14, -56,   0,  -5,  51,   9,  39,  47,   8,  25,  17,
  -93, -54, 107, 111, -55,  58, -14,  41,  85, -34,  58, 116,  94,  56, -90,-128,
 -123,  40,-101, -56, 120,  16, -52, -18,  93, 100,-128,   2,  56, 115,-124,-122,
   72,  91, 116,  30,  60,  94, -50,  47, -40,  28, 115, -85,  71, -82,  42,-119,
  -76,  68, -61,-104,  37, 127,  57,  89, -82, -86,  74,  72, -39, -18, 118, -62,
   48,  52, 126,  43, -89,  54, 106,  -6,  59,-118,  65, -68, 123, -31, -66,  91,
  111, -85,-122,-109, -10, -98,   3, -13,  81, -77, -55,-108,  95,  59,  97, 118,
  -50, -28, -42, -98, -70, -28, 123,-125, -15, -23,  16,-118,  12, 110,  46, -31,
  -26, -41, -35,  53,  59,  59,  27, -88, 104,  50,-103, 104, -83, 121, -93,  37,
  -25, -89,-107,  82, 125,  44, -87,  50,  92,  59,  97,  49, -97,-116, -13, -78,
   50,  72,  50,  12,  56, -85,  42, -21,  44,  35, -39, 104,  69, -77, 115,  81,
  -85,  21,  59, -33, -50,-118,  55, -82,-106, -76,  52,  19,  28,  57, -24,  15,
  -18,  18, -99, 118,  26, -73,  -7, -48, -78,  75, 107,-100, -90, -78, -80,  99,
   29, -17,  87,-125,  69,  98, 106, -93, -65,  18, 103, 123,  93, 106,  87, -32,
   87,  -2, -69, -97,  -3, -75,  79,  -2, 105, -58,   1,  66, -71, -31,  76, -24,
  113,  93,  49,  96, -18, -67, -91,-113,  46, -98,  -4,  71,  51,  75, -53, -87,
   28,  90,  27,  67,  60,  74,   3, -43,-114,  77,  62, -42,  89, -63, -75, -29,
  -56,-110,-123,  89,   0, -26, -23, 107, -10,-119,  -5, -70,  97,  13, -72, -80,
  -34,   4,  44,  64,  37, -63,-126, 113,  14,   3, -82,   1,  38,   0,  51, -24,
 -127,  87,  47,  -2,  -5,  15,  60,  -2,  63,  -1, -21, -48,  79, 104,  86, -36,
   -9,-102,  91,  86,  43,  10,  36, -57, -68,-112,-109,  76,  50, 100,-116,-107,
 -107, -66, -30,  38,   1,  -9, -62,  57,  94, 111,  95,  75, -32, -82, -83,  67,
   15,  26, -51,  48, 109, -80,  36, -59,  52, 101, -83,  22, 107,  53, 101, -69,
   21, 116,  58,  74,  74, -25,  92,  85,-108, -29,  -2, -64,  20,  37,  85,  21,
  -13, -44,  34, -22,-119,  97, 100, 120,  99,  83,-101,-107,  97,  -1, -54,  -6,
   96,  60,  54,-128,  44,  82, -45, -73,  31, 110, 118, -38, -35, -39,-103, -80,
  -99, 104, -92,  65,  49, -71,  48, -34,  40, 122,-105, -25,   6,  92, -21,  74,
   87,   5,  89,-125,-116,  24,  16,-110,  47, -99,  11, -47,  57,-113, -50,  88,
  -93,  53, 105, -21, -83,  53,-107, -43,  90, -69, -38, -59, -28,  76,   6,  50,
  108, -90,  97,  24,  74,  41,  81, -16,  92,  72,  68,-108, -56,   4,   2,  67,
    4, -40, -22,-101,  25,  69, -51, -83, -35,  74, -64,  91,-124,   2, -64, 123,
  -21, -67,  71,  36,   4, -49,   8,  56, 121,  14,  32,   0,   5,  16,   0,  44,
  -63,  43, -55,-111,  41,  74,  91,  84,  96,-119, 121,  96,  14, -55, -71, -22,
  -54, -15, -36, -27, -28,  33,  25,  89,  89,  72, -17, -67,-108,  50, 117, 105,
   94,  37,  81, 107, 105, -88, -41,  22, 116,  53,-120,  61,  75, -95, -44, -21,
 -103, 117, 124, -70, -45,  51, -27,  96, 125, -45, 113,-114, -19, 116,   2,  25,
   51, -76,  43, 104,-120, -64,-113, -77, -51, -11,-115, -85,  89,  86,  32,  50,
   41,  37,   2,  71,  68,-115,-122,  35,  15,-104,  50,  76,  89,  68,  19,  71,
   34,-118, 101,-110, -92, -35,  40, 110, -74, -62,  70, -37,-122,  65,  46,   4,
  -21, -74, -25,-106, 119, 117,  22, 119,-116, 111,-102,  77,  33, -76,-109,   9,
  109,  22, 124, 108, 121,  31, -64, -55,  70,  56, -45, -49,  -6, 101,  99,  90,
   21,  85, 119, 109, -67,  90, -65, 120, -26, -47,  71, -20, -15, -77,-109, 115,
  -27,  -1, 116, -23, -20,  71,-122, -89,  50,   6, -64, 112,  39,  52, -99, -43,
  -61,  22, -57, -31,   8,  32,  46, 103,  -3,  -5, -41, -14,  -7, -63, -23, -17,
 -113, 119, 120,  11,  47, 118,-125, -81, -50,  52, 110,  30,-116,  27, -32,  65,
  -94, -54,   8,  60,  36,  59,  23,  74, -14, -30, 111,   9,  43, -77,  38,  17,
   10,  44,  84, -38, -15,-104,  59, -59,  29,  -8,  18,-118,  89,  95, -63, 104,
  -14, -69, -81, 126, 107, -13,-123,  23,-106, 119, -17,  46,  48,  72,  36, 126,
  117, -27,  50,-124, 105, -86,  85, 100,  48, -48, 100,  39,  25, 113,-110,-111,
  -88,   4, -24, -68, -32,  66,  10,  41,  60, -78, -46,  58,   2,-120,-110,  70,
  -46, 104, -40, -76,  73, 113, -28, -30,-120, -73,-101, -47, -20,  28,  75,  82,
   43,  -8,   4,  44, -17,-115,  77,  81, -22,  44, -13,  85,  41,  61,  73, 114,
    8, -64,-127,   6, -21, -67, -31,  96,-108, -11,   6, 100,  33, -99,-103,  94,
  -70, -11,  80, 119,  -1, -82,  96, -70,  91, -26,  89,  85,  20, -67,  97, -81,
  -70, 120, -42, 100,   5, -41,  38, -12,-112,  32,  51, -61,  74,  10,  17,  48,
  112,  96, -84, -85, -84,  55, -56,  64, 113,-100,  12,  -6, -34,-125,  49, -58,
  106,-121, -56,  66, -87,  36,  87,  42,   8, 124,-110,  32, 103,  40,   5,   6,
 -110,  66, 105,   2, 105,  36,   7,  68, -98, 116,  17, -47,  35,  58,  32,  15,
  -64, -56,  35,   1,  67,-100,  93,  47,-116,  49, -91,  41,  43,  83,  90, -78,
  -60,  28,  34,   2,  35,  67,-118,-116,  22, -98,  98,  33,  66, -58, -54, -47,
  -24, -22, -27,  43,  27, -85, 107, -83, -46, -85,  52,  14, -90,  58,  98, -74,
   29, -50,  79, -53, -23,  22, -91,-127,  69, -42, -19, -33,  71,  69,  81, 100,
   -7, -56, 110, -83,-106, -27,-100,  15, -92,  28,  39,-115, -82,-116, -98, -33,
  -24, 111, 120,-106, -52, -52,-105, -34, -22,-118,  37, -95,  60, -83, -54, -87,
   74, -62, -96,  55,  27, 117, -90,  67, -39, -80,  99,  19,  24,-114,   1,  85,
  -90,  42, -84, -79,  78, 114, -87,-126,   8,  24, 119,-106,-128,  51, -80, -64,
  -61,-112,  69,   9, -88,  72,  38, 105, -38, -23,  68, -19,  46,-113,  67, -96,
  -64,  51, -44, -83,  70,  58,  63,  63, -69,  99,   7, -75,-109,-116, -29,  21,
  -96, -24,-119, 124,-116, 121,-111,-115,  81,-112,-118, -91, 108, -85, 120,  42,
  -99,-108,  65, -10, -39, -93, -43,-125,  47,-100,  -7, -52, -47, -24,-117, -57,
  122, -61,  51, -72, -79, 121,-112, 117,  62, 100,  70, 127,  97, -35,-120, -61,
   29,  -5,  -9, -36, 115, -28,  53,  -9,  63, -16,   6, 108,  36,  71, -97, 123,
   -6, -63,  63,  -2, -16, -79, -77,  47, -50, -84, 121, -61, -31, -39, -40,  -1,
   68,  78,-105, -70, -63,  -1,  19, 110,  94,  57, -69,  33,   7,-101,   7,-101,
   83, -83,  40,  16, -58,  91, 112, -55, -34, -99,  30, -71,  -8, -38,  13,  52,
  -66, 110,  88,  37, -42,  53,  38,  96,  17,  -9,   0,  -7, 100, -83,  27,-121,
 -119, -43, -97,  -3,  71,  63, -75, -10, -57, 127, -67,  39,  80, -45,  -9, -33,
   49, -56,   6, -64,  26,  27, -42, -52, -39, -59, -47, 120, 125,  88,-114,  -5,
 -114,  82,  30,-124,-126, -59,  12,  37,  99,  46,  31,  23, -42,   3,-127,   0,
   80, 113,  18, -91,  77,  30,-124,  65,  20,   6,  81,  98,-102,  13, -98,  38,
   42,  77, 101,  51,   9, -45, -60, 122,  91, 110, -12,-117, -94,-112,  27,  99,
  -12, -92,-120,  36,  33,  25, -99,-115,  71, -93, -47, -88, -88,-118,   6, -60,
   98, -70,  57, 123, -33, -66, 104, -41,  66, -36, 108,  96, -82,   7,  87, -42,
  -77, -89,  79,  86, -93,-115, 107, 125, -94,   4,-100,   1, 108,  45, -84,  75,
  120,-124,  26, -56,  59, -80, -58, -21,-126,-116,   1, 107, -22,  93,  36,  25,
   99,  12, -71,  10,   3, -90,-108,  10,  99,  46,   3,  68, 110,  61, 103,  82,
   96,  32,  89, -88,  32,  82,  44,  14, 120, -88,  80,-118, 112,-120,-114, 124,
  101,-115,  49,-107, -87,  42, -99,  23, -74, -84, -56,  88, -43,  10,  25,  99,
 -127, 100,  42,-120,  99,   4,  36,  79, -50,-125, -73, -60,-110,-118, -86, -54,
   86,  21, 103,  16,-122, -68,-111,  54, 102, -70, -78,  44, -85,  78,  71,  72,
  -59,  85, -56,-123,  64, -95,-120, 115, -12,-124, -58,  79,  34, 111, 101, 106,
  100,  81,  21,  37,  17,  41,  33,-119, 115,  13, -48,  98,  62,  65,-120, -91,
  112,  86,  91, 112,  57, 105,-120,  89, -26, -35,-110,-115,  58, -29, 114,  99,
  115,  92, 113, 107,  93, -98,  20, -91, -28,  74, -91,   2,-115, 100,-100,  41,
   33,  28, 103,  36,  66,-110,  50, -98, 110, -74, -69,  83, -40,  12,  69,  24,
   58,  41, -83,-112,-108,  36, -47,  84,  55, 108, -73,-104,  10, -14,  29,  11,
 -126, 113,-123,-110,  59,  42,  11,  11,  87,  39, -95, -93,  20,-104,  84,  13,
   23, -78, 112, -66, -83,  26, -62, -11, -42,-122,  71, -97,  92,  -1, -22, -77,
   23, -66,  -6, -76,  -1, -54,  23, -91,  83,  23, -53,  65,  51,  37, -43, 118,
 -121, -10, -50, -84,-113, -28, -49,  94, -34, -52, -38, -16,-114,-125, 119, -68,
  -11,   7, -34,  49, -35, 108,  63,  -4,  -8, -61,  79, -97, 123, -31, -50, -18,
  -18,  55,  -2, -48,  -9, -59,  95,  61, 118, -30, -45,  95,  26,  32,  60, -63,
  -32, -40, -88,  63, -45,-100,  58,  60, 102, 119, -23, -10, -82,-103,  96,-106,
    7, -24,  13,  77,  74,   3, -48, -36, -73, -69,   2,   8,  75,  96, -55, -33,
    2,  86, -32, -36,  90, -49,   5, -77, -58,  70, -52, 119, -71,-126,  39, -98,
   -5, -61, -97,  -6,-103, -39, -93, -49,  47, -33, -66,  63,  47,-122, -59,  -7,
  -13,  54,  21,  99,  70,  51,  20, -29, -88,-102,  15, -62,  77, -28,  27,  69,
   89, -94,  39, -14,  94,  59,  37, -72,  65,  23,  53,  90,  30,  25,  87,-127,
   76,  19,  17, -91,  24,   4, -96,-108,-109,  65, 107, 110,  71, -69, -45,-111,
 -127,  44, -85, 124, 114, -27,  74, -66, -71, -23, -78,  92,   1,  74,  36, 107,
   76,  85, -24,  66,  27, -83, -75, 113,-106,  73, -47, -20,  54,  91, -73, -66,
  -94,  17, -58, -46, -71, -31, -23,  11,  23,  46,  93, -50,  71, -61,  64, -16,
   48,  12,  65,  74, -17, -76, -45, -58,  91, -57, -55,  35,-128,  32,  18,   0,
   19, -52,  76, -91, -99,  54,-100,  72, 113, -95,-112,  51,   0, -16, -60,  68,
  -64, -91,   2,  33,  60,  23, -96,  66,  19,   6,  86,  42,  71,-104,  76,  47,
 -124,  97,  24,  37, -79,  80, -46,   2,  85, -42,  88, -17, -56, -61, 102, -20,
   81,  40,  30,  54, -61,  80, -74,  85, -96,-112,  75, -25, -48,  -7,  17,  -9,
  -34,  90,  93,  86,  78,  27, 109,  29,   7,  20,-116,  11, -58, -68,   3,-119,
  -40,  64,  36,-122,  68,   4,  12,  21,  98,  27,  49,   2,  68,   2, 111, -55,
   84,-107, -81,  28,  57, -17, -83,  99,-114, 114, -22, -43, -67,  16,  74, 121,
 -127,  76,   9, -30, -24, -68,  -9,  27,  97,  65,  76,  37,  59,  98,  93,  12,
  -61,-100,   2,  99, -92, 117, -43, 104, -30, -30, -23,-115, -43,  -2,  96,  60,
  116,  17,   0,  49,  22, -57, -82, -39, -64, -27,  29, -59,   4, -45, 118,  39,
  105, -75,  68,-110,  66,-110,  66,  16,   6,-115,  70, -38, -18, -12, -53,-116,
   53,-102,-115, -87, 118, -36, 106,-119,  36, -63,  32,   0,-122,  30,  88, 103,
  -59,-111, -45,  67,-104,  84,  33, -14,  70,  24, -51,  52,  84,  32, -64,  19,
  -50,  45,  11,-128,  23, -34, -13, -85, -29, -29, -49,  -9, -98, 120, -70,  60,
  127,  37, 114,-106,  59, 119,  53, -99,  44,  97,  99, -70,-107,  68, -87, -37,
   81,  25, -58, -93,  63, -56, -57,  89,  83, -36, -71,  -5, -90, 123, 127,  -8,
   29,  79, 127, -31, -40, 123,  63,  -2, 113,   1, -80,   0, -16,  37, 120, -20,
  -90,-101, 118, -65,  -7,-127, -41, -98,-102,  57,  13,  89, -17, -68,  -9, -57,
   27,  -8, -74, -68,  -6,  17, -57,  40,  80,  87, -91,  11, 114,  59,  40,  70,
 -111, -83,  56, -86, -58, -51, 123,  71, -96, -40, -41, -18, -10, -14, 117, -89,
  -82, 114,  48,   2, -92,  35,  80,   8,  92,  87, -97,  -4,-123,  95, -72, -16,
   71,  31, -38,  53, -56, -14, -37, 119, -75,  50, -35, 102, -92,  77,  46,   9,
  -96, -12,  90, 123, -17, -48, -64, -48,  72,  57, -86,-100,  68,-107,  48,-114,
  -52,  67,   3,  51, -82,  83, -45,   8, -29,  68,  36,  49,-119, -96,  34,  66,
   21, -74, -89, 103,  58,  51, -77, -94,  59,  51,  30,  15, -81, -82,  92, -98,
   12,  -6,  49,  80,   3,  80,-106,  37,-106, 102,  20,  91,  83,  86,  96,  72,
  -95,  16,  74,  66,  24,-118,  56,  22, 113,-104,  95,  29, 121,  93, -71,  44,
   -9, 101,  46,  56,   4,  18,  29,  56, 109,  53, -93,   8,  17,  25,  67,   6,
   64, -50,  90, 107, -63, 121,   2, -25,  29,   0, 103, -64, -48,  35, 120,   4,
  -28,  82,  40, -55, -92,  96,  82, -94, -32,  36,  36,-123,  81, -40, 106,  55,
  102, 102, -46, 110,  87,  70, -15, -70,  20,-127,  84,-127,-108, -32, -55,  85,
  -38,  84,  26,-100, 103,-128,  77, -49,  61,-111,  97, 100, -55, 122,  99,  77,
 -106, -23, -31,  68,  23,  37,  47, 123,  30,-127,-128,  57,  68, -57, -64,  35,
   35, -28, -64,  80, -22, -55,  86, 121,-107,   9, -50,   5, -31,  86, -98, -33,
   10,  83, -17,  78, -32,-100,   3, -73,  53,  22, -34,   3,  33,-121, -70, -95,
 -110,   0,  60,-111, 117, -42,  24, 107,  45,  35,  22, 104, -14, 121, -34,  31,
   13,  59, -69, -25,  51, -89, -99, -47,  18,  89, -53, -88,-100,  74, -83, -68,
   11,  89,  24,  37, 115,  11, -69, -76,  19,  65, -77,  93,   8,  31,  54,  18,
   30, -89,  46,-114, -62, -18,-108, -22, 116, 120,-102, -56,  48,-118, 100, -84,
 -115, -87, -68, -75, -50,-107,  70, -37, -54, 114, 100,  65,  16, -72, 118,  18,
 -121,  65, -84,-124, -88,  74, 123, 117, 125, -13, -71,  83,  87,-114,  29,  95,
   59,  -3, -30,  91,  62, -15,  17,   0,  -8, -53,  68, -90,  66,  40,  37,  43,
  -31,  75, -23, -99, -30,  80, -30, 108,  58,  87, 121,  99, 112, 124, 115,-114,
   79,   4, -47,  15, -97, -71, -76, 115, -22,  -2, 127, -10, -82, -73, 124, -32,
   47,  -2, -61,  83,  39, -97,  -5,-119, -73,  -3, -16, -85, -18, 124, -43,  11,
 -125, -43,-121,  62,  -2, -87, -25, -97, 122, 102, -17,  29, 123,  14, -37, -91,
   -1, 120,  -4,  73,  14, -61, -97, 111,  71,  -9,  42,   3, -83, -56,-116,  93,
    9, -47, -84, -59,   9, -85, -46, -75, -14,   9,-114,  63, 109, -81, -84,  65,
  115, -74,-108, -41, -81, 110,  -3,  47, -61, -22,   1,   0, -84, -73, 117,  66,
  -70,-100, 100,  97, -38, 112,-114,  56, -14, -54,  90, -91,  38,  56, -71, -14,
  -55,  31,  -3, -55, -20,-109,-113,  45, -17, -39, 117, 121,  33,-100,  30,  25,
   99,-116, -81,  11, -33, -42,  89, 107,  25,   1,  99, -52, -25,  21,  17,   1,
  -29, -60,  25,  19,-100, -87,-128,  75, -63,  57,-121,  72,  48,  38, -72,   8,
  -76,  67,  31, -58,-117, -73, -36, -46, -39, -67, 107, 100, -12, -28,  -8,-105,
   77,  85,-103, -68, -12, -58, 114,  15,-100,-128,-100,   7, -25,-117, 114,  82,
   87, 118, -22,  14, -27,  58, -51, 100, -83,  69, -80, -11, 118,  58,  68,   4,
   68, 117,-127, -98,-120, 124, -60, -72,  37, -90,  29,  26,   7,  14,  28,  17,
   49, -18,  57,  10,  39,  61,  67,  47,   1,   3,   9,-118, -93, -32, -56,-127,
  115, -18,  26,  75,  97, -69,  41,  59, 109, -39, 105,  69, -35, 110, -46, 106,
  115, -32,  85, 105, -80,  24,-128, 119, -82,  42, -85,  44,  43,  39,  67,  87,
 -107,  12, -67, -28,  60, -52, -75, 115, -50,  22,  85,  57, -55,-118, -47, -60,
  105, -61,   1,  37,  23,  62, -76,-124,  88,  57, 111,-112, -87,  32,  65,  46,
   16, 101,  16,   4,-100,  35, -29, -46,  74, -26,  56,   7,-119,-110,  33, -73,
 -106, -54,  66, -80,-112,-120, -64,-109,  -9, -42,-109,   3, -25, -67, -73,  68,
   20,   4,  17, 105,  11, 117, -46,   0, -64,  51, -84,  24,  25, -16,  74, -79,
  -48, -48,  64,  87, -55, -64, -88,-123,  41, -20,  77,  76,  18,  38,  50,  40,
  118,  77,   5,  81,  18, -76,  90,  44,  78, 125,  16,  99,-108, -88, -76,  33,
  -93,-104,-110, -92,  49, -43,  81, -19,  70, -59, -96,  34,   7,  30, -99,  54,
  -74, -84, 120, 127,  28, -60,  17,  11,  21,   8,  41, -30,  48,  74,  26,-124,
 -128,-117,  59,  -2,   6,   5, 127, -35,  14, 120, -87,  57, -64, -33,  41,   9,
    0, -66, -76, 119,-121,  19,  88, 122, -21,  25,-110,  96, -58,  90, -87, -59,
 -116, -94,  53, -21,  59,-125, -20, -82, -71,  61, 123,  47, -99, -68,  96,  91,
   -1, -22,  31, -68,  -7,  11, -49,  93,  -2, -14,-105, -65,  -4, -87,  79, 125,
  -54,  90,  -5, -20, -77, -49,  10,  33, -10, -20, -39, -13, -50, 119, -66, 115,
  125, 109, -11,-127, -69, -33, -16, -24, -87, -89,  76, -65,  -1,  63, -76, -94,
  -17, 111, 117,  18, -26, -64, 121, 109,-108, -83,  54, -57,  50,  31,  -9, -96,
  -99,  46,  -3, -35, -51, -89,  11, -42,-114,   8, -81, 111,  14,  -8,  47, -61,
  -86,  65,  -5, -54,-121,-127,   5,  29,   2,  23,-124,   0, -52,   3,  32,   2,
   66,   1,  79,  29,  -1,-117,  55,  -1,   8, 110, -84,-119, -37, 118, -56,  40,
 -100,  89,  55,  19, -38, -22, 126, 103,   4, -11,  58, 119, -17,  28,  34,  10,
    7, -64,  16,-112,   3, 103,  32, -71,-112,-127,  12,  20,  19,  66,  74,-107,
   91, -21, -61,  32, -20, 118, 102,  22,-105,  58,  83,  51,  27,  27,-101, -49,
   63,  -5, 124,-109, 101,  91, -74, -60,  88, -46,  22, -84,   3,  79, -24,-119,
  -15,-105, -82, -77, -18,  -8, 116,  91,-101,  74, -22, -83, -14,  15,  50,  68,
   68, -65, -43, -76,  95,-128,   1, -21, -72,  35,-123,  82,  74, -23,  25, -41,
  -28,-116, 119, 101,  34,  27,  65, -46, -28,  33,  -9, -52,  16, -93,  40,-112,
  -45,  29, -39,  74,  41, 109,  54, -70, -19, -88, -35,  98,  82, 120,  15, -50,
  120, -99,  21, -27,  36, -85, -42, -41, -83,  53, -74,  42, -55, 104, 114,  21,
   56,   7, -42, 120, 111, -35, -92, 112, -50,  57,  99,-111,-120, -41,  77,  28,
 -116,  35,  98,  65, -93,  72,   5, -36,-128, -45,  46,  12, -30,  48,-114,  89,
   16, -94,  18, -70,  17,-124,  34,-112,  40,  11, -60,  17,  57,  67,  32,  61,
   72,   7,  99,  59,  65,   2, -26,-119,-109,  71,  71,-100, -74, -74, -81,-102,
   80, -91,-112,  11,  64, 111, -99, -74,  70,  35,-111, -28, -88,   4,  99, -84,
  -87, -94,  42,  13,  77, 111,  20, -33, -78,  87, 106, -48, -77, -83, 102, -46,
  -48,  73,  87, -58,  97, -38, -22,   6, -83, -90,  72,-101,  44,  12,  65,  73,
  -30,  34,   7,  82,-107,-125, -63,-104,   6,-103, 116,  16, -58,-127,-120,  67,
   39,  24,  91,-104, -14,  96, -99,  45, 105,  50, -80,-105, -82, 100,  79,  63,
  -73, -15,  -8,  83,-125,  83, 103, -15, -14, -91, -41, -82, -81,   2, -64, -57,
   69,  16,  52,  18, -98,-124,  70, -32,-101, -49,  93,  -2, -44,  -2,-123,  55,
  -65, 112,  21,   0,  62, -65, 119,   7, 103,  44, -28, -46, 106,-109,-115, -57,
   90,  96,  39,  73,-122, 101, -74, 108,  88,  53, -67, -16,-102, -25, -98, 107,
  -20, -67,  -7, -18,  -7, -28,-111, 103, -50,  -4, -46,  47,  -3, -46,  99,-113,
   61, -10,-111,-113, 124, -60,  57,  55,  53,  53, 117, -17, -67,  -9, -66, -31,
   13, 111,  -8, 103,  -1, -53,  63, 109, -53,  22, -52, -92, -39, -27, -13, -17,
   12, -28,  27,-123,-102,  73,   2, -14, -34,  -6,  40,  96, 101, -63, -53, -15,
 -107,  66, -66, -30, -82, -73,  61,  -3, -96,-122,  84, 121,  -8, -81, -21,  13,
  -32, -60,  85, -32,   1,-100, 118,-116, 113,  96, -52, 122, -21,-124,  64,  24,
   76, -34,  -5, -25, 127,  -3,-113, 127, -18, -32, -14, -68, -66, 121, 119,  12,
  114, -13, -46,  96,  21, 124, -52,-120,-100,   3,  34,   7,   0, -50,-109, -87,
  -89,  93,   0,  41,-103, -32, -56,  37, -37, -34,  62, -68, -98,  -2,  12,  99,
   65, -44,  90,-100, -97, -34, -67, -88, -75,  62, -15, -60,  87,-118, -85, -67,
  -82, 103, -91, -88,  24,   1,  18, -44,  29, -91,  53, -84,-116, -64, -53,-105,
   86,-113,  92,-101,  43,  61,  17,  49,  34,  70,-124, -28,   9, -68,  39, 122,
  105,  75,  84, -50,  56,  32,  34, -45,   0, -38,  59,  46,  24,-113, -45,  32,
   80,  77,  36,  79,-104,   1,  65,  35,  74,-105,  22,-101, -53, -53, 106, 118,
  -58,   5, -86,  81, 102,-120,  88,  21, 101, 127, -19,  74, -66,  49, -80,-109,
 -119,  31,  23, -70, -56,  19,  80, -18,  -1,  35, -19, -67, -61,  36,  61, -85,
   43, -15, 115, -33, -16,-123, -54, -99, -89,  39,  75,  51,  35, 105,-108,  38,
   72,  72,   8, -95,   0,  66,-128,  36,-124,  16,  65, -58,   6,   4,-113, -67,
  -80,  60,  56, 109,   0,   3,  63, -81,  97,  89,  48, -63,  11,  56,-128,  97,
  109,  48, -58,-128, -63,  43, -94,  81,  64,  89,   2,   9,  69,  20,  70, 105,
   70,-102, -40,-109,  58,  87,  87,  -4, -46,  27, -18, -17,-113, -22,  25,-124,
 -115, 108,  61, -21,  -2, -89,  -5, -87, -86, -82,  -6, -62, -87, 123, -17, 123,
  -33, 115, -49,  49, -71,  53,   5,  57,  11, -17, -56,  89, 111,-115,  51,  54,
  119,  86,   8, -95, -12,  96,  90,  80,  56,  -8, -52,  22, -50,  57,  39, -91,
   42, -59, -88,-122,  94,  80,  87,  82,  87, 105,  25, -56,  48,  12, -30, -88,
  -38,  -9, -50, -38,-126,  82, -93,  50, -93,-115,   3,  17,  43,  81,-122, 125,
  -34, -76,-116, 103, -64,  15, 104,-121,  20,-109,  14, 100,  16, 104,  33,   2,
   41,  68,  28,  68, -75,  74,  80,-118,  49,  84, -91, -52, 103, -91,  96, 110,
  -17,-111,-111,-105,-100,  83,-106, 113,  49,  86, -85,-106, -86,-115, -54,  58,
   48,-125, -39,  58,  91,  20,  69, -66,-108, -25, 121, -41,  24,  55,  28,-105,
   88,   9,  17,  69, -91, -41,-100,  51, -72, 110, -99,  61,-113, -10,-109, 118,
  112, -25,-125, -77, -49, -19,  61,  -8, -24,-114, -41,  94, 127,  11,  54, -93,
  113, -23,-101,  30,  41,-117,  48,  80,  38,  90,  14, 101, -61, 107,-121, -67,
    3,  67,  70,  74,   3, -16, -68,  60, 104, -54, -92, -45,  36, 115, -28,  53,
    9,  41,  66, -31, -70, -67,  44, -82,   9,  61,  90,  46,  -1, -81, -87, 125,
   28, -46,  41, 107,  71, -98, -34, -67, -17,-117,  95,  -4, -30, -83, -73, -34,
   -6, -99, -17, 124,-121, -63, -11,  90, 125, -45, -90,  77, -91,  82, -23, -86,
  -85, -82, -70,  -5, -34, -69, 111,  -8, -65, -41,-113, -82,  29,  77,  36,-110,
  -36,  24,-110,  34, -44,  62,  55,-106, 124,  36,  20, 103, -52,  30, -15, -53,
  -73,   1, -14, -72, -31, -47, -65,  15, -42, -82, 116, -38,  -5, -96,  64,  36,
   99,  16,-100, -55,  84, -96,-108,  73,  23, -66,  -4, -73, -33,  -2,  -8, 103,
  -50,  57,  99, -99, -27, -68,  92,-114, 123, -51,  22,  25, -41,   8,  66, -21,
   51, 103, -99, 115,  14, -98, -67,  -9, -20, -67,   0,  73,  41,-103,  32,-124,
   80,  90, -77,  18,  32, 114,   0, -77, 103,  15, -60, -63, -40, -28, -72,  42,
  -59, 115,   7, -90,  58, -51,  69, -77, -44, -42, 105,  17,-112,  34, -95,-116,
   49, -74,  40, -32,  89,-109,  16,  32,  38, -80, 115,-100,  57,  48, -61, 123,
   58,  38,  70,  34,-119,   0,-110,  66, 122, 102, 111, -84,  57, -90, -67,  51,
  -32,-104,  70,  74,  15, -62, -71, -48,  10,  97,  40, -76, 114,  74,  22,-124,
 -104, -53, 114, -72, -94,  87,-114,-122, -21,  38,-121, -41, -82, -83, -44, -22,
   89,  59,  89,-102, 111, -26,-121,  15, -25,  -3,  94, 119, -87, -39, 111,  46,
  -55,  60,-117,  65,   1,  67,  89,  99, 115,   0,  94, 120, -17,   6, 125,   3,
  -21,  64,  94,  48, -86, 113,  72,  68,  30, -34, -26,  73, -22,  44,  19,  72,
   43, -83, -11, -72,-102, -52,  10,  46,  36, -95,  20, -86,  48,  80,  76, 101,
   14,  26,  40,  29, -76,-108,-125, -99,  -9, -43, -84, -88, 119,  10,  50, -90,
   21, -53,  78, -88,  38,  83, -80,  32, -42,-127,  15,  21,  66,-115,  56, -96,
   48,-128,-106,  43,  26, -21, -91,-108,  42, -48,  66,  41,-118, -76,   8, -76,
   12,   3, -87,  85,   1, -95,  44,  55,  38,  39,-124,  60, 112, -30, -74,  11,
  -32, 116,  42,  45,  59,  44,  45, -75,-122, -50, -37,  54, -72, -93,  10, -16,
   83, -49,  85,  75, -95,  10,-107, -53,  51,  57, -74, -31,  -7, 119, -10,  23,
   -1, -23, -65,  -9, -90,-114,  52, -90, 118,  91,   9,  21,   7, -73,  77, -44,
   46, -99, -19, -36, -66, 110, 101, 117, 108,  85,  32, -43,  81,-103,  12,  94,
  -42, -46,  14, 100, -56,  89, -31,  24,-128, -50,-105,  99,  68,  55,  73, -68,
   36,  87,  14,  -6, -32,  54, -37,  73, -17, 115,  47,  98,-120,-124, -59,  -1,
  -19, 103,  99,  39, -84,  41, -70,-117, 107,  54,-100, 122, -11, -43,  87, 127,
  -23,  75,  95,  26,-116,-117, -75,  59, -19, -71, -71, -71, 115, -49,  61,  -9,
  -74, -37, 110,  91, -77, 126, -99,   7,-102, -19,-106,  84,  96,-121, -72,  92,
  114, -20, -83, 119,  70,-112,  -9,  48,-119,  73,-128,  45,  87,  95, -26,  89,
  120, 103, -16, -85, -34,-100,  -1,  86,  55,  32,  34,   9,  16,   4,  -6,  62,
   45,-121, -64, -52, -20,  35, 127,  -5,-115, 125,  -1, -13,  35, 121, 104,  31,
  107,  21, 103,  79, -82, 111, -51,  45, 116,   3, -90,-112, -58,  13,  -9, 109,
   62,  72, -53,-125, 116,  44, -91,  84,  66, 106, -83,  11, -14, -92, -28,  96,
    8,-128, -63,  16,  36, -76,  82,  74, -47, 104, -75,  96, -41, -38, 119, -88,
   51,  63,  27, -64,-105,-107, 100, -14, -87, -21,  81,  22, 114,  97, -68,  49,
  -60, -16,  36,  32,   4,-104, -99, 115, -34,  91,  60,  79,  29,  -4,  -8, -28,
  -86, -51,  29,  19,-104, 121,  64, 121,  17,  90,  41, -83, -75, -42, -20,  32,
  -61,  72,  68,-127,  83, 100,   0,  31, -86,  82, -91,  22,-105,  75, -68, 106,
   99, 117, 116,  56, 108,-108,  10,-105,  -9, -10,  78, 117, -25,-105,  -4, 108,
  -45,  46, -74,  19,  91, 120, 103, 124, -98,-107,-116, -47, -60,  82, -64, -37,
  -62,  22,  69, -18,   5,  99, -71,  20,  97, 102,   2,  20,  64,  66,  20,  -3,
   84,   8, -63,  74,  88,  48,  17,  68, -96, 116,  24,-122,  97,-104, 106, -17,
    9, 113,  28,-106, -21, -43, -72,  90,  33, -83,  45, 113, -33, -71,-109,  59,
  -42,  16, 103,  50,  72,-122, 100, 127,  88, -38, -80,-122, -38,  80, -93,  82,
   47,  55, -54,  36,-123,   8,  66,  21,-123, -70,  92, -42, -27, -78,-118,  67,
  -87,-125,  37, -87,-124,-108,  20,  40, -46,  74,   4,-118,   6, -60,  43,  65,
  -79, 113, -95,   5, -54, -15, -36, 115,  71,-125,  -7, -42,  74,  85,  45,  34,
 -123, -36,-122, -21, -62, -28, -48,  83, -91,  53, -89,   3,  48,  -9, -36, 100,
  102, -26, 102,  14,  31, -23,  54,  23,  49,  53, -45, -99,  89, -72, -16, -42,
   91, -81, -97,  92, 117, -27, -12,  17,   0, -81, -68,  -5, -82, -21,  87,  85,
  105, 109,  35,  10,  66, -89,  84, -63,   4, -64,  68, -38, 121,-107, 121,  63,
   98,-106,  35, 104,-112,  58, 118, -98,  28,  19,  59,   0, -77,  -3, -10,-113,
  -42, -81, 120, -61,-127,-103, -41,  31, -99, -33, 121, -27,  37,  22, -36, 108,
   45, -11,  92,  65,  -3, -84, -94,  36,  89, 115,  79, -77,  57,  87,  13, -42,
 -120,  96, 126, 122,  -6, -43, 111, 122, -35, -25,  63,  -1,  -7, -41, -68, -26,
   53,  -9, -35, 127, -97,-110,  10,  64, -75,  90, -35, -74, 109, -37,-121,  62,
  -12, -95,  11,  94, 113, -63, -86,  85, -85, -10,  53,-113,  76,  84,  34,  78,
   51,  34,  74,  -5,-119,-106, -54, -79,  37, -46,  46, -93, -82, -86, 109, -72,
  -24,   2,  32,  20, -60,-128, 125,  62,  68,  95,  16, -84, -43, -76,-128,-114,
   16,-120,  14, -89,-127,   6,  -6, -83,  71,  -2, -20, -49, -98,  -3, -38, 117,
  -29, -37,  79,  88, -17, 100, -73, -43, 126, -30, -71, -99, 113, -71, 124,  66,
  101, -94,  87,  36, 123, -48,  45,-103,-126,-103, -91,  16, -92,-107,  26, -32,
 -107,-124,  84,  74,  11,  16,-111,  39, 120, -10,  16,  66,  43, -91,-125,  64,
 -121,  65,  63, -23, -51,  -9, 122, -36,  78, -86,-126,   2, -56, 110, -89,-109,
   -5,  34, -82,  86,-118,  78,  87,   8,  17,   8,   1, -64, 123, 103,-115,  25,
    0, -44, -37, 101,  65, -78, -29, 106,  80,   3, -68,  58, -10,  82,  74, -95,
  -92,  28,  88,-113,  42,  41, -75,  18,  74, -79,-105,  20, 104,  31,  40, -81,
 -124,  12,-126, 114, -75,  50,  50,  60,  86, -81, -41, -69,-107,  26,-106, -70,
  -99,  93, 123, -37,  83,   7,-109,-123,  57, -97,  39, -60, -42, 123,  11,  47,
   21,   9,  37,  73,-128,-104, -72,  16, 112, -62,  59, 102,  18, -20, -84, 117,
  -58,  98,-103,  -2, -84,  28, -61,  56,  47,  89,  56,-122,-124,   8, -62,  32,
 -120,  66,  17, 104,  72, -63,   4,-116,  -8, -55, -72, -79,  58, 108,-124,  70,
   98, -95,  72,  93, -38, -79, -90, 101,  50,-101, 119,-121,  74,-107, 104, -43,
   10, -65, 101,  83, 114, -10,  25,  98, -35, -55,  37,  55,-126,-106,-102,  31,
  -23,  13,-106, -77, -46,  11,  98,  33,  33,   9,  18,  16, -85, -46,  62, -40,
   25, 107, -78,  36, -49,-106,  50, -17, -67,-122,-112,  66, -72,  18,-105,  75,
   85, -60, -91, -15, -47, 122, 101,  56,   8, -22, -43,-126, -46, -59, -39, -90,
   -4, -10, -19,  11,-121,  15, 111,  -3,-117, -81,   2, -72, -31, -19, -17, -83,
  -28,  78, 101,   5, 101,  38,  67,  33,  24,   0,-122,-117, -34, -15,-101,  59,
   28, -21,  -3, -15,  72, -39,-117, 106, 110, -61, -36,   2, 104, -28, -90,  39,
   -6,-103,  55,  67, -58,  46,  87,  11, -35, -66,-105,  97,  92,  30, -66,  98,
  -22, -32,-114,-105,  93, 116, -34, -43, -81, 117, -59, -78, -77, -26, -63,  61,
  123,  77,  47, 113, -71,-111, 121, -98,-105, -88, -30,  -6,  81, -91,  -2, -49,
  -77,  -5,  49, -36, -56, -37, -67, -51,  91, -74,  28,  62, 124,  -8, -89,  55,
   95,  -1, -79,-113, 125, 108, 112, -47, -92,-108, -81, 123, -35, -21,-118, -94,
   56, 114, -28,  72, 123, -87, 117, -50, -10, -77, -10, -35, 116,  64,  83,  36,
    1, -31, -39, -28,  69,  20,  43,  34,  15, -21,  50, -17, -51,-106,-115,   8,
  -86, -56,  33,  67,  -6,  23, 117, -64,  11,  71,  86,  21,  49,  -5,  30, 108,
   85, 106, 106,  45, -19,  -5, -54, -41, 118, 126,  -1, -69,  27,-122, 101,  33,
   85, -69, -33, -81, -41,-121,  54,   8,-107, 100, -39, -34, -87,-125,  78,  -8,
  -38, 112,  45,  64, 116,-116,  -3,  46, 121, -64,-102,  39,-128,-104,  72, -80,
   32,-128, -92,  20,  44,-123,  39,  88, -17, 124,  81, -40,-123, -71,  40,   8,
   28, -71,  94,-106,  75,  33, -62,  56,  66,  33, -46, 102,  87,  44, -69,  58,
   14,   6,-114, -67,-121,  -9, -20,   1, 120, 126,  30,  88, -39,   3,  16,  36,
 -124,  16,-102, -76, -44,  74, 104,  69,  66,  56,   1,  16, -79,  20,  78,  82,
   24,-105,  10, -17,-100,  64,  84, -85, -42,-122,-121, -94,  32,  46, -14, -30,
  -48, -63,-125, -23, -20,  19, 121, -69, 103, -38,  29,  89,-104,  56,  82,  62,
 -108,  29,  54,  29,-109,  15,-109, -74, -98, 125, -63, -16, -60,  36,-100,  36,
  -81,-108,-107,  34, -54, -13, -63,  81,  12, -92,  37,  61,  89,  15, -31, -67,
 -113, -21, 117, -21, -99,  -9, -98,  61,-109, -29,  88, -88,  40,-116, 100, -96,
   79, 107, 108,  94, 104,  46,  60, 116, -24, -16,  35,  11,  51,  -9,  29, -99,
  -38, -47, 115, -77,  64,   6, -28,  13,-100, -45, -62,  21, -64, -91, -15, -70,
   51,  47, -71, -80, -12, -90,  75,-117,-105, -99,  62, 127,  66, 109, -27, 116,
   15,  16, -98, -55,  15,   6,-128,  72, 123,  18,   0, -46,  56, 103,-126,-105,
   36,  68,  84,-109, -27,-128,   5,  57,-122, -13,  75, -86, -45, 109, -50,-104,
  -67, 123, -52,-109,  15,-115,  -2, -58,-101,   1,  84,-128,  59, -74,  92,  16,
   44, -74,  47, -77, -39,  50,  22, -91, -25, -70, -54,  42,-100, -27, 126,-115,
   26, -55,   5,   3, 104,  78,  60, -81, -67, -18, -61,  83, -38,  34,  -9,  69,
    1,-101,-111,   3, -48, -51,  -5, -28, 125, -35, -93, -69, -84,-114,-128, 117,
  -25, -98, -85,  71,  71,  56,   8,   1, -76,  86,  15, -51,  61,  -2, 120, -89,
  -35, -34,   4,   0, -24,  29,  61,  26,  11,  93,-111,-102, -91,  74, -91, -46,
   89, -77, -88,-115, -36,  41,-128, -52,  84, -30, -54,  25, 103,  93, -16, -11,
  -81, 127,  61,-110, -36, -19, 118,  87,  76, -84,-104,-103, -99, -71, -28,-107,
 -105,  92, 124, -15, -59, -97,  -8, -60,  39, -76, -42,-117, -45, -77,  39, 109,
   57,  15,  30, 108,  92,  37, -46,  26,  66,  73, 109,-110,  76, -58, -86, -33,
   77,  60, -24,-116, 107, -33,-126,-108, -31, -32,  67,  12,-116, -70,  -1, 125,
  -80, 122,-119,-114,  32,-115,-128,  58,  -3,   7,  63,  -4, 103,-121, 111,  -4,
  -31,  -6, -31,  74,  81,  74, 107,  45, -37, -47, -31,-111, -76,  51,  92,  41,
 -113,   5, 113,  77,  71,  69, -32,  92,  36, -62,  72,  26,  99, -84,  49, -50,
   -5,-127,   4,-118,  90,  54,  99, 102,  73,  82,  42,   9,  45,  65, 100, -40,
  103,  73, -30, -67, -97, -52,  77, 102, 109, -95,  81, 104,  54,  46,  87,  25,
 -107, -99, -88, -85,  82,  66,  -7,  96,  72,  26, -57,  72, -57, -34, 123, -29,
  -99,  60, -42, -61,  88, -82,  37,-124,  56,  54,  11,  47,  73,  73,  33, -91,
   27,  88,  83,  74,  34,  45,-123,  82,  22,  92,  30,  26,  10,  27,  85,  43,
  -80, -44, -22, -12, 123,  71,  93, 102,-123, -29, -78, -21, 114, -64, 114,  84,
   48,  71, 125, -25, -72, 112,-127,  87, -29, 106, -56,  68,  57,-116,  35,  47,
   52,   5,  66,   7,-123, -27, 118,-111,  -9, -45,  76, -26, -87, -42,  58, -44,
   90,   8,  53,  88, -38,  41,  25, -56,  72, -11, -99,-107,  82, -22,  48,  28,
   80,  84, -93,  40, -82,  86, -85, -91,  82, -23, -90,  67,  71, 127, -16, -56,
   -3,  55, 117,-106, -90,  21,  16,   3,-127,  16,  69,  48,-126, 114, -77,  85,
  126,  40, -56,  30,-110, 115, -97,  79, -89,  94, 117, -61,  55, -33, 112, -17,
  119, -73,  79, -82, -87,  85, -85,  15,  86,  98,  17,  69,  84,  43, -21, -31,
   97,  61,  58,  36,-121,  26,  84, -85, -56,  32,  68,  42,  32,  72,-121,  97,
   92,  46,-123,  82, 117,  91, -67,  -7,  67,  71,  91, -77, -13, -22, -31,  29,
  -83,  35,-121,  47,  61,  -8, -20, -16,  75, -81,  -8, 110,  85,-107, 123, -50,
 -108, 113,  85, -17,  87,  34,-112, -16,  44,  18,  19,   9, -95,  85, -27,  64,
  -55,  43,  79,   0, -54,-119,   4, -16, -77, 117, -21,  47,-100,  58, 112,  -2,
  -66, -23, -21, -41, 105,  95,  88, 105,  69, -84,  74,   0,  68, 121,  56, -98,
 -104, -88,  77,-114, -37, -55, -11,-125,  55, -55,  42, -11, -61, -49,  60, -37,
   63, 124, 104,  11, -48, -65,  -2,  70,  15,  23,  30, 123,  -1, -79,  82, -91,
  -80, -58, -62,  65,-126,-126,  82, -71,  88, -38, -69,  56, -65,  24,  82,  61,
   44,-113, -43,  26,-106, -62, -59,  -7,-103, -15,-111, -31,  86, -85, 117, -55,
   37,-105, -20, -40, -79, -29, -11, -81, 127,  -3,  35,-113,  60, 114,  -9, -35,
  119, -81,  90, -75, -54,  21, -90,  81, -81,   7,  65,  72, -50, 106,   8,-109,
   23, -43,  56,  50,  84,  20, -34, -92,  73,  30,   7, -11,  87,  -4, -50, 111,
   65,  70, -57,  60,-108, 127,  -7, -95,  -1,  22,  88,-115,  16,  85,-101,  73,
   53, -35,  -7,  -5, -81, -70, -17, 125, 123, -27,-102,  17, -74, -90,-118, -31,
  118, -40,  38, -29,  70, -32, -87, -41, -51,  60,  21,-126, -84,  23,  92,  72,
  -29, -46,-127,  18, -78, 115,  76,-126,   2,  29,  19,  96,-116,  79, -71,  81,
   13,  11, -35, -23,  53, 107, 113,  73, -53, -79, -91, -59, 102, -96, -69,  40,
  -77,  42, -79, -55,  85,  94,  84,  36,  91,  72, -21,-112,-109,  54,  66,  -7,
  -68,  15,  64,   8,   5,  12,  86, -73,   0,-124,  22, -30, 121,  94,  54, -57,
  104, -53,  74,  73,  41,   1, -17,   9,-106, -67, -75, -34,   8,  33,-108,  10,
 -126,-128,-125,  40, -82,  85, -13,  44, -17,  28,  60, -28, -77,  66,  88,  95,
  102,  82,  32,   9, -54,  57,-121, -75, -34,  88, -17, -67, -92, -27, -63,  41,
   98, -24,  98,  48,  77,  42,  10,-105, -69, 126,   6,  65,-117, -47,  90,  35,
    0,   0,  32,   0,  73,  68,  65,  84,  21,  33,  42,  58,-100, -89, -68, -94,
 -108,  36,  41,  13,  52,  17, 116, -32,   2,  89,   8,  -8,  90,-115, 124,  16,
  -88, -80, -86, -83, -78,  45, -55,  84, -93, 117, -97, 123, 118, -17, -89, -97,
  122,-110, -67,   7,  20, 121,  65,   9, 121, -25,  60, 108,  83, -11,  93, -44,
   65, -30,  80, -88, 126,  36, 111,  42, -14, -67, -83, -20, 109,  -7, -31,  75,
   74,  35,  43, -40,  60,  90, -17, -26,  38,  25, -19,-122,-103,-118,   5,   5,
  101,  87, -28,  58,  69,  46,  51, 111, 107, -93, -61, -93,-109,  19,  36,  68,
  -65, -45,  77,  91, -99, -92, -45, -93, -60,  94,-106, -25,   0, -66,  29, -46,
  -54, -47, 113, -35,-112,  62,  84, 119, -98, -70,  -2,-107, -49,  28,  56, 126,
  -17,  24,-126,  21,  59, -10, -52, -66, -42, -17,  12, -38,  63, -71, 105,   3,
  104, -27, -83, -63, 107,  52, -41,-125, -79, 106,  52,  57,  94,-102,  88,   9,
   96, -20, -14, -41,  38, -87,  89, -56,-118,  -6,  19,  79,  14,  94, -80, 116,
   -3, -11,-115,  48, -72, -86,-109, -33,  57,  84,  45, -43,-121,  89, 102, -98,
  -59, -51,  43,-121,  94, 123, 116, -23, -62, -23, -26,-115,  19,  53,  46,-118,
  114,  41,  36, -69,  52,  22,  76, 124, -69, -73,-120,  74, -92, 102, -51, 105,
 -105, 109, -65,  -3, -66, -17,  19,  41,  33, -60, -29,-113,  63, -66,  98, -59,
   10,  41, -27, -35, 119, -33,  61,  53,  53, 101, -84,  25,  25,  25, -87, -71,
  -72,  59,  80, -81, -17,  24,  21,  81, -83,  92, 118, -74,  88,   8, -72, -66,
 -104, 119,   3, -39,  61, -21, 100,-120, 122,  17,  32, 112, -48,  14,-119, 124,
  -66, -58, -59,  11,-125, -43,   1,-112, -82, 127, -13, 125,  55, 126, -21, -70,
   13,  91,  55,  29,-102,  58,  52,  57,  49,  58, -65,  48, -97, 119, -38,  37,
   29, 107,  18, -74,  48,  68,  20, -58, -95,  20,  72,  77,  78, -52,  68,  94,
  -79,  60, -50,  65, -12, -52,  76, 126,-115,  75,  23, -69,  11, 112,  28,  20,
  -63, -46,  98,-101,-117,  60,  28, -85,-113, 117, -93,  -3, -86, -93, -55,  71,
  -46,  41,-101, 107, 107,-107, -73,-125,  60,-101,  61,  79,  46, -26,  87, -94,
 -123,  16,  -1,  66,  65, 100,  80, -77,  22, -50,  66,  16,-124,  10,-125,  32,
  -46,-127,  84,-118,  72, -62, 113,  -5, -56, -47, -63, 110,   2,  57,  15,-122,
  115, -52, -98, 115, -17,  13, -14,-127, -62,  41,   1, -20, 121, -96, -49,  59,
  104, -20, 102,  89, 102,  60,  51, -77,  86, -31,-128, -91, 111,-116, -83, -78,
   10,  61,   9, -80,  39,  98,  37,  68, -92,  41,  84,  66, -46,  16,  75,  25,
  -23, -52,  38,  -3,-123, -18,  -8,  -8,  -8,  88, 105, -30,  53, 119,  94, -41,
   73,  64,  32,  41,   4,   0, -25,  11,   6,   6,  45,  17, -17,  10, 100,  30,
 -116,  70, -93, -47, -22, -74,  44, -80, -92, 112,  71,-102, -78, -99, 123, -35,
  -60, -28,  68,  73,  21,  84,  86,   1,  69,  62,   2,  11,  98,   5,  69,  54,
   82, -85, -57,  71, -49, 122,  -8,  25,   0,  55,-100,  56, -42, 111, 117, 124,
   86,-112,  67, -61,  45,  95, -34,-111,  21, -93,  34, -48,-119,  53,  78,  83,
   38, -35,-113,  78,  90, -11,-122, -25,-114,  12, -98, -22,  35, -45,  68, -28,
  -67,  49,  38, -90, 122,  86, -28,   0, -84,-113,   1, -60,  99,-109,-113, -67,
   -6, -30, 109, -73, -34,  -3, -38,-125,  11,  83,  31,  -5,-128, -23,  -9,  23,
  -89,  14,   2, 120, -26,  91, -33, -48,  -3,  44,  38,  90,  44, 104,  59,   0,
   64,-114,-106, -37,  54,   7,  80, 120,  23,  27, -29, -56,  51,-120,-114, -23,
  -36, 120, -17,   9, -80, -42, -70,  34, -25, -80, 113,-108,  45, 100, -39,  66,
 -116, -81,-104,  56, 120, -57,   1, -10, 110, -45, -90,  77,-113,  63,  -2,  -8,
  -75, -41,  94,  -5,  -3, -17, 127,  95, 107, -67, 123, -49, -18,  48,   8,  87,
  -84,  88, -47, -20, 103,-119, 114, -46,-101, -43, -27,  96, -84,  20, -56,  80,
  -72, -44,  -7,  36,  39,  35,  14,-112,  -5, -32,  23,  63,-121, 114, -60,  64,
 -111,-104, -96, -92,   3,  56, -68,  24,  21,  65,   3,  95,  98, 119, -37,  71,
   -1, -14, -20,  77, -89,  29,-114,  -7, -92, -15,-107, -42,  21,-123,   3,  39,
   94,  72, -31, -99, -75,-114, -63,-106,  36,  72,  65,  59, -53,   5, 123,-126,
   16,  66,  72, -31,-103,  44,  91,   6,-120, 104,  49,  95, -84, -84,-116, -29,
 -103,  54,  47, -74,-122,  26,  67,  29,  89, -20,  77,  15, -83,-116, -57,  70,
   58, -87, -44, -28,-123, -51,  93, 102,  29,   7,   4,  37,  72, -72, 127, -53,
 -108,  -7, -72,-105, -38, -13,  53, -12,  72,  10,  34,  18,  36,-108,  84,  74,
   40, 118,  92, 100, -87,  49,  14,  73, 111,  48, -35,  44,  73,  12, -66,  58,
 -125, -47,  82, -21,  13, -47,  50, -98,-106,  27,  20,   0,  17,  21, -42,-112,
   90,  22,  68,  49, -50, -78,   1,  41,  41,-108,  26,-122,  36,  34,  47, -92,
   23,-124,  32, -96,  40,-128,-106,  68, 100, -70, 125, -27,  -6, -61,-123,  13,
   38,  38,  70, -29, 117, -65, -15, -64,  77,  59,  18,  36,   2, -38,  51, 123,
   71, -64, 104, -93, -70, 114, -27, -54, -79, -79,  49, -25,  92, -69, -35,  62,
   52, 123, -76, -73, -40, -19, -74,  90,  80,-124, 106, 116, -80,-105,  25, -64,
 -117, -30, -28, -94, -65, -90,  40, -59, -27,  82, -69, -20, -94,  84,  74,  86,
  -87, -76,  16,  74,  87,  42,   8,-106, -17,  78, -85, -43,  82,  76,  65,  16,
  -60,  58, 120, -19, 124,  23, -64,-115,  39,-116,  56, 118,  49, -23,  88, -85,
  -60,  57,  91, -28, -21,  16,  -1, 108, -43, -16,-123,  71,-102,   0,-112, -25,
   29,  99,  33,  40,-116,  74, 125,  81,-117,  71,  42,   0,  54, -68, -30,  21,
    0, -74, -67, -29, -51,  93,-101,  14, -34, 118, -25,  55, 126, -44,  92,-100,
   51,  89, -17,  92,  96, -40, -26, 113,  76,  10,  28,  86, -29, -63, -77,  81,
   97,  99,  82,   0,  94, -37,  78,  -2, -11, -67,  96, 102, -83,  20, -77, -81,
 -123, -95,-107, -15,-125,  29,  32, -17,-105,  38, -42, 119, 122, -67, -18, 108,
   -5, -12,-109,  78, -35, -80,  97,  67, -75,  90,  93, -77, 102, -51,  31,  -2,
  -31,  31, -34, 121, -25, -99, -69,  -9, -20, -50,-117, -68,  86, -85, -39,  32,
   52, -28,  11, -26,  40,  36, -74, 105,  63,  73,  43,  78, -44,  11,  62, -60,
    1, -99, 121,  50, -74, -97, -39,-127,  38, -57, -43, -78,-122,-121, -78, 126,
   89,  71, -30, -33,   6, 107,-120,  -4, -26,  63,  -6, -24,  90,  21, 123,  37,
  -42, -84,  89,  27, 116,  44,  19,  85,  26,  67, -76, 114,  41, -19, 119, -77,
   78,  87, -10,  59, 121, -65,-101, -90,  61, -27,  56,   8,  20, -44, -78,  46,
   51,   9,  41,   8,  96,  47,  37, -23,  48,-104,  45, -57, -62, 118,-121,  16,
   21,  81,-107, 114, 113,  98,  17, -82, -30,  76, -73, -26,  23,  20, -78,   8,
  -67,  24,  -3,-104,  82,  25,-126,  34, 105,  20,  89,  49, 114, -20,  82,  -2,
  -21, -85,  51,  32, -68,  30, -97,  99,  30,-116,  41, -77,   2,  51,-125, -68,
  -53,  11,-105,  89, -25,-100, -51,  11,  99,  92,  77,  50,-128,  65,  63, -53,
 -127,  -3,  32,-102,  50,  43,-112,  32, -63, -57,  76, -86,   6, -47,-102,   1,
   22, -92, -92,  20,  66,-127, -56, 123, 120,-126,  22,  66,-112,  18,  32,-110,
    2,  74,-120,  32,  32, -83,  48, -16, -56, 116, -34,  86,-125, -80, -37,   3,
  -71,  19,  75,  43, -34, -67, -21, -95, -97,  36,  -3, 114, -75,-126, -76,  39,
   60, -42, -83,  89, -79, 113, -29, -58, -55, -55, -55, -47, -47, -47, 122, -67,
   62,  60,  60,  60,  54,  54, -42, -20, -76, -97, 124, -12, -55,-101, 110, -68,
  117, -33, -20, -76, -17,  21,  76, 104,-123, 120, -54, -29, -63, -59,-123,-102,
   29, -83,  82,-112,  42, -89,  29, -64,-100,  43,  47, -64,  17,-119, -93,-121,
 -113,-100,   5,   0, -88,-118, -96,  20,-124,   2, -92, -27, -14,  -3, 114,  90,
  112,  81, -40,  94,  26, -79,  40,-127, -29,  48,  40,-106,  58, -26, -40,  26,
 -108,  26,  35, -75,  70, -93,  50,  62,  86,  27,  30,  10, -49, -34, -94, -63,
    0,-102,-100,   2, -72,  -9,  43, -33,  52, -51, -42, -67,  31,  -7, -36,  59,
   44, -65, 118, -17, -18,  27,  34,  10, -93,  16,  64, -83,  49,  82,  20, -74,
  -97,  22,  38,  90, -18, -89, -50,-124,  78,  11,  13, -32, -90,-111,  82, -24,
  101,  33,  10,  18,  90, -59, -15, -85,  14, -50,  99, -96,  78, -89,-108, 119,
 -123, 118,  60, -89, -43,  65,   2,-116,  15, -58,  43,-121,  14,  29,-110,  64,
   32, -59, -58,-115,  27,  79,  62,  -7, -28,  60, -49,-121,-122,-122,  78,  56,
  -31,-124,  56,-118, -99, 115,-109,-109,-109, -75, -93,-117, -29,  99,  67, -48,
  -56,-117, -68,  81,  46,  85,  28,  -6, -99,  36, -15, 112, -37, -50,  -5, -93,
  -97,  -2, -88,  15,  77,  16,   1,  35, 101,-114,  21,  35, -75,  80,  47,  66,
  -90,  61,  66, -38,  -3, -31, -99, -93, -25, -99, 118,  16,-119, 122, 124,  55,
  -59, -91, -66, -53, -85, -75, -72, -79, 118,  66,  37,  85, -35, 109, 115, -73,
   98,  23,  23, -14,   5,  46,-110,  62,  91,   6, -40,-125,   5,-124,   4, -79,
  119, -16,-106,  89,  48, -39, 117, -44,  64, -89,  63, -93, -30,  27,  54,-116,
   31, -82,  53,  54, -73,-110,  97,-105, -42,-128,  83,  15,  36,-108, 116,  74,
  -35, -84, -98,  10,  33,-124, -79, -34, -63,   8,  25, 102, -63, -81,  63, -98,
 -127, -85, -22, -15,  74,  96, -80, -75,  11, -64,  89,  79,  68,  98, -80,  15,
  -28,-119,  -4, -78,  12,  37, -69, 124,   0,  80,  75, -20,-103,  29,-104,   9,
    0,   2,  17,  16,  13,  38,  -2,  61,   3,  44,   0,  34,  72, -95,-119,-103,
  -71,  48,   6,-128,  10, -61,  48,  12,  25, -80, -42, -25,  90,-112,  36, -87,
    3,  21, 104,  34, -63, -42, -61,  88, -23, -87, 109, -70, -27, -47, -22, -71,
   27, -50,  -8, -33,  15,  -3, -30, -21, -45,  83, -91, -54, 100, -65, -37,  12,
   44, -74,-100, 113, -54, -42, -83,  91,  87, -82,  92, -39, -23, 116, -10, -17,
  -33, 127, -28, -56,  17, -25, -36, -16, -16, -16, -42, -77,  95,  50,  62,  58,
  -10, -82, -73,  -3, -42,  -9,  -2,  -7, -57,  59, 118,  63,  43, -76,  34,   8,
 -108, -53, -69,  91,  75, 103,  36,  89,-112,   9,  25, 123,-112, 100,   1,  71,
   16,  64, -34, -22,  94,  57, -75,  -8, -35,-120, -34,-110, -15,  85,  11,  -3,
  123,  87,-115,  19,-111,  56,  38, -89, -93, 114,  54, -71,  -9, -28, -67,  16,
  -99,  44,-107,   2,-117,-109,-115, -47, -15,  21,-125, 103, -73,  92, -13, -90,
  -88, -42,  40,  24, -99, 126, -17, -48, 109, -73,  31, -34, -73, -17, -19, -65,
   -5, -57,  79, 127,  -9, -57,  47,  -1,  14,  74, 123, -89, 106,  16, 101, -67,
   28,  62,-125,  70, 100,  25,   0,  14,  -9, -37,  44,-107,  40, -55, -88, -71,
   28,  44, -58, -25, -28,  37,  69, -14,  79,  68, -66,  76, -86,  18,  55, -68,
   20,  82,  73,  41, 111,  93, -77, -30, -43,-121, 102, -82,-104, -19, -36, -67,
  102,-108,  61,  85, -75, 126, -76,  72,-102,   4,  37, -61,  32,  18,  90,  74,
    9,  58, -80, 127,  -9, -50, -99,  59,-101, -51, -26, 121, -25, -99,  -9, -91,
   47, 125, -55,  90,  -5, -51, 111, 126, -13,-109, -97,  -4,  36,  17,  13,-107,
  -53,  51,-117, -77, -16,  24,  47,  48, 106, -88,-105,  39,  -5,-127, -59,  74,
   -4, -31, 123, 111,-126,  22, 101,-124,  48,-128,  68,  95, -48,-110,  77,-122,
  -12,-117,  83, -66, -98, -71, -25, -98, -47, -59,-114, -47, -74, -39, 105, -82,
  111,-121,-117, -35,  30,  85, 117,  50, -69, -48, -23,  -9, -94,  40,   8,  74,
 -127,  86,  85,  25, -56, -72,  82, 118, -35, -60, -12,  -5, -35, -76,-128, 119,
   98,  64, -55, -16, -50,  23,   5, 123, -97, -77, -17,  20, -19, -15,  60,  79,
 -125, -46, 110,  81, -38,  85,  91, -65, -80, -48,  14, -37,-117, -85,  86,-115,
  -35, -77,  -2,  96, -68,-128,  85,  45, 113,-110,  -9, -93,  40,  60,  -9, 115,
  -19, -72, -92,  68,  26, -67, -48,  33,  -3,-117,  29,-127, -29,-113,-128, -32,
  -40,  57, -25, -84, -29,-127,  36,-124,  86, -94,  87, 120,-110,-126,-124,-128,
   32,-121,  95, 110, 104,  58, -57,  12,   6,-125,   9,  78, -46, 113,  73,  21,
 -101, 101,  82,  74,  65,  10,  82,  72,  41,  73,   8,  37, -91,  82, 100,  35,
   37,-124,-112,  16, -16, 112, -90, -80, -59, -78, -57, -43,-102,  85, -85, -73,
  -99, -13, -46,   7,-102,-117,  31,-100, -98,  10,  13,-110, -91, 102,   0,-100,
  124, -14, -26, -53,  46, -65,  98, 102, 102, -26, -58,-101, 110, 126, -22, -87,
  103, -36,  49, -94, -69,   7, 110, -71, -21, -34, -45,  54, 110, 120, -43, -59,
  -81, 120, -39,  57,  47,  41, -14, 116, -17, -63,   3,  22, -16, -70, -44,  18,
  -40,-117,  98,  40, -45,  85, -83,-103,  56,  21,  86, 120,  39, -84, 117,  25,
    0,  84, -61, 101,  84,  37,  73,   2,  37,-115,  91, 110,-126,  -6, -60,  25,
   71, -82,  28,  85,  87, -81, -86,-108, -61, 112, -84, 113, -26,-103, 103,  36,
  -19, -18, -32, -39, -59, -35,-121,  14, -19, -67,  -9, -32, -18, 125,  75,  75,
  -51,-105, -64,  13,  32, -68, -71,  81,   1, -48,  31,-110,  29, -59,  65,  73,
   28, 106,  12,  95, -34, 106, -66, 122,  38,  -3, -23, 104,   3,  64,-100, -25,
  -87, -51,-115,  67, 108,-105,  33,  49, -25,   4,-128,-109,  47, 120, -87,  17,
  118, 113, 105,  78, -51,  47,   9, -87,  -8, 121,  10, -15, -42,  90, -10, -66,
  -95, -29,   7, 109,  10,  47,  68, -92,  76, -46, 110,  47, -60,-123, -25, -73,
  -68, -11,  77, -89, 110,  57, -89, -45, -23, -84,  94, -67,  -6, -92,-109,  78,
   90, -75, 106, -43,  27, -33, -12, -90,-111,-111,-111, -67, 123,  -9, -18, -35,
  -65, -17, -48, -47,  61,-111, -59,  56, 100,  37, -84,  28,  32,  51,  -6,-101,
  -81, 127, -49,  87,  -2, -90,  83, -94,  50,  66, 105,-128, -44, 115,  64,  20,
   81, -84,  98,  -4, -86, -40, -43,  11,-126, -11, -39,  27, -18,  56, -38,  62,
  -78, 126, 118,  67,  40,  77, 106, -52, -40, -48, -48,  -2,-123,  67, -85,  29,
  -26, -38, -71,  43,-105, -87,  81,  11, -94,-112, 106,  13,-108, -86, -82,  97,
  124,  97,-126, -92,  15, 107,  76,-102,-104, 126, -97,  83,   1,   2,  25, -29,
  -84, -91, -47, -40, -52, 116,  39, -85,  35,  19,  25, -33,  -7, -60, -45,  62,
  113, -95, 108,  61, -11, -40, -61,  47,  99, -95, -83,-109,  36,  68,  20, -16,
  -64,-126,   7, -16, -42, -67,-112,  87, -51, -81, 117, -79,  33, -94,  64,  72,
  -57, -34,  14,  68,   8,   5, 121, 112, -18,  10, 120,  71,-110,-123, -32,  65,
  113, 123,  76, -91,-126,-120,-120, -84,   7,  99,  96,-113,   6,  34,  71, -16,
  -52, 108, -67, -12,  62,  12,  67,  21,  68,  68,-125,  53,-110, -48,  90,  11,
  -95, 114,   5, -23,  33,  60, -61, 122, 103,  45,  43,  25, -42,  43, -91,  90,
  -11,-108,-109,  55,  25, -82, -66, -18,  71,  95,  16, 125,-104,  80, -42, 115,
  -69,  -7, -52, -45,  55, 110,  58,  -7, 103,  63,  -1,  -7,  19,  79,  60, -47,
  -18, -12,   9, -88, -43, -54,  99,  99,  99, -42, -38,   3,  83,-121, -85,-107,
  -14, -45, 123, -10, -18, -97, -38,  -1, -54,-117,  95, -79,  -7, -76,-109,  23,
  -37,  11, -51, 118, -81, 103,  -5,-123,  14, 118, -93,  56,  49,  23, -85,-108,
  106, -57,  72,-123,  13,-115,  71, 102,  40,-120,   1, -28, -57,  50, 123,  22,
   10,  14,  37, -53, -27,-100, -72, -23,  -4, 115, 103, 103, 103, -89, -10, -18,
   19,  73, 127, -72,  81,  13, -86, -75,  -3, -73, -35, 123, 104,  -1,-127,  13,
  -97,  -7,  50,-128, 103, 127, 116,   3, 103, -39, 122,  21, -98, -69,  98, 114,
  -42,  46,  12,  46, -35,-110, -53,   0, -60, 113,  37,  55, -82, -73,-104,  16,
   45, -29, -96, -39, -20,   1, 112, 125,  89,  47,-105, -94, 106,  44,  79, -35,
   54, 120,  -4,  13,  -9, 127,  31, -64, -74,-113, -67, 127, -10, -70,  31, -50,
   -1, -32,  89,   7, -57, 112, -42, 123, -21, -24,  56,  88,-107,  36, -37, -17,
   63,-124,  34,  64,  88,   8, -18, -49,  47,-106,  70, -42,  94, 122, -59, 101,
  -65,  -3, -98, -33,  25,  26,  94, 125, -53,  45, -73, 124, -28,  35,  31, -71,
  -18, -70, -21, -66,  -6, -43, -81, -66, -27, -51, 111, -34, -74, 109, -37, -27,
 -105,  95, -66,  -7,-100, 109, 119,  -1, -55,-121,  26, -64,  34, -36, -77, -11,
   -8, -54, -49, 124, 116,  -3, -75, -41,  38,  38,  86, -16,  38, -19,  75,  21,
  -93,  42,-116, 117,  37,-106, -71,  45,  58,-126, 107, -14,  69, -20,  96,-123,
  -51,  78,  87,-109, -37,  63,  51, -78, 105, -72,  27,  22, -83,  61, -69,  43,
 -109, -91,  96, 106, -74,  90,-107, -82, -97, -89, 105, -18,  26,  53, -89,  85,
  110,  28,-111,  44,  71, -27, -79,-111,  70,-111, 101,  73, -77, -39, -75,-123,
  -53,  11, -91,-108,   0,  20,-112,  20, -90,  54,  81,  67, -98,-124, -69, -98,
   56,  39, 108, -68, 122, 108,  -4,  20, -14,  67,  38,  27, -90,  82, -82,  41,
  -43, -36,  21, -55, -68,  99, -49,  50,-108, -43,  88,-108,  61,  90, -65, -10,
  120,   6, 106, -21, -49,  87,  72,  93,  14, -82, -57, 100, 121,  61,-127,-124,
   96, 112, -18,-116,  49,  70,   4,   1, 121, -49, -50,-111, 103, 118, -98, 104,
   80,-110,  10,  61,  24,-122,  26,  56, -79,  19,  59, -25, 115, 111, -99, 115,
 -109, -27, -78,-108,  18,  68,  82, -54,  32,-116,   7,  14, -48, -58, 121, -37,
   47,   0,  34,  79,-126,  33, -91,  10, -21,-107, -95,  53,-109,  67, -85,  86,
   70, 125,  -1, -18, 123, -82,-117,-102, -38,  67, 104, -14,  99,  39,-115, -82,
   90,  61, 126, 120, -49,  -2,  -5, -98,  -4,-123, -13, 124, -11,  27, -82,  -6,
   -3, -33,  -1,  -3,-115,  27,  55,  18, -47, -30, -30, -30,-114,  29,  59, -66,
   -2,-115, 111, -35,  -5, -13, -97, 117,  11, -13, -56, -50,  29, -89, 111,  62,
  -27, -60,  83,  55, -52,  61, -68, -61,  20,-122,  75, -27,  89,  87, -12, 109,
   81, -74, -44,-107, 100,  20,  42,  86,  40,  47,  91, -62,   1, -96,  82, 120,
   -5,-119,  43,  94, -75, 111, -26, -11,  51, -99, -57, -81, 122, 121, 117, 116,
  120, 112, -42, -75, 109, -89, 118, -97,  13,-101,  79,  62, -45, -33, -75, 127,
   -1, 115,  83,  57, -36,  72, 110,   7,   6,  50,   0,  98, 109,  68,  68, -96,
  124,  58,  59,  92,  72,  37, -99,   4,  32,  12,   1,  72,-114, -76,  37, 100,
   29,  65, -96,-105, -45,  -3, -48,-103,  27,   1, 108,  -5, -60,  -1, -88, 110,
  -38,  16,-116,-114, -10,  86, -44,   6,-113, -17,  -6, -54, -83, -37, -50, -71,
  -20,-101,-105, -65,  71,  -7,  94, -88,-104, -75,  87,-102,  10, -26,  95,  50,
   90,-104, -91,  84,  33, -85,  39,-106,  58,  21,-116,  53,-117, -91,  82, -91,
  114, -51,  91, -34, 114, -10,  85, -81, 125, -32,-114,  27,  63,  -6,  39, -17,
  122,  -7, -53,  95, 126, -42,  89, 103,  93, 127,  -3, -11, 127, -12, -63,  63,
    2, 112, -45,  77,  55, -35, 114, -53,  45,  31,  -4, -16,-121, -10,  62, -10,
   76,   1, -68, -22, -83, 111, 127,  -9, -25,  62,-102, -83,  28,  61,-116,  96,
  -75,  18, -80,   6,  65, -56,  18, 115, -56,  26,  58,  66,  55,  15, -29, -88,
   -8, -43, -11, -74,  42,   0,  98, -81,   9,  96,  15, -61,  80,  26,   4,  11,
  -68, -12, -81,  -1,  -6, -82, 111, -33, -72,  -1, -64, -34, -45, -71,  35, -41,
 -113,  77, 111,  91, -25,  30,  91,  88, -64,  10,  90,  74, 108, -88,  92, -31,
  -46,  86,-105, -32,-108, 100,  45, -55,   6, -62,  13,-115,  59,  98,  47,  29,
   15,-107,  77,  36,  77,-110, -21, -62,   7,  14,  38, 104,  47,-103,  48, -20,
  -76, -33,-109, -92,-111,  51,  75,  83,  71, -25,  36,  58,  99, -94, -41,  21,
 -128,-128,   7, -68,-118,   1,  38, -10,  92, 100,  69, -95, -40, -30,  87,   5,
  -53,-105,  73, -54, -50,  -4,  90,  16,  91,  47,   0, 104,  64,  15, -54, 102,
  -96,  70,  10,  26,-126,-108,   7,  59,  98,  79, -20, -92, -16, -53, -31, -43,
   45, 105,-122, -13, 126, -64,  30,  20, -78, -92,-126, -47, -96,  28,  40, -99,
  112, -18,  29,  36,  -5,  56,-118,  75, 113,  41,  51,  69,  47, -51,-104,  72,
  -94, -48, -70,  84,  95,  18,  98, 116,-100,  27,-107,  98, -45, -16,-127,  56,
   57, 101, -70,  -7,  15, 125, -36, -76,  99, -49, 116,   8,  84, -86,-115,  76,
  109,  25,  58, 117, 106, 106,  -6,  23, 123, -98, -86, -60, -31,  79, 126, -14,
 -109, -43, -85,  87,  95, 119, -35,  -9,  -2,  -6,  -1, 124, -71,  90, -87, 103,
   89, 118, -54,  41, -89,  -4, -81,-113,  -2, -15,-113, 126, 116, -38, -97,  -1,
   -7,  95,  77,  31,  94,  48, -23,  83, -89, 111,  57,  51,  82,  42, -53, 108,
 -109, -13, -79,  66,  60,  26,  -7, -19,  50,  16,-123, -87, -25,-106,  69,-104,
 -117, -46, -21,  14,  77, -33, -75, 118, 124, -45,  89,  91,  -3,  80, 117, -71,
   18, -88,  14,  31,  57, -38,  28, 112,  82, -18,  -3, -14, -33, 103, -51, -42,
 -122, -72, -92,  75,  94,  18,-100, -93, -96, -84,-116,  89, -66,  68,  34,-118,
  -83,-127, -17,  23, -56,  61, -95,   0,  44,   0, -74,  26,  64, -11, -20, 109,
   35, -89, 108,  24,  94, -69, -46, 101, -63, 115,  31,  -6, -32,  73, -97,  -2,
  -52, -59,-113, -17,   2,  80, -87,-108, 102, 111, -65, 103, 110, -33, -63, -30,
  -55,-121,  39, 102,  23,   1, 108,  -5, -54, -97,   3, 120,  71, -70,  -8,-125,
  -47,  10,-120, -32, -78, -61,  34,  11, -62, -22, -75,   7,-105,   6, -97, 114,
  -39,  66,  -1,-103,-111,  -6, -49, 105, -68, -50, -51, 105, -75,  88,  45, -12,
  108,  65,-115, -45, -42, 127,  -9,  47, -66,  -8,-111, -65,  -8, -68, 100,  33,
 -124,  -8, -44, -89,  62, -11,-103, -49, 124,   6,-128,  32, -15,  -2,  -9, -65,
   -1, -18, -69, -17, -66,  -1,  -2,  -5, -25,-113,  76, -97, 127, -63,   5, -65,
   -3, -83, -81,  67,  74, 105, -52, 106, -83,  29,-100,  84,  33,   0,   2,  38,
    6, 116, -21, 106,   8, -96,  -6, -85,  -9,  90,-119,  65,   7,-121,-103,  61,
   11,  45,   1,  44,  19,  94,  93, 121, -22, -76,-115, -77,  59,  30,   8, 102,
  -69,  27, 117, -43,-101, -82,  31,   5, -11, -45,  52, -79,  41,  21, 125,  99,
  117,-118,  56, 119,-126, -87,  40, 105,  95,  13, 124, 119,-106, -75, -92,  82,
  -40, -88,-108, -94, -47,  97, 105,  92, -34, -18, 101, -99, -34,-119,  62, 110,
  118,-105,-114,  90,-119, 114,  41,   8,-107,  70,  92, -78,  22,  77, 111,   3,
  -31, -23,-105, 101, -24, -65,-114, -96,  47, -90,  12,   0,  64, -98, 126, -19,
  -29,  16,  68,  12,  90,  -2, -51,  68,-125,-114,  42, -54, -50, 105,  21, -24,
   80,  73,   6,  91,  39,  60,-124, 103,  98,  70,  20,-107, -62, -56,  89, -37,
   73, -46, -62, -72,  40,  42,-123,  82,  91, 107, -67,-124, -85,-106,-102,-115,
  -88, -76, 114,-104, 116,-112,  55,-101, -61, -99,  86, -34, -28, -17, -18, 121,
  -50,   2,  96,  80,  97,  79,  59,  99, -21,-111,-123, -71, -57,  -9,  60,  21,
 -116,-108,  14, -17,-103, -70, -27,-106,  91,  46, -68, -16,-107,   0, -94,  40,
    0,-117,-111,-111,-111,  27, 111, -68, -79, -77,  52,  -1, -74, -73, -67, -83,
   84,  42,  -3, -23,  39,  63, -67, -72, -40,-102,-103,-103,  25,  25,  25,-103,
 -101,-101, -77, -20,-123,-110,  16, -34,  58,   7,  34,  33, -91,  32,  41,-108,
    0, -48, -23,  37, -23,  83, -69, -96, -12, 105,   0,-128,  -7, -17, -33,  38,
  -51, 114, -18,  30, -21, 100,-122,  73,  51,  27, -30,  28, -20,-108, -17, -39,
   18,-114, 101, -10,  98, -82, -61,-128,  42,   7, 106, -78,  94, -86, -82, 108,
  -84,-102,   0, 112,  -2, -97,  -4,  33,-128, 109, -17, 124, 115,-110, 100,  -3,
  110,  47,  30,   2,-114,  -7, -65,   1, -72,  -7,  99, -97, -42,  75, -67,   8,
 -100,  47,  23, -55,  -8, 118,  44, 100, -96,-107, -42,  16, -60, -52,  44, 117,
   44, -96,  72,  -2, 120,  98,  68,  50, 114, 101,  98,  83,-100,  24,-106, 102,
   76, -79,-108,  67, -44,  74, -66,  99, -30,  40,  -6, -10,  63, 126, -21, -97,
   -1, -18, -37,  39, -97, -79,  -7,-124, -55, -75,-121,  14,  29, 106, -75,  90,
   59, 119, -18,  84,  82,  93, 120, -31,-123,  91, -73, 110, -35, -65, 127,  -1,
   64, -94,  -2,  -9, 126, -17,  -9, -92,-108,   3, 115, -81, -29,  46,  52,  -1,
  -18,-113,-110, -16, -34,  59,  18,-102,-119,  28,   9, -53, -50,  21,  54,  14,
   66,  40,  28,  25,  25,-102,  81,  40, -14, -42, 107,  -9,-104, -77,  15,  53,
  -36, -38, 112, -79,-102,  81, -83,  92, -19, -91, -75, 118,  33,  28,-100,  64,
    1, -74, -58, -85, -90, -21, -63,  57,  73, -94,  40,  98,  33, 116,  24, -55,
   40, -46,  16, -84, -11,  -4, -36, 116,  51, -23,   8, -25, -53,  50,  64, -33,
 -112,  20,  66, -21,-100,  11,  48, -61,  51,  13, -46,  55,   0,  34, -79,  12,
  -48,-127, -68, -16,  47,  89, -31, -53,-128,  22, -65,  30,-108,-126, 126,  61,
 -120,-113,-123, -46, -27, -40,  44,-114,   9,  83, -58, -71,  23, -98,-119, -20,
  -14, 100, -63, -79, -82, -83,  10, 116, -31, -39, 121, -10,-124, -44, -40, -62,
  -10, -62,  48, -86,-107, -85,-117,  21,  95,  91,  49, -34,-114, -76,-116,-107,
  118,  38,  58, -70, -72, 106,  62, 127, -90, -67, 120, 127, -73,-107,   3, -43,
   40,  34, -95, -90,  23, 102,  14, -20, -39,  75,  74, -36, -16, -67,  31, -66,
   -5, -35, -17,  -2, -15,-113, 127,  76,   4,  33,  40, -53,  10,  37, -43, -16,
  -16, -16, 105, -89, -99, 118, -54,  41, -89, -52, -49, -49, 111, -36, -76, -23,
  -54,  43, -81,  -8, -31,-113, 111, -36, -73, 111, -33,-122,  13,  27, -26,  23,
   23, -78, -62,  65,-121,-122,  77, 102,-118,  16,  90,  74, -55, -34,  11,  33,
    1,  -8, -62,  44, -50,  47, -40,  99, -25, -41,-107,  89, -93, -74,  28, 107,
  -90,  85,  22,  43,  17,  11,  54,-103,  45,  10,  71,  10, -98, -70, -22,-104,
   64, -28, -87, -97,  -4, 111,  98, 100,-108,  -5,  30, -83, -84, -29,  82, -81,
    5,-128,  67, 121,  54,   2, 116,  -9,  77,  23, -77,  75,  -3, -39,-123, -10,
  115, -49, -12, -14, -12, -79, -49,  -4, -11,-101, -69,  41,-128,  52,  93, -78,
   37, -68, -91,  -1, -53,  24, -15,  91, -87,   7, 112, -35, 120, -59,  58, -21,
  -67,  -9,  16,  18,  42,  96, -25,  61,  23, -38,  89, -23,  42, -52,-111,-106,
   15, -73, -26,  51,   1,  36,  25,  67, -70,  44, 107,-108, -85, 103, 109, -33,
   90,  90, -75, -22, -15,   7, 127,  49,  49,  49, -15, -20, -77, -49, -34, 127,
   -1,  -3, -52, 124, -19, -75, -41,  62,  -6, -24, -93,  39,-100, 112, -62, 125,
   15, -36,  47, -91, -68, -26,-102, 107, -98,  31,-128, -24, -59,  -7, -64,  43,
  -10, 126, -48,  54, 119,  36,  28,-112, 123,  27,  41,  38,  54,  93, -83,-121,
   -6,  -3,  13, 105, 105,  90,  39, 127, -61,  -3, -35,  16,-101, -90, -59,-106,
  125, -56, -42, 122,  99,  76, 102,  77,  42, -68,   9, -76, -92,  32, -52,-124,
  -18,-101, -71,   8,  89,  97,-109, -92, -51, -19, -59, 120, -79,  50,  60,  60,
   60, -46,  24, -86,-116,  15, -81,-103,  58,  16, -78,  51, -79,  64,  44, -70,
 -123,  29, -40, -22,  57, -31, -28, -15, -91, -44,  64,  59,-105, 104, -48,-108,
  -30,  99,  11, -34,  95, -58, -50, -63,-103, -68, -64,  -7,  -8,  23,  56, -79,
  -25, -57, 102, -63, -16,  96, -14,  32, -94,  40,   8, -83, -75, -50, 123,-110,
   82,  71,  65,  16,  71, 114, -32, -73,-106, 102, -98,   9,  74, -22,  74,-123,
   72,  56, -25,  10,-110,-103, -96, -15,  83,  78,-100, -84,  77,  28, -19, -11,
   -8, -56,  52, 117,  91,-115, 118,  17, -72, -16,  59,  -7, -47,-106,-122,   4,
  -22,  36, -93,  48,-100,  58,  60,-107,-111, -65,  -7,-122,-101,  98, -24, -37,
  111, -65,  61,-118,  34,  32,  43,  10,  95, -83,-106, -69, -35,  -2,-109,  79,
   61, -71, 113, -29, -58,  75,  94, -11, -22, -85, -81, -66, 122, 104, 104, -24,
 -102, -33, 124, -21, -19, 119, -35, -35, -23, -10, -93, -72,  92,  46,  85, 123,
  -51,-106,   9, -92,  97, -28, -42,  42, -95,  33,-123, -13,  -4,-118,  -3,  83,
  -73,-114,-113,-106, -54, -27, -64, -38, -62, 100,  63,  46, -53, -41,  -9, -35,
  -37, 123,  -4, -13,  99,  85, 105, -83,  11, -46,  65,  62,  84, -55,  70,  74,
   67,  39, -84, -39, 112, -26, -87, -75,-115,  91,  68, 117, -71,-111, -94, -89,
   22, -37,  -9,  61,-103,  43,-117, -95,  18,-115, -97, -40,  16,  37,   0, -61,
  -69, -90,   1,  60, -13, -43, 127,  74, -69,  29,   7,  23,   4,-126,-103, -59,
  -79, -21,  55,  86,  46,  57, -62,  -9, -57,  74,   5,-117,  65, -82, 122, -98,
  -43,  39,-104,   8,  50,  40,  67,  69,  14,  14, -42, -62,  43, -17,  75, -96,
  -48, -45,  35, 121,  87,  84,-124, -49,-124,-128, -24, 117,  90, -27,  56,   4,
  -47,  29, -73, -35,  30,-110,-116, -29, 120, -32,   7, -74, 109, -37, -74, -75,
  107, -41, -34, 125,  -9, -35, -37, -73, 111, -65,  -3, -10, -37,  47, -65,  -4,
  114,   0,  89,-106,  69,  81,  52, -64, -61,-117,  65,  42,   0,  37,   4, -32,
    9,  12, -57, 112,  18,  66,-118,-112,  61,  90, -83,  35,  95,  -3, -37, -22,
  -77,-113, 108,-128, -83, -86, -46,  29, 121, -14,-115, -94, -69,  78,-106, -34,
   41, -58,  78,  58, -38, -93,  90,  32,  74,   1, 115, -50, -20,-119, -39,-109,
   79,  53, -40,  91, -55,  62, -16, -66, -41,  77,  58, -51, -59, -93,   7,  14,
   12,  24,  30, 121, -87,  47,   9,  99,   6, -85, -87,  54,  17, -44, -83, -12,
  125, -40,  76,  -6, -64,   8,   0, 124,  12,-127, -57,-109,  57,  61,-113, 111,
   -5, 124,  29,  93,-117,  95,  63, 126, -61,  -4,   2,  32, -90, 101,  39,  62,
  -14,  12,  64,   2,   4,   2, -93, 107,  50,  33,-124,  12, -75,-118,  35,  25,
    6,  78,-118, -52, -39, -62, -38,  17,  17, 123,  37, 114, 112, -58,  28,  86,
  -53,  67,-115,-122,  -9, -66, -45, -22, -54, -93,  11, -83,-125, 105, -73, -45,
  -74,   7,  15, -55, 126, -85,  90,  25, 122,  70, -60, -33,  88,-126,  23,  24,
   26,  30, -74, -35, -92,  94, -87,  30,-103,  93, 120, -57, 111,  95, 123, -10,
  -39, 103,  63, -13,  -8,  83,  39,-100, 112, -62,  99,-113,  61,  25, -57, 122,
   98,  98, 100, 118, 118,  94,  43,  93, -87,  84, -34,  -8, -58,  55,  30,  56,
  112,  96, -17, -34, -67,-112, -30,  45, 111,  -3,-115,  11,  46, -68, -16, -58,
   27, 127,  50,  59,  59,  75,  82, -28,-128,  35, 114,  68,  22,  68,  66,-110,
   16,  68,  22,  64, -71,  20,  37,  89, -22,   9,  50,  12, -36, -79, 115, -73,
  -85,  70,   7, 127, -84, 120, -29,-107,  97, -71, 114, -30, 105, -89,-105,  86,
 -116, -73, 122, -67,  35, -13, -13,  71, 127, 113,   3,  22,  -5,  -6,-101,  -1,
  112, -18, -83,  63,  91,  -9, 127, -66,  -2, -36,  71,  -1, -65, -56,-112, -24,
   23, -22, -47,  39, -41, -33, 122, -13,  13, -27, -58, -21,  -6,  45,   0,  87,
  116, -26, -81,  27,  14, -95, -43,  97, -93,   2,  33,  75,  36, -82,  27,  29,
  -71, 102,  97, -47,  24,  73, -60,-126, -88,-112, -53,  87,-102,-103,   5,-111,
   56, -90,  21,  87, 120,  45,  29,-119,   1, -51, -36, -72,-104,  73,  67,  53,
   11, -77, -41, -61, -25,  30,-106, -99,-128, 119,  -4, -12,  83,  79,-100, -11,
 -110,-105, -36,  -5, -56,-114,   4,  -7,  41, -89,-100, -78, -80, -80, -80, 121,
  -13, -26, 119, -67, -21,  93,  95,  -5, -38, -41,-122,-121,-121, -17, -70, -21,
   46,   0, -97,  -3, -20, 103,   1,-124,  97, 120,  60, -90, -68,  72, -49,  98,
  -75,  76,  25, 116,  32,   9,   0,  33,  36, 108, -15, -44, -51, -73, -52, 124,
   -8,  83,  91, 125, -65, -48,  24, -87,  85, -50,  55, -61,  15,  44, -50, -35,
  -29, -77,  59, -22, -77, 111,-116, -30,-117,  69,  -4, -54,  52,  62, -47,  23,
  115,  65, 126, -92, -20,  91, -79,  -9,  57,-113,-101,  64,  41, -91, -76,  38,
   37,  61, -72,  48,  38, -73, -58,  90,  59,-107,-120, -66, -76, -69, 108,  -6,
   68, -42, 105, -72,  98, -46,  69, -21,  80, -38,  24, -43, -25, -94, -91, -63,
  -79,  -6, -63,-126,  -2, -40,  55,  89, -54,  95, -97,  26, -28,  11,  36,  10,
 -121,  23,  42,  15,-120,-103,   5,-125,   5,  63,  95,-109,  54, -84,  86,-126,
   56,-118,  74, -79,  84, -54, -78,  47, -84,  33,  98,  37,  72, 120, 105, -68,
  -25,  40, -88,  14,  85,  27, -29, -29,-107,  74,  37, -23, -10, 122, -67, -52,
  -19,  60, -72,-108,   7,  25,  88,  73,  81, -82,-106, -30, -47, -47,  29,  75,
  -35, 121,   1,  56, -31, -99, 112,-124, -87, -93,-121,   0,  92, 117, -39, 101,
  -81, -66, -12, -46, -17, 125, -25,  -5, -37, -73, 111, 127, -14, -55,  39, -53,
  -27, -14, -24, -24, 104,  16,   4,-121,  14,  29, -71, -24, -94,-117, -50,  63,
   -1,  -4,  -9, -66,  -9, -67,  67,  35,  99,  73,-110,  60,  -7, -44,  51,  87,
   92, 113, -27,-115,  55,  -3, 100, 113, -87,  53,  62,  62, -66,  56, -33, 116,
   36,  88,  72,-110,-110,   5,  65, -48,  96,  56,  -4,  -4,   3,-121,  -1, -11,
   73, -83,  -5, -99,  55,  63,  -5, -87,  63,  62,  -7, -61, 127, 122, -42,  -9,
  127,  -4, -64,  53, -41,  28, 124,  98,  -9, -36,  77,  63,  85,  44,  87,-116,
   79, -44,  78, 123, -23,-102, -81, 125, 116, -22,  11, -97, -38,  -5,  39,  -1,
  117, -61, -57,  -1,  -4, -92,-113, 125, -14,  -8, 127,  -3,  83,  64, -74, -92,
  -65, -67, -90, 106,   5, 108,-111,   7, -79, -84,  68, -15, -38, -68,  86,  56,
  107,  92,  81,  72,  -6, -42, -70,-107, 102, -76,-102, -77, -53, 125,  49,  82,
    8,  34,-110,-125,  70,  31, -29, -72,  38, -73, 115,-126,   0,-106, -46,  43,
  -46,  86,-108, 101, -20, -61, 104, 103, -46, -19,   5,  32,  25,  42,  86, -98,
   29,  28, 126, 118, -49,  61, -81,  -6, -32,  37,  35, 113, -67,  93, 116,   7,
   14,  51, -17, 125, -17, 123, 119, -18, -36,  25,  69, -47,  25, 103,-100, -15,
   87,  95,  -8, -85,  70, -93, -79, 121, -13, 102,  99, -52,  64, 119,  86, 107,
  125, 124,  78, -23, -33,   7, -85,-125,-105,-112, -16,  80,  26,  14,-112, 108,
  -47, -18,  63, 114, -13, -19,  27,  78, -35, -16, -90, -80, -68, -29, -48, -82,
   -5, 103,-102, -67,  82,  86,   9, -29,  21,  46, -35,-107, 101, -33,  34, -71,
   59, 107,  46,-104, -32,  28,  29,-108, 107, -60,-123,   3,  57,  48,  66, -55,
  -50, 102,  69, -42,-121,  -9,   0,  24,   8,   0,   5,  62, -51,  86, 100,  28,
  -89,-111,  95,  50,  69, -57,-101,  37, -50, -89,-118,  69, -37,  91, 120, 109,
   99, -24,  24, -99,-124,   1,   8,   6,  51,  60,  13, -84,  86,   0, -64,  -5,
   95, 113,-103, -14,  47,-128,  86,  -9,   2,-123,-128,  39,  79,-125, -56, -54,
    0,  67,  16,  13,  72,-122,-126,   8, -42,-103,  36,  43,-104, -83, -75, -58,
   59,  34, -46,  82, -74, -56,  33,  80, -43, -47,  70,  99,  98,  66,  41, -43,
   91, -22, 118, 102,  23, -14,-123,  37, 105, 114, -53,  36,  85, 104, -22,-111,
   48, -94,-120, -94, -37,  22,  -9, 122, -93,  38,  27,  43,-102, -19, -91, -96,
   18, -12,  90, -39, 127,  -7, -35, 119, -49, -20, -97, 122, -30, -79,  29, 127,
  -13, 119,  95, 125, -33,  -5, -34,  -9, 119, 127,  -9,  15, -67,  94, -81, -45,
  -39, 109,-116,  29,  30,  26, -66, -12, -46,  75,  -9, -18, -35, 123, -21, 109,
  -73, 110,  56, 113,  67, -87,  84, -38, -79,  99, -57,  69,  23,  93,  52,  52,
   60, -68, -44, 108, 122, -17,  33,-123, 101,  24, -49,-114,  80,  88, -61,  36,
 -120,   9, -64,   3,  39, -83,  74, -46,  44,  41, -52, -56, -60, -86, -38,  -8,
 -118, -45, 110, -65,  11, -64, -98,-101,  30, -77, 105, 126, -14,-121,  -1,  20,
   64, 115, -18, 104,  99, -21, 105,  27, -73, -97, -61, -91,  96, 122, 105, -82,
  113, -37, 109, -64,  71,  15, 124, -32,  83, 105, -98,  63, -11, -87,  47, -89,
 -111, -74,  74,  50, -77, -86, 112,  54,  20, 101,   4,   2,  52,-108,-128,  68,
  -63,  38, -13, 109, -33,  28,-116, -11, 122,   6, -25,  30,  57,  34,  69,  37,
   33,   6,  73,-103,  -4, -32, -70,  49,  27, 107,-103, -39, 121, -88,  40, -75,
  -82, -81,-100,  17,-126,  60, -53,  32,  88,-118, -29,  59,-110,  89,   0,  72,
   92, -92, -29, -82,  77,-125, -70,  78,  19, 115, -49, 125,  63,  -1, -24,-121,
   -2, -57,-125, -49,  62,  58, -40, 113, 108, -75,  90, -49,  61,  -9, -36,  59,
  -34, -15,-114, 111, 126, -13,-101, 113,  20,  -1, -63,  31,  -4,   1,-128,-127,
   75, -62, 113,-126, -57,-117,  92,  96,-111, -31,  84,  -7,   0,  86, -80,  70,
  -97,  80,-127,  69,  47,  -7, -54, 111, -68, 125, -18, -26,  59, -34,  -4, -22,
   11, -11,  -6, -38,  47, 110,  -2, -39, -61,   7, -25, -10,-114, -42, -28,  98,
  -63,  90, -20,  50,-109, -69, -94,  89,  87, -21, -98,  93,  82, 111, -53, -62,
  115,  90, -48, -50, 117,  66, -28,-115,  80,-110,   8,-124,  84,  32, 118, -34,
   24,-109,-101, -62,  57, -25, -75, -44,  30,-127,  19,   1,-108, -46, -95, -43,
  106,  49,  79, -26, -69, -35,  19, -86,  21,  12,  58,  15,  68,  16, 116,  60,
 -114,  30,-113, -79, -57, -51, -95,-105,  49,  27,  -2,  -6, -54, -58, -65,  80,
   25,   0,   3,  12,-108, -32,  73,-126,   6,  96,  21,  32,  33,   4,  49,-114,
   79, -59,  28,-105, -12,  -9, -21,  86,-105,-121, -22, -70,  92,  94,  90,  90,
   90,-104, -98,  87,-103,  45,  91, 114, -35, -52,-116,  22,  37,  53, -84,  11,
  -39,  86, -55, -22,  52,  43,-113, -83, -69,  -4, -31,   7, 118, 115,  99,-126,
 -123, 111, -88,  -7, 100,  78, 106,  60, 124,  -5,  93, -65,  -1, -98, -33, 127,
   -4, -23, 103, -41, -97, -70,  -7,  39,  55,  -2, -16, -53,  95,  -2, -14, -89,
   63,  -3, -39,  40,  10, -62,  48,  -4, -67, -33,  -3,-125, 107, -81, -67, -10,
  -99, -17, 124, -25,   3,  15,  62, 112, -18,  57, -25,  22, -42,  52,-101, -51,
   15, 126,  -8,  67,  63,  -8, -63,  15, 110, -69, -11, -42,-119,-107,  43,  -5,
   51, 115, 103, -55, 104,-120, 122, -17, -44, -11, -72,  65,   8, -24,  53, 123,
 -101, 119, -97,  56,  41,  77, -26,-123,  60, -78, -40,  68, -71, -66, 106, -13,
  -87,-115, 117,  27, -74,  -4, -61,  55,   0, -52, 127, -19, -49,  22,  14,  30,
  -38,  -4,  63, -65,   0, -32, -95,-105, 109,  79, -90, -25,  93, -73, 119, -55,
  -62,  18,-128, 111, -22, -64,   6, -28,  35,   1,  56,   7,  67,   4, -95,  73,
   39,  65,  64,  58,  36, -51,  22,   5,  -5,  20,  34,  87, -62,  42,  26,  22,
 -103,   7,  51, -32, -55,  11,  64, -80,-105,  30,-126,-111,  72, -27, -67,-121,
  -13, -20,  60,   1, -53,  93, 106, -49, 125,   3, -57,-100,   8,  36,  26,  46,
   71,  77, -56, 125,-115,  -8, -97,-102, -67, 110,-120, -70, -85,  20, -42, -26,
   17, -68, -53, -32,  49,  94, -85,  -3, -34, 111, -66, -17, -46, -73, -67, 126,
  -57,-114,  29,-109,-109,-109,  71,-113,  30, -83,  84,  42,  -9, -35, 119, -33,
  117, -41,  93, -73, -76, -76, -28, -40,  39,  73,  82,  42,  45, 115,  -1, -14,
   60,  31, -44,   3,  47,  42, -78, -26,   8,-107, -96,-127, -23,   9,  81, -31,
  -64,  82,-119, 126, -83, 118,  23,  37,-107,-101, 111, -71,  -6, -36, 115,  46,
  125, -59, -71,  27,  15,  29, -70,  -9, -47, 103,  31, 114,  73,  57,  24,  61,
   61,  56,  48,-106, -71,-108,  43,  79, 119, -45,  63, -42, -67,-113, -82, -33,
  124, -63,  92, -89, 109,-114, -70,  86,-119,-123,-125,  52,  65,-120,  40, -48,
   66,   7, -46, 106, -74, -98, -75, 115,  96, -81,  85, -50, -94,  95, -28, -62,
  -39,  88, -23, -15, -72, 124, -64, -58, -29, -38,  86, 124, -22,-115, -75, -70,
  -20,  41,-116,  97, 107, -46,  47,-111,  16,-126,-114,  47,-100,  -4, -79, -19,
  -16,  28, -39, 113,  67,  51,  -9, -68,  25, -41,  48, -25, -50, 112,  88,  93,
  -54, -67,-106,  49, 105,  78,-117,-123, -86,  26, -21,-117, -82, -12,-110, -92,
  115,  46,  80, -95, -55, 109,  24,  71, -34, 120, -57, 108, -75, 112,-123,   9,
   84, -88,-108,  54,  32,-114, -93, -14, -16, 112,  52,  84,-113,-123,  50, -35,
  118, 115, -49, -98, -92, -75,  16,  27,  39,  85, -20,  75,  85,  63,  20, -78,
  -96, -44,  10, -39, -18, -23, -79, 126, -99,  84, -74, -56, -69,  37,  96, -14,
   36, -26,-110,  44, -55,   2, -65, -13, -50, -33, 121, -16, -79, -89,  31, 120,
  -26, 105, -49, -68, 119, -49, -82,   7,  30, 120, -24,-102, 107, -34,  -6, -64,
    3,  15, -19, -38, -75, -21,-110,  75,  46,-103,  92,  57, -15, -12,  51,  79,
   -2, -30,-111,-121,-108,  84,  51,  51,  51,  39, -98, 120, -30, -63,-125,   7,
   91, -51, -91,  65, -55,  36,-128, 122,  76,-103,  77,  38,-120,-106, -76,  25,
   66,  28, 113,   0, -96,  39,  85,   9,  58,  32, -71, -94,  92, -17, 118, -69,
  -23, -77, -69,  70, -59, 114,-101, 105,  -1,-105, -65, -43,-100,-103, 123, -30,
   79, -65, -28, -84,  -1, -83,  99, 105, -25, -70,-112,  56,-116, -54, -11, -64,
   51,  59, -10,  14,   2,  20,  65,   8,  87, -72, -56,  69,-103, -90,-106, -80,
   94, -39,  50, -87, -86,-106, 117,  41, 114,  56,  54, 105,  73, 106,  97, -39,
   25,  75,  36,  13, -56,  16, 115,  32, 101,  63,  37, -53, 105, -50,  14, 100,
  -94, -14,-111,  44, -99,-122, -89,  40,  56,  44, 125, -71, -34,  80, -75, -58,
  -59,  87, -68, -18, -84,-117,  94, -15, -10,  -9, -66, -17, -48, -30,   2, -93,
   44, 109, -42, -15, 125,   6, 107, -89,  21,   5,-123,  43, -70,-103,  -7, -63,
  125,  55, -49, 115, 115,  -5, -10, -19, -67,  78, -45, -28,  -3, -37, -17,  -5,
  -39, -30, -30,  98, -46, 107,  77, -19, -33,  13, -32,  56,  82, 113, -84, 114,
  125, -79,  96,  37,-112,  -9,  94,  64,   0,-112,  16,  30,  78,  18, -99, 124,
   -6, -87,  -1, -11,   7,-128, -84, 100,  15, -19,  90,  -9, -36, -98,  83, -73,
  110, 122, -37,   5,  23, 108, -35, -69, -17, -89,   7, -98,  11, 114,-112,  67,
  -26, 109,  27, -66, -39,  65,  87, -49,  39,  94,  57, -91,  53,  41, -25,-100,
  -13,  54, -53, 108, -31,  10,  15, -23,  60,  57,-127, -78,  39, -63,  32, 118,
  100, -99, 103,  79,  36, -67, 119,-103, -73, -85, -92,-119, -55,  18,  23,-123,
   98, -89, -99,  67, -34,  53,  -3,  44, -53, 115,  89,  91, -34,  23,  21,  60,
  -48,   1,  24,  68, -63,  70,  22,  61, -33, -47, -17, 120,-123, -32, -40, -21,
  -82, -92,-100,  19,  29,  20,-106, 125,  46,-117,-110,-126,  82,-118, -68,-108,
 -110, -39,  65,  42,  21, -23, -36,  -7, -84, -56, -30, -72,  84, 117,  41,   0,
  -31,  51,  69,  40,  87, -86,  97, -75,  98, -39, -12,-114,  30, 106, -74,  -5,
  -16, -58, 102, 125, -25, -99, -42,  90,  69,  33,  19,-103,  34,  39,  99, -68,
   42,  88,   2, -42, -59,  62, 122, -56,  52,   7, -98,  50,  82, -54,  36,  73,
  -92, -96, -13, -49,  63,  -1, -17,  -1,  -2, -17, -99,  99,   0,  89,  86, -36,
  127,  -1,  -3,  90, -21,-119,-119,-119, 107, -82, -71, -26,  31,  -1, -15,  31,
  -17, -68, -13, -50, -41, -68, -26,  53, -11, 122, -67,  90, -87,  59, -25, -62,
   48,-116, -29, 120, 110, 110, 110, -59,-118,  21,   3,  81, -20,  18,  72,-128,
  -59,-128,  34, 118,  -4, -25, -40, -78,   3,  66,  72,  41, -69,  75, -83, -57,
  127, -15, -56, -96, -37, 122, -32, -71,  61, -74,  40,  28, 121,  93,-110,  63,
   28,  46,  67,-109,  35,-120,-111, -54, -94, 115,  82,  46,  19,  97, -56, 121,
  120,  38, -17, -55,  99, 126, -60,  40,  33,  75,-114, -94,  84,-107,  82,  71,
  -71,  75,   3, -31,   2,  10, -87,-100, 102, -58,  57, 104,  85,  97, -87,  90,
  -67, 110,  43,  47,  28, -16, -72,  64,  41,  36,  31,  74, -95, -93, -79, 117,
  -21,  86, 111,  57,  -3, -94, 115, -50,  58, 121, -37, -42,  77, -37, -73,  33,
 -118,  65, -62,  91,  79,  65, -12, 113,  -5, -39, 119, -66,  -3,  29,   8, -75,
   75, -36, -96, -18,  52, -58,  44,  51,-116,-117,  98,  96, 115, -68, 115, -25,
   78, -17,  -3, -30, -30, -30, -47, -93,  71,  31, 126,  -8, -31,  43, -81, -68,
  114, -11, -70, 117,  47,  30,-102, -65,   6, -84,   2,  -2,  56,  88,   5,-108,
  -75,-123,  22,  98, -37,  -7,  47, -69, -38, -84, -67, -98,  15,  78, -59, 120,
  -89,  26, 111,  62, -16, 120,-116, -30, -62,  51, -73, -68,  -1, 117,  87, -34,
  -11, -12,  83, -69,  15, -50,  28, -22, -92,  42,-110,  75,   2, -86,-101, -10,
  -29,  74,  30, -60,   1, 123,  65,   4,-106,  68, 108,-103,  11,-104,-100, -56,
   74,-106,  86,  72,  33, -68,  27, 112, -26, -95,  33,  45,  56,  97, -65, -62,
  -76,-120,  96,   5,  59,-110,  68,  28,-110,  83,   4,   5,-124,-125,  80,  74,
   30,  12,  90,  46, 127,  29,-128, -66,   8,   0,-120,  99,  89,  27, -64,  96,
   14,  46,  35,  51, -62,  50,  13, -59, -68,  52,  85, -61,-115, 106, 100, -76,
  -77,-117,  75, -78,  42,   8,  90,  19,  75, -94, -52,  23,  68, -92,  66, -49,
   34,  91,  72,-110,  90,  61,  42,  55,  42,  82,-121, 125, 103,  22, -38,  71,
 -110,  94,-102, -10,-109,  74,  70,  66,   8,  18, -60,-126,-100,-106,  90, 105,
    2, -56,  24, 101,  77,  63, -52, -83,-128, -15, -43,  67,   0,   0,  27,  53,
   73,  68,  65,  84,-124,  72,  77, -39,  71, -73, -11,-113, -62,   3, -95, -16,
  -34,  39, 105,  54,  49,  62, -74, 126,  -3,  -6,  -5, -18, -69,  47,   8,-108,
  -75,-106,  25,   7,  14,  28, 120, -10, -39, 103,  59, -99, -50,-102,  53, 107,
  118, -19, -38, -75, 113, -29, -58, -69, -18, -70, -85, -39,  92,  10,-125, -40,
   24,  19,   4,  65, -93, -47, -24, 116,  58, -75,  90,  13, -52,  73,-110, -44,
    0,-123, -25,  -9,-118,  25,   0,  91,-105, -39,  66, 120,  14, -96, 106, -75,
   90, -55,  35,  61, -74,-127,  23, 122,  82,  65, -56,  90, -70,  64,  38, -60,
  -58,  21,-106,  61, 121,  82,  70, -40, -36, -72,-127,  23,  92,  16, -21,  99,
   74, -99, 107,  22, 103, -70,  10, 125,  77,  89, -96, 114,  82,  42, 101, -18,
   27, 116,  -3, -68, -77,-116, -96,  69,-104, -26, -10,  17, -96,  15,-116, -82,
   94, 117, -30,  41,  39,  -3, -89,  -1,  -4, -98, -45,  78, -39, -68, 118,  -3,
    6,-124,  33,  36, -79,  64,  31, 112,  16,  57,-100,-121,  23,-112,   5,  21,
   33, -47,  27, -33, -14,-122,  -1, -14, -33,  71,-106, 102, 103,   1,  12,   4,
  114, 112,-116,  99, -28, -67, -17, 118, -69,  -1,  -5, -77, 127,  62,  62,  54,
  108, -83, 109,  46, 117, -62,  64, 126, -32,   3,  31,  -8, -97,  31,  -1,  -8,
  127,   4, -87,   3, -80,-126, 104,  89, -92,  69,   0, -52,   2,-126,  86,-100,
  126, -38, -69,  57, -97,   3, -10,  25, -20, -22, -50, -99, -43,  88, -79,-104,
  119, 127, -80, -29, -23,  85,  79, -17, 123, -55, -74, 117,  39,  15,-115, -18,
 -101,  95, 122, 116,  97, -18, -56,  82, -89, -60, -36,  37,  94,  76,-116,  84,
   78,   0,-110,-104,  88,  42, -63,  36, -92,-110, -20,-108,  48,-103, 101, -48,
  -96, -35,  14,  65,-114, -68,  97, 100, -28,  33, -91,   9,  84,  26, -24, -36,
 -110, -78,  66,  67,   6,  50, -48, -54, -61, 102,  32,  79,  12, -14,  60,  -8,
   99,-128, -47,  52,  60, -82, 106,   1, -31,-119,-114, 121,  93, -89, -79, -95,
   86,  34,  37, -58, -93,  74, -87,-105, -87, -76, -33,  40,  -4,  74, -87,  91,
 -123, -52,-118,-108,   9, -98,  60,  27, -60,-107,  32,-120, -62,  44, -53, -22,
 -107,  49, -87,   2,  42,  20,  59, -47, -21, -11, -52,  98, -89, -52,  98,  68,
 -108, 109,  69,  16, -96,  73, -75, 109,-111,  91, 111,  61,  11, 120,   5,   4,
  -71, -17, -56, -62,  74,-118,  50,  22,  58,  -8,  89, -47,  31, 108,  90,  88,
  107,   1,-100, 112, -62,   9,  59, 119, -18,  52, 102,  89, -92, 106, 114, 114,
  -30, -64,-127,   3,  68, 116, -34, 121, -25,-123,  97,  -8, -46,-105, -66, 116,
  -53,-106,  45, -41,  95, 127,  -3, -64, -13,-110,-103, -61,  48,  28,  -8, -70,
    7,  65,  32,-107, -86,  86, -85, 122, 105,  81,  51,  41,  57, -40, -55, -13,
  -25, -18,-101,   6, 112, -27,-127, -23, -97, -84,  25, 114, -50, -90, -58,  74,
    6, 123, -70, -94, -67,  60,-101, 122,  85, -73,  -1, -29,-111, 122,  46,  96,
  -68,  43, -68, -73, -42,  43,  41,   3, -87,   2, -19, -67,-121,-110,-127,  96,
   98, -25, -67, -55,-115, 113,  68,  20, -40,  56, 114, -50,  25,  74,  61, 102,
  -77, -94, -23,  76,  83,  82,  86,   9, -53,  93, -43,  88, -77, 106, -12, -76,
 -109,  95,  -7, -78, 115,  79, 127, -27,-123, 107, -49, -36, -94, -53,  53,  11,
 -111,  36, -74,  90,  82, -52, 112,  30, -58, 121,   7, 114,-126,   9,   2,  14,
 -111, -44, 121,-106,  85, -93, -56, -92,  89,  37,  80, 119, 124, -17, 123, 111,
  126, -13,-101,  -9,  29, -99,  61,  62,  48,  23,   4,  65,-102, -90,   0, -78,
   44,-109,   2,-117, -83, -74,  49, -82,  82,  41, -35, 122, -21, -83,  47,  61,
  -17,  60,   0, -34,  57, -15, -94,-106,  82,  47,  28,  89, -91,  20, -16, -16,
   30,  82,-128,  84,   0, 118, -88,  55, -10, -98,  29,  95, -79,   3, -11, -47,
 -119, -23,  34,-101, -21, -76,-107,-106,  89,  57, -56, -32, -78,   7, -98, -88,
   43, -47,  88, -71, -22, -83,-105,  94,  34,  85, -12, -13, 123, 126, 126, 104,
  102,  54, -82, -43,  50, -97,  72,   6, 121,  22,-114,   7,  27,-104,   1,  49,
 -111, -17,  41,  98,-126,  99, -80,  36,  16,  89, -49,  57,  59,  39,  41,  19,
  -47,-110, -57, 124,-114, 118,-102,  33, 119,   2, -46,   6,  58,-107,  88,-103,
   13, -28, -18,  73,-111,-108,   2,-110,-124,  18,  36,-124,  24,  78, 121, -48,
   52,  29,  44, -29,   6,  -2,-126,-118, -31,  80, -80,  38, 103, 115, -35, -10,
   14,-127,-101, -88, -10,-110, 108,  79,-110, 103,  73, -24, -95,  25,  44,  20,
    9,  33, -38, -99,  66, -10,  17, -60, -11, -76,  80, -99, 118, 119, -87, -33,
 -107,-127,  84,  74,  69,  20,  84, -62, -88,-103, 100, 105,-103, -86,-106, -58,
 -126,  80, -77,  79,  93, 110,  76, -82, -96,  20,-109,  36,-122, -77,  22,  28,
   58, -76,  52, -10,  58, -80, -44,-118,  45,  51,  75,  65,  27,  54, 108, 120,
  -12, -47,  71,-107,  18, -58,  -6, 122, -67, -70, 117, -21, -42,  77,  27,  55,
   94, 118, -39, 101,  90, -21,  78, -89, -13,-119,  79, 124, -30, -16, -31, -61,
   90, -21,-113, 125, -20, -29, -52, -36, -21, -11, -42, -81,  95, -65, -44, 110,
   17,  81, -77, -39, -12, -34,   7,  65,  16,  56,   4,   4,   5,  65,   4, -17,
   -3,  -3, -21,  70,  83,  79,  61, -21, -75, -16,  82,  74,  98, 120, -21,-120,
  -24,-106, -95,  26,  11,  98,   8, 107, 109, -31, 109,  65, -98, -91,  12, -92,
   46,   9,  21,  64,-121,  80,  61, -45, -12, -50,  65, -95, -56, -83,  45,  44,
   44,  10, -10,  26, -14,  41,  68, 109,  -8,  89,  20,  75,-128,   8,  42,  39,
  -66, -20, 101,  87, -66, -27, -22, -83,-105,  94, -76, 106, -45,   9,-112, -54,
   65,  25,   8,  64,   9,-112,   0,  66,-113,  32,  86,-125,  -2,-119,  98,  40,
   41,  64,  96, -17,-104, -84, -32,-128, 123,  54,  10,  35, -18, 101,  58,-114,
   64, 126, -37, -10, -19, 123,  -9, -17,  41,  16,  60, -12, -48,  67, -73, -35,
  118, -37,  99,-113,  61, 118, -12, -24, -47, 126, -65,  95, -83,  86,  39,  39,
   39, -41, -84,  94, -71, 117, -21, -42, 119, -67, -21,  93, -58,-104, -72,  84,
    2, -77,  49,  70,   7, -63,  -1,  59,  84,   1,  53, -80,-101,  92, -74,-106,
  100,   8,  18, -98, -67,  80,  -8, -49, 119, -34, -10,-121,  39, -67,  -4, -34,
  -23, -39,  26, -80,  10, -62,  75,  95,  84,   0, -32,  72,  32, -83,-118,  15,
  -49,  76,  63, 115, -13,  77,-109, -91,  -6,  98, -89,-109,  73, -25,  59, -35,
   66, -28,  82, 106,  37,  67, -91, -92, 102,  10, -68,-109, -42,   8, -21, 101,
   32,   8,-126, -31,-123,  16,  44, 100, -18,-116, -15,  76,  74, -11, -83, -98,
  -55,-118,-125,  54, 109,  91, -29,  28,-110, -64,  28, -16, 118, -97, -29, 110,
  -96,   6,  41,  94, -63,   9,  80,  32, -92,  36,  72, -94,  83, -70, -39, -32,
   48,  53,-124,-106,  82,  65,  40,  18,   4,  68,  38, 106,  56,  27,  58,  62,
  -63,-118,   3,-108,  61, -46,-101,  63,  50, -17,  25,-112,  27,  86, -83,-104,
   28, -81,  86,  43,  81, -96, -92, -92, 125, 123, 118,  51,  -4,-106,  51, -50,
   52,   7,  30,  -9,  28, -10,-110, -80,  95, -92,  89,-106, -44, -85, -75, -95,
  122, -23, -24, -47, -42, -40,  81, -65, -38, -32,-100, -70, 106,  48,   7,   0,
  -79, -73, -50, -79,  87,  90,  18, -63,  81,  81,-108, 101, -76, -57, 101,-114,
    1, -87, -76,  51,  74, -87, -62, -40, 122, -67,  62, 117,  -8,-112, 115,  94,
  107,  89,  46,-105, -21, -11,  -6, 101,-105,  93, -26, -67, -97, -99, -99, -51,
  -13, 124,  97,  97, -31,  47,  -1, -14,  47, -75, -42, -33,  -7, -50,  63,  -2,
  -39, 103,  62,  59,  63,  63,  95, -85, -43,  70,  71,  71,  39,  39,  39, -89,
  103, 103, -40,  -5, -23, -23, -23,  49, -25,   2,  37,   2,  69,-126, -56, -61,
   57,  71, -20,  33,  60,  27,  83, 104,  33,  25, -62,  17,  67,-112,-110,   2,
 -128,  51,  14, -95,  34,-117,-112,  72, -86,  64,  74, -19,  45, -37, -62, -10,
  -45, -84, -58,  81,  43,  77, -37, -62,  44,  56, -45,  15, -91, -87, -57, -77,
   -3,  94, -41, -72,  60,   8,  54,  95, 124, -31,-107, 111, 125, -61,  89, -81,
  -72, 120,  98, 114,-107,  16,   1,  11, -23, -91, -24,  35,  -9,-128,   7,   2,
   40,   9, -46,   0,  91,  16,  64,  10, -20, -64, -20, -60, 114, -81, -48,  19,
   49,  49, -27,  89,  17,-106,   2,  16,  72,  71,  89,-111, 122,  66,  16,   6,
    0,   2, -88, -13, -50,  59, -17, -36, 115, -49,  29, 120, 120,  28,   7, -42,
  -15, -83,  41, -91, -61,  65, -39, -29, -39,  62,-113,-118,  -4,  -1,   4, -42,
   99,-122, -88,  52,  56,  56, 102, -80,  80,   5, 108,  16, 111,  -4,  -4, -77,
  123,  30, 121, -32, 103,  95,  -4, -32,-121,  31, 123,  -4,   9, -19, -96, -37,
 -104,  12, -80, -64,  98, -91, 117,  97,  44, -93,  34,  87, -23,  66, -37, 121,
  -44, -93, -70,  11, 103,  91,-103,-105,-123,  13,  72,   4,  97, -84,-125,-102,
 -108,  85,  31,-124, -16, -62,  21,-125, -36,  77,  66, 121,-126,  41,  92,  14,
   23,-122, -70, 107,-111,  18, -92,-106,  35, -54,   7, -20,-106, 116, 116,  72,
 -105,  91, -58, 113, 105,   8, -98, -55,  59, -29, -68, 100,  54,  12,   1,-110,
   76, 119, -83, -52,   0, -64, 122,  56,  15, -25, -31,-105, -89, -89, -74, -82,
   60, -23, -87, -87, -57, -42, -91,  -7,  -5, -58,  38, -10, -86, -42, -99, -66,
  115, -14, -71, -25, -68,  -1,-109, -97, 123, -61,  43,  94, -34,  79,-118,   3,
  123,  -9,  60, -67, -29, -15, -35,  59, -97, -34, 121, 120,  97, 113, 126,  78,
   30,-104,  62, 125, -17,  98,  20,  69, 117, -30,  60,  71,  59, -15,  43, -85,
  -15,  -6,-119, -11,  43,  16, 124, 127, 105, 118,  49, -17, -83,  49,  69,  77,
  112,   0, -53, -16,-103,  39, 120,  74, -55,-109,  32,  89,  -8,  82,  20, -34,
  -97, 117,  97,-127,-128,-108, -11,-125, -27, -99,-108, 114, 122, 122,-102,  25,
  -50, -71,  36,  73,   0, -36, 122, -21, -83,  51,  51,  51, -41,  92, 115,  77,
  -75,  90, -67, -29,-114,  59, 110, -65,  -3, -50,-109,  78, -38, 120, -18, -71,
  -25, 126, -31,  11,  95, -72, -31,-122,  27,  70,  70,  70,   6, -26, -85, 123,
  -10, -19,   5,  81, -91,  82,-111,-117,  45, -83, -95,-124,  36,  98, -17, -67,
 -121,   7,  19,  60,  75,  15,  38, 118, -16,-106,  61, -80,  44,-122, -23,   5,
 -100,  43,-100, 103,   6,  49, 108, -18,-112,  88, -45, -51,-117, -62,  -7, -44,
  -24,  37, -72, -60, -21,  78, -91,  54, 121, -10,-103, -25, -65, -23,  13, -89,
   95, -12, -78, -11, -89, -98,   2,-118, -91,   8,   8,-112,  12,  88,-126,  64,
   42, -87,   7,-116,  15,-122,-100,-103,   7,  22,-113, -58,-101,  66, -78,  36,
   29,  65,  12, -52,  47,   6,   3, 106, -34,  66,-110,  36,  33, 100,   5,  22,
   40, 108,  49, -88,-119,   1, -92, 121,  26,-121,  49,-114, -55,  88,  28,-121,
  -44,-128, -77, -87, -75,  30, 120,  30, 105, -83, 107, -75, -38,-128, -77, -14,
   31,-126,  42, -96, -64, -20,   7,-125, 119,  36,-105, -39,  31,  10,  30,  50,
   81,-112, -75, -54,  -7,  23,  95, 126,  -2, -67,  23, -52,-118,  -2,  55,  62,
  -10, -39,  31, 127, -18, 111, 119,  23,  89,   8, -76,-111, -42,-127, -70,  69,
 -115, -67, -86,-126,  34, -99, -50, 116, -57,  87,-116, -74,  10,  51, -99, -90,
   75, -67,  46,-125, -21,  10, -93,-127, -86,  75,  53,  41, -76, -25, -27, 108,
  108, -40, -77, 115,-106,  93,   8,  44,-104,  94,  46, -88,  26, -88,  97, -26,
  122,-122, -91,  66, -74, 109,  48, 107, -24,  64,-100,  14, -66,  50,  32, -25,
   25,-122,  88,-109, -16,  32,  36,  94,-112,  16,  36, -91,-105, -62, -77,-122,
    8, -92,  20,  66, -16, -28,  10, -53,  99, -30, -32, -63,  53,  78, -82,  14,
  -12,  80,  24, -97, -86, -57, -74,  14, 109,  -4, -34,-105, -65,  -6, -32,   3,
   -9,  63, -10, -16,  67,   7,  -9,  60,  87,-110, 114, -88,  82,  58, 105, 116,
   68,  44,  44,  30, -51,  59, -82, -35,   9,  20,-122,-122, -94, -14, 100, -83,
  -66, 126,  60,  92, -45, -56,-118,  -7, -18,-102, -75, 109, -98,  78,  72, 120,
  -97, 105, -10,  96, -49,  44,  28,   9, -57,-122,  40,  84,  30,-127, -46,-121,
  108,  47, 116, -56, -63, -54, 115,  39, -53, -75,-110, -91,  82, 105, 126, 126,
  -98,   8,  82, -54, 122, -67, -66, 125,  -5, -10,  27, -82, -65, -66,  82, -87,
  108, -33, -66,  93, 107, -35, -17,  -9, -73, 108,  57, -29, -13, -97,  -1, 124,
  -67,  94,  47, 114,  -5, -34,  -9, -66, -41,  57, 119, -14, -26,  83, -94,  40,
  -70, -27, -74,  91, -63,  92, -83,  86, -79, -72,  36,  65,-110,   6,  36, 113,
  102, 118, -52,  82,  48,-120, -56,  59,  15,  41,-123,  86, -98, -55, -80,-121,
  103,-112,  72,  76, -18,  10, 103,  10,  88,  32,  97,  44,   1, -67,-127, 123,
  -29, -21,  94,  -7, -14,-117,  46, -68, -22,  45, -65, -47,  88, -75,   6,  82,
   51, -95, 111,  25,-110, -62, -60,  35,  20,  78,  -6,-126, -68, -42,  76,  76,
   37,  64, -80, -23,  35,-118,  36,  73,  38,-104,  28,  16,  90, -79,-122, 103,
  -28, -50, 106,  65, 106, -80,-117,  70,   3, -37, 103,   6,  60, -68, -76, -50,
  -71,  80, 105,   1,  65,  12,-101,-103, 106,  16,  35, 101, -60, -65, -60, -33,
  -96,  47,  62, -32, -83,   3,  24, 108,  80,   1,  72,-110, 100,-128,  84,  -2,
 -113,-123,  86,-123,-127, -47, -48, -32,-117,  33,-105, 127,  43,  44, 119,-120,
  -68,  98,  17,  84,  39,  80,  -3, -64, -89,  63,  -5,   7,  31,  -5, -45,  60,
  -49, 111,  -4, -21, -65, -67, -17, -66, 123,  31, -68, -17, -89,  -5,-101, -83,
   67, -64, -38, -98,  90,-107, -40, 106,  60, -46, -23,  38, 101, -10, -37, -92,
   14, -85,  81,-121, -35, -66, -92, -65,  43, -79,  73, -55,-105, -45,-112,  72,
   72,  73,  62, -17,-109,  41,  26, -79,  30,  41,-107,  13, 120, -77,  13,  16,
    7,  41, -53,  57,-105,  63,  45,-117,  37,  -8, -62, -50, 109,  50,  46, -98,
   14,  12,-112, -61, 103,  64, -15,  -1, -73, 119, -82,  65, 114,  84, -41,  29,
   -1, -97,  -5, -24, -98, -98,-103, 125,  72, -69,  90,  36,  91,  70,  15,-124,
    4,-127,   4,  98,  27,-126,  44,-126, 113,   8,   5,  24,-125, 108,   3,  34,
   70, 114, 120,-104,-112,-108, 109,  65, -54,  81,  30, -91, -40,  88,  74, -15,
 -127,   8, -20,  80,  73,  44, -54,  40, 113,  48,  56, -58,  46,-126,  72,  92,
  -60, 101,  43, -56, 101,  30,  74,  97,  81,  32,  36,-127,  86,  66,  22,  43,
  -55,  72,  66,  43, -19, 123, 103, -90, -69, -17, -67, -25, -28,  67, -17,  46,
   50,  73,  44,  17,-100,-110, -41, -98, -33,-121, -87, -23, -39,-103, -83, -22,
  -35,  -1, 116, -97, 123, -49,  57,  -1,   3, -54, -75,  98, 109, -68,   2,  80,
  -29,-110,  97,  98, -17,-112,   4, -53,  28, -11,  27, -53, -27, -46,  96, -49,
   86, -86, -67,  62,-107, -92, -46, -49, -33, -69, 124, -34, 101, 115,  62,-112,
 -123, 116, -59,  31, 126, 108, -25,  -2, -41,  91, 117, -44,  82, -78, -77,  22,
  -52, 111,  61, 117, -58, -87, 115,  79,  63, 125,  -6, -20, -31,  -3,  71,  -9,
  -19, -21, -50,-119,  85, -71, -84, -90, 119, 117, -98, 114,  74,  42,  -6, -59,
  -34,  35,  71, -87, -11,  75,  59,  -1,  57,-114, 117,  20,  69,  78,  27,  79,
   85,  10,  90,  19,  51,  15,  59,  36,-107,  84,  69, -27, -68,  20,  -4,  22,
   81,-103,  85,  85,-105,  13, -94, -44, -34, 110,   7,   7,-121, -29, 114, -46,
  -33, -33,  95,  44,  80,  23,  95, 125, -11,  71,  23,  47, -18,  61, 124, -72,
  -85, -85, 107, -37, -74, 109,-113,  -3, -53, -29, 107, -42, -84, -71, -14, -61,
 -117, -17, -67,  -9, -34,  21, 127, -14,  23, -75, -58, 104, 123, -71, 122, -26,
   -4,   5,  31, -65, -31, -70,   6,  92,  -9, -34,  93,   0,  -4, -32,  96,-128,
   76,  65,  52, -37,  39, -45,  57,-121, -11, 105, 100,  36,-120, -14, -84,-115,
   98,  97, -15,  66,  80,  33,  72,-102, -26,-103, 115,   1, -24,  54, -74, -50,
   50, -86,  53, -73, -73,  77, -99, -65, -32, -20,  15,  93, -12, -63, -85, -82,
  -98,  -5, -34,  -9, -63,  -2,-108,-121,  25,   1, -43, -30, -82,  89,  30, -37,
 -108, -44,  69,-117,  13,   1,  64,-119, -52, -40, 127,-102,-128, -88, 116, -20,
  -89, -12,  91, 114,  47,  52, -10,-111,   8, -26, -51, -97,  17,  76,  98,   1,
   28, -85,  84,  20,  73,-106,  -1,  41,  23,  53, -79, -79,  -6,  14, -81, -84,
   63, -53,  -7, 122, -94, -95, -76,  56,  44, -36,  36,  99,  19,  35, -28, -80,
   10,  18,  22, -50, -97,  -1,-109,  61,  -5, -25, -58, -79, 117,  -2, 125,  84,
  -78,  70, -90, -76,  38,-111, -10,  33, -83,  37,  42,  78,  76,  41, 107, 100,
   14,-106,  33,  65, 113,-128,-124, -32,  34, -46,-102,  68, 124,-104,  25, 115,
   20,  69,  12,-107,  -7,-112,  51,  72, -37,   0, -14, -98,  15,  43, -25,  25,
   78,  66,-125,  57, 101,  78,   3,  59,   1,   3,  42, -73, -50,  80,  29, -30,
  -64,   2,-107,  51, 106, -62,-103,  86,-103,-117,   3,  70, -49,  84,  -8,  84,
   52, 111, -19,-121,  23,-100, 127, -55, 117, -89,-100, 125,  -6,  20, -97, -67,
   78, -42, 102,  30,  35, -75,-127, -34,  67, -61,-115, -47, -70, -49,-109, 114,
  121,  96,  96, -96,  60,  52,  80,  74,  27,-107, -31,-127,-114, -66,  35,  29,
 -121, -33,  56, -91, -81, 111, -54, -48, 112,  37, -53,  14, -50, -24,  16,  17,
  -17,  56, -53, -78,  16,-126, -42, -74,   8, -71, -46,  64, 101,  79,-119, -23,
  -97,  87,-102, -15,-119, -34, -66, 103, -40,  85,   5, -75,  16,  19,  26, 113,
   28, -35, 116, -45,  77,-113,  62,  -6, -24, -32, -32, -32, -35, 119, -33, -67,
  116, -23,  82, -91, -44, 107, -81, -67,  54, 111, -34, -68, -27, -53,-105, 127,
   -5, -37,-113, -66, 113, -24,-115,-117,  46, -70,  -8, -43, -35, -81, -58,  81,
 -100, -70, -58,-126, -39, -89,  13,  -9,  13,  92,  -6,-111, -53,  22, 127,  98,
  -55,  53, -41, 126, -84,-123, -84, -55, -62,  69,-106, -25,-103, -24, -52,  56,
  -22, -76,  28,  84, -50,  62,  84,-100, 109,  15, 113, -51, 101,-114, 104,  40,
   -8, -93, -98,-121, -76,  26,  53, 122, -48,  -5,  17, -49, -17,  89, 114, -43,
   21,  87,  93, 125, -47,  21,  87, -96, -67,  29, -38, -28, -48,  14, -54,   1,
  -19,  56, 126,  33, -56, 100, -25, 103,  85, 103, -67, -39,-101,  63,  62,  65,
   84, 107, -99,  59, -88,  40, -14, -64, -80, 115, -33, -39, -79, -13, -68, 115,
  -50, 121, 118, -41,-113,  13, 104,  27, -41, 102,-109, 122,  -9, -47,  -6,  44,
  -63, 105, 109,  45,-122, 121, 100, -72, -33,  68, -74,  69,  26, -94,  85,  14,
  120,  69,  78,  88,-108, -80,-121, -79, 122,-105, -55, -54, -28,  90, -56,  36,
 -126, -74,  96, -90,   4,  78, -40, 104,  71,  67, -19, -95,  40, -54,  14,  76,
   78, 116,  16, -14,   2,  17, -55, -84, -14,  34,  57,-103,  76, -85,-122,  98,
   47,  94,-104, -55,-123,-106,  74,  87, 110, -87,  18, 106, 118, -12,  72,  -5,
  127,  28, 126, 126, -21, -34,  70,  53,  42, -27,-103,  70, -26,-115,  66, 108,
   84, -18,  58,  83, -98, -46,  55,  60,  75, -20, -81, -43, -35,-103, 114,  84,
  107,-120,  38,  86, -38,  65, -25,  74,  -9,  70,-122,  75, 113,  54,  60,  76,
  -92, -57, 111, 100,-122,-116,-122,  42, -90,  81, 122,  33,  45,  44, -93, -32,
  -34,  44,-125,  49,  94,  60,  41,  49,  74,  51, 115,-106, 101, -53,-106,  45,
  107, 111, 111, -65, -11, -42,  91, 123, 122, 122,  62,  -3, -23,  79, -65, -16,
  -62,  11,  75,-106,  44,  89, -66, 124,  -7, -34, -98,  -3,  -5, -10, -19, 123,
  117,  -9, -85, -19, 109, -19, -42, -38, -76,  63,  93, -11,  87, -85, 127, -14,
  -29, -98, -96, -72, 123, -21, 118, -54,  96,-115,  76, -85, -76, 105,  55,   0,
 -107,  43,-112,  98, -91,  68, -79,  35, 110,  72,  45,  79, -73, -64, 113, -55,
   14, 106, 125, -40,-104, -22, -68, 121,  23,  44, -66, -22, 119, -81, -67, -74,
  -21, -84, -77, 107,  65, -30, -72, -28,-127,  92,  56,  -8,  96,  78, -68, -64,
  110, -14, 115,-100,  51,  -3, -17, -41, -19,  72,   1,   2, -25, 125,  91,-108,
    8, -16,  74,  -9, -85,  22,  -8,  -2,  -9, 126, 112, -33, -67, 119, 111, 126,
  -18, -39, -19, -75,  70,   7, -95,  99, 120, 100,   6,  48, -85,  82, -86,   6,
  -86,  80, -82,-119,  50, -25, -75,  86,  86, -87,  74, 100,-103, 115, -49,  62,
  -87, 105,  99, 109, -86, -43, -88, 112, -81,  18, -91,-125,  40, -26,-104, -69,
  -14, -96,-117,   4,  22,  25, -83,  20,  17,  21, -69,  84, -43,  54,  65, -50,
  -79,  88, 104,-109,-123, -36, -80, 106,  13, -74, -84,  -8,  39, -22,  48, 105,
  -33,   6, -52, -88,-116, 126, 110,-128,-122, -45,  67, -50, -27, -83, -56,   3,
  -14,  58, -32,  12,   0, -76,  39, 101,  78, -21, -48, 112,  10,   3,  81,  68,
  -71,-105,-116,-115, 120, -83,  69, 116, -16,  41, -89, -52, -95, 100, -76,-122,
  -42, -38, -24,  88, 107, -83, -75,  13,  33,  56, -25,-118, 106,  78,  11,  61,
   36, -36,   7,-128, -87,  48, -43,  50, -58,  52,  26,  89, 111, 111, -17, -54,
 -107,  43,  59,  59,  59,  87, -81,  94, -67, 118, -19, -38,  60,  -9,   0, -98,
  120, -30,-119, -91,  75,-105,  62,  -3, -12, -45, -33,  -3, -18, 119,   1,  12,
   14,  13,   2,  88, 124, -35, -57, -25, -97, 113, -58, -33, -35,  -5,  55, -73,
   -1, -15, -14, -75,  95,  91,  87,-119,-115, -11, -28, -21, 105,-119, -47,  21,
   85,  58, -88,-118, -95, -47,  94,-105,  30, -47,  24, -48, 122,  88,  -7,  -7,
   55, -33, 112, -34,   7,  62, -16,  -2,  11, 127, -69,  52, -13,  61,-120,  19,
  -24,  40,-121, 106,   0, 101,  13, -10, 112,-103,  47,-105,  12,  72, -63,   3,
   33, -60,  90,  -1,  -1,  79, -31,  61,  -7,  -4, -81, -89,  -8,-106,  88,  -8,
  -51,  67, -82,  67, -23,  68,  19, -32, -13, -52,  89, 101, -75,  54,  87, 125,
  -24, 119,  46, -70, -28,  34, 107, -51,  19,  27, -66,  -1,-123,  85,  95, -36,
  -66,  -7,  -7, 110,  66, -75, -98,  11, -13,  89,  64,  75, -84,  99,  82,  83,
  109,  28, -27, -82,-109,-108, 117,  58,  98,  25,  40,  91,  67,  74,   9,  83,
   16, -59,  33,  98, -74, -92,  20, -80,  71,-107,-120, -95, -64,  10, -92,   1,
   61,  30,  78,-105, -46, -47,  40, -96,  74,  81, -94, -83,-126, -42, -92,  97,
   98,  84, -20,-100, 122,  35, -53, 107, -71, -53,-113,-108, -72, -83, -84, -45,
 -106,-100,  66,  78, -20, -67, 106, -51, -13,  60,  13,  60,-102, -27,-125, 112,
  105, -94,  93, -84,  51,  29,  72, -34, 109,  44, -57, -20,  44,  55,  44,  50,
  -91,  29,  89, -64,  80,-108,  70,  68,  36,  76,-127, -61,-104, 107, -96,  20,
   11, -67,  16,  72, -57,  20,  -9,   9,-113,   2,  80,-106, -31,  68,  66, -93,
  -31,-120,  48,  50,  50,  98,-116,  -7, -20, 103,  63, -69, 126,  -3,  -6,  60,
   -9, -45, -90, 117,  24,  99,  74, -91, -46, 125,  -9, -35, 119,  -7, -27,  87,
   62, -11, -44,  83,-107, 114,  37,-124, -64, -52, -73, -36, 114, -53,-122,  13,
   27,  90,  90,  90,  42,-107, -54,  51, -49, 108,  74, -84, 106,   4, -82,  42,
  -45,-123,  82, -42,-120, -73,-113, -44,-113, -96, -26, -38, -70, -50, -68, -10,
 -118,-113, -36, -10,  -5, 103,-100, 127, 126,  26, -94,  72,  71,   0, -14, -79,
  -96, 113, 108, -38, -86,   7,-116,  65, 108,  12,  35, 120,-105, 105, -83, -76,
   33, -64,   3, 111,  35, -55,  62,  73, 121,  27, -33, -57, -79,-108,-102,  21,
    5, -50, -68, -77,-120, -94,  72,   3, -56,  27, -75, -88,-108,-108,-108,   9,
 -114,  63,  -6, -63, -53,-106,  60, 115,-103,   3,  94, -39, 123, -16,  -2,-121,
  -65, -10, -64,  87, -18,  -5, -49, -93,  67,  58, 115,   6,  60,  77, -96, -78,
  124,  70,  61, -99, -94, 117,  71,  82, 110,  31, -82,  89, 107,  35, -85, -76,
  -42, -84,  37,  23,-121,  32,  44,  40, -87,  24,  69, -82,  92,  68, 115,  40,
  -90, -14,  17,  81,-122,   8,  10,  71,-125, -73,  33,-128, -43,  81,  23,  14,
 -103, -47, 122, 107, -71,  43,  24,  77,  37, -93, 108,   4,  59, -59,-120, 118,
  -92, -13,  16,  49,  18,  42,-103, -96, -37,  18,-101, -54, 112, 106,  84,  70,
   20,  75,-108, 100, -70,  97, 122,  12, 105, 109,  98,-126, 118,  98,  61, -57,
   33,-109,-112,  82,  27,  26,  74,  41,  64,-104, -95,  20,-109, -24,  98, 114,
  -75,  72,  96,  66, -84, -94, -34,  60,  77,  21, -76, 104,  33,-128,-104,   8,
 -107,  74, 121, -21, -42, -83,  71,-114,  28,  -7, -26,  55,  31,  81,-118, -90,
   79, -17,-102,  57, 115, -90,  -9, -66, -81, -81,  79, 107, 125,  -8,-115,  55,
  -10, -19, -37,  87, -85, -41,   0, -84,  -6, -30, -86, -23,  93, -89, -84, 124,
  -24, -95, -69,  87, -33, -11, -16,  55, -65,  33,  64, -61, -15, 111, -52,-103,
  115, -76, -25, -11, 103,  17, -50,  59,  -9, -67,  31, -71,  -2, -70,  69,  87,
  126, -72, 109, -63, -36, -96,-108,-121, -54,  32,  85,-112, 100, -16,  94, -96,
   97, -93, -15,  57,  16, -60,-100, -27, 100,  45,-120,  67, 112,-111,  49,  32,
   17, 112,-102, -89,  73, -12,  43,  44, -42, -73,   4,   0,  19,-121,  14,-107,
  -52, -91,-119, 109,  81,  32, -49,  65,  36, -40, 114, -30, -64, 113, -67,-127,
   40, -26,  72,-115,   4, 104,-125,   5, -89, -67, -21, -17,  63,  -1,  -7, -81,
  -34,  -7,  -7,  35,  74, -42, -36, -77, -26,  75,  -9, -36, -13,  -6,  80,  31,
   12,   6,  43, -27,  48,  90,-105,-111,-111, 118, -96, -54,  89,   7, 116,  39,
   69,  83,-107, 109,-123,  45, 107, -60,  34,  46, -49,  53,  72,  72, -76,-126,
   40,  34,  16,-125,  73, -92,  33,  21, 103,  66,  10,  87,  21,  36, -91, -14,
   -2,  70,  -6,   3, -55,  15, -40,   0,  18,-120,-127,-118,  20,-120,  91,  28,
    2,  91, -85,-104,  57,  36,  71, -26,  12, -53,  39, -30, -74, -45,  89,  76,
  -88,   7,-126,  38,  31,   5, 107,  85, -30,  67, 112,-100, -79,  86, -58,-104,
  -78, -46,  68,-118,  68,   2,-108,  50,  70,-111,  97, -26, -62,  87,  86,-128,
   80, -20, 121,  18,-116, -46,-121,  71,   7, -95,  33,  14,  92,  40,  68,  48,
   58,  90,  47,-105,  75,  67,  67,  67, -25, -98, 123, -50,-106,  45,  91,  43,
 -107,  10,-128, -87,  83, -89,  42, -91, -78,  44,  27,  25,  25,  41,  82, -78,
  -25, -97, 119,  -2, -11, -41,  95, -65, -18, -97, -42,  45,  -4, -83,  11,  58,
   59,  59, -97, 122, -26, 105, 104,-120, -58,-113, -74, 109,-119, -29,-118, -73,
 -110,  34,  52,-124,-103,-110,  58,  40, 102, -60,  14, -79,  16,  32,   4, -79,
  -79,-102,  88,  56,-115,  25, -93, -39,   8,  34,   8,  48, -70,  92,  24, -54,
   17,  33,  25, 119,  88,  -7, -27, -26,  56,  87,  86,  25,  55, -16, -97, 120,
   52,  64, 100,  74, -20,  65,  10,  26,  26,  90,  51, -64,  66, -93, -27,  16,
  -63,  69,-126,  22,  49, -56,   4,  42,  64,  59, -64,  77,  11, -43, -65,  94,
  126, -57,  61, 127,  -6, -25,  30,  -8, -37,  -5, -41, 126,  -3, -63,-121, -73,
   61,  -1,   2,-128,  58,  52,  73, -40,-101,-122,  56, 109,-108,-127,  10, -48,
  -94,-112,  88,  -3, 126, -42,  74,  41,  99,-107,   1,-111,   2,  17,  65,  32,
   18, -38, -78,  72, -59,-127, -95, -90,  42,  59,  61, 110,  31,  13,  94, -25,
   35,  80,  37,-107,-121,-110, -73,  86,-107, 116,-114,  -2,  54,  15, 103,   8,
   42,   4,   7,  86,  52,  56, 108,  91, -37,-116, -86, -89, -47, -56,  40,  26,
  -43,  64, 101, -81,-103, -88, -24, -42, -16,  36,  33,-120,  23,  23,-119,  50,
  -96,-100, -13,  16,   2, -95,-104,  61,  73, -29,  27, -35, -59,  68,  55, -47,
  -48,  35,  25,  96,   9,  78,  64,-128, -80, -75, -38, -71,  80, -81, -89,-113,
   61, -10, -40, -86,  85, -85,  22,  47,  -2, -40, -34, -67, 123, -67,  -9, -69,
  119, -17,  78, -45, 116, -47, -94,  69,   7,  15,  30,  28,  24,  24,   0, -80,
  114, -27, -54,-115,  27,  55,  -2, -37, -29,  -1, -70, -18,  43,  -9, 127, -27,
   -2, -75,  71,   7,  -6,  97, 104, -23,  77, -97,-116, -85,  21, -87, -91, -54,
  -40,  42,-103, 106,  49, -55,  85,   0,   6,  44,  64,-100,  83,   3, -29,-119,
   80, -64,  20, -26, -52,   4,  56, -83,   8,  32,  76,  52, -17,-113,  85, 118,
  -68, -93,  60, -26,  36, -31, 109,  15, 109,  -5, 121, 113, -41,  93, 119,  61,
   -8, -32,-125, 123, -10, -20,   1,  16, -57, 113,  81,-124,-101, 101,  25,   8,
   49,  97,-118, -90, 119, -59, -91, -23, -58, -74,  11, -73,  10, -75,  70,  38,
  -55,  27,  36,  80,  62, -77,  34, -19,-107, -72,  45,  41, 113,-106,-114,  12,
  102,  27, -20, -44, 122, -18,  82, -31,  26,-121,  33, 113,  65,  71, -86,  92,
   22,  77,  55,-116,  28,  45,-105,-112, -60,-111,-127, 104,  33,  75, 100,  73,
 -127, 101,  52,   2,   1,  42,-120,  17, 101,  73, 105, -47,  69, -56,  97,  66,
  -51,  24,   3, 101, -72, -16, 104, -77,   6,-128,  11,  82,   9,-125, -89, -90,
 -106, -89, -49,  -5, -53,-125,  59, -65,  19,   4,-116,  22,  79,  65,  36, -45,
   58,-118,  34, 102,-122,-124,  23,  95, 124, -15, -90,  79,  46, 123, 113, -53,
   54,  20,  98,  51, -10, -46,  75,  47, -67, -15, -58,  27, 119, -18, -36,  57,
  119, -18,  92, 107, -19, -19, -73, -33,  -2, -64, -38,  -5, 123, 122, 122,  86,
   -4, -39,-118, -30, -49, -19,  89,  56,   4, -91,  53, -34, -47, -50, -29, -81,
   22,  39,  77, -84,  24, -73,   1, -36, -80,  97, -61, -70, 117, -21,  30, 127,
   -4, -15, -79, 122, -22, -56,  32, 120,   4, -60,  64,   9,-120,-127,  10,  80,
    1,  22,  36, -27,-106,  56, 110,  33,  93, -50,  92, -43,-121,  78,  19, 117,
   68, -91,  68, -21, 118,  51, -24,  67,  40, -58, 100, 101, -34,-109,  82,  38,
 -118,   3, 100,-113, -53,  34, 109,  20,   9,  92, -96,  16,-118, -94,   2, -91,
   80,  70,  38,  34,   2,  37,-118, -58,  60,   3,  33,  34,  16, 109,  52,  41,
   35,  90,   7, -79, -92,  98,  88, -59, -62,  62, -12, -73, -85, -22,-112, 121,
   29, -55,-102,  -2, -41, -70,  19,  64,  20,   2,  80, -79, -74, -58, -50,  57,
  107, 109,  41, -74,  87,  94, 121, -27, -22,  59, -65, 112, -51,  53, -41, 116,
  -17, -36, -83, -76,-103,  54, 109, -38,  37,-105,  92, -78, 112, -31, -62,  11,
   46, -72,  96, -53,-106,  45,  95,  -2, -14,-105,  87, -84,  88, -15, -66, 115,
  -50,  93, -78, 100, -55,-127,   3,   7, -22,  89, -29,-127, -81,  62, 112, -13,
  -89,  62, -27, -67, -73,  81, -44,  20, -21,-119, 115, -46, -60,  42,  34, -34,
   -5,  34,-125,  92,  36, -27, -78,  44, -37, -67, 123,  -9, -65, 111,  -4, -31,
   -6, -11, -21,  55,  63, -13,  44,  32, -54,  90,  13,   9,  33, 112,   8, -80,
   12,-127, 102, -76,  48,  42,  64,  39, -48,  17,  39,  45, -91,  -8,-116,  48,
   24,  41,  84,  98,-107, 104, -85,  67,  80,  65,  52,   7, -15,  16, -37,  90,
   -8, -80,  22,  99, -48,  52,  36, -46, -58, 106,  51, 125,  52, 103,  17, -81,
  -32,  21,  57,   5, -89,-111, -77,  56, 112,  45,  47, 101,  74,  70, -31,  -5,
 -112,  -9, -87, -48,  47,  89, 127,-112,  17,-121,  87,  51, 116,   0,  22, -47,
 -113, -63,  40, -59,-107,  84,  42, 112,  64, -44,-117,  90, -75,  90, 117, -50,
   65,  66,-110,  36, -97, -69, -29, -10, -37, 110, -69, -19,  91, -33,  -6, -42,
 -109,  63, 120, 122, -47, -94,  69,  67,  67,  67, -77, 102, -51, -38, -79,  99,
  -57, -82,  93, -69, 110, -66,  -7, -26, 105, -45, -90,  -3, -47, -83, 127,  80,
  -85, -43, 122,  -5,-114,-100,  54,  -9, -76,  93, -69, 119,-113, 117,-106,  55,
 -107,  -6, 118,  56,-103,  98,  29, -13,   5, -14, -34,  24,  83, -28,-108, -67,
   -9,  70,  25,   4,-127, -95, -66, -66, -95,   7,  31, 122, -24, -85,  -1,  -8,
   15, -69, -69, 119,   1,  24, -13,  90,  37,-127,  48,-108,  76, -12,  94, -59,
 -128,   1,  74,  64,-123, 116,-103,  80,  49,  54, -47, -38,-110, -22, 116,  53,
   13, -46,  90,  27, -83,  52,  67, -40,  23,-121, 123,-115, 114, -32,  44, 112,
    3,  33,  19, 110,   4, 105,   4, -28,   1, -61, -59, -17,   6,  48, -74,  73,
  -92,   5, -62, -32, -84,  53, -63, 112,   6, 101, -96,  53, -56, -76, -26,  94,
   33,  31, -90, -96, -76,  41, -42,  79,-118, -48, -47,  49,  53,-119, -20, 103,
   62, -13,-103, -91,  75,-105, -18, -39, -45, -77, 121, -13, -26,-125,   7,  15,
   46,  92, -72, 112, -42, -84,  89,  73,-110, -12, -12, -12, -36, 120, -29,-115,
  -77, 103, -49, -35,  -2, -14, 118,   0, 105,-106,  27, 107, 125, 120,  27,  -3,
  -14,  77,  10,  78, 102,  24, 112,  44,  69,  72,  64,  68,-112,  12, -62,  80,
    6,  66, -52, -94,-108,  21, -96, -81, -81,  -1,-121,  95,  95, -65, 105, -13,
  115,  79,  62, -75, -79, -25, -16,  94,  15,  64,  43,  79,  28,   2,  32,  49,
   72,  72,  88,-125,  45,-118,  13,  90,  16,  80,  43, 124,  87, -87, -88,  40,
  -57,  68,  33, 100,  14,  48,  48, -26,  69, -87, -88, -88,  56,   7,  33,   9,
 -111,  67,   8,  69,  -1,   1,   1,  74,  65,  17,  20,-107, -77,   6, -63, -44,
   17,  68,   9, -56,  23,  69, 117,  40, -61,-116,-104, -94,  26, -65,  81, -81,
    3,  56, -25, -20,  51, -69, -69, -69,-105,  45,  91, 118, -23, -91,-105, -51,
 -100,  57,  51,-118, -94,-127,-127,-127,  67,-121,  14,  21,-123, -98, -42, -38,
 -105,  95, -39,   1,  96, -51,  61,  -9,  46,  95, -66, -36, -58,-111,  -9,  94,
   41,  21,-124, -83, 110,  74, -10,  68,  57, 105,  98,  45,  42, -25,-117,  56,
  -75, -80, -20,  43,  -4,-127, -99, -82,  19, -76,   6,   5,  72, 112,-100, -40,
   24, -96,  52, 109,  68, -91,  74,-102, -89,  74, -87, -56,  68,-103, 107, 108,
  -38, -76, -23,-111,  71,  30, -39, -72, 113, -29,  -2, -67,   7,  64,-124,  16,
   64,-128,  38,  37,  82,  56, -35, 112,-120, -95, -57, 103, 104,  20, -25, -88,
  -58,  -4,-126, -92, -40, -15,   7,  72,  20,-118,   5,  53,  32, -28,  73, -96,
   53,  89, -91,  73,  20, 123, -49,   0,   1,-103,-110,  82, -71,-100, -42, 107,
   16,  36,-106,  52, -95, -18,-124,  13,  12,-101, -30,  20,  90,  91,  42,-115,
   70,-125,  61, -97, 125, -42,  25, 121, -98,  27,  99, -14,  60,  47,-107,  74,
  -75,  90,  45,-124,  48, 103, -50,-100, -95, -95, -95,-105, -74, -66, -52, -64,
   55,  30,  -2, -58,  13,  75,-105,-126,  48,  58,  58,  90, -87,  86,  89,  88,
 -111, 106,   6,   2,  39, -50, -55,  20, 107,  81, -95,  83, 116, -89,  76,  20,
  -20, -28,  96,-127,  16,  68,  21, -34,  84, -29,  62,   2,   1,   6,  99, -58,
   42,-128,  15, -16,  12,  82, -48,  26,  10,   3,  71,  -5,  95, 122, -23, -91,
   31,  -3, -24,  -7, 109, -37, -74, -67, -14, -54,-114, -98, 125,  -5,  70, -21,
  117,  93,  -8,  33,   0,   1,  30,-128, -43,-102,-120, 114, -97,  91,  35, -52,
  -62,  69,  76,  81,  12,  80,   4,   4, -30,  98,  25, -21, -40,  99,  80,  24,
  -53,-100,  69,  68,  35,  34,  70,  19,-126, 116, -76, -75,  28,  30,  30,-127,
    2, -76, -79, -71,  56,   4, -83, -75, -75,  54,  75,  83, -91,   0,  70,  75,
   53,   1, 112, -58,-126,   5, -43, 106, -75,  82, -87,  20, -29,  74,-122,-122,
 -122, -46,  52, -51,  29, -33, -71, 106, -11,  23, -18, -68, 115, 120, 104,  40,
   78,  74, 113,  28,  51,-124,  64,-127,-125, 121,  39, 125,  30, -65,  98,-100,
   76, -79,  78, -52, -79,  40,  40,  90, -84, 116, -48,  80, -29,  43,-113, -30,
   81,  88,   0, -90, -97,  50,-104,  17,  25, -53,-120,  42,-109,   1,  10,  34,
  -52, -80,  58,-126,-128,  25,  74,  33,  16, 124, -16,   7,  14,  28, -40,  -2,
  -14, -42,  29, -35, -35, 123,  -9, -67,  86,-104, -90, -17, -17, -18,   9,  33,
  -28, -98,-125, -16,  88, -93,  30,   1,  32, -61, 126,  44, 100,  37, -45, -38,
  -34,  54,  99,  -6, -69,  79, -99,  61, 107, -58,-116,  25, 103, -99,  -9, -21,
  -17,  63, -25,  55,  63, 120, -34,  -7, -36, -16, -65, 119, -21,  45,-113, -82,
  127,  76,  75, -87,  18,  36,-115, -14, -62,  86,-124,   0, -83,  73,-119,   4,
 -122,  53,  20, -68,   8, -96,   8,  44, -88,-108, -29,  90,  61,   3, -32, -40,
    1, -58,  59, 103,  34,  11, -64, 115, -48, -86,  -8,  34,-119, 105,  46, -78,
   78,-104,  95,-108,-104, -11,  23,-103,   9,  35,-122,  44, -53, -26, -49, -97,
  -65, 127,  -1,  -2,  98,  16,  87, -98, -25,   0,-118, -81,  92,  17, -61, 104,
  -83,-117,  39,  69, -95,  49,-128,  59, -18, -72,  99, -51,-102,  53, -47,  59,
  -21,  61, 106,  82, -48,  20, -21, 113,  40, 118, -42, -14,  60, 119, -50,  85,
   42,-107, -63, -63, -63,  77,-101,  54,  61,  -7, -28,-109, -49,  61,  -9, -36,
  -63,-125,   7,  15,  29,  58,  52,  97, -31,  91, -48, -43, -43, 117, -31,-123,
   23,  94, 126,  -7, -27,  23,  95, 124, -15,-116,  25,  51,  42,-107,  10,  17,
   29, -21,  65, -46, -28,  -1,  76,  83, -84,  39,  68, -79, -65,  86,  60,  22,
   23, -44,  40,-118,  68, -60,  57, 103,-116,  57,  54,  64,  41,  46, -61,  19,
   17, 121,  97,  -3, -48, -36, -91,  -6, -71, -48,  20, -21, -15, 105,  52,  26,
   73,-110,  96, -68,  21,  78,  41,  85, -36, -18,  39,  90,  56,  68, -92, -40,
    7,-104, 120, -59,  57,  87, -68, -19,  29, 118,  29,  53,  57,-106, -90,  88,
 -113, -61,-124, 117, 104, -83,  86,  43, -22, -86,  48, 110,-124, 123, 108, -37,
  -49,-101,  35, -27,  67,  40,  52,  58, -15,  34,  17,  21, -17,  63, -39, -89,
   50, -23, 105,-118, -11,  56,  20, -30,  43,  36, -53, -52, -75,  90,  45,  73,
 -110,  34,  36,  40, -76,  56, 113,-117, 127, -53,  30, -36,   4,  39, -24,-108,
  -37, -28, -72,  52, -59, 122,  28,  10,  69, -66, 101,-123, -12,-106,  43, 101,
 -111, -38,  40,  20,  89,  72, -77, -24,  14,  40, -90,  21,  23,  79,  78, -10,
  121,  -4,  50, -48,  20, -21, 113,  40, -44,  86,  92,  92,  11, -89,-122,  99,
   69,  -7, -77,  63,  59, -31,  74, -14, -74,-100, -13,-101,  -4, 111,  52, -59,
  -38, 100, -46, -48,-116, -91,-102,  76,  26,-102,  98, 109,  50, 105, 104,-118,
  -75, -55, -92, -95,  41, -42,  38,-109,-122, -90,  88,-101,  76,  26,-102,  98,
  109,  50, 105, 104,-118, -75, -55, -92, -95,  41, -42,  38,-109,-122, -90,  88,
 -101,  76,  26,  -2,  11, -87,  59,-121,  83,  76,  26,  40, -81,   0,   0,   0,
   67, 116,  69,  88, 116,  83, 111, 102, 116, 119,  97, 114, 101,   0,  64,  40,
   35,  41,  73, 109,  97, 103, 101,  77,  97, 103, 105,  99, 107,  32,  52,  46,
   50,  46,  57,  32,  57,  57,  47,  48,  57,  47,  48,  49,  32,  99, 114, 105,
  115, 116, 121,  64, 109, 121, 115, 116, 105,  99,  46, 101, 115,  46, 100, 117,
  112, 111, 110, 116,  46,  99, 111, 109, -19, -24, -39, -16,   0,   0,   0,  42,
  116,  69,  88, 116,  83, 105, 103, 110,  97, 116, 117, 114, 101,   0,  52, 100,
   48,  50,  51, 102,  50, 102,  50,  98, 102,  55,  56,  57,  48,  51,  57,  55,
   49,  52,  49,  51,  48,  55,  51, 102,  99,  50, 101,  57,  49,  97, 104, -42,
   85, -36,   0,   0,   0,   9, 116,  69,  88, 116,  68, 101, 108,  97, 121,   0,
   49,  48,  48,  92,  25,-124,  15,   0,   0,   0,   0,  73,  69,  78,  68, -82,
   66,  96,-126
  };


  //  Place somewhere ;

  class Place extends Panel implements Runnable {

    Image bgBuffer = null;
    Image carImage = null;
    Graphics g1 = null;
    int x=0;
    int y=10000;
    int xo=0;
    int yo=0;
    boolean stop = false;

    Place(int width, int height, Color background) {
      this.setSize(width, height);
      this.setBackground(background);
      carImage = Toolkit.getDefaultToolkit().createImage(DATA);

      (new Thread(this,"DriveCar Place Thread")).start();
    }


    public void update(Graphics g) {
      paint(g);
      }

    public void paint(Graphics g) {
 
      int w = carImage.getWidth(null);
      int h = carImage.getHeight(null);

      if (bgBuffer == null
                  || bgBuffer.getWidth(null) != w
                  || bgBuffer.getHeight(null) != h) {
        bgBuffer = this.createImage(w,h);
        if (bgBuffer != null) {
          g1 = bgBuffer.getGraphics();
          g1.clearRect(0,0,w, h);
          g.clearRect(0,0,this.getBounds().width,this.getBounds().height);
        }
      }

      if (bgBuffer != null) {
        g.drawImage(bgBuffer, xo, yo, xo+w-1, yo+h-1, 0, 0, w-1, h-1, null);
        g.drawImage(carImage, x, y, null);
      }
    }

    public void run() {
      int xb = 0;
      int yb = 0;
      int xStep = -4;
      int yStep = 1;
      int xe = 0;
      int xtest = 400;
      try {
        while (xb == 0 || /*yb == 0 ||*/ xe == 0 || xtest != xb) {
          if (xb!=0) xtest=xb;            // this.getBounds() seems to need time to stabilize
          Thread.sleep(200);
          xb = this.getBounds().width-1;
          yb = 0;//-carImage.getHeight(null)/4;
          xe = -carImage.getWidth(null);
        }
        x = xb;
        y = yb;
  //    System.out.println("x1="+x1+" y1="+y1+" xStep="+xStep);
        while (!stop) {
  //      System.out.println(" x="+x+" y="+y);
          this.repaint();
          Thread.sleep(40);
          xo=x;
          yo=y;
          x += xStep;
          y += yStep;
          if (x <= xe)  {
            x = xb;
            y = yb;
          }
        }
      }
      catch (/*Interrupted*/Exception e) {
        System.out.println("caught unwanted Exception "+e);
        e.printStackTrace();
      }
    }

  }
  
  public DriveCar() {
//    somewhere = new Place(getBounds().width, getBounds().height, Color.white);
//    add(somewhere, BorderLayout.CENTER);
  }

  public String getHelpText(){
    return ("To be successful, this test should show a white background, a red moving Corvette with a" +
            "white label \"ACUNIA\" on it, the Corvette should move diagonally from the upper right " +
            "corner of your screen, to its lower left corner. The car disappears bit by bit at the " +
            "left border of the screen, and then re-appears bit by bit at the right border.");
  }
     	
  public Panel getPanel(VisualTester vte) {
    vt = vte;
    return new Place(getBounds().width, getBounds().height, Color.white);
    //return somewhere;
  }

  public void start(java.awt.Panel p, boolean autorun){
    try {
      (new Thread((Place)p,"DriveCar Thread")).start();
    }
    catch(ClassCastException cce) {}
  }

  public void stop(java.awt.Panel p){
    try {
      ((Place)p).stop = true;
    }
    catch(ClassCastException cce) {}
  }

  static public void main(String[] args) {
    new DriveCar();
  }
}

